import {
  HashManager
} from "../chunk-FN54PEFD.js";
import {
  Scrypt
} from "../chunk-7JOSD2MP.js";
import "../chunk-NJXUVUWA.js";
import "../chunk-HRTBMSFS.js";
import "../chunk-5WRI5ZAA.js";

// factories/hash_manager.ts
var HashManagerFactory = class _HashManagerFactory {
  /**
   * Config accepted by hash manager
   */
  #config;
  constructor(config) {
    this.#config = config || {
      default: "scrypt",
      list: {
        scrypt: () => new Scrypt({})
      }
    };
  }
  /**
   * Merge factory parameters
   */
  merge(config) {
    return new _HashManagerFactory(config);
  }
  /**
   * Create hash manager instance
   */
  create() {
    return new HashManager(this.#config);
  }
};
export {
  HashManagerFactory
};
//# sourceMappingURL=main.js.map