import { defineCommand } from 'citty';
import { resolve } from 'pathe';
import { l as loadKit } from '../shared/cli.DlcAx0De.mjs';
import { c as cleanupNuxtDirs } from '../shared/cli.CixXmuNe.mjs';
import { c as cwdArgs, b as legacyRootDirArgs } from '../shared/cli.TH4BiEd5.mjs';
import 'jiti';
import 'node:fs';
import 'ohash';
import '../shared/cli.CoNbGSsT.mjs';
import 'node:path';
import 'node:process';
import 'std-env';
import 'consola';
import 'node:url';

const cleanup = defineCommand({
  meta: {
    name: "cleanup",
    description: "Clean up generated Nuxt files and caches"
  },
  args: {
    ...cwdArgs,
    ...legacyRootDirArgs
  },
  async run(ctx) {
    const cwd = resolve(ctx.args.cwd || ctx.args.rootDir);
    const { loadNuxtConfig } = await loadKit(cwd);
    const nuxtOptions = await loadNuxtConfig({ cwd, overrides: { dev: true } });
    await cleanupNuxtDirs(nuxtOptions.rootDir, nuxtOptions.buildDir);
  }
});

export { cleanup as default };
