'use strict';

const kit = require('@nuxt/kit');
const unifont = require('unifont');

function defineFontProvider(options) {
  return options;
}
function toUnifontProvider(name, provider) {
  return unifont.defineFontProvider(name, async (options) => {
    const nuxt = kit.useNuxt();
    await provider.setup?.(options, nuxt);
    return {
      async resolveFont(fontFamily, options2) {
        const result = await provider.resolveFontFaces(fontFamily, options2);
        return result || void 0;
      }
    };
  });
}

exports.defineFontProvider = defineFontProvider;
exports.toUnifontProvider = toUnifontProvider;
