import { T as TestOptions, a as TestContext, b as TestHooks } from './shared/test-utils.DsSnl8Os.mjs';
export { $ as $fetch, G as GotoOptions, N as NuxtPage, S as StartServerOptions, h as TestRunner, c as createBrowser, d as createPage, f as fetch, g as getBrowser, s as startServer, e as stopServer, u as url, w as waitForHydration } from './shared/test-utils.DsSnl8Os.mjs';
import { LogType } from 'consola';
import 'playwright-core';
import '@nuxt/schema';
import 'tinyexec';

declare function createTestContext(options: Partial<TestOptions>): TestContext;
declare function useTestContext(): TestContext;
declare function setTestContext(context: TestContext): TestContext;
declare function setTestContext(context?: TestContext): TestContext | undefined;
declare function isDev(): boolean;
declare function recoverContextFromEnv(): void;
declare function exposeContextToEnv(): void;

declare function mockFn(): ((...args: unknown[]) => unknown) | undefined;
declare function mockLogger(): Record<LogType, (...args: unknown[]) => void>;

declare function loadFixture(): Promise<void>;
declare function buildFixture(): Promise<void>;

declare function setupCucumber(hooks: TestHooks): Promise<void>;

declare function setupJest(hooks: TestHooks): Promise<void>;

declare function setupVitest(hooks: TestHooks): Promise<void>;

declare const setupMaps: {
    cucumber: typeof setupCucumber;
    jest: typeof setupJest;
    vitest: typeof setupVitest;
};
declare function createTest(options: Partial<TestOptions>): TestHooks;
declare function setup(options?: Partial<TestOptions>): Promise<void>;

interface RunTestOptions {
    rootDir: string;
    dev?: boolean;
    watch?: boolean;
    runner?: 'vitest';
    globalSetup?: boolean;
}
declare function runTests(opts: RunTestOptions): Promise<void>;

export { type RunTestOptions, TestContext, TestHooks, TestOptions, buildFixture, createTest, createTestContext, exposeContextToEnv, isDev, loadFixture, mockFn, mockLogger, recoverContextFromEnv, runTests, setTestContext, setup, setupMaps, useTestContext };
