export declare const reasonsSettingsSchema: {
    readonly type: "object";
    readonly properties: {
        readonly hide: {
            readonly type: "boolean";
            readonly default: false;
        };
        readonly component: {
            readonly type: "string";
            readonly enum: readonly ["radio", "checkbox"];
            readonly default: "checkbox";
        };
        readonly label: {
            readonly type: "string";
        };
        readonly items: {
            readonly type: "array";
            readonly items: {
                readonly type: "string";
            };
        };
    };
    readonly additionalProperties: false;
};
export declare const feedbackConfigSchema: {
    readonly type: "object";
    readonly properties: {
        readonly hide: {
            readonly type: "boolean";
            readonly default: false;
        };
        readonly type: {
            readonly type: "string";
            readonly enum: readonly ["rating", "sentiment", "comment", "reasons", "mood", "scale"];
            readonly default: "sentiment";
        };
        readonly settings: {
            readonly type: "object";
            readonly properties: {
                readonly label: {
                    readonly type: "string";
                };
                readonly submitText: {
                    readonly type: "string";
                };
                readonly buttonText: {
                    readonly type: "string";
                };
                readonly component: {
                    readonly type: "string";
                    readonly enum: readonly ["radio", "checkbox"];
                    readonly default: "checkbox";
                };
                readonly items: {
                    readonly type: "array";
                    readonly items: {
                        readonly type: "string";
                    };
                    readonly minItems: 1;
                };
                readonly leftScaleLabel: {
                    readonly type: "string";
                };
                readonly rightScaleLabel: {
                    readonly type: "string";
                };
                readonly reasons: {
                    readonly type: "object";
                    readonly properties: {
                        readonly like: {
                            readonly type: "object";
                            readonly properties: {
                                readonly hide: {
                                    readonly type: "boolean";
                                    readonly default: false;
                                };
                                readonly component: {
                                    readonly type: "string";
                                    readonly enum: readonly ["radio", "checkbox"];
                                    readonly default: "checkbox";
                                };
                                readonly label: {
                                    readonly type: "string";
                                };
                                readonly items: {
                                    readonly type: "array";
                                    readonly items: {
                                        readonly type: "string";
                                    };
                                };
                            };
                            readonly additionalProperties: false;
                        };
                        readonly dislike: {
                            readonly type: "object";
                            readonly properties: {
                                readonly hide: {
                                    readonly type: "boolean";
                                    readonly default: false;
                                };
                                readonly component: {
                                    readonly type: "string";
                                    readonly enum: readonly ["radio", "checkbox"];
                                    readonly default: "checkbox";
                                };
                                readonly label: {
                                    readonly type: "string";
                                };
                                readonly items: {
                                    readonly type: "array";
                                    readonly items: {
                                        readonly type: "string";
                                    };
                                };
                            };
                            readonly additionalProperties: false;
                        };
                        readonly satisfied: {
                            readonly type: "object";
                            readonly properties: {
                                readonly hide: {
                                    readonly type: "boolean";
                                    readonly default: false;
                                };
                                readonly component: {
                                    readonly type: "string";
                                    readonly enum: readonly ["radio", "checkbox"];
                                    readonly default: "checkbox";
                                };
                                readonly label: {
                                    readonly type: "string";
                                };
                                readonly items: {
                                    readonly type: "array";
                                    readonly items: {
                                        readonly type: "string";
                                    };
                                };
                            };
                            readonly additionalProperties: false;
                        };
                        readonly neutral: {
                            readonly type: "object";
                            readonly properties: {
                                readonly hide: {
                                    readonly type: "boolean";
                                    readonly default: false;
                                };
                                readonly component: {
                                    readonly type: "string";
                                    readonly enum: readonly ["radio", "checkbox"];
                                    readonly default: "checkbox";
                                };
                                readonly label: {
                                    readonly type: "string";
                                };
                                readonly items: {
                                    readonly type: "array";
                                    readonly items: {
                                        readonly type: "string";
                                    };
                                };
                            };
                            readonly additionalProperties: false;
                        };
                        readonly dissatisfied: {
                            readonly type: "object";
                            readonly properties: {
                                readonly hide: {
                                    readonly type: "boolean";
                                    readonly default: false;
                                };
                                readonly component: {
                                    readonly type: "string";
                                    readonly enum: readonly ["radio", "checkbox"];
                                    readonly default: "checkbox";
                                };
                                readonly label: {
                                    readonly type: "string";
                                };
                                readonly items: {
                                    readonly type: "array";
                                    readonly items: {
                                        readonly type: "string";
                                    };
                                };
                            };
                            readonly additionalProperties: false;
                        };
                        readonly hide: {
                            readonly type: "boolean";
                            readonly default: false;
                        };
                        readonly component: {
                            readonly type: "string";
                            readonly enum: readonly ["radio", "checkbox"];
                            readonly default: "checkbox";
                        };
                        readonly label: {
                            readonly type: "string";
                        };
                        readonly items: {
                            readonly type: "array";
                            readonly items: {
                                readonly type: "string";
                            };
                        };
                    };
                    readonly additionalProperties: false;
                };
                readonly comment: {
                    readonly type: "object";
                    readonly properties: {
                        readonly hide: {
                            readonly type: "boolean";
                            readonly default: false;
                        };
                        readonly label: {
                            readonly type: "string";
                        };
                        readonly likeLabel: {
                            readonly type: "string";
                        };
                        readonly dislikeLabel: {
                            readonly type: "string";
                        };
                        readonly satisfiedLabel: {
                            readonly type: "string";
                        };
                        readonly neutralLabel: {
                            readonly type: "string";
                        };
                        readonly dissatisfiedLabel: {
                            readonly type: "string";
                        };
                    };
                    readonly additionalProperties: false;
                };
            };
            readonly additionalProperties: false;
        };
    };
    readonly additionalProperties: false;
};
