import type { FromSchema } from 'json-schema-to-ts';
export declare const deprecatedRefDocsSchema: {
    readonly type: "object";
    readonly properties: {
        readonly theme: {
            readonly type: "object";
            readonly properties: {
                readonly breakpoints: {
                    readonly type: "object";
                    readonly properties: {
                        readonly small: {
                            readonly type: "string";
                        };
                        readonly medium: {
                            readonly type: "string";
                        };
                        readonly large: {
                            readonly type: "string";
                        };
                    };
                };
                readonly codeBlock: {
                    readonly type: "object";
                    readonly properties: {
                        readonly backgroundColor: {
                            readonly type: "string";
                        };
                        readonly borderRadius: {
                            readonly type: "string";
                        };
                        readonly tokens: {
                            readonly type: "object";
                            readonly properties: {
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                                readonly color: {
                                    readonly type: "string";
                                };
                            };
                        };
                    };
                };
                readonly colors: {
                    readonly type: "object";
                    readonly properties: {
                        readonly accent: {
                            readonly type: "object";
                            readonly properties: {
                                readonly main: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                                readonly dark: {
                                    readonly type: "string";
                                };
                                readonly contrastText: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly border: {
                            readonly type: "object";
                            readonly properties: {
                                readonly main: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                                readonly dark: {
                                    readonly type: "string";
                                };
                                readonly contrastText: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly error: {
                            readonly type: "object";
                            readonly properties: {
                                readonly main: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                                readonly dark: {
                                    readonly type: "string";
                                };
                                readonly contrastText: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly http: {
                            readonly type: "object";
                            readonly properties: {
                                readonly basic: {
                                    readonly type: "string";
                                };
                                readonly delete: {
                                    readonly type: "string";
                                };
                                readonly get: {
                                    readonly type: "string";
                                };
                                readonly head: {
                                    readonly type: "string";
                                };
                                readonly link: {
                                    readonly type: "string";
                                };
                                readonly options: {
                                    readonly type: "string";
                                };
                                readonly patch: {
                                    readonly type: "string";
                                };
                                readonly post: {
                                    readonly type: "string";
                                };
                                readonly put: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly primary: {
                            readonly type: "object";
                            readonly properties: {
                                readonly main: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                                readonly dark: {
                                    readonly type: "string";
                                };
                                readonly contrastText: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly responses: {
                            readonly type: "object";
                            readonly properties: {
                                readonly error: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly backgroundColor: {
                                            readonly type: "string";
                                        };
                                        readonly borderColor: {
                                            readonly type: "string";
                                        };
                                        readonly color: {
                                            readonly type: "string";
                                        };
                                        readonly tabTextColor: {
                                            readonly type: "string";
                                        };
                                    };
                                };
                                readonly info: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly backgroundColor: {
                                            readonly type: "string";
                                        };
                                        readonly borderColor: {
                                            readonly type: "string";
                                        };
                                        readonly color: {
                                            readonly type: "string";
                                        };
                                        readonly tabTextColor: {
                                            readonly type: "string";
                                        };
                                    };
                                };
                                readonly redirect: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly backgroundColor: {
                                            readonly type: "string";
                                        };
                                        readonly borderColor: {
                                            readonly type: "string";
                                        };
                                        readonly color: {
                                            readonly type: "string";
                                        };
                                        readonly tabTextColor: {
                                            readonly type: "string";
                                        };
                                    };
                                };
                                readonly success: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly backgroundColor: {
                                            readonly type: "string";
                                        };
                                        readonly borderColor: {
                                            readonly type: "string";
                                        };
                                        readonly color: {
                                            readonly type: "string";
                                        };
                                        readonly tabTextColor: {
                                            readonly type: "string";
                                        };
                                    };
                                };
                            };
                        };
                        readonly secondary: {
                            readonly type: "object";
                            readonly properties: {
                                readonly main: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                                readonly dark: {
                                    readonly type: "string";
                                };
                                readonly contrastText: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly success: {
                            readonly type: "object";
                            readonly properties: {
                                readonly main: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                                readonly dark: {
                                    readonly type: "string";
                                };
                                readonly contrastText: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly text: {
                            readonly type: "object";
                            readonly properties: {
                                readonly primary: {
                                    readonly type: "string";
                                };
                                readonly secondary: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly tonalOffset: {
                            readonly type: "number";
                        };
                        readonly warning: {
                            readonly type: "object";
                            readonly properties: {
                                readonly main: {
                                    readonly type: "string";
                                };
                                readonly light: {
                                    readonly type: "string";
                                };
                                readonly dark: {
                                    readonly type: "string";
                                };
                                readonly contrastText: {
                                    readonly type: "string";
                                };
                            };
                        };
                    };
                };
                readonly components: {
                    readonly type: "object";
                    readonly properties: {
                        readonly buttons: {
                            readonly type: "object";
                            readonly properties: {
                                readonly borderRadius: {
                                    readonly type: "string";
                                };
                                readonly hoverStyle: {
                                    readonly type: "string";
                                };
                                readonly boxShadow: {
                                    readonly type: "string";
                                };
                                readonly hoverBoxShadow: {
                                    readonly type: "string";
                                };
                                readonly sizes: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly small: {
                                            readonly type: "object";
                                            readonly properties: {
                                                readonly fontSize: {
                                                    readonly type: "string";
                                                };
                                                readonly padding: {
                                                    readonly type: "string";
                                                };
                                                readonly minWidth: {
                                                    readonly type: "string";
                                                };
                                            };
                                        };
                                        readonly medium: {
                                            readonly type: "object";
                                            readonly properties: {
                                                readonly fontSize: {
                                                    readonly type: "string";
                                                };
                                                readonly padding: {
                                                    readonly type: "string";
                                                };
                                                readonly minWidth: {
                                                    readonly type: "string";
                                                };
                                            };
                                        };
                                        readonly large: {
                                            readonly type: "object";
                                            readonly properties: {
                                                readonly fontSize: {
                                                    readonly type: "string";
                                                };
                                                readonly padding: {
                                                    readonly type: "string";
                                                };
                                                readonly minWidth: {
                                                    readonly type: "string";
                                                };
                                            };
                                        };
                                        readonly xlarge: {
                                            readonly type: "object";
                                            readonly properties: {
                                                readonly fontSize: {
                                                    readonly type: "string";
                                                };
                                                readonly padding: {
                                                    readonly type: "string";
                                                };
                                                readonly minWidth: {
                                                    readonly type: "string";
                                                };
                                            };
                                        };
                                    };
                                };
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly httpBadges: {
                            readonly type: "object";
                            readonly properties: {
                                readonly borderRadius: {
                                    readonly type: "string";
                                };
                                readonly color: {
                                    readonly type: "string";
                                };
                                readonly sizes: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly medium: {
                                            readonly type: "object";
                                            readonly properties: {
                                                readonly fontFamily: {
                                                    readonly type: "string";
                                                };
                                                readonly fontSize: {
                                                    readonly type: "string";
                                                };
                                                readonly fontWeight: {
                                                    readonly type: "string";
                                                };
                                                readonly lineHeight: {
                                                    readonly type: "string";
                                                };
                                            };
                                        };
                                        readonly small: {
                                            readonly type: "object";
                                            readonly properties: {
                                                readonly fontFamily: {
                                                    readonly type: "string";
                                                };
                                                readonly fontSize: {
                                                    readonly type: "string";
                                                };
                                                readonly fontWeight: {
                                                    readonly type: "string";
                                                };
                                                readonly lineHeight: {
                                                    readonly type: "string";
                                                };
                                            };
                                        };
                                    };
                                };
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly layoutControls: {
                            readonly type: "object";
                            readonly properties: {
                                readonly top: {
                                    readonly type: "string";
                                };
                                readonly width: {
                                    readonly type: "string";
                                };
                                readonly height: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly panels: {
                            readonly type: "object";
                            readonly properties: {
                                readonly borderRadius: {
                                    readonly type: "string";
                                };
                                readonly backgroundColor: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly tryItButton: {
                            readonly type: "object";
                            readonly properties: {
                                readonly fullWidth: {
                                    readonly type: "boolean";
                                };
                            };
                        };
                        readonly tryItSendButton: {
                            readonly type: "object";
                            readonly properties: {
                                readonly fullWidth: {
                                    readonly type: "boolean";
                                };
                            };
                        };
                    };
                };
                readonly layout: {
                    readonly type: "object";
                    readonly properties: {
                        readonly showDarkRightPanel: {
                            readonly type: "boolean";
                        };
                        readonly stacked: {
                            readonly type: "object";
                            readonly properties: {
                                readonly maxWidth: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly small: {
                                            readonly type: "string";
                                        };
                                        readonly medium: {
                                            readonly type: "string";
                                        };
                                        readonly large: {
                                            readonly type: "string";
                                        };
                                    };
                                };
                            };
                        };
                        readonly 'three-panel': {
                            readonly type: "object";
                            readonly properties: {
                                readonly maxWidth: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly small: {
                                            readonly type: "string";
                                        };
                                        readonly medium: {
                                            readonly type: "string";
                                        };
                                        readonly large: {
                                            readonly type: "string";
                                        };
                                    };
                                };
                                readonly middlePanelMaxWidth: {
                                    readonly type: "object";
                                    readonly properties: {
                                        readonly small: {
                                            readonly type: "string";
                                        };
                                        readonly medium: {
                                            readonly type: "string";
                                        };
                                        readonly large: {
                                            readonly type: "string";
                                        };
                                    };
                                };
                            };
                        };
                    };
                };
                readonly logo: {
                    readonly type: "object";
                    readonly properties: {
                        readonly gutter: {
                            readonly type: "string";
                        };
                        readonly maxHeight: {
                            readonly type: "string";
                        };
                        readonly maxWidth: {
                            readonly type: "string";
                        };
                    };
                };
                readonly fab: {
                    readonly type: "object";
                    readonly properties: {
                        readonly backgroundColor: {
                            readonly type: "string";
                        };
                        readonly color: {
                            readonly type: "string";
                        };
                    };
                };
                readonly overrides: {
                    readonly type: "object";
                    readonly properties: {
                        readonly DownloadButton: {
                            readonly type: "object";
                            readonly properties: {
                                readonly custom: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly NextSectionButton: {
                            readonly type: "object";
                            readonly properties: {
                                readonly custom: {
                                    readonly type: "string";
                                };
                            };
                        };
                    };
                };
                readonly rightPanel: {
                    readonly type: "object";
                    readonly properties: {
                        readonly backgroundColor: {
                            readonly type: "string";
                        };
                        readonly panelBackgroundColor: {
                            readonly type: "string";
                        };
                        readonly panelControlsBackgroundColor: {
                            readonly type: "string";
                        };
                        readonly showAtBreakpoint: {
                            readonly type: "string";
                        };
                        readonly textColor: {
                            readonly type: "string";
                        };
                        readonly width: {
                            readonly type: "string";
                        };
                    };
                };
                readonly schema: {
                    readonly type: "object";
                    readonly properties: {
                        readonly breakFieldNames: {
                            readonly type: "boolean";
                        };
                        readonly caretColor: {
                            readonly type: "string";
                        };
                        readonly caretSize: {
                            readonly type: "string";
                        };
                        readonly constraints: {
                            readonly type: "object";
                            readonly properties: {
                                readonly backgroundColor: {
                                    readonly type: "string";
                                };
                                readonly border: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly defaultDetailsWidth: {
                            readonly type: "string";
                        };
                        readonly examples: {
                            readonly type: "object";
                            readonly properties: {
                                readonly backgroundColor: {
                                    readonly type: "string";
                                };
                                readonly border: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly labelsTextSize: {
                            readonly type: "string";
                        };
                        readonly linesColor: {
                            readonly type: "string";
                        };
                        readonly nestedBackground: {
                            readonly type: "string";
                        };
                        readonly nestingSpacing: {
                            readonly type: "string";
                        };
                        readonly requireLabelColor: {
                            readonly type: "string";
                        };
                        readonly typeNameColor: {
                            readonly type: "string";
                        };
                        readonly typeTitleColor: {
                            readonly type: "string";
                        };
                    };
                };
                readonly shape: {
                    readonly type: "object";
                    readonly properties: {
                        readonly borderRadius: {
                            readonly type: "string";
                        };
                    };
                };
                readonly sidebar: {
                    readonly type: "object";
                    readonly properties: {
                        readonly activeBgColor: {
                            readonly type: "string";
                        };
                        readonly activeTextColor: {
                            readonly type: "string";
                        };
                        readonly backgroundColor: {
                            readonly type: "string";
                        };
                        readonly borderRadius: {
                            readonly type: "string";
                        };
                        readonly breakPath: {
                            readonly type: "boolean";
                        };
                        readonly caretColor: {
                            readonly type: "string";
                        };
                        readonly caretSize: {
                            readonly type: "string";
                        };
                        readonly groupItems: {
                            readonly type: "object";
                            readonly properties: {
                                readonly subItemsColor: {
                                    readonly type: "string";
                                };
                                readonly textTransform: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly level1items: {
                            readonly type: "object";
                            readonly properties: {
                                readonly subItemsColor: {
                                    readonly type: "string";
                                };
                                readonly textTransform: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly rightLineColor: {
                            readonly type: "string";
                        };
                        readonly separatorLabelColor: {
                            readonly type: "string";
                        };
                        readonly showAtBreakpoint: {
                            readonly type: "string";
                        };
                        readonly spacing: {
                            readonly type: "object";
                            readonly properties: {
                                readonly unit: {
                                    readonly type: "number";
                                };
                                readonly paddingHorizontal: {
                                    readonly type: "string";
                                };
                                readonly paddingVertical: {
                                    readonly type: "string";
                                };
                                readonly offsetTop: {
                                    readonly type: "string";
                                };
                                readonly offsetLeft: {
                                    readonly type: "string";
                                };
                                readonly offsetNesting: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly textColor: {
                            readonly type: "string";
                        };
                        readonly width: {
                            readonly type: "string";
                        };
                        readonly fontFamily: {
                            readonly type: "string";
                        };
                        readonly fontSize: {
                            readonly type: "string";
                        };
                        readonly fontWeight: {
                            readonly type: "string";
                        };
                        readonly lineHeight: {
                            readonly type: "string";
                        };
                    };
                };
                readonly spacing: {
                    readonly type: "object";
                    readonly properties: {
                        readonly sectionHorizontal: {
                            readonly type: "number";
                        };
                        readonly sectionVertical: {
                            readonly type: "number";
                        };
                        readonly unit: {
                            readonly type: "number";
                        };
                    };
                };
                readonly typography: {
                    readonly type: "object";
                    readonly properties: {
                        readonly fontWeightBold: {
                            readonly type: "string";
                        };
                        readonly fontWeightLight: {
                            readonly type: "string";
                        };
                        readonly fontWeightRegular: {
                            readonly type: "string";
                        };
                        readonly heading1: {
                            readonly type: "object";
                            readonly properties: {
                                readonly color: {
                                    readonly type: "string";
                                };
                                readonly transform: {
                                    readonly type: "string";
                                };
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly heading2: {
                            readonly type: "object";
                            readonly properties: {
                                readonly color: {
                                    readonly type: "string";
                                };
                                readonly transform: {
                                    readonly type: "string";
                                };
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly heading3: {
                            readonly type: "object";
                            readonly properties: {
                                readonly color: {
                                    readonly type: "string";
                                };
                                readonly transform: {
                                    readonly type: "string";
                                };
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly headings: {
                            readonly type: "object";
                            readonly properties: {
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly lineHeight: {
                            readonly type: "string";
                        };
                        readonly links: {
                            readonly type: "object";
                            readonly properties: {
                                readonly color: {
                                    readonly type: "string";
                                };
                                readonly hover: {
                                    readonly type: "string";
                                };
                                readonly textDecoration: {
                                    readonly type: "string";
                                };
                                readonly hoverTextDecoration: {
                                    readonly type: "string";
                                };
                                readonly visited: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly optimizeSpeed: {
                            readonly type: "boolean";
                        };
                        readonly rightPanelHeading: {
                            readonly type: "object";
                            readonly properties: {
                                readonly color: {
                                    readonly type: "string";
                                };
                                readonly transform: {
                                    readonly type: "string";
                                };
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly smoothing: {
                            readonly type: "string";
                            readonly enum: readonly ["auto", "none", "antialiased", "subpixel-antialiased", "grayscale"];
                        };
                        readonly fontFamily: {
                            readonly type: "string";
                        };
                        readonly fontSize: {
                            readonly type: "string";
                        };
                        readonly fontWeight: {
                            readonly type: "string";
                        };
                        readonly code: {
                            readonly type: "object";
                            readonly properties: {
                                readonly backgroundColor: {
                                    readonly type: "string";
                                };
                                readonly color: {
                                    readonly type: "string";
                                };
                                readonly wordBreak: {
                                    readonly type: "string";
                                    readonly enum: readonly ["break-all", "break-word", "keep-all", "normal", "revert", "unset", "inherit", "initial"];
                                };
                                readonly wrap: {
                                    readonly type: "boolean";
                                };
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                        readonly fieldName: {
                            readonly type: "object";
                            readonly properties: {
                                readonly fontFamily: {
                                    readonly type: "string";
                                };
                                readonly fontSize: {
                                    readonly type: "string";
                                };
                                readonly fontWeight: {
                                    readonly type: "string";
                                };
                                readonly lineHeight: {
                                    readonly type: "string";
                                };
                            };
                        };
                    };
                };
                readonly links: {
                    readonly properties: {
                        readonly color: {
                            readonly type: "string";
                        };
                    };
                };
                readonly codeSample: {
                    readonly properties: {
                        readonly backgroundColor: {
                            readonly type: "string";
                        };
                    };
                };
            };
        };
        readonly ctrlFHijack: {
            readonly type: "boolean";
        };
        readonly defaultSampleLanguage: {
            readonly type: "string";
        };
        readonly disableDeepLinks: {
            readonly type: "boolean";
        };
        readonly disableSearch: {
            readonly type: "boolean";
        };
        readonly disableSidebar: {
            readonly type: "boolean";
        };
        readonly downloadDefinitionUrl: {
            readonly type: "string";
        };
        readonly expandDefaultServerVariables: {
            readonly type: "boolean";
        };
        readonly enumSkipQuotes: {
            readonly type: "boolean";
        };
        readonly expandDefaultRequest: {
            readonly type: "boolean";
        };
        readonly expandDefaultResponse: {
            readonly type: "boolean";
        };
        readonly expandResponses: {
            readonly type: "string";
        };
        readonly expandSingleSchemaField: {
            readonly type: "boolean";
        };
        readonly generateCodeSamples: {
            readonly type: "object";
            readonly properties: {
                readonly skipOptionalParameters: {
                    readonly type: "boolean";
                };
                readonly languages: {
                    readonly type: "array";
                    readonly items: {
                        readonly type: "object";
                        readonly properties: {
                            readonly label: {
                                readonly type: "string";
                            };
                            readonly lang: {
                                readonly enum: readonly ["curl", "C#", "Go", "Java", "Java8+Apache", "JavaScript", "Node.js", "PHP", "Python", "R", "Ruby"];
                            };
                        };
                        readonly required: readonly ["lang"];
                    };
                };
            };
            readonly required: readonly ["languages"];
        };
        readonly generatedPayloadSamplesMaxDepth: {
            readonly type: "number";
        };
        readonly hideDownloadButton: {
            readonly type: "boolean";
        };
        readonly hideHostname: {
            readonly type: "boolean";
        };
        readonly hideInfoSection: {
            readonly type: "boolean";
        };
        readonly hideLogo: {
            readonly type: "boolean";
        };
        readonly hideRequestPayloadSample: {
            readonly type: "boolean";
        };
        readonly hideRightPanel: {
            readonly type: "boolean";
        };
        readonly hideSchemaPattern: {
            readonly type: "boolean";
        };
        readonly hideSingleRequestSampleTab: {
            readonly type: "boolean";
        };
        readonly hideSecuritySection: {
            readonly type: "boolean";
        };
        readonly hideTryItPanel: {
            readonly type: "boolean";
        };
        readonly hideFab: {
            readonly type: "boolean";
        };
        readonly hideOneOfDescription: {
            readonly type: "boolean";
        };
        readonly htmlTemplate: {
            readonly type: "string";
        };
        readonly jsonSampleExpandLevel: {
            readonly oneOf: readonly [{
                readonly type: "number";
                readonly minimum: 1;
            }, {
                readonly type: "string";
            }];
        };
        readonly labels: {
            readonly type: "object";
            readonly properties: {
                readonly enum: {
                    readonly type: "string";
                };
                readonly enumSingleValue: {
                    readonly type: "string";
                };
                readonly enumArray: {
                    readonly type: "string";
                };
                readonly default: {
                    readonly type: "string";
                };
                readonly deprecated: {
                    readonly type: "string";
                };
                readonly example: {
                    readonly type: "string";
                };
                readonly examples: {
                    readonly type: "string";
                };
                readonly nullable: {
                    readonly type: "string";
                };
                readonly recursive: {
                    readonly type: "string";
                };
                readonly arrayOf: {
                    readonly type: "string";
                };
                readonly webhook: {
                    readonly type: "string";
                };
                readonly authorizations: {
                    readonly type: "string";
                };
                readonly tryItAuthBasicUsername: {
                    readonly type: "string";
                };
                readonly tryItAuthBasicPassword: {
                    readonly type: "string";
                };
            };
        };
        readonly menuToggle: {
            readonly type: "boolean";
        };
        readonly nativeScrollbars: {
            readonly type: "boolean";
        };
        readonly noAutoAuth: {
            readonly type: "boolean";
        };
        readonly onDeepLinkClick: {
            readonly type: "object";
        };
        readonly pagination: {
            readonly enum: readonly ["none", "section", "item"];
        };
        readonly pathInMiddlePanel: {
            readonly type: "boolean";
        };
        readonly payloadSampleIdx: {
            readonly type: "number";
            readonly minimum: 0;
        };
        readonly requestInterceptor: {
            readonly type: "object";
        };
        readonly requiredPropsFirst: {
            readonly type: "boolean";
        };
        readonly routingStrategy: {
            readonly type: "string";
        };
        readonly samplesTabsMaxCount: {
            readonly type: "number";
        };
        readonly schemaExpansionLevel: {
            readonly oneOf: readonly [{
                readonly type: "number";
                readonly minimum: 0;
            }, {
                readonly type: "string";
            }];
        };
        readonly minCharacterLengthToInitSearch: {
            readonly type: "number";
            readonly minimum: 1;
        };
        readonly maxResponseHeadersToShowInTryIt: {
            readonly type: "number";
            readonly minimum: 0;
        };
        readonly scrollYOffset: {
            readonly oneOf: readonly [{
                readonly type: "number";
            }, {
                readonly type: "string";
            }];
        };
        readonly searchAutoExpand: {
            readonly type: "boolean";
        };
        readonly searchFieldLevelBoost: {
            readonly type: "number";
            readonly minimum: 0;
        };
        readonly searchMaxDepth: {
            readonly type: "number";
            readonly minimum: 1;
        };
        readonly searchMode: {
            readonly type: "string";
            readonly enum: readonly ["default", "path-only"];
        };
        readonly searchOperationTitleBoost: {
            readonly type: "number";
        };
        readonly searchTagTitleBoost: {
            readonly type: "number";
        };
        readonly sendXUserAgentInTryIt: {
            readonly type: "boolean";
        };
        readonly showChangeLayoutButton: {
            readonly type: "boolean";
        };
        readonly showConsole: {
            readonly type: "boolean";
        };
        readonly showNextButton: {
            readonly type: "boolean";
        };
        readonly showRightPanelToggle: {
            readonly type: "boolean";
        };
        readonly showSecuritySchemeType: {
            readonly type: "boolean";
        };
        readonly showWebhookVerb: {
            readonly type: "boolean";
        };
        readonly showObjectSchemaExamples: {
            readonly type: "boolean";
        };
        readonly disableTryItRequestUrlEncoding: {
            readonly type: "boolean";
        };
        readonly sidebarLinks: {
            readonly type: "object";
            readonly properties: {
                readonly beforeInfo: {
                    readonly type: "array";
                    readonly items: {
                        readonly type: "object";
                        readonly properties: {
                            readonly label: {
                                readonly type: "string";
                            };
                            readonly link: {
                                readonly type: "string";
                            };
                            readonly target: {
                                readonly type: "string";
                            };
                        };
                        readonly required: readonly ["label", "link"];
                    };
                };
                readonly end: {
                    readonly type: "array";
                    readonly items: {
                        readonly type: "object";
                        readonly properties: {
                            readonly label: {
                                readonly type: "string";
                            };
                            readonly link: {
                                readonly type: "string";
                            };
                            readonly target: {
                                readonly type: "string";
                            };
                        };
                        readonly required: readonly ["label", "link"];
                    };
                };
            };
        };
        readonly sideNavStyle: {
            readonly type: "string";
            readonly enum: readonly ["summary-only", "path-first", "id-only"];
        };
        readonly simpleOneOfTypeLabel: {
            readonly type: "boolean";
        };
        readonly sortEnumValuesAlphabetically: {
            readonly type: "boolean";
        };
        readonly sortOperationsAlphabetically: {
            readonly type: "boolean";
        };
        readonly sortPropsAlphabetically: {
            readonly type: "boolean";
        };
        readonly sortTagsAlphabetically: {
            readonly type: "boolean";
        };
        readonly suppressWarnings: {
            readonly type: "boolean";
        };
        readonly unstable_externalDescription: {
            readonly type: "boolean";
        };
        readonly unstable_ignoreMimeParameters: {
            readonly type: "boolean";
        };
        readonly untrustedDefinition: {
            readonly type: "boolean";
        };
        readonly showAccessMode: {
            readonly type: "boolean";
        };
        readonly preserveOriginalExtensionsName: {
            readonly type: "boolean";
        };
        readonly markdownHeadingsAnchorLevel: {
            readonly type: "number";
        };
    };
    readonly additionalProperties: false;
};
export type DeprecatedRefDocsConfig = FromSchema<typeof deprecatedRefDocsSchema>;
