import SVGElement from '../svg-element/SVGElement.js';
import SVGStringList from '../../svg/SVGStringList.js';
import * as PropertySymbol from '../../PropertySymbol.js';
import Event from '../../event/Event.js';
/**
 * SVG Animation Element.
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/API/SVGAnimationElement
 */
export default class SVGAnimationElement extends SVGElement {
    [PropertySymbol.requiredExtensions]: SVGStringList | null;
    [PropertySymbol.systemLanguage]: SVGStringList | null;
    onbegin: ((event: Event) => void) | null;
    onend: ((event: Event) => void) | null;
    onrepeat: ((event: Event) => void) | null;
    /**
     * Returns required extensions.
     *
     * @returns Required extensions.
     */
    get requiredExtensions(): SVGStringList;
    /**
     * Returns system language.
     *
     * @returns System language.
     */
    get systemLanguage(): SVGStringList;
    /**
     * Returns target element.
     *
     * @returns Target element.
     */
    get targetElement(): SVGElement | null;
}
//# sourceMappingURL=SVGAnimationElement.d.ts.map