/**
 * vis-data
 * http://visjs.org/
 *
 * Manage unstructured data using DataSet. Add, update, and remove data, and listen for changes in the data.
 *
 * @version 7.1.9
 * @date    2023-11-24T17:53:34.179Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */function yu(r,n){if(!(r instanceof n))throw new TypeError("Cannot call a class as a function")}var bl=typeof globalThis<"u"?globalThis:typeof window<"u"?window:typeof global<"u"?global:typeof self<"u"?self:{};function G(r){return r&&r.__esModule&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r}var z$={exports:{}},zo=function(r){return r&&r.Math===Math&&r},ve=zo(typeof globalThis=="object"&&globalThis)||zo(typeof window=="object"&&window)||zo(typeof self=="object"&&self)||zo(typeof bl=="object"&&bl)||function(){return this}()||bl||Function("return this")(),ne=function(r){try{return!!r()}catch{return!0}},UO=ne,qa=!UO(function(){var r=function(){}.bind();return typeof r!="function"||r.hasOwnProperty("prototype")}),VO=qa,H$=Function.prototype,Tv=H$.apply,Pv=H$.call,Nn=typeof Reflect=="object"&&Reflect.apply||(VO?Pv.bind(Tv):function(){return Pv.apply(Tv,arguments)}),W$=qa,U$=Function.prototype,Rd=U$.call,GO=W$&&U$.bind.bind(Rd,Rd),fe=W$?GO:function(r){return function(){return Rd.apply(r,arguments)}},V$=fe,KO=V$({}.toString),qO=V$("".slice),Qr=function(r){return qO(KO(r),8,-1)},YO=Qr,XO=fe,G$=function(r){if(YO(r)==="Function")return XO(r)},Dd=typeof document=="object"&&document.all,QO=typeof Dd>"u"&&Dd!==void 0,K$={all:Dd,IS_HTMLDDA:QO},q$=K$,JO=q$.all,$e=q$.IS_HTMLDDA?function(r){return typeof r=="function"||r===JO}:function(r){return typeof r=="function"},Ai={},ZO=ne,Le=!ZO(function(){return Object.defineProperty({},1,{get:function(){return 7}})[1]!==7}),eT=qa,Ho=Function.prototype.call,je=eT?Ho.bind(Ho):function(){return Ho.apply(Ho,arguments)},gu={},Y$={}.propertyIsEnumerable,X$=Object.getOwnPropertyDescriptor,tT=X$&&!Y$.call({1:2},1);gu.f=tT?function(n){var e=X$(this,n);return!!e&&e.enumerable}:Y$;var Ri=function(r,n){return{enumerable:!(r&1),configurable:!(r&2),writable:!(r&4),value:n}},rT=fe,iT=ne,nT=Qr,$l=Object,aT=rT("".split),mu=iT(function(){return!$l("z").propertyIsEnumerable(0)})?function(r){return nT(r)==="String"?aT(r,""):$l(r)}:$l,Fn=function(r){return r==null},oT=Fn,sT=TypeError,Kc=function(r){if(oT(r))throw new sT("Can't call method on "+r);return r},uT=mu,lT=Kc,ur=function(r){return uT(lT(r))},Iv=$e,Q$=K$,hT=Q$.all,Xe=Q$.IS_HTMLDDA?function(r){return typeof r=="object"?r!==null:Iv(r)||r===hT}:function(r){return typeof r=="object"?r!==null:Iv(r)},pe={},wl=pe,_l=ve,dT=$e,kv=function(r){return dT(r)?r:void 0},lt=function(r,n){return arguments.length<2?kv(wl[r])||kv(_l[r]):wl[r]&&wl[r][n]||_l[r]&&_l[r][n]},cT=fe,De=cT({}.isPrototypeOf),Jr=typeof navigator<"u"&&String(navigator.userAgent)||"",J$=ve,El=Jr,Cv=J$.process,xv=J$.Deno,Av=Cv&&Cv.versions||xv&&xv.version,Rv=Av&&Av.v8,Ut,Us;Rv&&(Ut=Rv.split("."),Us=Ut[0]>0&&Ut[0]<4?1:+(Ut[0]+Ut[1]));!Us&&El&&(Ut=El.match(/Edge\/(\d+)/),(!Ut||Ut[1]>=74)&&(Ut=El.match(/Chrome\/(\d+)/),Ut&&(Us=+Ut[1])));var Bn=Us,Dv=Bn,fT=ne,vT=ve,pT=vT.String,Ln=!!Object.getOwnPropertySymbols&&!fT(function(){var r=Symbol("symbol detection");return!pT(r)||!(Object(r)instanceof Symbol)||!Symbol.sham&&Dv&&Dv<41}),yT=Ln,Z$=yT&&!Symbol.sham&&typeof Symbol.iterator=="symbol",gT=lt,mT=$e,bT=De,$T=Z$,wT=Object,Ya=$T?function(r){return typeof r=="symbol"}:function(r){var n=gT("Symbol");return mT(n)&&bT(n.prototype,wT(r))},_T=String,jn=function(r){try{return _T(r)}catch{return"Object"}},ET=$e,ST=jn,OT=TypeError,$t=function(r){if(ET(r))return r;throw new OT(ST(r)+" is not a function")},TT=$t,PT=Fn,qc=function(r,n){var e=r[n];return PT(e)?void 0:TT(e)},Sl=je,Ol=$e,Tl=Xe,IT=TypeError,kT=function(r,n){var e,t;if(n==="string"&&Ol(e=r.toString)&&!Tl(t=Sl(e,r))||Ol(e=r.valueOf)&&!Tl(t=Sl(e,r))||n!=="string"&&Ol(e=r.toString)&&!Tl(t=Sl(e,r)))return t;throw new IT("Can't convert object to primitive value")},e1={exports:{}},CT=!0,Mv=ve,xT=Object.defineProperty,AT=function(r,n){try{xT(Mv,r,{value:n,configurable:!0,writable:!0})}catch{Mv[r]=n}return n},RT=ve,DT=AT,Nv="__core-js_shared__",MT=RT[Nv]||DT(Nv,{}),Yc=MT,Fv=Yc;(e1.exports=function(r,n){return Fv[r]||(Fv[r]=n!==void 0?n:{})})("versions",[]).push({version:"3.33.2",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.33.2/LICENSE",source:"https://github.com/zloirock/core-js"});var zn=e1.exports,NT=Kc,FT=Object,wt=function(r){return FT(NT(r))},BT=fe,LT=wt,jT=BT({}.hasOwnProperty),Me=Object.hasOwn||function(n,e){return jT(LT(n),e)},zT=fe,HT=0,WT=Math.random(),UT=zT(1 .toString),bu=function(r){return"Symbol("+(r===void 0?"":r)+")_"+UT(++HT+WT,36)},VT=ve,GT=zn,Bv=Me,KT=bu,qT=Ln,YT=Z$,on=VT.Symbol,Pl=GT("wks"),XT=YT?on.for||on:on&&on.withoutSetter||KT,ge=function(r){return Bv(Pl,r)||(Pl[r]=qT&&Bv(on,r)?on[r]:XT("Symbol."+r)),Pl[r]},QT=je,Lv=Xe,jv=Ya,JT=qc,ZT=kT,eP=ge,tP=TypeError,rP=eP("toPrimitive"),iP=function(r,n){if(!Lv(r)||jv(r))return r;var e=JT(r,rP),t;if(e){if(n===void 0&&(n="default"),t=QT(e,r,n),!Lv(t)||jv(t))return t;throw new tP("Can't convert object to primitive value")}return n===void 0&&(n="number"),ZT(r,n)},nP=iP,aP=Ya,$u=function(r){var n=nP(r,"string");return aP(n)?n:n+""},oP=ve,zv=Xe,Md=oP.document,sP=zv(Md)&&zv(Md.createElement),Xc=function(r){return sP?Md.createElement(r):{}},uP=Le,lP=ne,hP=Xc,t1=!uP&&!lP(function(){return Object.defineProperty(hP("div"),"a",{get:function(){return 7}}).a!==7}),dP=Le,cP=je,fP=gu,vP=Ri,pP=ur,yP=$u,gP=Me,mP=t1,Hv=Object.getOwnPropertyDescriptor;Ai.f=dP?Hv:function(n,e){if(n=pP(n),e=yP(e),mP)try{return Hv(n,e)}catch{}if(gP(n,e))return vP(!cP(fP.f,n,e),n[e])};var bP=ne,$P=$e,wP=/#|\.prototype\./,Xa=function(r,n){var e=EP[_P(r)];return e===OP?!0:e===SP?!1:$P(n)?bP(n):!!n},_P=Xa.normalize=function(r){return String(r).replace(wP,".").toLowerCase()},EP=Xa.data={},SP=Xa.NATIVE="N",OP=Xa.POLYFILL="P",r1=Xa,Wv=G$,TP=$t,PP=qa,IP=Wv(Wv.bind),Zr=function(r,n){return TP(r),n===void 0?r:PP?IP(r,n):function(){return r.apply(n,arguments)}},_t={},kP=Le,CP=ne,i1=kP&&CP(function(){return Object.defineProperty(function(){},"prototype",{value:42,writable:!1}).prototype!==42}),xP=Xe,AP=String,RP=TypeError,Ct=function(r){if(xP(r))return r;throw new RP(AP(r)+" is not an object")},DP=Le,MP=t1,NP=i1,Wo=Ct,Uv=$u,FP=TypeError,Il=Object.defineProperty,BP=Object.getOwnPropertyDescriptor,kl="enumerable",Cl="configurable",xl="writable";_t.f=DP?NP?function(n,e,t){if(Wo(n),e=Uv(e),Wo(t),typeof n=="function"&&e==="prototype"&&"value"in t&&xl in t&&!t[xl]){var i=BP(n,e);i&&i[xl]&&(n[e]=t.value,t={configurable:Cl in t?t[Cl]:i[Cl],enumerable:kl in t?t[kl]:i[kl],writable:!1})}return Il(n,e,t)}:Il:function(n,e,t){if(Wo(n),e=Uv(e),Wo(t),MP)try{return Il(n,e,t)}catch{}if("get"in t||"set"in t)throw new FP("Accessors not supported");return"value"in t&&(n[e]=t.value),n};var LP=Le,jP=_t,zP=Ri,Pr=LP?function(r,n,e){return jP.f(r,n,zP(1,e))}:function(r,n,e){return r[n]=e,r},Uo=ve,HP=Nn,WP=G$,UP=$e,VP=Ai.f,GP=r1,Ki=pe,KP=Zr,qi=Pr,Vv=Me,qP=function(r){var n=function(e,t,i){if(this instanceof n){switch(arguments.length){case 0:return new r;case 1:return new r(e);case 2:return new r(e,t)}return new r(e,t,i)}return HP(r,this,arguments)};return n.prototype=r.prototype,n},H=function(r,n){var e=r.target,t=r.global,i=r.stat,a=r.proto,o=t?Uo:i?Uo[e]:(Uo[e]||{}).prototype,s=t?Ki:Ki[e]||qi(Ki,e,{})[e],u=s.prototype,l,h,d,c,f,v,p,y,g;for(c in n)l=GP(t?c:e+(i?".":"#")+c,r.forced),h=!l&&o&&Vv(o,c),v=s[c],h&&(r.dontCallGetSet?(g=VP(o,c),p=g&&g.value):p=o[c]),f=h&&p?p:n[c],!(h&&typeof v==typeof f)&&(r.bind&&h?y=KP(f,Uo):r.wrap&&h?y=qP(f):a&&UP(f)?y=WP(f):y=f,(r.sham||f&&f.sham||v&&v.sham)&&qi(y,"sham",!0),qi(s,c,y),a&&(d=e+"Prototype",Vv(Ki,d)||qi(Ki,d,{}),qi(Ki[d],c,f),r.real&&u&&(l||!u[c])&&qi(u,c,f)))},YP=H,XP=Le,Gv=_t.f;YP({target:"Object",stat:!0,forced:Object.defineProperty!==Gv,sham:!XP},{defineProperty:Gv});var QP=pe,n1=QP.Object,JP=z$.exports=function(n,e,t){return n1.defineProperty(n,e,t)};n1.defineProperty.sham&&(JP.sham=!0);var ZP=z$.exports,eI=ZP,a1=eI,tI=a1,rI=tI,iI=rI,nI=iI,o1=nI,wu=G(o1),aI=Qr,ei=Array.isArray||function(n){return aI(n)==="Array"},oI=Math.ceil,sI=Math.floor,uI=Math.trunc||function(n){var e=+n;return(e>0?sI:oI)(e)},lI=uI,_u=function(r){var n=+r;return n!==n||n===0?0:lI(n)},hI=_u,dI=Math.min,cI=function(r){return r>0?dI(hI(r),9007199254740991):0},fI=cI,xt=function(r){return fI(r.length)},vI=TypeError,pI=9007199254740991,Eu=function(r){if(r>pI)throw vI("Maximum allowed index exceeded");return r},yI=$u,gI=_t,mI=Ri,Hn=function(r,n,e){var t=yI(n);t in r?gI.f(r,t,mI(0,e)):r[t]=e},bI=ge,$I=bI("toStringTag"),s1={};s1[$I]="z";var Qc=String(s1)==="[object z]",wI=Qc,_I=$e,Ts=Qr,EI=ge,SI=EI("toStringTag"),OI=Object,TI=Ts(function(){return arguments}())==="Arguments",PI=function(r,n){try{return r[n]}catch{}},Ir=wI?Ts:function(r){var n,e,t;return r===void 0?"Undefined":r===null?"Null":typeof(e=PI(n=OI(r),SI))=="string"?e:TI?Ts(n):(t=Ts(n))==="Object"&&_I(n.callee)?"Arguments":t},II=fe,kI=$e,Nd=Yc,CI=II(Function.toString);kI(Nd.inspectSource)||(Nd.inspectSource=function(r){return CI(r)});var u1=Nd.inspectSource,xI=fe,AI=ne,l1=$e,RI=Ir,DI=lt,MI=u1,h1=function(){},NI=[],d1=DI("Reflect","construct"),Jc=/^\s*(?:class|function)\b/,FI=xI(Jc.exec),BI=!Jc.test(h1),la=function(n){if(!l1(n))return!1;try{return d1(h1,NI,n),!0}catch{return!1}},c1=function(n){if(!l1(n))return!1;switch(RI(n)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return BI||!!FI(Jc,MI(n))}catch{return!0}};c1.sham=!0;var Su=!d1||AI(function(){var r;return la(la.call)||!la(Object)||!la(function(){r=!0})||r})?c1:la,Kv=ei,LI=Su,jI=Xe,zI=ge,HI=zI("species"),qv=Array,WI=function(r){var n;return Kv(r)&&(n=r.constructor,LI(n)&&(n===qv||Kv(n.prototype))?n=void 0:jI(n)&&(n=n[HI],n===null&&(n=void 0))),n===void 0?qv:n},UI=WI,Ou=function(r,n){return new(UI(r))(n===0?0:n)},VI=ne,GI=ge,KI=Bn,qI=GI("species"),Qa=function(r){return KI>=51||!VI(function(){var n=[],e=n.constructor={};return e[qI]=function(){return{foo:1}},n[r](Boolean).foo!==1})},YI=H,XI=ne,QI=ei,JI=Xe,ZI=wt,ek=xt,Yv=Eu,Xv=Hn,tk=Ou,rk=Qa,ik=ge,nk=Bn,f1=ik("isConcatSpreadable"),ak=nk>=51||!XI(function(){var r=[];return r[f1]=!1,r.concat()[0]!==r}),ok=function(r){if(!JI(r))return!1;var n=r[f1];return n!==void 0?!!n:QI(r)},sk=!ak||!rk("concat");YI({target:"Array",proto:!0,arity:1,forced:sk},{concat:function(n){var e=ZI(this),t=tk(e,0),i=0,a,o,s,u,l;for(a=-1,s=arguments.length;a<s;a++)if(l=a===-1?e:arguments[a],ok(l))for(u=ek(l),Yv(i+u),o=0;o<u;o++,i++)o in l&&Xv(t,i,l[o]);else Yv(i+1),Xv(t,i++,l);return t.length=i,t}});var uk=Ir,lk=String,Di=function(r){if(uk(r)==="Symbol")throw new TypeError("Cannot convert a Symbol value to a string");return lk(r)},Tu={},hk=_u,dk=Math.max,ck=Math.min,Pu=function(r,n){var e=hk(r);return e<0?dk(e+n,0):ck(e,n)},fk=ur,vk=Pu,pk=xt,Qv=function(r){return function(n,e,t){var i=fk(n),a=pk(i),o=vk(t,a),s;if(r&&e!==e){for(;a>o;)if(s=i[o++],s!==s)return!0}else for(;a>o;o++)if((r||o in i)&&i[o]===e)return r||o||0;return!r&&-1}},yk={includes:Qv(!0),indexOf:Qv(!1)},Ja={},gk=fe,Al=Me,mk=ur,bk=yk.indexOf,$k=Ja,Jv=gk([].push),v1=function(r,n){var e=mk(r),t=0,i=[],a;for(a in e)!Al($k,a)&&Al(e,a)&&Jv(i,a);for(;n.length>t;)Al(e,a=n[t++])&&(~bk(i,a)||Jv(i,a));return i},Zc=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],wk=v1,_k=Zc,Iu=Object.keys||function(n){return wk(n,_k)},Ek=Le,Sk=i1,Ok=_t,Tk=Ct,Pk=ur,Ik=Iu;Tu.f=Ek&&!Sk?Object.defineProperties:function(n,e){Tk(n);for(var t=Pk(e),i=Ik(e),a=i.length,o=0,s;a>o;)Ok.f(n,s=i[o++],t[s]);return n};var kk=lt,p1=kk("document","documentElement"),Ck=zn,xk=bu,Zv=Ck("keys"),ku=function(r){return Zv[r]||(Zv[r]=xk(r))},Ak=Ct,Rk=Tu,ep=Zc,Dk=Ja,Mk=p1,Nk=Xc,Fk=ku,tp=">",rp="<",Fd="prototype",Bd="script",y1=Fk("IE_PROTO"),Rl=function(){},g1=function(r){return rp+Bd+tp+r+rp+"/"+Bd+tp},ip=function(r){r.write(g1("")),r.close();var n=r.parentWindow.Object;return r=null,n},Bk=function(){var r=Nk("iframe"),n="java"+Bd+":",e;return r.style.display="none",Mk.appendChild(r),r.src=String(n),e=r.contentWindow.document,e.open(),e.write(g1("document.F=Object")),e.close(),e.F},Vo,Ps=function(){try{Vo=new ActiveXObject("htmlfile")}catch{}Ps=typeof document<"u"?document.domain&&Vo?ip(Vo):Bk():ip(Vo);for(var r=ep.length;r--;)delete Ps[Fd][ep[r]];return Ps()};Dk[y1]=!0;var Mi=Object.create||function(n,e){var t;return n!==null?(Rl[Fd]=Ak(n),t=new Rl,Rl[Fd]=null,t[y1]=n):t=Ps(),e===void 0?t:Rk.f(t,e)},Za={},Lk=v1,jk=Zc,zk=jk.concat("length","prototype");Za.f=Object.getOwnPropertyNames||function(n){return Lk(n,zk)};var ef={},np=Pu,Hk=xt,Wk=Hn,Uk=Array,Vk=Math.max,m1=function(r,n,e){for(var t=Hk(r),i=np(n,t),a=np(e===void 0?t:e,t),o=Uk(Vk(a-i,0)),s=0;i<a;i++,s++)Wk(o,s,r[i]);return o.length=s,o},Gk=Qr,Kk=ur,b1=Za.f,qk=m1,$1=typeof window=="object"&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Yk=function(r){try{return b1(r)}catch{return qk($1)}};ef.f=function(n){return $1&&Gk(n)==="Window"?Yk(n):b1(Kk(n))};var eo={};eo.f=Object.getOwnPropertySymbols;var Xk=Pr,Wn=function(r,n,e,t){return t&&t.enumerable?r[n]=e:Xk(r,n,e),r},Qk=_t,tf=function(r,n,e){return Qk.f(r,n,e)},to={},Jk=ge;to.f=Jk;var ap=pe,Zk=Me,eC=to,tC=_t.f,we=function(r){var n=ap.Symbol||(ap.Symbol={});Zk(n,r)||tC(n,r,{value:eC.f(r)})},rC=je,iC=lt,nC=ge,aC=Wn,w1=function(){var r=iC("Symbol"),n=r&&r.prototype,e=n&&n.valueOf,t=nC("toPrimitive");n&&!n[t]&&aC(n,t,function(i){return rC(e,this)},{arity:1})},oC=Qc,sC=Ir,uC=oC?{}.toString:function(){return"[object "+sC(this)+"]"},lC=Qc,hC=_t.f,dC=Pr,cC=Me,fC=uC,vC=ge,op=vC("toStringTag"),Ni=function(r,n,e,t){if(r){var i=e?r:r.prototype;cC(i,op)||hC(i,op,{configurable:!0,value:n}),t&&!lC&&dC(i,"toString",fC)}},pC=ve,yC=$e,sp=pC.WeakMap,gC=yC(sp)&&/native code/.test(String(sp)),mC=gC,_1=ve,bC=Xe,$C=Pr,Dl=Me,Ml=Yc,wC=ku,_C=Ja,up="Object already initialized",Ld=_1.TypeError,EC=_1.WeakMap,Vs,xa,Gs,SC=function(r){return Gs(r)?xa(r):Vs(r,{})},OC=function(r){return function(n){var e;if(!bC(n)||(e=xa(n)).type!==r)throw new Ld("Incompatible receiver, "+r+" required");return e}};if(mC||Ml.state){var Jt=Ml.state||(Ml.state=new EC);Jt.get=Jt.get,Jt.has=Jt.has,Jt.set=Jt.set,Vs=function(r,n){if(Jt.has(r))throw new Ld(up);return n.facade=r,Jt.set(r,n),n},xa=function(r){return Jt.get(r)||{}},Gs=function(r){return Jt.has(r)}}else{var Yi=wC("state");_C[Yi]=!0,Vs=function(r,n){if(Dl(r,Yi))throw new Ld(up);return n.facade=r,$C(r,Yi,n),n},xa=function(r){return Dl(r,Yi)?r[Yi]:{}},Gs=function(r){return Dl(r,Yi)}}var Un={set:Vs,get:xa,has:Gs,enforce:SC,getterFor:OC},TC=Zr,PC=fe,IC=mu,kC=wt,CC=xt,xC=Ou,lp=PC([].push),xr=function(r){var n=r===1,e=r===2,t=r===3,i=r===4,a=r===6,o=r===7,s=r===5||a;return function(u,l,h,d){for(var c=kC(u),f=IC(c),v=TC(l,h),p=CC(f),y=0,g=d||xC,m=n?g(u,p):e||o?g(u,0):void 0,w,$;p>y;y++)if((s||y in f)&&(w=f[y],$=v(w,y,c),r))if(n)m[y]=$;else if($)switch(r){case 3:return!0;case 5:return w;case 6:return y;case 2:lp(m,w)}else switch(r){case 4:return!1;case 7:lp(m,w)}return a?-1:t||i?i:m}},Vn={forEach:xr(0),map:xr(1),filter:xr(2),some:xr(3),every:xr(4),find:xr(5),findIndex:xr(6),filterReject:xr(7)},Cu=H,ro=ve,rf=je,AC=fe,_n=Le,En=Ln,RC=ne,Fe=Me,DC=De,jd=Ct,xu=ur,nf=$u,MC=Di,zd=Ri,Aa=Mi,E1=Iu,NC=Za,S1=ef,FC=eo,O1=Ai,T1=_t,BC=Tu,P1=gu,hp=Wn,LC=tf,af=zn,jC=ku,I1=Ja,dp=bu,zC=ge,HC=to,WC=we,UC=w1,VC=Ni,k1=Un,Au=Vn.forEach,vt=jC("hidden"),Ru="Symbol",Ra="prototype",GC=k1.set,cp=k1.getterFor(Ru),qt=Object[Ra],fi=ro.Symbol,ya=fi&&fi[Ra],KC=ro.RangeError,qC=ro.TypeError,Nl=ro.QObject,C1=O1.f,vi=T1.f,x1=S1.f,YC=P1.f,A1=AC([].push),Er=af("symbols"),io=af("op-symbols"),XC=af("wks"),Hd=!Nl||!Nl[Ra]||!Nl[Ra].findChild,R1=function(r,n,e){var t=C1(qt,n);t&&delete qt[n],vi(r,n,e),t&&r!==qt&&vi(qt,n,t)},Wd=_n&&RC(function(){return Aa(vi({},"a",{get:function(){return vi(this,"a",{value:7}).a}})).a!==7})?R1:vi,Fl=function(r,n){var e=Er[r]=Aa(ya);return GC(e,{type:Ru,tag:r,description:n}),_n||(e.description=n),e},Du=function(n,e,t){n===qt&&Du(io,e,t),jd(n);var i=nf(e);return jd(t),Fe(Er,i)?(t.enumerable?(Fe(n,vt)&&n[vt][i]&&(n[vt][i]=!1),t=Aa(t,{enumerable:zd(0,!1)})):(Fe(n,vt)||vi(n,vt,zd(1,{})),n[vt][i]=!0),Wd(n,i,t)):vi(n,i,t)},of=function(n,e){jd(n);var t=xu(e),i=E1(t).concat(F1(t));return Au(i,function(a){(!_n||rf(D1,t,a))&&Du(n,a,t[a])}),n},QC=function(n,e){return e===void 0?Aa(n):of(Aa(n),e)},D1=function(n){var e=nf(n),t=rf(YC,this,e);return this===qt&&Fe(Er,e)&&!Fe(io,e)?!1:t||!Fe(this,e)||!Fe(Er,e)||Fe(this,vt)&&this[vt][e]?t:!0},M1=function(n,e){var t=xu(n),i=nf(e);if(!(t===qt&&Fe(Er,i)&&!Fe(io,i))){var a=C1(t,i);return a&&Fe(Er,i)&&!(Fe(t,vt)&&t[vt][i])&&(a.enumerable=!0),a}},N1=function(n){var e=x1(xu(n)),t=[];return Au(e,function(i){!Fe(Er,i)&&!Fe(I1,i)&&A1(t,i)}),t},F1=function(r){var n=r===qt,e=x1(n?io:xu(r)),t=[];return Au(e,function(i){Fe(Er,i)&&(!n||Fe(qt,i))&&A1(t,Er[i])}),t};En||(fi=function(){if(DC(ya,this))throw new qC("Symbol is not a constructor");var n=!arguments.length||arguments[0]===void 0?void 0:MC(arguments[0]),e=dp(n),t=function(i){var a=this===void 0?ro:this;a===qt&&rf(t,io,i),Fe(a,vt)&&Fe(a[vt],e)&&(a[vt][e]=!1);var o=zd(1,i);try{Wd(a,e,o)}catch(s){if(!(s instanceof KC))throw s;R1(a,e,o)}};return _n&&Hd&&Wd(qt,e,{configurable:!0,set:t}),Fl(e,n)},ya=fi[Ra],hp(ya,"toString",function(){return cp(this).tag}),hp(fi,"withoutSetter",function(r){return Fl(dp(r),r)}),P1.f=D1,T1.f=Du,BC.f=of,O1.f=M1,NC.f=S1.f=N1,FC.f=F1,HC.f=function(r){return Fl(zC(r),r)},_n&&LC(ya,"description",{configurable:!0,get:function(){return cp(this).description}}));Cu({global:!0,constructor:!0,wrap:!0,forced:!En,sham:!En},{Symbol:fi});Au(E1(XC),function(r){WC(r)});Cu({target:Ru,stat:!0,forced:!En},{useSetter:function(){Hd=!0},useSimple:function(){Hd=!1}});Cu({target:"Object",stat:!0,forced:!En,sham:!_n},{create:QC,defineProperty:Du,defineProperties:of,getOwnPropertyDescriptor:M1});Cu({target:"Object",stat:!0,forced:!En},{getOwnPropertyNames:N1});UC();VC(fi,Ru);I1[vt]=!0;var JC=Ln,B1=JC&&!!Symbol.for&&!!Symbol.keyFor,ZC=H,ex=lt,tx=Me,rx=Di,L1=zn,ix=B1,Bl=L1("string-to-symbol-registry"),nx=L1("symbol-to-string-registry");ZC({target:"Symbol",stat:!0,forced:!ix},{for:function(r){var n=rx(r);if(tx(Bl,n))return Bl[n];var e=ex("Symbol")(n);return Bl[n]=e,nx[e]=n,e}});var ax=H,ox=Me,sx=Ya,ux=jn,lx=zn,hx=B1,fp=lx("symbol-to-string-registry");ax({target:"Symbol",stat:!0,forced:!hx},{keyFor:function(n){if(!sx(n))throw new TypeError(ux(n)+" is not a symbol");if(ox(fp,n))return fp[n]}});var dx=fe,no=dx([].slice),cx=fe,vp=ei,fx=$e,pp=Qr,vx=Di,yp=cx([].push),px=function(r){if(fx(r))return r;if(vp(r)){for(var n=r.length,e=[],t=0;t<n;t++){var i=r[t];typeof i=="string"?yp(e,i):(typeof i=="number"||pp(i)==="Number"||pp(i)==="String")&&yp(e,vx(i))}var a=e.length,o=!0;return function(s,u){if(o)return o=!1,u;if(vp(this))return u;for(var l=0;l<a;l++)if(e[l]===s)return u}}},yx=H,j1=lt,z1=Nn,gx=je,ao=fe,H1=ne,gp=$e,mp=Ya,W1=no,mx=px,bx=Ln,$x=String,jr=j1("JSON","stringify"),Go=ao(/./.exec),bp=ao("".charAt),wx=ao("".charCodeAt),_x=ao("".replace),Ex=ao(1 .toString),Sx=/[\uD800-\uDFFF]/g,$p=/^[\uD800-\uDBFF]$/,wp=/^[\uDC00-\uDFFF]$/,_p=!bx||H1(function(){var r=j1("Symbol")("stringify detection");return jr([r])!=="[null]"||jr({a:r})!=="{}"||jr(Object(r))!=="{}"}),Ep=H1(function(){return jr("\uDF06\uD834")!=='"\\udf06\\ud834"'||jr("\uDEAD")!=='"\\udead"'}),Ox=function(r,n){var e=W1(arguments),t=mx(n);if(!(!gp(t)&&(r===void 0||mp(r))))return e[1]=function(i,a){if(gp(t)&&(a=gx(t,this,$x(i),a)),!mp(a))return a},z1(jr,null,e)},Tx=function(r,n,e){var t=bp(e,n-1),i=bp(e,n+1);return Go($p,r)&&!Go(wp,i)||Go(wp,r)&&!Go($p,t)?"\\u"+Ex(wx(r,0),16):r};jr&&yx({target:"JSON",stat:!0,arity:3,forced:_p||Ep},{stringify:function(n,e,t){var i=W1(arguments),a=z1(_p?Ox:jr,null,i);return Ep&&typeof a=="string"?_x(a,Sx,Tx):a}});var Px=H,Ix=Ln,kx=ne,U1=eo,Cx=wt,xx=!Ix||kx(function(){U1.f(1)});Px({target:"Object",stat:!0,forced:xx},{getOwnPropertySymbols:function(n){var e=U1.f;return e?e(Cx(n)):[]}});var Ax=we;Ax("asyncIterator");var Rx=we;Rx("hasInstance");var Dx=we;Dx("isConcatSpreadable");var Mx=we;Mx("iterator");var Nx=we;Nx("match");var Fx=we;Fx("matchAll");var Bx=we;Bx("replace");var Lx=we;Lx("search");var jx=we;jx("species");var zx=we;zx("split");var Hx=we,Wx=w1;Hx("toPrimitive");Wx();var Ux=lt,Vx=we,Gx=Ni;Vx("toStringTag");Gx(Ux("Symbol"),"Symbol");var Kx=we;Kx("unscopables");var qx=ve,Yx=Ni;Yx(qx.JSON,"JSON",!0);var Xx=pe,Qx=Xx.Symbol,Gn={},Ud=Le,Jx=Me,V1=Function.prototype,Zx=Ud&&Object.getOwnPropertyDescriptor,sf=Jx(V1,"name"),eA=sf&&function(){}.name==="something",tA=sf&&(!Ud||Ud&&Zx(V1,"name").configurable),rA={EXISTS:sf,PROPER:eA,CONFIGURABLE:tA},iA=ne,G1=!iA(function(){function r(){}return r.prototype.constructor=null,Object.getPrototypeOf(new r)!==r.prototype}),nA=Me,aA=$e,oA=wt,sA=ku,uA=G1,Sp=sA("IE_PROTO"),Vd=Object,lA=Vd.prototype,Mu=uA?Vd.getPrototypeOf:function(r){var n=oA(r);if(nA(n,Sp))return n[Sp];var e=n.constructor;return aA(e)&&n instanceof e?e.prototype:n instanceof Vd?lA:null},hA=ne,dA=$e,cA=Xe,fA=Mi,Op=Mu,vA=Wn,pA=ge,Gd=pA("iterator"),K1=!1,vr,Ll,jl;[].keys&&(jl=[].keys(),"next"in jl?(Ll=Op(Op(jl)),Ll!==Object.prototype&&(vr=Ll)):K1=!0);var yA=!cA(vr)||hA(function(){var r={};return vr[Gd].call(r)!==r});yA?vr={}:vr=fA(vr);dA(vr[Gd])||vA(vr,Gd,function(){return this});var q1={IteratorPrototype:vr,BUGGY_SAFARI_ITERATORS:K1},gA=q1.IteratorPrototype,mA=Mi,bA=Ri,$A=Ni,wA=Gn,_A=function(){return this},EA=function(r,n,e,t){var i=n+" Iterator";return r.prototype=mA(gA,{next:bA(+!t,e)}),$A(r,i,!1,!0),wA[i]=_A,r},SA=fe,OA=$t,TA=function(r,n,e){try{return SA(OA(Object.getOwnPropertyDescriptor(r,n)[e]))}catch{}},PA=$e,IA=String,kA=TypeError,CA=function(r){if(typeof r=="object"||PA(r))return r;throw new kA("Can't set "+IA(r)+" as a prototype")},xA=TA,AA=Ct,RA=CA,Y1=Object.setPrototypeOf||("__proto__"in{}?function(){var r=!1,n={},e;try{e=xA(Object.prototype,"__proto__","set"),e(n,[]),r=n instanceof Array}catch{}return function(i,a){return AA(i),RA(a),r?e(i,a):i.__proto__=a,i}}():void 0),DA=H,MA=je,NA=rA,FA=EA,BA=Mu,LA=Ni,Tp=Wn,jA=ge,Pp=Gn,zA=q1,HA=NA.PROPER,Ko=zA.BUGGY_SAFARI_ITERATORS,zl=jA("iterator"),Ip="keys",qo="values",kp="entries",WA=function(){return this},uf=function(r,n,e,t,i,a,o){FA(e,n,t);var s=function(g){if(g===i&&c)return c;if(!Ko&&g&&g in h)return h[g];switch(g){case Ip:return function(){return new e(this,g)};case qo:return function(){return new e(this,g)};case kp:return function(){return new e(this,g)}}return function(){return new e(this)}},u=n+" Iterator",l=!1,h=r.prototype,d=h[zl]||h["@@iterator"]||i&&h[i],c=!Ko&&d||s(i),f=n==="Array"&&h.entries||d,v,p,y;if(f&&(v=BA(f.call(new r)),v!==Object.prototype&&v.next&&(LA(v,u,!0,!0),Pp[u]=WA)),HA&&i===qo&&d&&d.name!==qo&&(l=!0,c=function(){return MA(d,this)}),i)if(p={values:s(qo),keys:a?c:s(Ip),entries:s(kp)},o)for(y in p)(Ko||l||!(y in h))&&Tp(h,y,p[y]);else DA({target:n,proto:!0,forced:Ko||l},p);return o&&h[zl]!==c&&Tp(h,zl,c,{name:i}),Pp[n]=c,p},lf=function(r,n){return{value:r,done:n}},UA=ur,Cp=Gn,X1=Un;_t.f;var VA=uf,Yo=lf,Q1="Array Iterator",GA=X1.set,KA=X1.getterFor(Q1);VA(Array,"Array",function(r,n){GA(this,{type:Q1,target:UA(r),index:0,kind:n})},function(){var r=KA(this),n=r.target,e=r.index++;if(!n||e>=n.length)return r.target=void 0,Yo(void 0,!0);switch(r.kind){case"keys":return Yo(e,!1);case"values":return Yo(n[e],!1)}return Yo([e,n[e]],!1)},"values");Cp.Arguments=Cp.Array;var qA={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},YA=qA,XA=ve,QA=Ir,JA=Pr,xp=Gn,ZA=ge,Ap=ZA("toStringTag");for(var Hl in YA){var Rp=XA[Hl],Wl=Rp&&Rp.prototype;Wl&&QA(Wl)!==Ap&&JA(Wl,Ap,Hl),xp[Hl]=xp.Array}var eR=Qx,J1=eR,tR=ge,rR=_t.f,Dp=tR("metadata"),Mp=Function.prototype;Mp[Dp]===void 0&&rR(Mp,Dp,{value:null});var iR=we;iR("asyncDispose");var nR=we;nR("dispose");var aR=we;aR("metadata");var oR=J1,sR=oR,uR=lt,lR=fe,hf=uR("Symbol"),hR=hf.keyFor,dR=lR(hf.prototype.valueOf),Z1=hf.isRegisteredSymbol||function(n){try{return hR(dR(n))!==void 0}catch{return!1}},cR=H,fR=Z1;cR({target:"Symbol",stat:!0},{isRegisteredSymbol:fR});var vR=zn,ew=lt,pR=fe,yR=Ya,gR=ge,Ks=ew("Symbol"),Np=Ks.isWellKnownSymbol,tw=ew("Object","getOwnPropertyNames"),mR=pR(Ks.prototype.valueOf),Fp=vR("wks");for(var Ul=0,Bp=tw(Ks),bR=Bp.length;Ul<bR;Ul++)try{var Lp=Bp[Ul];yR(Ks[Lp])&&gR(Lp)}catch{}var rw=function(n){if(Np&&Np(n))return!0;try{for(var e=mR(n),t=0,i=tw(Fp),a=i.length;t<a;t++)if(Fp[i[t]]==e)return!0}catch{}return!1},$R=H,wR=rw;$R({target:"Symbol",stat:!0,forced:!0},{isWellKnownSymbol:wR});var _R=we;_R("matcher");var ER=we;ER("observable");var SR=H,OR=Z1;SR({target:"Symbol",stat:!0,name:"isRegisteredSymbol"},{isRegistered:OR});var TR=H,PR=rw;TR({target:"Symbol",stat:!0,name:"isWellKnownSymbol",forced:!0},{isWellKnown:PR});var IR=we;IR("metadataKey");var kR=we;kR("patternMatch");var CR=we;CR("replaceAll");var xR=sR,AR=xR,df=AR,sn=G(df),cf=fe,RR=_u,DR=Di,MR=Kc,NR=cf("".charAt),jp=cf("".charCodeAt),FR=cf("".slice),zp=function(r){return function(n,e){var t=DR(MR(n)),i=RR(e),a=t.length,o,s;return i<0||i>=a?r?"":void 0:(o=jp(t,i),o<55296||o>56319||i+1===a||(s=jp(t,i+1))<56320||s>57343?r?NR(t,i):o:r?FR(t,i,i+2):(o-55296<<10)+(s-56320)+65536)}},BR={codeAt:zp(!1),charAt:zp(!0)},LR=BR.charAt,jR=Di,iw=Un,zR=uf,Hp=lf,nw="String Iterator",HR=iw.set,WR=iw.getterFor(nw);zR(String,"String",function(r){HR(this,{type:nw,string:jR(r),index:0})},function(){var n=WR(this),e=n.string,t=n.index,i;return t>=e.length?Hp(void 0,!0):(i=LR(e,t),n.index+=i.length,Hp(i,!1))});var UR=to,VR=UR.f("iterator"),GR=VR,aw=GR,KR=aw,qR=KR,YR=qR,XR=YR,ow=XR,QR=G(ow);function Sn(r){"@babel/helpers - typeof";return Sn=typeof sn=="function"&&typeof QR=="symbol"?function(n){return typeof n}:function(n){return n&&typeof sn=="function"&&n.constructor===sn&&n!==sn.prototype?"symbol":typeof n},Sn(r)}var JR=to,ZR=JR.f("toPrimitive"),eD=ZR,tD=eD,rD=tD,iD=rD,nD=iD,aD=nD,oD=aD,sD=G(oD);function uD(r,n){if(Sn(r)!=="object"||r===null)return r;var e=r[sD];if(e!==void 0){var t=e.call(r,n||"default");if(Sn(t)!=="object")return t;throw new TypeError("@@toPrimitive must return a primitive value.")}return(n==="string"?String:Number)(r)}function sw(r){var n=uD(r,"string");return Sn(n)==="symbol"?n:String(n)}function Wp(r,n){for(var e=0;e<n.length;e++){var t=n[e];t.enumerable=t.enumerable||!1,t.configurable=!0,"value"in t&&(t.writable=!0),wu(r,sw(t.key),t)}}function Nu(r,n,e){return n&&Wp(r.prototype,n),e&&Wp(r,e),wu(r,"prototype",{writable:!1}),r}function zr(r,n,e){return n=sw(n),n in r?wu(r,n,{value:e,enumerable:!0,configurable:!0,writable:!0}):r[n]=e,r}var uw=fe,lD=$t,hD=Xe,dD=Me,Up=no,cD=qa,lw=Function,fD=uw([].concat),vD=uw([].join),Vl={},pD=function(r,n,e){if(!dD(Vl,n)){for(var t=[],i=0;i<n;i++)t[i]="a["+i+"]";Vl[n]=lw("C,a","return new C("+vD(t,",")+")")}return Vl[n](r,e)},hw=cD?lw.bind:function(n){var e=lD(this),t=e.prototype,i=Up(arguments,1),a=function(){var s=fD(i,Up(arguments));return this instanceof a?pD(e,s.length,s):e.apply(n,s)};return hD(t)&&(a.prototype=t),a},yD=H,Vp=hw;yD({target:"Function",proto:!0,forced:Function.bind!==Vp},{bind:Vp});var gD=ve,mD=pe,tt=function(r,n){var e=mD[r+"Prototype"],t=e&&e[n];if(t)return t;var i=gD[r],a=i&&i.prototype;return a&&a[n]},bD=tt,$D=bD("Function","bind"),wD=De,_D=$D,Gl=Function.prototype,ED=function(r){var n=r.bind;return r===Gl||wD(Gl,r)&&n===Gl.bind?_D:n},SD=ED,dw=SD,OD=dw,cw=G(OD),TD=$t,PD=wt,ID=mu,kD=xt,CD=TypeError,Gp=function(r){return function(n,e,t,i){TD(e);var a=PD(n),o=ID(a),s=kD(a),u=r?s-1:0,l=r?-1:1;if(t<2)for(;;){if(u in o){i=o[u],u+=l;break}if(u+=l,r?u<0:s<=u)throw new CD("Reduce of empty array with no initial value")}for(;r?u>=0:s>u;u+=l)u in o&&(i=e(i,o[u],u,a));return i}},xD={left:Gp(!1),right:Gp(!0)},AD=ne,Fu=function(r,n){var e=[][r];return!!e&&AD(function(){e.call(null,n||function(){return 1},1)})},RD=ve,DD=Qr,oo=DD(RD.process)==="process",MD=H,ND=xD.left,FD=Fu,Kp=Bn,BD=oo,LD=!BD&&Kp>79&&Kp<83,jD=LD||!FD("reduce");MD({target:"Array",proto:!0,forced:jD},{reduce:function(n){var e=arguments.length;return ND(this,n,e,e>1?arguments[1]:void 0)}});var zD=tt,HD=zD("Array","reduce"),WD=De,UD=HD,Kl=Array.prototype,VD=function(r){var n=r.reduce;return r===Kl||WD(Kl,r)&&n===Kl.reduce?UD:n},GD=VD,KD=GD,qD=KD,YD=G(qD),XD=H,QD=Vn.filter,JD=Qa,ZD=JD("filter");XD({target:"Array",proto:!0,forced:!ZD},{filter:function(n){return QD(this,n,arguments.length>1?arguments[1]:void 0)}});var eM=tt,tM=eM("Array","filter"),rM=De,iM=tM,ql=Array.prototype,nM=function(r){var n=r.filter;return r===ql||rM(ql,r)&&n===ql.filter?iM:n},aM=nM,oM=aM,sM=oM,un=G(sM),uM=H,lM=Vn.map,hM=Qa,dM=hM("map");uM({target:"Array",proto:!0,forced:!dM},{map:function(n){return lM(this,n,arguments.length>1?arguments[1]:void 0)}});var cM=tt,fM=cM("Array","map"),vM=De,pM=fM,Yl=Array.prototype,yM=function(r){var n=r.map;return r===Yl||vM(Yl,r)&&n===Yl.map?pM:n},gM=yM,mM=gM,bM=mM,Vt=G(bM),$M=ei,wM=xt,_M=Eu,EM=Zr,fw=function(r,n,e,t,i,a,o,s){for(var u=i,l=0,h=o?EM(o,s):!1,d,c;l<t;)l in e&&(d=h?h(e[l],l,n):e[l],a>0&&$M(d)?(c=wM(d),u=fw(r,n,d,c,u,a-1)-1):(_M(u+1),r[u]=d),u++),l++;return u},SM=fw,OM=H,TM=SM,PM=$t,IM=wt,kM=xt,CM=Ou;OM({target:"Array",proto:!0},{flatMap:function(n){var e=IM(this),t=kM(e),i;return PM(n),i=CM(e,0),i.length=TM(i,e,e,t,0,1,n,arguments.length>1?arguments[1]:void 0),i}});var xM=tt;xM("Array","flatMap");var AM=je,qp=Ct,RM=qc,vw=function(r,n,e){var t,i;qp(r);try{if(t=RM(r,"return"),!t){if(n==="throw")throw e;return e}t=AM(t,r)}catch(a){i=!0,t=a}if(n==="throw")throw e;if(i)throw t;return qp(t),e},DM=Ct,MM=vw,NM=function(r,n,e,t){try{return t?n(DM(e)[0],e[1]):n(e)}catch(i){MM(r,"throw",i)}},FM=ge,BM=Gn,LM=FM("iterator"),jM=Array.prototype,pw=function(r){return r!==void 0&&(BM.Array===r||jM[LM]===r)},zM=Ir,Yp=qc,HM=Fn,WM=Gn,UM=ge,VM=UM("iterator"),Bu=function(r){if(!HM(r))return Yp(r,VM)||Yp(r,"@@iterator")||WM[zM(r)]},GM=je,KM=$t,qM=Ct,YM=jn,XM=Bu,QM=TypeError,ff=function(r,n){var e=arguments.length<2?XM(r):n;if(KM(e))return qM(GM(e,r));throw new QM(YM(r)+" is not iterable")},JM=Zr,ZM=je,eN=wt,tN=NM,rN=pw,iN=Su,nN=xt,Xp=Hn,aN=ff,oN=Bu,Qp=Array,sN=function(n){var e=eN(n),t=iN(this),i=arguments.length,a=i>1?arguments[1]:void 0,o=a!==void 0;o&&(a=JM(a,i>2?arguments[2]:void 0));var s=oN(e),u=0,l,h,d,c,f,v;if(s&&!(this===Qp&&rN(s)))for(c=aN(e,s),f=c.next,h=t?new this:[];!(d=ZM(f,c)).done;u++)v=o?tN(c,a,[d.value,u],!0):d.value,Xp(h,u,v);else for(l=nN(e),h=t?new this(l):Qp(l);l>u;u++)v=o?a(e[u],u):e[u],Xp(h,u,v);return h.length=u,h},uN=ge,yw=uN("iterator"),gw=!1;try{var lN=0,Jp={next:function(){return{done:!!lN++}},return:function(){gw=!0}};Jp[yw]=function(){return this},Array.from(Jp,function(){throw 2})}catch{}var mw=function(r,n){try{if(!n&&!gw)return!1}catch{return!1}var e=!1;try{var t={};t[yw]=function(){return{next:function(){return{done:e=!0}}}},r(t)}catch{}return e},hN=H,dN=sN,cN=mw,fN=!cN(function(r){Array.from(r)});hN({target:"Array",stat:!0,forced:fN},{from:dN});var vN=pe,pN=vN.Array.from,yN=pN,bw=yN,gN=bw,vf=G(gN),mN=Bu,bN=mN,$N=bN,wN=$N,_N=wN,EN=_N,SN=EN,ON=SN,$w=ON,ww=G($w),TN=$w,pf=G(TN),PN=H,IN=ei;PN({target:"Array",stat:!0},{isArray:IN});var kN=pe,CN=kN.Array.isArray,xN=CN,_w=xN,AN=_w,RN=AN,DN=RN,MN=DN,NN=MN,Ew=G(NN);function FN(r){if(Ew(r))return r}var BN=Le,LN=ei,jN=TypeError,zN=Object.getOwnPropertyDescriptor,HN=BN&&!function(){if(this!==void 0)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(r){return r instanceof TypeError}}(),Sw=HN?function(r,n){if(LN(r)&&!zN(r,"length").writable)throw new jN("Cannot set read only .length");return r.length=n}:function(r,n){return r.length=n},WN=H,UN=wt,VN=xt,GN=Sw,KN=Eu,qN=ne,YN=qN(function(){return[].push.call({length:4294967296},1)!==4294967297}),XN=function(){try{Object.defineProperty([],"length",{writable:!1}).push()}catch(r){return r instanceof TypeError}},QN=YN||!XN();WN({target:"Array",proto:!0,arity:1,forced:QN},{push:function(n){var e=UN(this),t=VN(e),i=arguments.length;KN(t+i);for(var a=0;a<i;a++)e[t]=arguments[a],t++;return GN(e,t),t}});var JN=tt,ZN=JN("Array","push"),e2=De,t2=ZN,Xl=Array.prototype,r2=function(r){var n=r.push;return r===Xl||e2(Xl,r)&&n===Xl.push?t2:n},i2=r2,n2=i2,a2=n2,o2=a2,s2=o2,u2=s2,Ow=u2,l2=G(Ow);function h2(r,n){var e=r==null?null:typeof sn<"u"&&ww(r)||r["@@iterator"];if(e!=null){var t,i,a,o,s=[],u=!0,l=!1;try{if(a=(e=e.call(r)).next,n===0){if(Object(e)!==e)return;u=!1}else for(;!(u=(t=a.call(e)).done)&&(l2(s).call(s,t.value),s.length!==n);u=!0);}catch(h){l=!0,i=h}finally{try{if(!u&&e.return!=null&&(o=e.return(),Object(o)!==o))return}finally{if(l)throw i}}return s}}var d2=H,Zp=ei,c2=Su,f2=Xe,ey=Pu,v2=xt,p2=ur,y2=Hn,g2=ge,m2=Qa,b2=no,$2=m2("slice"),w2=g2("species"),Ql=Array,_2=Math.max;d2({target:"Array",proto:!0,forced:!$2},{slice:function(n,e){var t=p2(this),i=v2(t),a=ey(n,i),o=ey(e===void 0?i:e,i),s,u,l;if(Zp(t)&&(s=t.constructor,c2(s)&&(s===Ql||Zp(s.prototype))?s=void 0:f2(s)&&(s=s[w2],s===null&&(s=void 0)),s===Ql||s===void 0))return b2(t,a,o);for(u=new(s===void 0?Ql:s)(_2(o-a,0)),l=0;a<o;a++,l++)a in t&&y2(u,l,t[a]);return u.length=l,u}});var E2=tt,S2=E2("Array","slice"),O2=De,T2=S2,Jl=Array.prototype,P2=function(r){var n=r.slice;return r===Jl||O2(Jl,r)&&n===Jl.slice?T2:n},I2=P2,Tw=I2,k2=Tw,C2=k2,x2=C2,A2=x2,Pw=A2,R2=G(Pw),D2=bw,M2=D2,N2=M2,F2=N2,B2=F2,Iw=G(B2);function Kd(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}function kw(r,n){var e;if(r){if(typeof r=="string")return Kd(r,n);var t=R2(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Iw(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return Kd(r,n)}}function L2(){throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function dt(r,n){return FN(r)||h2(r,n)||kw(r,n)||L2()}function j2(r){if(Ew(r))return Kd(r)}function z2(r){if(typeof sn<"u"&&ww(r)!=null||r["@@iterator"]!=null)return Iw(r)}function H2(){throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function pt(r){return j2(r)||z2(r)||kw(r)||H2()}var W2=J1,Lu=G(W2),U2=tt,V2=U2("Array","concat"),G2=De,K2=V2,Zl=Array.prototype,q2=function(r){var n=r.concat;return r===Zl||G2(Zl,r)&&n===Zl.concat?K2:n},Y2=q2,X2=Y2,Q2=X2,ju=G(Q2),J2=Tw,zu=G(J2),Z2=lt,eF=fe,tF=Za,rF=eo,iF=Ct,nF=eF([].concat),yf=Z2("Reflect","ownKeys")||function(n){var e=tF.f(iF(n)),t=rF.f;return t?nF(e,t(n)):e},aF=H,oF=yf;aF({target:"Reflect",stat:!0},{ownKeys:oF});var sF=pe,uF=sF.Reflect.ownKeys,lF=uF,hF=lF,dF=hF,cF=G(dF),fF=_w,It=G(fF),vF=H,pF=wt,Cw=Iu,yF=ne,gF=yF(function(){Cw(1)});vF({target:"Object",stat:!0,forced:gF},{keys:function(n){return Cw(pF(n))}});var mF=pe,bF=mF.Object.keys,$F=bF,wF=$F,_F=wF,gf=G(_F),EF=Vn.forEach,SF=Fu,OF=SF("forEach"),TF=OF?[].forEach:function(n){return EF(this,n,arguments.length>1?arguments[1]:void 0)},PF=H,ty=TF;PF({target:"Array",proto:!0,forced:[].forEach!==ty},{forEach:ty});var IF=tt,kF=IF("Array","forEach"),CF=kF,xF=CF,AF=Ir,RF=Me,DF=De,MF=xF,eh=Array.prototype,NF={DOMTokenList:!0,NodeList:!0},xw=function(r){var n=r.forEach;return r===eh||DF(eh,r)&&n===eh.forEach||RF(NF,AF(r))?MF:n},FF=xw,Ei=G(FF),BF=H,LF=fe,jF=ei,zF=LF([].reverse),ry=[1,2];BF({target:"Array",proto:!0,forced:String(ry)===String(ry.reverse())},{reverse:function(){return jF(this)&&(this.length=this.length),zF(this)}});var HF=tt,WF=HF("Array","reverse"),UF=De,VF=WF,th=Array.prototype,GF=function(r){var n=r.reverse;return r===th||UF(th,r)&&n===th.reverse?VF:n},KF=GF,Aw=KF,qF=Aw,YF=G(qF),iy=jn,XF=TypeError,Rw=function(r,n){if(!delete r[n])throw new XF("Cannot delete property "+iy(n)+" of "+iy(r))},QF=H,JF=wt,ZF=Pu,eB=_u,tB=xt,rB=Sw,iB=Eu,nB=Ou,aB=Hn,rh=Rw,oB=Qa,sB=oB("splice"),uB=Math.max,lB=Math.min;QF({target:"Array",proto:!0,forced:!sB},{splice:function(n,e){var t=JF(this),i=tB(t),a=ZF(n,i),o=arguments.length,s,u,l,h,d,c;for(o===0?s=u=0:o===1?(s=0,u=i-a):(s=o-2,u=lB(uB(eB(e),0),i-a)),iB(i+s-u),l=nB(t,u),h=0;h<u;h++)d=a+h,d in t&&aB(l,h,t[d]);if(l.length=u,s<u){for(h=a;h<i-u;h++)d=h+u,c=h+s,d in t?t[c]=t[d]:rh(t,c);for(h=i;h>i-u+s;h--)rh(t,h-1)}else if(s>u)for(h=i-u;h>a;h--)d=h+u-1,c=h+s-1,d in t?t[c]=t[d]:rh(t,c);for(h=0;h<s;h++)t[h+a]=arguments[h+2];return rB(t,i-u+s),l}});var hB=tt,dB=hB("Array","splice"),cB=De,fB=dB,ih=Array.prototype,vB=function(r){var n=r.splice;return r===ih||cB(ih,r)&&n===ih.splice?fB:n},pB=vB,yB=pB,gB=yB,Dw=G(gB),ny=Le,mB=fe,bB=je,$B=ne,nh=Iu,wB=eo,_B=gu,EB=wt,SB=mu,Xi=Object.assign,ay=Object.defineProperty,OB=mB([].concat),TB=!Xi||$B(function(){if(ny&&Xi({b:1},Xi(ay({},"a",{enumerable:!0,get:function(){ay(this,"b",{value:3,enumerable:!1})}}),{b:2})).b!==1)return!0;var r={},n={},e=Symbol("assign detection"),t="abcdefghijklmnopqrst";return r[e]=7,t.split("").forEach(function(i){n[i]=i}),Xi({},r)[e]!==7||nh(Xi({},n)).join("")!==t})?function(n,e){for(var t=EB(n),i=arguments.length,a=1,o=wB.f,s=_B.f;i>a;)for(var u=SB(arguments[a++]),l=o?OB(nh(u),o(u)):nh(u),h=l.length,d=0,c;h>d;)c=l[d++],(!ny||bB(s,u,c))&&(t[c]=u[c]);return t}:Xi,PB=H,oy=TB;PB({target:"Object",stat:!0,arity:2,forced:Object.assign!==oy},{assign:oy});var IB=pe,kB=IB.Object.assign,CB=kB,xB=CB,AB=xB,RB=G(AB),DB=H,MB=ne,NB=wt,Mw=Mu,FB=G1,BB=MB(function(){Mw(1)});DB({target:"Object",stat:!0,forced:BB,sham:!FB},{getPrototypeOf:function(n){return Mw(NB(n))}});var LB=pe,jB=LB.Object.getPrototypeOf,zB=jB,HB=zB,WB=H,UB=Le,VB=Mi;WB({target:"Object",stat:!0,sham:!UB},{create:VB});var GB=pe,KB=GB.Object,qB=function(n,e){return KB.create(n,e)},YB=qB,Nw=YB,XB=Nw,QB=G(XB),qd=pe,JB=Nn;qd.JSON||(qd.JSON={stringify:JSON.stringify});var ZB=function(n,e,t){return JB(qd.JSON.stringify,null,arguments)},eL=ZB,tL=eL,rL=tL,iL=G(rL),nL=typeof Bun=="function"&&Bun&&typeof Bun.version=="string",aL=TypeError,Fw=function(r,n){if(r<n)throw new aL("Not enough arguments");return r},Bw=ve,oL=Nn,sL=$e,uL=nL,lL=Jr,hL=no,dL=Fw,cL=Bw.Function,fL=/MSIE .\./.test(lL)||uL&&function(){var r=Bw.Bun.version.split(".");return r.length<3||r[0]==="0"&&(r[1]<3||r[1]==="3"&&r[2]==="0")}(),Lw=function(r,n){var e=n?2:1;return fL?function(t,i){var a=dL(arguments.length,1)>e,o=sL(t)?t:cL(t),s=a?hL(arguments,e):[],u=a?function(){oL(o,this,s)}:o;return n?r(u,i):r(u)}:r},vL=H,jw=ve,pL=Lw,sy=pL(jw.setInterval,!0);vL({global:!0,bind:!0,forced:jw.setInterval!==sy},{setInterval:sy});var yL=H,zw=ve,gL=Lw,uy=gL(zw.setTimeout,!0);yL({global:!0,bind:!0,forced:zw.setTimeout!==uy},{setTimeout:uy});var mL=pe,bL=mL.setTimeout,$L=bL,wL=G($L),Hw={exports:{}};(function(r){function n(t){if(t)return e(t);this._callbacks=new Map}function e(t){return Object.assign(t,n.prototype),t._callbacks=new Map,t}n.prototype.on=function(t,i){const a=this._callbacks.get(t)??[];return a.push(i),this._callbacks.set(t,a),this},n.prototype.once=function(t,i){const a=(...o)=>{this.off(t,a),i.apply(this,o)};return a.fn=i,this.on(t,a),this},n.prototype.off=function(t,i){if(t===void 0&&i===void 0)return this._callbacks.clear(),this;if(i===void 0)return this._callbacks.delete(t),this;const a=this._callbacks.get(t);if(a){for(const[o,s]of a.entries())if(s===i||s.fn===i){a.splice(o,1);break}a.length===0?this._callbacks.delete(t):this._callbacks.set(t,a)}return this},n.prototype.emit=function(t,...i){const a=this._callbacks.get(t);if(a){const o=[...a];for(const s of o)s.apply(this,i)}return this},n.prototype.listeners=function(t){return this._callbacks.get(t)??[]},n.prototype.listenerCount=function(t){if(t)return this.listeners(t).length;let i=0;for(const a of this._callbacks.values())i+=a.length;return i},n.prototype.hasListeners=function(t){return this.listenerCount(t)>0},n.prototype.addEventListener=n.prototype.on,n.prototype.removeListener=n.prototype.off,n.prototype.removeEventListener=n.prototype.off,n.prototype.removeAllListeners=n.prototype.off,r.exports=n})(Hw);var _L=Hw.exports,EL=G(_L);/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function Xt(){return Xt=Object.assign||function(r){for(var n=1;n<arguments.length;n++){var e=arguments[n];for(var t in e)Object.prototype.hasOwnProperty.call(e,t)&&(r[t]=e[t])}return r},Xt.apply(this,arguments)}function jt(r,n){r.prototype=Object.create(n.prototype),r.prototype.constructor=r,r.__proto__=n}function Xo(r){if(r===void 0)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return r}var Yd;typeof Object.assign!="function"?Yd=function(n){if(n==null)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(n),t=1;t<arguments.length;t++){var i=arguments[t];if(i!=null)for(var a in i)i.hasOwnProperty(a)&&(e[a]=i[a])}return e}:Yd=Object.assign;var Si=Yd,ly=["","webkit","Moz","MS","ms","o"],SL=typeof document>"u"?{style:{}}:document.createElement("div"),OL="function",ln=Math.round,Oi=Math.abs,mf=Date.now;function Hu(r,n){for(var e,t,i=n[0].toUpperCase()+n.slice(1),a=0;a<ly.length;){if(e=ly[a],t=e?e+i:n,t in r)return t;a++}}var pr;typeof window>"u"?pr={}:pr=window;var Ww=Hu(SL.style,"touchAction"),Uw=Ww!==void 0;function TL(){if(!Uw)return!1;var r={},n=pr.CSS&&pr.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach(function(e){return r[e]=n?pr.CSS.supports("touch-action",e):!0}),r}var Vw="compute",Gw="auto",Xd="manipulation",pi="none",Da="pan-x",Ma="pan-y",Qo=TL(),PL=/mobile|tablet|ip(ad|hone|od)|android/i,Kw="ontouchstart"in pr,IL=Hu(pr,"PointerEvent")!==void 0,kL=Kw&&PL.test(navigator.userAgent),so="touch",CL="pen",bf="mouse",xL="kinect",AL=25,st=1,Fi=2,xe=4,mt=8,qs=1,uo=2,lo=4,ho=8,On=16,ar=uo|lo,yi=ho|On,qw=ar|yi,Yw=["x","y"],Ys=["clientX","clientY"];function yr(r,n,e){var t;if(r)if(r.forEach)r.forEach(n,e);else if(r.length!==void 0)for(t=0;t<r.length;)n.call(e,r[t],t,r),t++;else for(t in r)r.hasOwnProperty(t)&&n.call(e,r[t],t,r)}function Wu(r,n){return typeof r===OL?r.apply(n&&n[0]||void 0,n):r}function hi(r,n){return r.indexOf(n)>-1}function RL(r){if(hi(r,pi))return pi;var n=hi(r,Da),e=hi(r,Ma);return n&&e?pi:n||e?n?Da:Ma:hi(r,Xd)?Xd:Gw}var Xw=function(){function r(e,t){this.manager=e,this.set(t)}var n=r.prototype;return n.set=function(t){t===Vw&&(t=this.compute()),Uw&&this.manager.element.style&&Qo[t]&&(this.manager.element.style[Ww]=t),this.actions=t.toLowerCase().trim()},n.update=function(){this.set(this.manager.options.touchAction)},n.compute=function(){var t=[];return yr(this.manager.recognizers,function(i){Wu(i.options.enable,[i])&&(t=t.concat(i.getTouchAction()))}),RL(t.join(" "))},n.preventDefaults=function(t){var i=t.srcEvent,a=t.offsetDirection;if(this.manager.session.prevented){i.preventDefault();return}var o=this.actions,s=hi(o,pi)&&!Qo[pi],u=hi(o,Ma)&&!Qo[Ma],l=hi(o,Da)&&!Qo[Da];if(s){var h=t.pointers.length===1,d=t.distance<2,c=t.deltaTime<250;if(h&&d&&c)return}if(!(l&&u)&&(s||u&&a&ar||l&&a&yi))return this.preventSrc(i)},n.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},r}();function $f(r,n){for(;r;){if(r===n)return!0;r=r.parentNode}return!1}function Qw(r){var n=r.length;if(n===1)return{x:ln(r[0].clientX),y:ln(r[0].clientY)};for(var e=0,t=0,i=0;i<n;)e+=r[i].clientX,t+=r[i].clientY,i++;return{x:ln(e/n),y:ln(t/n)}}function hy(r){for(var n=[],e=0;e<r.pointers.length;)n[e]={clientX:ln(r.pointers[e].clientX),clientY:ln(r.pointers[e].clientY)},e++;return{timeStamp:mf(),pointers:n,center:Qw(n),deltaX:r.deltaX,deltaY:r.deltaY}}function Xs(r,n,e){e||(e=Yw);var t=n[e[0]]-r[e[0]],i=n[e[1]]-r[e[1]];return Math.sqrt(t*t+i*i)}function Qd(r,n,e){e||(e=Yw);var t=n[e[0]]-r[e[0]],i=n[e[1]]-r[e[1]];return Math.atan2(i,t)*180/Math.PI}function Jw(r,n){return r===n?qs:Oi(r)>=Oi(n)?r<0?uo:lo:n<0?ho:On}function DL(r,n){var e=n.center,t=r.offsetDelta||{},i=r.prevDelta||{},a=r.prevInput||{};(n.eventType===st||a.eventType===xe)&&(i=r.prevDelta={x:a.deltaX||0,y:a.deltaY||0},t=r.offsetDelta={x:e.x,y:e.y}),n.deltaX=i.x+(e.x-t.x),n.deltaY=i.y+(e.y-t.y)}function Zw(r,n,e){return{x:n/r||0,y:e/r||0}}function ML(r,n){return Xs(n[0],n[1],Ys)/Xs(r[0],r[1],Ys)}function NL(r,n){return Qd(n[1],n[0],Ys)+Qd(r[1],r[0],Ys)}function FL(r,n){var e=r.lastInterval||n,t=n.timeStamp-e.timeStamp,i,a,o,s;if(n.eventType!==mt&&(t>AL||e.velocity===void 0)){var u=n.deltaX-e.deltaX,l=n.deltaY-e.deltaY,h=Zw(t,u,l);a=h.x,o=h.y,i=Oi(h.x)>Oi(h.y)?h.x:h.y,s=Jw(u,l),r.lastInterval=n}else i=e.velocity,a=e.velocityX,o=e.velocityY,s=e.direction;n.velocity=i,n.velocityX=a,n.velocityY=o,n.direction=s}function BL(r,n){var e=r.session,t=n.pointers,i=t.length;e.firstInput||(e.firstInput=hy(n)),i>1&&!e.firstMultiple?e.firstMultiple=hy(n):i===1&&(e.firstMultiple=!1);var a=e.firstInput,o=e.firstMultiple,s=o?o.center:a.center,u=n.center=Qw(t);n.timeStamp=mf(),n.deltaTime=n.timeStamp-a.timeStamp,n.angle=Qd(s,u),n.distance=Xs(s,u),DL(e,n),n.offsetDirection=Jw(n.deltaX,n.deltaY);var l=Zw(n.deltaTime,n.deltaX,n.deltaY);n.overallVelocityX=l.x,n.overallVelocityY=l.y,n.overallVelocity=Oi(l.x)>Oi(l.y)?l.x:l.y,n.scale=o?ML(o.pointers,t):1,n.rotation=o?NL(o.pointers,t):0,n.maxPointers=e.prevInput?n.pointers.length>e.prevInput.maxPointers?n.pointers.length:e.prevInput.maxPointers:n.pointers.length,FL(e,n);var h=r.element,d=n.srcEvent,c;d.composedPath?c=d.composedPath()[0]:d.path?c=d.path[0]:c=d.target,$f(c,h)&&(h=c),n.target=h}function LL(r,n,e){var t=e.pointers.length,i=e.changedPointers.length,a=n&st&&t-i===0,o=n&(xe|mt)&&t-i===0;e.isFirst=!!a,e.isFinal=!!o,a&&(r.session={}),e.eventType=n,BL(r,e),r.emit("hammer.input",e),r.recognize(e),r.session.prevInput=e}function Na(r){return r.trim().split(/\s+/g)}function $a(r,n,e){yr(Na(n),function(t){r.addEventListener(t,e,!1)})}function wa(r,n,e){yr(Na(n),function(t){r.removeEventListener(t,e,!1)})}function dy(r){var n=r.ownerDocument||r;return n.defaultView||n.parentWindow||window}var Kn=function(){function r(e,t){var i=this;this.manager=e,this.callback=t,this.element=e.element,this.target=e.options.inputTarget,this.domHandler=function(a){Wu(e.options.enable,[e])&&i.handler(a)},this.init()}var n=r.prototype;return n.handler=function(){},n.init=function(){this.evEl&&$a(this.element,this.evEl,this.domHandler),this.evTarget&&$a(this.target,this.evTarget,this.domHandler),this.evWin&&$a(dy(this.element),this.evWin,this.domHandler)},n.destroy=function(){this.evEl&&wa(this.element,this.evEl,this.domHandler),this.evTarget&&wa(this.target,this.evTarget,this.domHandler),this.evWin&&wa(dy(this.element),this.evWin,this.domHandler)},r}();function Ti(r,n,e){if(r.indexOf&&!e)return r.indexOf(n);for(var t=0;t<r.length;){if(e&&r[t][e]==n||!e&&r[t]===n)return t;t++}return-1}var jL={pointerdown:st,pointermove:Fi,pointerup:xe,pointercancel:mt,pointerout:mt},zL={2:so,3:CL,4:bf,5:xL},e0="pointerdown",t0="pointermove pointerup pointercancel";pr.MSPointerEvent&&!pr.PointerEvent&&(e0="MSPointerDown",t0="MSPointerMove MSPointerUp MSPointerCancel");var r0=function(r){jt(n,r);function n(){var t,i=n.prototype;return i.evEl=e0,i.evWin=t0,t=r.apply(this,arguments)||this,t.store=t.manager.session.pointerEvents=[],t}var e=n.prototype;return e.handler=function(i){var a=this.store,o=!1,s=i.type.toLowerCase().replace("ms",""),u=jL[s],l=zL[i.pointerType]||i.pointerType,h=l===so,d=Ti(a,i.pointerId,"pointerId");u&st&&(i.button===0||h)?d<0&&(a.push(i),d=a.length-1):u&(xe|mt)&&(o=!0),!(d<0)&&(a[d]=i,this.callback(this.manager,u,{pointers:a,changedPointers:[i],pointerType:l,srcEvent:i}),o&&a.splice(d,1))},n}(Kn);function Fa(r){return Array.prototype.slice.call(r,0)}function wf(r,n,e){for(var t=[],i=[],a=0;a<r.length;){var o=n?r[a][n]:r[a];Ti(i,o)<0&&t.push(r[a]),i[a]=o,a++}return e&&(n?t=t.sort(function(s,u){return s[n]>u[n]}):t=t.sort()),t}var HL={touchstart:st,touchmove:Fi,touchend:xe,touchcancel:mt},WL="touchstart touchmove touchend touchcancel",_f=function(r){jt(n,r);function n(){var t;return n.prototype.evTarget=WL,t=r.apply(this,arguments)||this,t.targetIds={},t}var e=n.prototype;return e.handler=function(i){var a=HL[i.type],o=UL.call(this,i,a);o&&this.callback(this.manager,a,{pointers:o[0],changedPointers:o[1],pointerType:so,srcEvent:i})},n}(Kn);function UL(r,n){var e=Fa(r.touches),t=this.targetIds;if(n&(st|Fi)&&e.length===1)return t[e[0].identifier]=!0,[e,e];var i,a,o=Fa(r.changedTouches),s=[],u=this.target;if(a=e.filter(function(l){return $f(l.target,u)}),n===st)for(i=0;i<a.length;)t[a[i].identifier]=!0,i++;for(i=0;i<o.length;)t[o[i].identifier]&&s.push(o[i]),n&(xe|mt)&&delete t[o[i].identifier],i++;if(s.length)return[wf(a.concat(s),"identifier",!0),s]}var VL={mousedown:st,mousemove:Fi,mouseup:xe},GL="mousedown",KL="mousemove mouseup",Ef=function(r){jt(n,r);function n(){var t,i=n.prototype;return i.evEl=GL,i.evWin=KL,t=r.apply(this,arguments)||this,t.pressed=!1,t}var e=n.prototype;return e.handler=function(i){var a=VL[i.type];a&st&&i.button===0&&(this.pressed=!0),a&Fi&&i.which!==1&&(a=xe),this.pressed&&(a&xe&&(this.pressed=!1),this.callback(this.manager,a,{pointers:[i],changedPointers:[i],pointerType:bf,srcEvent:i}))},n}(Kn),qL=2500,cy=25;function fy(r){var n=r.changedPointers,e=n[0];if(e.identifier===this.primaryTouch){var t={x:e.clientX,y:e.clientY},i=this.lastTouches;this.lastTouches.push(t);var a=function(){var s=i.indexOf(t);s>-1&&i.splice(s,1)};setTimeout(a,qL)}}function YL(r,n){r&st?(this.primaryTouch=n.changedPointers[0].identifier,fy.call(this,n)):r&(xe|mt)&&fy.call(this,n)}function XL(r){for(var n=r.srcEvent.clientX,e=r.srcEvent.clientY,t=0;t<this.lastTouches.length;t++){var i=this.lastTouches[t],a=Math.abs(n-i.x),o=Math.abs(e-i.y);if(a<=cy&&o<=cy)return!0}return!1}var i0=function(){var r=function(n){jt(e,n);function e(i,a){var o;return o=n.call(this,i,a)||this,o.handler=function(s,u,l){var h=l.pointerType===so,d=l.pointerType===bf;if(!(d&&l.sourceCapabilities&&l.sourceCapabilities.firesTouchEvents)){if(h)YL.call(Xo(Xo(o)),u,l);else if(d&&XL.call(Xo(Xo(o)),l))return;o.callback(s,u,l)}},o.touch=new _f(o.manager,o.handler),o.mouse=new Ef(o.manager,o.handler),o.primaryTouch=null,o.lastTouches=[],o}var t=e.prototype;return t.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Kn);return r}();function QL(r){var n,e=r.options.inputClass;return e?n=e:IL?n=r0:kL?n=_f:Kw?n=i0:n=Ef,new n(r,LL)}function hn(r,n,e){return Array.isArray(r)?(yr(r,e[n],e),!0):!1}var Is=1,Bt=2,Tn=4,Hr=8,gr=Hr,Ba=16,rr=32,JL=1;function ZL(){return JL++}function Jo(r,n){var e=n.manager;return e?e.get(r):r}function vy(r){return r&Ba?"cancel":r&Hr?"end":r&Tn?"move":r&Bt?"start":""}var co=function(){function r(e){e===void 0&&(e={}),this.options=Xt({enable:!0},e),this.id=ZL(),this.manager=null,this.state=Is,this.simultaneous={},this.requireFail=[]}var n=r.prototype;return n.set=function(t){return Si(this.options,t),this.manager&&this.manager.touchAction.update(),this},n.recognizeWith=function(t){if(hn(t,"recognizeWith",this))return this;var i=this.simultaneous;return t=Jo(t,this),i[t.id]||(i[t.id]=t,t.recognizeWith(this)),this},n.dropRecognizeWith=function(t){return hn(t,"dropRecognizeWith",this)?this:(t=Jo(t,this),delete this.simultaneous[t.id],this)},n.requireFailure=function(t){if(hn(t,"requireFailure",this))return this;var i=this.requireFail;return t=Jo(t,this),Ti(i,t)===-1&&(i.push(t),t.requireFailure(this)),this},n.dropRequireFailure=function(t){if(hn(t,"dropRequireFailure",this))return this;t=Jo(t,this);var i=Ti(this.requireFail,t);return i>-1&&this.requireFail.splice(i,1),this},n.hasRequireFailures=function(){return this.requireFail.length>0},n.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},n.emit=function(t){var i=this,a=this.state;function o(s){i.manager.emit(s,t)}a<Hr&&o(i.options.event+vy(a)),o(i.options.event),t.additionalEvent&&o(t.additionalEvent),a>=Hr&&o(i.options.event+vy(a))},n.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=rr},n.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(rr|Is)))return!1;t++}return!0},n.recognize=function(t){var i=Si({},t);if(!Wu(this.options.enable,[this,i])){this.reset(),this.state=rr;return}this.state&(gr|Ba|rr)&&(this.state=Is),this.state=this.process(i),this.state&(Bt|Tn|Hr|Ba)&&this.tryEmit(i)},n.process=function(t){},n.getTouchAction=function(){},n.reset=function(){},r}(),Jd=function(r){jt(n,r);function n(t){var i;return t===void 0&&(t={}),i=r.call(this,Xt({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},t))||this,i.pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}var e=n.prototype;return e.getTouchAction=function(){return[Xd]},e.process=function(i){var a=this,o=this.options,s=i.pointers.length===o.pointers,u=i.distance<o.threshold,l=i.deltaTime<o.time;if(this.reset(),i.eventType&st&&this.count===0)return this.failTimeout();if(u&&l&&s){if(i.eventType!==xe)return this.failTimeout();var h=this.pTime?i.timeStamp-this.pTime<o.interval:!0,d=!this.pCenter||Xs(this.pCenter,i.center)<o.posThreshold;this.pTime=i.timeStamp,this.pCenter=i.center,!d||!h?this.count=1:this.count+=1,this._input=i;var c=this.count%o.taps;if(c===0)return this.hasRequireFailures()?(this._timer=setTimeout(function(){a.state=gr,a.tryEmit()},o.interval),Bt):gr}return rr},e.failTimeout=function(){var i=this;return this._timer=setTimeout(function(){i.state=rr},this.options.interval),rr},e.reset=function(){clearTimeout(this._timer)},e.emit=function(){this.state===gr&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},n}(co),Pn=function(r){jt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Xt({pointers:1},t))||this}var e=n.prototype;return e.attrTest=function(i){var a=this.options.pointers;return a===0||i.pointers.length===a},e.process=function(i){var a=this.state,o=i.eventType,s=a&(Bt|Tn),u=this.attrTest(i);return s&&(o&mt||!u)?a|Ba:s||u?o&xe?a|Hr:a&Bt?a|Tn:Bt:rr},n}(co);function n0(r){return r===On?"down":r===ho?"up":r===uo?"left":r===lo?"right":""}var Sf=function(r){jt(n,r);function n(t){var i;return t===void 0&&(t={}),i=r.call(this,Xt({event:"pan",threshold:10,pointers:1,direction:qw},t))||this,i.pX=null,i.pY=null,i}var e=n.prototype;return e.getTouchAction=function(){var i=this.options.direction,a=[];return i&ar&&a.push(Ma),i&yi&&a.push(Da),a},e.directionTest=function(i){var a=this.options,o=!0,s=i.distance,u=i.direction,l=i.deltaX,h=i.deltaY;return u&a.direction||(a.direction&ar?(u=l===0?qs:l<0?uo:lo,o=l!==this.pX,s=Math.abs(i.deltaX)):(u=h===0?qs:h<0?ho:On,o=h!==this.pY,s=Math.abs(i.deltaY))),i.direction=u,o&&s>a.threshold&&u&a.direction},e.attrTest=function(i){return Pn.prototype.attrTest.call(this,i)&&(this.state&Bt||!(this.state&Bt)&&this.directionTest(i))},e.emit=function(i){this.pX=i.deltaX,this.pY=i.deltaY;var a=n0(i.direction);a&&(i.additionalEvent=this.options.event+a),r.prototype.emit.call(this,i)},n}(Pn),a0=function(r){jt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Xt({event:"swipe",threshold:10,velocity:.3,direction:ar|yi,pointers:1},t))||this}var e=n.prototype;return e.getTouchAction=function(){return Sf.prototype.getTouchAction.call(this)},e.attrTest=function(i){var a=this.options.direction,o;return a&(ar|yi)?o=i.overallVelocity:a&ar?o=i.overallVelocityX:a&yi&&(o=i.overallVelocityY),r.prototype.attrTest.call(this,i)&&a&i.offsetDirection&&i.distance>this.options.threshold&&i.maxPointers===this.options.pointers&&Oi(o)>this.options.velocity&&i.eventType&xe},e.emit=function(i){var a=n0(i.offsetDirection);a&&this.manager.emit(this.options.event+a,i),this.manager.emit(this.options.event,i)},n}(Pn),o0=function(r){jt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Xt({event:"pinch",threshold:0,pointers:2},t))||this}var e=n.prototype;return e.getTouchAction=function(){return[pi]},e.attrTest=function(i){return r.prototype.attrTest.call(this,i)&&(Math.abs(i.scale-1)>this.options.threshold||this.state&Bt)},e.emit=function(i){if(i.scale!==1){var a=i.scale<1?"in":"out";i.additionalEvent=this.options.event+a}r.prototype.emit.call(this,i)},n}(Pn),s0=function(r){jt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Xt({event:"rotate",threshold:0,pointers:2},t))||this}var e=n.prototype;return e.getTouchAction=function(){return[pi]},e.attrTest=function(i){return r.prototype.attrTest.call(this,i)&&(Math.abs(i.rotation)>this.options.threshold||this.state&Bt)},n}(Pn),u0=function(r){jt(n,r);function n(t){var i;return t===void 0&&(t={}),i=r.call(this,Xt({event:"press",pointers:1,time:251,threshold:9},t))||this,i._timer=null,i._input=null,i}var e=n.prototype;return e.getTouchAction=function(){return[Gw]},e.process=function(i){var a=this,o=this.options,s=i.pointers.length===o.pointers,u=i.distance<o.threshold,l=i.deltaTime>o.time;if(this._input=i,!u||!s||i.eventType&(xe|mt)&&!l)this.reset();else if(i.eventType&st)this.reset(),this._timer=setTimeout(function(){a.state=gr,a.tryEmit()},o.time);else if(i.eventType&xe)return gr;return rr},e.reset=function(){clearTimeout(this._timer)},e.emit=function(i){this.state===gr&&(i&&i.eventType&xe?this.manager.emit(this.options.event+"up",i):(this._input.timeStamp=mf(),this.manager.emit(this.options.event,this._input)))},n}(co),l0={domEvents:!1,touchAction:Vw,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},py=[[s0,{enable:!1}],[o0,{enable:!1},["rotate"]],[a0,{direction:ar}],[Sf,{direction:ar},["swipe"]],[Jd],[Jd,{event:"doubletap",taps:2},["tap"]],[u0]],ej=1,yy=2;function gy(r,n){var e=r.element;if(e.style){var t;yr(r.options.cssProps,function(i,a){t=Hu(e.style,a),n?(r.oldCssProps[t]=e.style[t],e.style[t]=i):e.style[t]=r.oldCssProps[t]||""}),n||(r.oldCssProps={})}}function tj(r,n){var e=document.createEvent("Event");e.initEvent(r,!0,!0),e.gesture=n,n.target.dispatchEvent(e)}var my=function(){function r(e,t){var i=this;this.options=Si({},l0,t||{}),this.options.inputTarget=this.options.inputTarget||e,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=e,this.input=QL(this),this.touchAction=new Xw(this,this.options.touchAction),gy(this,!0),yr(this.options.recognizers,function(a){var o=i.add(new a[0](a[1]));a[2]&&o.recognizeWith(a[2]),a[3]&&o.requireFailure(a[3])},this)}var n=r.prototype;return n.set=function(t){return Si(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},n.stop=function(t){this.session.stopped=t?yy:ej},n.recognize=function(t){var i=this.session;if(!i.stopped){this.touchAction.preventDefaults(t);var a,o=this.recognizers,s=i.curRecognizer;(!s||s&&s.state&gr)&&(i.curRecognizer=null,s=null);for(var u=0;u<o.length;)a=o[u],i.stopped!==yy&&(!s||a===s||a.canRecognizeWith(s))?a.recognize(t):a.reset(),!s&&a.state&(Bt|Tn|Hr)&&(i.curRecognizer=a,s=a),u++}},n.get=function(t){if(t instanceof co)return t;for(var i=this.recognizers,a=0;a<i.length;a++)if(i[a].options.event===t)return i[a];return null},n.add=function(t){if(hn(t,"add",this))return this;var i=this.get(t.options.event);return i&&this.remove(i),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},n.remove=function(t){if(hn(t,"remove",this))return this;var i=this.get(t);if(t){var a=this.recognizers,o=Ti(a,i);o!==-1&&(a.splice(o,1),this.touchAction.update())}return this},n.on=function(t,i){if(t===void 0||i===void 0)return this;var a=this.handlers;return yr(Na(t),function(o){a[o]=a[o]||[],a[o].push(i)}),this},n.off=function(t,i){if(t===void 0)return this;var a=this.handlers;return yr(Na(t),function(o){i?a[o]&&a[o].splice(Ti(a[o],i),1):delete a[o]}),this},n.emit=function(t,i){this.options.domEvents&&tj(t,i);var a=this.handlers[t]&&this.handlers[t].slice();if(!(!a||!a.length)){i.type=t,i.preventDefault=function(){i.srcEvent.preventDefault()};for(var o=0;o<a.length;)a[o](i),o++}},n.destroy=function(){this.element&&gy(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},r}(),rj={touchstart:st,touchmove:Fi,touchend:xe,touchcancel:mt},ij="touchstart",nj="touchstart touchmove touchend touchcancel",aj=function(r){jt(n,r);function n(){var t,i=n.prototype;return i.evTarget=ij,i.evWin=nj,t=r.apply(this,arguments)||this,t.started=!1,t}var e=n.prototype;return e.handler=function(i){var a=rj[i.type];if(a===st&&(this.started=!0),!!this.started){var o=oj.call(this,i,a);a&(xe|mt)&&o[0].length-o[1].length===0&&(this.started=!1),this.callback(this.manager,a,{pointers:o[0],changedPointers:o[1],pointerType:so,srcEvent:i})}},n}(Kn);function oj(r,n){var e=Fa(r.touches),t=Fa(r.changedTouches);return n&(xe|mt)&&(e=wf(e.concat(t),"identifier",!0)),[e,t]}function h0(r,n,e){var t="DEPRECATED METHOD: "+n+`
`+e+` AT 
`;return function(){var i=new Error("get-stack-trace"),a=i&&i.stack?i.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,t,a),r.apply(this,arguments)}}var d0=h0(function(r,n,e){for(var t=Object.keys(n),i=0;i<t.length;)(!e||e&&r[t[i]]===void 0)&&(r[t[i]]=n[t[i]]),i++;return r},"extend","Use `assign`."),sj=h0(function(r,n){return d0(r,n,!0)},"merge","Use `assign`.");function uj(r,n,e){var t=n.prototype,i;i=r.prototype=Object.create(t),i.constructor=r,i._super=t,e&&Si(i,e)}function by(r,n){return function(){return r.apply(n,arguments)}}var lj=function(){var r=function(e,t){return t===void 0&&(t={}),new my(e,Xt({recognizers:py.concat()},t))};return r.VERSION="2.0.17-rc",r.DIRECTION_ALL=qw,r.DIRECTION_DOWN=On,r.DIRECTION_LEFT=uo,r.DIRECTION_RIGHT=lo,r.DIRECTION_UP=ho,r.DIRECTION_HORIZONTAL=ar,r.DIRECTION_VERTICAL=yi,r.DIRECTION_NONE=qs,r.DIRECTION_DOWN=On,r.INPUT_START=st,r.INPUT_MOVE=Fi,r.INPUT_END=xe,r.INPUT_CANCEL=mt,r.STATE_POSSIBLE=Is,r.STATE_BEGAN=Bt,r.STATE_CHANGED=Tn,r.STATE_ENDED=Hr,r.STATE_RECOGNIZED=gr,r.STATE_CANCELLED=Ba,r.STATE_FAILED=rr,r.Manager=my,r.Input=Kn,r.TouchAction=Xw,r.TouchInput=_f,r.MouseInput=Ef,r.PointerEventInput=r0,r.TouchMouseInput=i0,r.SingleTouchInput=aj,r.Recognizer=co,r.AttrRecognizer=Pn,r.Tap=Jd,r.Pan=Sf,r.Swipe=a0,r.Pinch=o0,r.Rotate=s0,r.Press=u0,r.on=$a,r.off=wa,r.each=yr,r.merge=sj,r.extend=d0,r.bindFn=by,r.assign=Si,r.inherit=uj,r.bindFn=by,r.prefixed=Hu,r.toArray=Fa,r.inArray=Ti,r.uniqueArray=wf,r.splitStr=Na,r.boolOrFn=Wu,r.hasParent=$f,r.addEventListeners=$a,r.removeEventListeners=wa,r.defaults=Si({},l0,{preset:py}),r}(),hj=lj;function c0(r,n){var e=typeof Lu<"u"&&pf(r)||r["@@iterator"];if(!e){if(It(r)||(e=dj(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function dj(r,n){var e;if(r){if(typeof r=="string")return $y(r,n);var t=zu(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return vf(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return $y(r,n)}}function $y(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}var f0=Lu("DELETE");function cj(r){for(var n,e=arguments.length,t=new Array(e>1?e-1:0),i=1;i<e;i++)t[i-1]=arguments[i];return v0.apply(void 0,ju(n=[{},r]).call(n,t))}function v0(){var r=Qs.apply(void 0,arguments);return y0(r),r}function Qs(){for(var r=arguments.length,n=new Array(r),e=0;e<r;e++)n[e]=arguments[e];if(n.length<2)return n[0];if(n.length>2){var t;return Qs.apply(void 0,ju(t=[v0(n[0],n[1])]).call(t,pt(zu(n).call(n,2))))}var i=n[0],a=n[1];if(i instanceof Date&&a instanceof Date)return i.setTime(a.getTime()),i;var o=c0(cF(a)),s;try{for(o.s();!(s=o.n()).done;){var u=s.value;Object.prototype.propertyIsEnumerable.call(a,u)&&(a[u]===f0?delete i[u]:i[u]!==null&&a[u]!==null&&typeof i[u]=="object"&&typeof a[u]=="object"&&!It(i[u])&&!It(a[u])?i[u]=Qs(i[u],a[u]):i[u]=p0(a[u]))}}catch(l){o.e(l)}finally{o.f()}return i}function p0(r){return It(r)?Vt(r).call(r,function(n){return p0(n)}):typeof r=="object"&&r!==null?r instanceof Date?new Date(r.getTime()):Qs({},r):r}function y0(r){for(var n=0,e=gf(r);n<e.length;n++){var t=e[n];r[t]===f0?delete r[t]:typeof r[t]=="object"&&r[t]!==null&&y0(r[t])}}function fj(){var r=function(){};return{on:r,off:r,destroy:r,emit:r,get(){return{set:r}}}}var vj=typeof window<"u"?window.Hammer||hj:function(){return fj()};function fr(r){var n=this,e;this._cleanupQueue=[],this.active=!1,this._dom={container:r,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push(function(){n._dom.overlay.parentNode.removeChild(n._dom.overlay)});var t=vj(this._dom.overlay);t.on("tap",cw(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push(function(){t.destroy()});var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Ei(i).call(i,function(a){t.on(a,function(o){o.srcEvent.stopPropagation()})}),document&&document.body&&(this._onClick=function(a){pj(a.target,r)||n.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push(function(){document.body.removeEventListener("click",n._onClick)})),this._escListener=function(a){("key"in a?a.key==="Escape":a.keyCode===27)&&n.deactivate()}}EL(fr.prototype);fr.current=null;fr.prototype.destroy=function(){var r,n;this.deactivate();var e=c0(YF(r=Dw(n=this._cleanupQueue).call(n,0)).call(r)),t;try{for(e.s();!(t=e.n()).done;){var i=t.value;i()}}catch(a){e.e(a)}finally{e.f()}};fr.prototype.activate=function(){fr.current&&fr.current.deactivate(),fr.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)};fr.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")};fr.prototype._onTapOverlay=function(r){this.activate(),r.srcEvent.stopPropagation()};function pj(r,n){for(;r;){if(r===n)return!0;r=r.parentNode}return!1}var yj=Su,gj=jn,mj=TypeError,g0=function(r){if(yj(r))return r;throw new mj(gj(r)+" is not a constructor")},bj=H,$j=lt,ah=Nn,wj=hw,wy=g0,_j=Ct,_y=Xe,Ej=Mi,m0=ne,Of=$j("Reflect","construct"),Sj=Object.prototype,Oj=[].push,b0=m0(function(){function r(){}return!(Of(function(){},[],r)instanceof r)}),$0=!m0(function(){Of(function(){})}),Ey=b0||$0;bj({target:"Reflect",stat:!0,forced:Ey,sham:Ey},{construct:function(n,e){wy(n),_j(e);var t=arguments.length<3?n:wy(arguments[2]);if($0&&!b0)return Of(n,e,t);if(n===t){switch(e.length){case 0:return new n;case 1:return new n(e[0]);case 2:return new n(e[0],e[1]);case 3:return new n(e[0],e[1],e[2]);case 4:return new n(e[0],e[1],e[2],e[3])}var i=[null];return ah(Oj,i,e),new(ah(wj,n,i))}var a=t.prototype,o=Ej(_y(a)?a:Sj),s=ah(n,o,e);return _y(s)?s:o}});var Tj=pe,Pj=Tj.Reflect.construct,Ij=Pj,kj=Ij,Cj=kj,ks=G(Cj),xj=pe,Aj=xj.Object.getOwnPropertySymbols,Rj=Aj,Dj=Rj,Mj=Dj,Sy=G(Mj),w0={exports:{}},Nj=H,Fj=ne,Bj=ur,_0=Ai.f,E0=Le,Lj=!E0||Fj(function(){_0(1)});Nj({target:"Object",stat:!0,forced:Lj,sham:!E0},{getOwnPropertyDescriptor:function(n,e){return _0(Bj(n),e)}});var jj=pe,S0=jj.Object,zj=w0.exports=function(n,e){return S0.getOwnPropertyDescriptor(n,e)};S0.getOwnPropertyDescriptor.sham&&(zj.sham=!0);var Hj=w0.exports,Wj=Hj,Uj=Wj,Vj=Uj,O0=G(Vj),Gj=H,Kj=Le,qj=yf,Yj=ur,Xj=Ai,Qj=Hn;Gj({target:"Object",stat:!0,sham:!Kj},{getOwnPropertyDescriptors:function(n){for(var e=Yj(n),t=Xj.f,i=qj(e),a={},o=0,s,u;i.length>o;)u=t(e,s=i[o++]),u!==void 0&&Qj(a,s,u);return a}});var Jj=pe,Zj=Jj.Object.getOwnPropertyDescriptors,ez=Zj,tz=ez,rz=tz,Oy=G(rz),T0={exports:{}},iz=H,nz=Le,Ty=Tu.f;iz({target:"Object",stat:!0,forced:Object.defineProperties!==Ty,sham:!nz},{defineProperties:Ty});var az=pe,P0=az.Object,oz=T0.exports=function(n,e){return P0.defineProperties(n,e)};P0.defineProperties.sham&&(oz.sham=!0);var sz=T0.exports,uz=sz,lz=uz,hz=lz,dz=G(hz),cz=a1,fz=G(cz);function I0(r){if(r===void 0)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return r}var vz=Nw,pz=vz,yz=pz,gz=yz,k0=gz,mz=G(k0),bz=H,$z=Y1;bz({target:"Object",stat:!0},{setPrototypeOf:$z});var wz=pe,_z=wz.Object.setPrototypeOf,Ez=_z,Sz=Ez,Oz=Sz,Tz=Oz,Pz=Tz,Iz=Pz,C0=Iz,Zd=G(C0),kz=dw,Cz=kz,xz=Cz,Az=xz,Rz=Az,x0=G(Rz);function ec(r,n){var e;return ec=Zd?x0(e=Zd).call(e):function(i,a){return i.__proto__=a,i},ec(r,n)}function Dz(r,n){if(typeof n!="function"&&n!==null)throw new TypeError("Super expression must either be null or a function");r.prototype=mz(n.prototype,{constructor:{value:r,writable:!0,configurable:!0}}),wu(r,"prototype",{writable:!1}),ec(r,n)}function Mz(r,n){if(n&&(Sn(n)==="object"||typeof n=="function"))return n;if(n!==void 0)throw new TypeError("Derived constructors may only return object or undefined");return I0(r)}var Nz=HB,Fz=Nz,Bz=Fz,Lz=Bz,A0=Lz,Py=G(A0);function Js(r){var n;return Js=Zd?x0(n=Py).call(n):function(t){return t.__proto__||Py(t)},Js(r)}var R0={exports:{}},D0={exports:{}};(function(r){var n=df,e=ow;function t(i){"@babel/helpers - typeof";return r.exports=t=typeof n=="function"&&typeof e=="symbol"?function(a){return typeof a}:function(a){return a&&typeof n=="function"&&a.constructor===n&&a!==n.prototype?"symbol":typeof a},r.exports.__esModule=!0,r.exports.default=r.exports,t(i)}r.exports=t,r.exports.__esModule=!0,r.exports.default=r.exports})(D0);var jz=D0.exports,zz=xw,Hz=zz,Wz=Hz,Uz=Wz,Vz=Uz,Iy=Me,Gz=yf,Kz=Ai,qz=_t,Yz=function(r,n,e){for(var t=Gz(n),i=qz.f,a=Kz.f,o=0;o<t.length;o++){var s=t[o];!Iy(r,s)&&!(e&&Iy(e,s))&&i(r,s,a(n,s))}},Xz=Xe,Qz=Pr,Jz=function(r,n){Xz(n)&&"cause"in n&&Qz(r,"cause",n.cause)},Zz=fe,M0=Error,e3=Zz("".replace),t3=function(r){return String(new M0(r).stack)}("zxcasd"),N0=/\n\s*at [^:]*:[^\n]*/,r3=N0.test(t3),i3=function(r,n){if(r3&&typeof r=="string"&&!M0.prepareStackTrace)for(;n--;)r=e3(r,N0,"");return r},n3=ne,a3=Ri,o3=!n3(function(){var r=new Error("a");return"stack"in r?(Object.defineProperty(r,"stack",a3(1,7)),r.stack!==7):!0}),s3=Pr,u3=i3,l3=o3,ky=Error.captureStackTrace,h3=function(r,n,e,t){l3&&(ky?ky(r,n):s3(r,"stack",u3(e,t)))},d3=Zr,c3=je,f3=Ct,v3=jn,p3=pw,y3=xt,Cy=De,g3=ff,m3=Bu,xy=vw,b3=TypeError,Cs=function(r,n){this.stopped=r,this.result=n},Ay=Cs.prototype,Bi=function(r,n,e){var t=e&&e.that,i=!!(e&&e.AS_ENTRIES),a=!!(e&&e.IS_RECORD),o=!!(e&&e.IS_ITERATOR),s=!!(e&&e.INTERRUPTED),u=d3(n,t),l,h,d,c,f,v,p,y=function(m){return l&&xy(l,"normal",m),new Cs(!0,m)},g=function(m){return i?(f3(m),s?u(m[0],m[1],y):u(m[0],m[1])):s?u(m,y):u(m)};if(a)l=r.iterator;else if(o)l=r;else{if(h=m3(r),!h)throw new b3(v3(r)+" is not iterable");if(p3(h)){for(d=0,c=y3(r);c>d;d++)if(f=g(r[d]),f&&Cy(Ay,f))return f;return new Cs(!1)}l=g3(r,h)}for(v=a?r.next:l.next;!(p=c3(v,l)).done;){try{f=g(p.value)}catch(m){xy(l,"throw",m)}if(typeof f=="object"&&f&&Cy(Ay,f))return f}return new Cs(!1)},$3=Di,w3=function(r,n){return r===void 0?arguments.length<2?"":n:$3(r)},_3=H,E3=De,S3=Mu,Zs=Y1,O3=Yz,F0=Mi,oh=Pr,sh=Ri,T3=Jz,P3=h3,I3=Bi,k3=w3,C3=ge,x3=C3("toStringTag"),eu=Error,A3=[].push,In=function(n,e){var t=E3(uh,this),i;Zs?i=Zs(new eu,t?S3(this):uh):(i=t?this:F0(uh),oh(i,x3,"Error")),e!==void 0&&oh(i,"message",k3(e)),P3(i,In,i.stack,1),arguments.length>2&&T3(i,arguments[2]);var a=[];return I3(n,A3,{that:a}),oh(i,"errors",a),i};Zs?Zs(In,eu):O3(In,eu,{name:!0});var uh=In.prototype=F0(eu.prototype,{constructor:sh(1,In),message:sh(1,""),name:sh(1,"AggregateError")});_3({global:!0,constructor:!0,arity:2},{AggregateError:In});var R3=lt,D3=tf,M3=ge,N3=Le,Ry=M3("species"),B0=function(r){var n=R3(r);N3&&n&&!n[Ry]&&D3(n,Ry,{configurable:!0,get:function(){return this}})},F3=De,B3=TypeError,Tf=function(r,n){if(F3(n,r))return r;throw new B3("Incorrect invocation")},Dy=Ct,L3=g0,j3=Fn,z3=ge,H3=z3("species"),L0=function(r,n){var e=Dy(r).constructor,t;return e===void 0||j3(t=Dy(e)[H3])?n:L3(t)},W3=Jr,j0=/(?:ipad|iphone|ipod).*applewebkit/i.test(W3),kt=ve,U3=Nn,V3=Zr,My=$e,G3=Me,z0=ne,Ny=p1,K3=no,Fy=Xc,q3=Fw,Y3=j0,X3=oo,tc=kt.setImmediate,rc=kt.clearImmediate,Q3=kt.process,lh=kt.Dispatch,J3=kt.Function,By=kt.MessageChannel,Z3=kt.String,hh=0,_a={},Ly="onreadystatechange",La,si,dh,ch;z0(function(){La=kt.location});var Pf=function(r){if(G3(_a,r)){var n=_a[r];delete _a[r],n()}},fh=function(r){return function(){Pf(r)}},jy=function(r){Pf(r.data)},zy=function(r){kt.postMessage(Z3(r),La.protocol+"//"+La.host)};(!tc||!rc)&&(tc=function(n){q3(arguments.length,1);var e=My(n)?n:J3(n),t=K3(arguments,1);return _a[++hh]=function(){U3(e,void 0,t)},si(hh),hh},rc=function(n){delete _a[n]},X3?si=function(r){Q3.nextTick(fh(r))}:lh&&lh.now?si=function(r){lh.now(fh(r))}:By&&!Y3?(dh=new By,ch=dh.port2,dh.port1.onmessage=jy,si=V3(ch.postMessage,ch)):kt.addEventListener&&My(kt.postMessage)&&!kt.importScripts&&La&&La.protocol!=="file:"&&!z0(zy)?(si=zy,kt.addEventListener("message",jy,!1)):Ly in Fy("script")?si=function(r){Ny.appendChild(Fy("script"))[Ly]=function(){Ny.removeChild(this),Pf(r)}}:si=function(r){setTimeout(fh(r),0)});var H0={set:tc,clear:rc},W0=function(){this.head=null,this.tail=null};W0.prototype={add:function(r){var n={item:r,next:null},e=this.tail;e?e.next=n:this.head=n,this.tail=n},get:function(){var r=this.head;if(r){var n=this.head=r.next;return n===null&&(this.tail=null),r.item}}};var U0=W0,e5=Jr,t5=/ipad|iphone|ipod/i.test(e5)&&typeof Pebble<"u",r5=Jr,i5=/web0s(?!.*chrome)/i.test(r5),Pi=ve,Hy=Zr,n5=Ai.f,vh=H0.set,a5=U0,o5=j0,s5=t5,u5=i5,ph=oo,Wy=Pi.MutationObserver||Pi.WebKitMutationObserver,Uy=Pi.document,Vy=Pi.process,Zo=Pi.Promise,Gy=n5(Pi,"queueMicrotask"),ic=Gy&&Gy.value,Qi,yh,gh,es,Ky;if(!ic){var ts=new a5,rs=function(){var r,n;for(ph&&(r=Vy.domain)&&r.exit();n=ts.get();)try{n()}catch(e){throw ts.head&&Qi(),e}r&&r.enter()};!o5&&!ph&&!u5&&Wy&&Uy?(yh=!0,gh=Uy.createTextNode(""),new Wy(rs).observe(gh,{characterData:!0}),Qi=function(){gh.data=yh=!yh}):!s5&&Zo&&Zo.resolve?(es=Zo.resolve(void 0),es.constructor=Zo,Ky=Hy(es.then,es),Qi=function(){Ky(rs)}):ph?Qi=function(){Vy.nextTick(rs)}:(vh=Hy(vh,Pi),Qi=function(){vh(rs)}),ic=function(r){ts.head||Qi(),ts.add(r)}}var l5=ic,h5=function(r,n){try{arguments.length===1?console.error(r):console.error(r,n)}catch{}},qn=function(r){try{return{error:!1,value:r()}}catch(n){return{error:!0,value:n}}},d5=ve,Yn=d5.Promise,V0=typeof Deno=="object"&&Deno&&typeof Deno.version=="object",c5=V0,f5=oo,v5=!c5&&!f5&&typeof window=="object"&&typeof document=="object",p5=ve,Ea=Yn,y5=$e,g5=r1,m5=u1,b5=ge,$5=v5,w5=V0,mh=Bn,qy=Ea&&Ea.prototype,_5=b5("species"),nc=!1,G0=y5(p5.PromiseRejectionEvent),E5=g5("Promise",function(){var r=m5(Ea),n=r!==String(Ea);if(!n&&mh===66||!(qy.catch&&qy.finally))return!0;if(!mh||mh<51||!/native code/.test(r)){var e=new Ea(function(a){a(1)}),t=function(a){a(function(){},function(){})},i=e.constructor={};if(i[_5]=t,nc=e.then(function(){})instanceof t,!nc)return!0}return!n&&($5||w5)&&!G0}),fo={CONSTRUCTOR:E5,REJECTION_EVENT:G0,SUBCLASSING:nc},lr={},Yy=$t,S5=TypeError,O5=function(r){var n,e;this.promise=new r(function(t,i){if(n!==void 0||e!==void 0)throw new S5("Bad Promise constructor");n=t,e=i}),this.resolve=Yy(n),this.reject=Yy(e)};lr.f=function(r){return new O5(r)};var T5=H,tu=oo,Kr=ve,vo=je,P5=Wn,I5=Ni,k5=B0,C5=$t,ac=$e,x5=Xe,A5=Tf,R5=L0,K0=H0.set,If=l5,D5=h5,M5=qn,N5=U0,q0=Un,oc=Yn,Y0=fo,X0=lr,Uu="Promise",Q0=Y0.CONSTRUCTOR,F5=Y0.REJECTION_EVENT,bh=q0.getterFor(Uu),B5=q0.set,L5=oc&&oc.prototype,dn=oc,$h=L5,J0=Kr.TypeError,sc=Kr.document,kf=Kr.process,uc=X0.f,j5=uc,z5=!!(sc&&sc.createEvent&&Kr.dispatchEvent),Z0="unhandledrejection",H5="rejectionhandled",Xy=0,e_=1,W5=2,Cf=1,t_=2,is,Qy,U5,r_=function(r){var n;return x5(r)&&ac(n=r.then)?n:!1},i_=function(r,n){var e=n.value,t=n.state===e_,i=t?r.ok:r.fail,a=r.resolve,o=r.reject,s=r.domain,u,l,h;try{i?(t||(n.rejection===t_&&G5(n),n.rejection=Cf),i===!0?u=e:(s&&s.enter(),u=i(e),s&&(s.exit(),h=!0)),u===r.promise?o(new J0("Promise-chain cycle")):(l=r_(u))?vo(l,u,a,o):a(u)):o(e)}catch(d){s&&!h&&s.exit(),o(d)}},n_=function(r,n){r.notified||(r.notified=!0,If(function(){for(var e=r.reactions,t;t=e.get();)i_(t,r);r.notified=!1,n&&!r.rejection&&V5(r)}))},a_=function(r,n,e){var t,i;z5?(t=sc.createEvent("Event"),t.promise=n,t.reason=e,t.initEvent(r,!1,!0),Kr.dispatchEvent(t)):t={promise:n,reason:e},!F5&&(i=Kr["on"+r])?i(t):r===Z0&&D5("Unhandled promise rejection",e)},V5=function(r){vo(K0,Kr,function(){var n=r.facade,e=r.value,t=Jy(r),i;if(t&&(i=M5(function(){tu?kf.emit("unhandledRejection",e,n):a_(Z0,n,e)}),r.rejection=tu||Jy(r)?t_:Cf,i.error))throw i.value})},Jy=function(r){return r.rejection!==Cf&&!r.parent},G5=function(r){vo(K0,Kr,function(){var n=r.facade;tu?kf.emit("rejectionHandled",n):a_(H5,n,r.value)})},cn=function(r,n,e){return function(t){r(n,t,e)}},mn=function(r,n,e){r.done||(r.done=!0,e&&(r=e),r.value=n,r.state=W5,n_(r,!0))},lc=function(r,n,e){if(!r.done){r.done=!0,e&&(r=e);try{if(r.facade===n)throw new J0("Promise can't be resolved itself");var t=r_(n);t?If(function(){var i={done:!1};try{vo(t,n,cn(lc,i,r),cn(mn,i,r))}catch(a){mn(i,a,r)}}):(r.value=n,r.state=e_,n_(r,!1))}catch(i){mn({done:!1},i,r)}}};Q0&&(dn=function(n){A5(this,$h),C5(n),vo(is,this);var e=bh(this);try{n(cn(lc,e),cn(mn,e))}catch(t){mn(e,t)}},$h=dn.prototype,is=function(n){B5(this,{type:Uu,done:!1,notified:!1,parent:!1,reactions:new N5,rejection:!1,state:Xy,value:void 0})},is.prototype=P5($h,"then",function(n,e){var t=bh(this),i=uc(R5(this,dn));return t.parent=!0,i.ok=ac(n)?n:!0,i.fail=ac(e)&&e,i.domain=tu?kf.domain:void 0,t.state===Xy?t.reactions.add(i):If(function(){i_(i,t)}),i.promise}),Qy=function(){var r=new is,n=bh(r);this.promise=r,this.resolve=cn(lc,n),this.reject=cn(mn,n)},X0.f=uc=function(r){return r===dn||r===U5?new Qy(r):j5(r)});T5({global:!0,constructor:!0,wrap:!0,forced:Q0},{Promise:dn});I5(dn,Uu,!1,!0);k5(Uu);var K5=Yn,q5=mw,Y5=fo.CONSTRUCTOR,Vu=Y5||!q5(function(r){K5.all(r).then(void 0,function(){})}),X5=H,Q5=je,J5=$t,Z5=lr,eH=qn,tH=Bi,rH=Vu;X5({target:"Promise",stat:!0,forced:rH},{all:function(n){var e=this,t=Z5.f(e),i=t.resolve,a=t.reject,o=eH(function(){var s=J5(e.resolve),u=[],l=0,h=1;tH(n,function(d){var c=l++,f=!1;h++,Q5(s,e,d).then(function(v){f||(f=!0,u[c]=v,--h||i(u))},a)}),--h||i(u)});return o.error&&a(o.value),t.promise}});var iH=H,nH=fo.CONSTRUCTOR,Zy=Yn;Zy&&Zy.prototype;iH({target:"Promise",proto:!0,forced:nH,real:!0},{catch:function(r){return this.then(void 0,r)}});var aH=H,oH=je,sH=$t,uH=lr,lH=qn,hH=Bi,dH=Vu;aH({target:"Promise",stat:!0,forced:dH},{race:function(n){var e=this,t=uH.f(e),i=t.reject,a=lH(function(){var o=sH(e.resolve);hH(n,function(s){oH(o,e,s).then(t.resolve,i)})});return a.error&&i(a.value),t.promise}});var cH=H,fH=je,vH=lr,pH=fo.CONSTRUCTOR;cH({target:"Promise",stat:!0,forced:pH},{reject:function(n){var e=vH.f(this);return fH(e.reject,void 0,n),e.promise}});var yH=Ct,gH=Xe,mH=lr,o_=function(r,n){if(yH(r),gH(n)&&n.constructor===r)return n;var e=mH.f(r),t=e.resolve;return t(n),e.promise},bH=H,$H=lt,wH=CT,_H=Yn,EH=fo.CONSTRUCTOR,SH=o_,OH=$H("Promise"),TH=!EH;bH({target:"Promise",stat:!0,forced:wH},{resolve:function(n){return SH(TH&&this===OH?_H:this,n)}});var PH=H,IH=je,kH=$t,CH=lr,xH=qn,AH=Bi,RH=Vu;PH({target:"Promise",stat:!0,forced:RH},{allSettled:function(n){var e=this,t=CH.f(e),i=t.resolve,a=t.reject,o=xH(function(){var s=kH(e.resolve),u=[],l=0,h=1;AH(n,function(d){var c=l++,f=!1;h++,IH(s,e,d).then(function(v){f||(f=!0,u[c]={status:"fulfilled",value:v},--h||i(u))},function(v){f||(f=!0,u[c]={status:"rejected",reason:v},--h||i(u))})}),--h||i(u)});return o.error&&a(o.value),t.promise}});var DH=H,MH=je,NH=$t,FH=lt,BH=lr,LH=qn,jH=Bi,zH=Vu,eg="No one promise resolved";DH({target:"Promise",stat:!0,forced:zH},{any:function(n){var e=this,t=FH("AggregateError"),i=BH.f(e),a=i.resolve,o=i.reject,s=LH(function(){var u=NH(e.resolve),l=[],h=0,d=1,c=!1;jH(n,function(f){var v=h++,p=!1;d++,MH(u,e,f).then(function(y){p||c||(c=!0,a(y))},function(y){p||c||(p=!0,l[v]=y,--d||o(new t(l,eg)))})}),--d||o(new t(l,eg))});return s.error&&o(s.value),i.promise}});var HH=H,hc=Yn,WH=ne,UH=lt,VH=$e,GH=L0,tg=o_,KH=hc&&hc.prototype,qH=!!hc&&WH(function(){KH.finally.call({then:function(){}},function(){})});HH({target:"Promise",proto:!0,real:!0,forced:qH},{finally:function(r){var n=GH(this,UH("Promise")),e=VH(r);return this.then(e?function(t){return tg(n,r()).then(function(){return t})}:r,e?function(t){return tg(n,r()).then(function(){throw t})}:r)}});var YH=pe,XH=YH.Promise,QH=XH,JH=QH,ZH=H,eW=lr;ZH({target:"Promise",stat:!0},{withResolvers:function(){var n=eW.f(this);return{promise:n.promise,resolve:n.resolve,reject:n.reject}}});var tW=JH,rW=tW,iW=H,nW=lr,aW=qn;iW({target:"Promise",stat:!0,forced:!0},{try:function(r){var n=nW.f(this),e=aW(r);return(e.error?n.reject:n.resolve)(e.value),n.promise}});var oW=rW,sW=oW,uW=sW,lW=Aw,hW=lW,dW=hW,cW=dW,fW=cW;(function(r){var n=jz.default,e=o1,t=df,i=k0,a=A0,o=Vz,s=Ow,u=C0,l=uW,h=fW,d=Pw;function c(){r.exports=c=function(){return v},r.exports.__esModule=!0,r.exports.default=r.exports;var f,v={},p=Object.prototype,y=p.hasOwnProperty,g=e||function(A,T,P){A[T]=P.value},m=typeof t=="function"?t:{},w=m.iterator||"@@iterator",$=m.asyncIterator||"@@asyncIterator",E=m.toStringTag||"@@toStringTag";function k(A,T,P){return e(A,T,{value:P,enumerable:!0,configurable:!0,writable:!0}),A[T]}try{k({},"")}catch{k=function(P,z,q){return P[z]=q}}function D(A,T,P,z){var q=T&&T.prototype instanceof ye?T:ye,K=i(q.prototype),Te=new Tt(z||[]);return g(K,"_invoke",{value:Ce(A,P,Te)}),K}function j(A,T,P){try{return{type:"normal",arg:A.call(T,P)}}catch(z){return{type:"throw",arg:z}}}v.wrap=D;var R="suspendedStart",M="suspendedYield",W="executing",X="completed",Y={};function ye(){}function Ge(){}function ke(){}var St={};k(St,w,function(){return this});var rt=a,Qe=rt&&rt(rt(et([])));Qe&&Qe!==p&&y.call(Qe,w)&&(St=Qe);var Ot=ke.prototype=ye.prototype=i(St);function Je(A){var T;o(T=["next","throw","return"]).call(T,function(P){k(A,P,function(z){return this._invoke(P,z)})})}function ce(A,T){function P(q,K,Te,it){var ht=j(A[q],A,K);if(ht.type!=="throw"){var ai=ht.arg,Cr=ai.value;return Cr&&n(Cr)=="object"&&y.call(Cr,"__await")?T.resolve(Cr.__await).then(function(oi){P("next",oi,Te,it)},function(oi){P("throw",oi,Te,it)}):T.resolve(Cr).then(function(oi){ai.value=oi,Te(ai)},function(oi){return P("throw",oi,Te,it)})}it(ht.arg)}var z;g(this,"_invoke",{value:function(K,Te){function it(){return new T(function(ht,ai){P(K,Te,ht,ai)})}return z=z?z.then(it,it):it()}})}function Ce(A,T,P){var z=R;return function(q,K){if(z===W)throw new Error("Generator is already running");if(z===X){if(q==="throw")throw K;return{value:f,done:!0}}for(P.method=q,P.arg=K;;){var Te=P.delegate;if(Te){var it=Oe(Te,P);if(it){if(it===Y)continue;return it}}if(P.method==="next")P.sent=P._sent=P.arg;else if(P.method==="throw"){if(z===R)throw z=X,P.arg;P.dispatchException(P.arg)}else P.method==="return"&&P.abrupt("return",P.arg);z=W;var ht=j(A,T,P);if(ht.type==="normal"){if(z=P.done?X:M,ht.arg===Y)continue;return{value:ht.arg,done:P.done}}ht.type==="throw"&&(z=X,P.method="throw",P.arg=ht.arg)}}}function Oe(A,T){var P=T.method,z=A.iterator[P];if(z===f)return T.delegate=null,P==="throw"&&A.iterator.return&&(T.method="return",T.arg=f,Oe(A,T),T.method==="throw")||P!=="return"&&(T.method="throw",T.arg=new TypeError("The iterator does not provide a '"+P+"' method")),Y;var q=j(z,A.iterator,T.arg);if(q.type==="throw")return T.method="throw",T.arg=q.arg,T.delegate=null,Y;var K=q.arg;return K?K.done?(T[A.resultName]=K.value,T.next=A.nextLoc,T.method!=="return"&&(T.method="next",T.arg=f),T.delegate=null,Y):K:(T.method="throw",T.arg=new TypeError("iterator result is not an object"),T.delegate=null,Y)}function Ze(A){var T,P={tryLoc:A[0]};1 in A&&(P.catchLoc=A[1]),2 in A&&(P.finallyLoc=A[2],P.afterLoc=A[3]),s(T=this.tryEntries).call(T,P)}function cr(A){var T=A.completion||{};T.type="normal",delete T.arg,A.completion=T}function Tt(A){this.tryEntries=[{tryLoc:"root"}],o(A).call(A,Ze,this),this.reset(!0)}function et(A){if(A||A===""){var T=A[w];if(T)return T.call(A);if(typeof A.next=="function")return A;if(!isNaN(A.length)){var P=-1,z=function q(){for(;++P<A.length;)if(y.call(A,P))return q.value=A[P],q.done=!1,q;return q.value=f,q.done=!0,q};return z.next=z}}throw new TypeError(n(A)+" is not iterable")}return Ge.prototype=ke,g(Ot,"constructor",{value:ke,configurable:!0}),g(ke,"constructor",{value:Ge,configurable:!0}),Ge.displayName=k(ke,E,"GeneratorFunction"),v.isGeneratorFunction=function(A){var T=typeof A=="function"&&A.constructor;return!!T&&(T===Ge||(T.displayName||T.name)==="GeneratorFunction")},v.mark=function(A){return u?u(A,ke):(A.__proto__=ke,k(A,E,"GeneratorFunction")),A.prototype=i(Ot),A},v.awrap=function(A){return{__await:A}},Je(ce.prototype),k(ce.prototype,$,function(){return this}),v.AsyncIterator=ce,v.async=function(A,T,P,z,q){q===void 0&&(q=l);var K=new ce(D(A,T,P,z),q);return v.isGeneratorFunction(T)?K:K.next().then(function(Te){return Te.done?Te.value:K.next()})},Je(Ot),k(Ot,E,"Generator"),k(Ot,w,function(){return this}),k(Ot,"toString",function(){return"[object Generator]"}),v.keys=function(A){var T=Object(A),P=[];for(var z in T)s(P).call(P,z);return h(P).call(P),function q(){for(;P.length;){var K=P.pop();if(K in T)return q.value=K,q.done=!1,q}return q.done=!0,q}},v.values=et,Tt.prototype={constructor:Tt,reset:function(T){var P;if(this.prev=0,this.next=0,this.sent=this._sent=f,this.done=!1,this.delegate=null,this.method="next",this.arg=f,o(P=this.tryEntries).call(P,cr),!T)for(var z in this)z.charAt(0)==="t"&&y.call(this,z)&&!isNaN(+d(z).call(z,1))&&(this[z]=f)},stop:function(){this.done=!0;var T=this.tryEntries[0].completion;if(T.type==="throw")throw T.arg;return this.rval},dispatchException:function(T){if(this.done)throw T;var P=this;function z(ai,Cr){return Te.type="throw",Te.arg=T,P.next=ai,Cr&&(P.method="next",P.arg=f),!!Cr}for(var q=this.tryEntries.length-1;q>=0;--q){var K=this.tryEntries[q],Te=K.completion;if(K.tryLoc==="root")return z("end");if(K.tryLoc<=this.prev){var it=y.call(K,"catchLoc"),ht=y.call(K,"finallyLoc");if(it&&ht){if(this.prev<K.catchLoc)return z(K.catchLoc,!0);if(this.prev<K.finallyLoc)return z(K.finallyLoc)}else if(it){if(this.prev<K.catchLoc)return z(K.catchLoc,!0)}else{if(!ht)throw new Error("try statement without catch or finally");if(this.prev<K.finallyLoc)return z(K.finallyLoc)}}}},abrupt:function(T,P){for(var z=this.tryEntries.length-1;z>=0;--z){var q=this.tryEntries[z];if(q.tryLoc<=this.prev&&y.call(q,"finallyLoc")&&this.prev<q.finallyLoc){var K=q;break}}K&&(T==="break"||T==="continue")&&K.tryLoc<=P&&P<=K.finallyLoc&&(K=null);var Te=K?K.completion:{};return Te.type=T,Te.arg=P,K?(this.method="next",this.next=K.finallyLoc,Y):this.complete(Te)},complete:function(T,P){if(T.type==="throw")throw T.arg;return T.type==="break"||T.type==="continue"?this.next=T.arg:T.type==="return"?(this.rval=this.arg=T.arg,this.method="return",this.next="end"):T.type==="normal"&&P&&(this.next=P),Y},finish:function(T){for(var P=this.tryEntries.length-1;P>=0;--P){var z=this.tryEntries[P];if(z.finallyLoc===T)return this.complete(z.completion,z.afterLoc),cr(z),Y}},catch:function(T){for(var P=this.tryEntries.length-1;P>=0;--P){var z=this.tryEntries[P];if(z.tryLoc===T){var q=z.completion;if(q.type==="throw"){var K=q.arg;cr(z)}return K}}throw new Error("illegal catch attempt")},delegateYield:function(T,P,z){return this.delegate={iterator:et(T),resultName:P,nextLoc:z},this.method==="next"&&(this.arg=f),Y}},v}r.exports=c,r.exports.__esModule=!0,r.exports.default=r.exports})(R0);var vW=R0.exports,xs=vW(),pW=xs;try{regeneratorRuntime=xs}catch{typeof globalThis=="object"?globalThis.regeneratorRuntime=xs:Function("r","regeneratorRuntime = r")(xs)}var ct=G(pW),s_={exports:{}},yW=ne,gW=yW(function(){if(typeof ArrayBuffer=="function"){var r=new ArrayBuffer(8);Object.isExtensible(r)&&Object.defineProperty(r,"a",{value:8})}}),mW=ne,bW=Xe,$W=Qr,rg=gW,As=Object.isExtensible,wW=mW(function(){As(1)}),_W=wW||rg?function(n){return!bW(n)||rg&&$W(n)==="ArrayBuffer"?!1:As?As(n):!0}:As,EW=ne,SW=!EW(function(){return Object.isExtensible(Object.preventExtensions({}))}),OW=H,TW=fe,PW=Ja,IW=Xe,xf=Me,kW=_t.f,ig=Za,CW=ef,Af=_W,xW=bu,AW=SW,u_=!1,Sr=xW("meta"),RW=0,Rf=function(r){kW(r,Sr,{value:{objectID:"O"+RW++,weakData:{}}})},DW=function(r,n){if(!IW(r))return typeof r=="symbol"?r:(typeof r=="string"?"S":"P")+r;if(!xf(r,Sr)){if(!Af(r))return"F";if(!n)return"E";Rf(r)}return r[Sr].objectID},MW=function(r,n){if(!xf(r,Sr)){if(!Af(r))return!0;if(!n)return!1;Rf(r)}return r[Sr].weakData},NW=function(r){return AW&&u_&&Af(r)&&!xf(r,Sr)&&Rf(r),r},FW=function(){BW.enable=function(){},u_=!0;var r=ig.f,n=TW([].splice),e={};e[Sr]=1,r(e).length&&(ig.f=function(t){for(var i=r(t),a=0,o=i.length;a<o;a++)if(i[a]===Sr){n(i,a,1);break}return i},OW({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:CW.f}))},BW=s_.exports={enable:FW,fastKey:DW,getWeakData:MW,onFreeze:NW};PW[Sr]=!0;var l_=s_.exports,LW=H,jW=ve,zW=l_,HW=ne,WW=Pr,UW=Bi,VW=Tf,GW=$e,KW=Xe,qW=Fn,YW=Ni,XW=_t.f,QW=Vn.forEach,JW=Le,h_=Un,ZW=h_.set,e4=h_.getterFor,d_=function(r,n,e){var t=r.indexOf("Map")!==-1,i=r.indexOf("Weak")!==-1,a=t?"set":"add",o=jW[r],s=o&&o.prototype,u={},l;if(!JW||!GW(o)||!(i||s.forEach&&!HW(function(){new o().entries().next()})))l=e.getConstructor(n,r,t,a),zW.enable();else{l=n(function(c,f){ZW(VW(c,h),{type:r,collection:new o}),qW(f)||UW(f,c[a],{that:c,AS_ENTRIES:t})});var h=l.prototype,d=e4(r);QW(["add","clear","delete","forEach","get","has","set","keys","values","entries"],function(c){var f=c==="add"||c==="set";c in s&&!(i&&c==="clear")&&WW(h,c,function(v,p){var y=d(this).collection;if(!f&&i&&!KW(v))return c==="get"?void 0:!1;var g=y[c](v===0?0:v,p);return f?this:g})}),i||XW(h,"size",{configurable:!0,get:function(){return d(this).collection.size}})}return YW(l,r,!1,!0),u[r]=l,LW({global:!0,forced:!0},u),i||e.setStrong(l,r,t),l},t4=Wn,r4=function(r,n,e){for(var t in n)e&&e.unsafe&&r[t]?r[t]=n[t]:t4(r,t,n[t],e);return r},i4=Mi,n4=tf,ng=r4,a4=Zr,o4=Tf,s4=Fn,u4=Bi,l4=uf,ns=lf,h4=B0,ha=Le,ag=l_.fastKey,c_=Un,og=c_.set,wh=c_.getterFor,f_={getConstructor:function(r,n,e,t){var i=r(function(l,h){o4(l,a),og(l,{type:n,index:i4(null),first:void 0,last:void 0,size:0}),ha||(l.size=0),s4(h)||u4(h,l[t],{that:l,AS_ENTRIES:e})}),a=i.prototype,o=wh(n),s=function(l,h,d){var c=o(l),f=u(l,h),v,p;return f?f.value=d:(c.last=f={index:p=ag(h,!0),key:h,value:d,previous:v=c.last,next:void 0,removed:!1},c.first||(c.first=f),v&&(v.next=f),ha?c.size++:l.size++,p!=="F"&&(c.index[p]=f)),l},u=function(l,h){var d=o(l),c=ag(h),f;if(c!=="F")return d.index[c];for(f=d.first;f;f=f.next)if(f.key===h)return f};return ng(a,{clear:function(){for(var h=this,d=o(h),c=d.index,f=d.first;f;)f.removed=!0,f.previous&&(f.previous=f.previous.next=void 0),delete c[f.index],f=f.next;d.first=d.last=void 0,ha?d.size=0:h.size=0},delete:function(l){var h=this,d=o(h),c=u(h,l);if(c){var f=c.next,v=c.previous;delete d.index[c.index],c.removed=!0,v&&(v.next=f),f&&(f.previous=v),d.first===c&&(d.first=f),d.last===c&&(d.last=v),ha?d.size--:h.size--}return!!c},forEach:function(h){for(var d=o(this),c=a4(h,arguments.length>1?arguments[1]:void 0),f;f=f?f.next:d.first;)for(c(f.value,f.key,this);f&&f.removed;)f=f.previous},has:function(h){return!!u(this,h)}}),ng(a,e?{get:function(h){var d=u(this,h);return d&&d.value},set:function(h,d){return s(this,h===0?0:h,d)}}:{add:function(h){return s(this,h=h===0?0:h,h)}}),ha&&n4(a,"size",{configurable:!0,get:function(){return o(this).size}}),i},setStrong:function(r,n,e){var t=n+" Iterator",i=wh(n),a=wh(t);l4(r,n,function(o,s){og(this,{type:t,target:o,state:i(o),kind:s,last:void 0})},function(){for(var o=a(this),s=o.kind,u=o.last;u&&u.removed;)u=u.previous;return!o.target||!(o.last=u=u?u.next:o.state.first)?(o.target=void 0,ns(void 0,!0)):ns(s==="keys"?u.key:s==="values"?u.value:[u.key,u.value],!1)},e?"entries":"values",!e,!0),h4(n)}},d4=d_,c4=f_;d4("Map",function(r){return function(){return r(this,arguments.length?arguments[0]:void 0)}},c4);var f4=pe,v4=f4.Map,p4=v4,y4=p4,g4=y4,v_=G(g4),m4=H,b4=Vn.some,$4=Fu,w4=$4("some");m4({target:"Array",proto:!0,forced:!w4},{some:function(n){return b4(this,n,arguments.length>1?arguments[1]:void 0)}});var _4=tt,E4=_4("Array","some"),S4=De,O4=E4,_h=Array.prototype,T4=function(r){var n=r.some;return r===_h||S4(_h,r)&&n===_h.some?O4:n},P4=T4,I4=P4,k4=I4,C4=G(k4),x4=tt,A4=x4("Array","keys"),R4=A4,D4=R4,M4=Ir,N4=Me,F4=De,B4=D4,Eh=Array.prototype,L4={DOMTokenList:!0,NodeList:!0},j4=function(r){var n=r.keys;return r===Eh||F4(Eh,r)&&n===Eh.keys||N4(L4,M4(r))?B4:n},z4=j4,Ji=G(z4),sg=m1,H4=Math.floor,dc=function(r,n){var e=r.length,t=H4(e/2);return e<8?W4(r,n):U4(r,dc(sg(r,0,t),n),dc(sg(r,t),n),n)},W4=function(r,n){for(var e=r.length,t=1,i,a;t<e;){for(a=t,i=r[t];a&&n(r[a-1],i)>0;)r[a]=r[--a];a!==t++&&(r[a]=i)}return r},U4=function(r,n,e,t){for(var i=n.length,a=e.length,o=0,s=0;o<i||s<a;)r[o+s]=o<i&&s<a?t(n[o],e[s])<=0?n[o++]:e[s++]:o<i?n[o++]:e[s++];return r},V4=dc,G4=Jr,ug=G4.match(/firefox\/(\d+)/i),K4=!!ug&&+ug[1],q4=Jr,Y4=/MSIE|Trident/.test(q4),X4=Jr,lg=X4.match(/AppleWebKit\/(\d+)\./),Q4=!!lg&&+lg[1],J4=H,p_=fe,Z4=$t,e6=wt,hg=xt,t6=Rw,dg=Di,Df=ne,r6=V4,i6=Fu,cg=K4,n6=Y4,fg=Bn,vg=Q4,Fr=[],pg=p_(Fr.sort),a6=p_(Fr.push),o6=Df(function(){Fr.sort(void 0)}),s6=Df(function(){Fr.sort(null)}),u6=i6("sort"),y_=!Df(function(){if(fg)return fg<70;if(!(cg&&cg>3)){if(n6)return!0;if(vg)return vg<603;var r="",n,e,t,i;for(n=65;n<76;n++){switch(e=String.fromCharCode(n),n){case 66:case 69:case 70:case 72:t=3;break;case 68:case 71:t=4;break;default:t=2}for(i=0;i<47;i++)Fr.push({k:e+i,v:t})}for(Fr.sort(function(a,o){return o.v-a.v}),i=0;i<Fr.length;i++)e=Fr[i].k.charAt(0),r.charAt(r.length-1)!==e&&(r+=e);return r!=="DGBEFHACIJK"}}),l6=o6||!s6||!u6||!y_,h6=function(r){return function(n,e){return e===void 0?-1:n===void 0?1:r!==void 0?+r(n,e)||0:dg(n)>dg(e)?1:-1}};J4({target:"Array",proto:!0,forced:l6},{sort:function(n){n!==void 0&&Z4(n);var e=e6(this);if(y_)return n===void 0?pg(e):pg(e,n);var t=[],i=hg(e),a,o;for(o=0;o<i;o++)o in e&&a6(t,e[o]);for(r6(t,h6(n)),a=hg(t),o=0;o<a;)e[o]=t[o++];for(;o<i;)t6(e,o++);return e}});var d6=tt,c6=d6("Array","sort"),f6=De,v6=c6,Sh=Array.prototype,p6=function(r){var n=r.sort;return r===Sh||f6(Sh,r)&&n===Sh.sort?v6:n},y6=p6,g6=y6,m6=g6,cc=G(m6),b6=tt,$6=b6("Array","values"),w6=$6,_6=w6,E6=Ir,S6=Me,O6=De,T6=_6,Oh=Array.prototype,P6={DOMTokenList:!0,NodeList:!0},I6=function(r){var n=r.values;return r===Oh||O6(Oh,r)&&n===Oh.values||S6(P6,E6(r))?T6:n},k6=I6,yg=G(k6),C6=aw,fn=G(C6),x6=tt,A6=x6("Array","entries"),R6=A6,D6=R6,M6=Ir,N6=Me,F6=De,B6=D6,Th=Array.prototype,L6={DOMTokenList:!0,NodeList:!0},j6=function(r){var n=r.entries;return r===Th||F6(Th,r)&&n===Th.entries||N6(L6,M6(r))?B6:n},z6=j6,H6=G(z6);let as;const W6=new Uint8Array(16);function U6(){if(!as&&(as=typeof crypto<"u"&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!as))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return as(W6)}const Ke=[];for(let r=0;r<256;++r)Ke.push((r+256).toString(16).slice(1));function V6(r,n=0){return Ke[r[n+0]]+Ke[r[n+1]]+Ke[r[n+2]]+Ke[r[n+3]]+"-"+Ke[r[n+4]]+Ke[r[n+5]]+"-"+Ke[r[n+6]]+Ke[r[n+7]]+"-"+Ke[r[n+8]]+Ke[r[n+9]]+"-"+Ke[r[n+10]]+Ke[r[n+11]]+Ke[r[n+12]]+Ke[r[n+13]]+Ke[r[n+14]]+Ke[r[n+15]]}const G6=typeof crypto<"u"&&crypto.randomUUID&&crypto.randomUUID.bind(crypto);var gg={randomUUID:G6};function K6(r,n,e){if(gg.randomUUID&&!n&&!r)return gg.randomUUID();r=r||{};const t=r.random||(r.rng||U6)();return t[6]=t[6]&15|64,t[8]=t[8]&63|128,V6(t)}function mg(r){return typeof r=="string"||typeof r=="number"}var q6=function(){function r(n){yu(this,r),zr(this,"_queue",[]),zr(this,"_timeout",null),zr(this,"_extended",null),this.delay=null,this.max=1/0,this.setOptions(n)}return Nu(r,[{key:"setOptions",value:function(e){e&&typeof e.delay<"u"&&(this.delay=e.delay),e&&typeof e.max<"u"&&(this.max=e.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var e=this._extended.object,t=this._extended.methods,i=0;i<t.length;i++){var a=t[i];a.original?e[a.name]=a.original:delete e[a.name]}this._extended=null}}},{key:"replace",value:function(e,t){var i=this,a=e[t];if(!a)throw new Error("Method "+t+" undefined");e[t]=function(){for(var o=arguments.length,s=new Array(o),u=0;u<o;u++)s[u]=arguments[u];i.queue({args:s,fn:a,context:this})}}},{key:"queue",value:function(e){typeof e=="function"?this._queue.push({fn:e}):this._queue.push(e),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var e=this;this._queue.length>this.max&&this.flush(),this._timeout!=null&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&typeof this.delay=="number"&&(this._timeout=wL(function(){e.flush()},this.delay))}},{key:"flush",value:function(){var e,t;Ei(e=Dw(t=this._queue).call(t,0)).call(e,function(i){i.fn.apply(i.context||i.fn,i.args||[])})}}],[{key:"extend",value:function(e,t){var i=new r(t);if(e.flush!==void 0)throw new Error("Target object already has a property flush");e.flush=function(){i.flush()};var a=[{name:"flush",original:void 0}];if(t&&t.replace)for(var o=0;o<t.replace.length;o++){var s=t.replace[o];a.push({name:s,original:e[s]}),i.replace(e,s)}return i._extended={object:e,methods:a},i}}]),r}(),Y6=function(){function r(){yu(this,r),zr(this,"_subscribers",{"*":[],add:[],remove:[],update:[]}),zr(this,"subscribe",r.prototype.on),zr(this,"unsubscribe",r.prototype.off)}return Nu(r,[{key:"_trigger",value:function(e,t,i){var a,o;if(e==="*")throw new Error("Cannot trigger event *");Ei(a=ju(o=[]).call(o,pt(this._subscribers[e]),pt(this._subscribers["*"]))).call(a,function(s){s(e,t,i??null)})}},{key:"on",value:function(e,t){typeof t=="function"&&this._subscribers[e].push(t)}},{key:"off",value:function(e,t){var i;this._subscribers[e]=un(i=this._subscribers[e]).call(i,function(a){return a!==t})}}]),r}(),X6=d_,Q6=f_;X6("Set",function(r){return function(){return r(this,arguments.length?arguments[0]:void 0)}},Q6);var J6=pe,Z6=J6.Set,eU=Z6,tU=eU,rU=tU,Ph=G(rU),iU=ff,nU=iU,aU=nU,oU=aU,sU=oU,uU=sU,lU=uU,hU=lU,dU=hU,cU=dU,Ih=G(cU);function Zt(r,n){var e=typeof Lu<"u"&&pf(r)||r["@@iterator"];if(!e){if(It(r)||(e=fU(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function fU(r,n){var e;if(r){if(typeof r=="string")return bg(r,n);var t=zu(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return vf(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return bg(r,n)}}function bg(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}var $g=function(r){function n(e){yu(this,n),this._pairs=e}return Nu(n,[{key:r,value:ct.mark(function e(){var t,i,a,o,s;return ct.wrap(function(l){for(;;)switch(l.prev=l.next){case 0:t=Zt(this._pairs),l.prev=1,t.s();case 3:if((i=t.n()).done){l.next=9;break}return a=dt(i.value,2),o=a[0],s=a[1],l.next=7,[o,s];case 7:l.next=3;break;case 9:l.next=14;break;case 11:l.prev=11,l.t0=l.catch(1),t.e(l.t0);case 14:return l.prev=14,t.f(),l.finish(14);case 17:case"end":return l.stop()}},e,this,[[1,11,14,17]])})},{key:"entries",value:ct.mark(function e(){var t,i,a,o,s;return ct.wrap(function(l){for(;;)switch(l.prev=l.next){case 0:t=Zt(this._pairs),l.prev=1,t.s();case 3:if((i=t.n()).done){l.next=9;break}return a=dt(i.value,2),o=a[0],s=a[1],l.next=7,[o,s];case 7:l.next=3;break;case 9:l.next=14;break;case 11:l.prev=11,l.t0=l.catch(1),t.e(l.t0);case 14:return l.prev=14,t.f(),l.finish(14);case 17:case"end":return l.stop()}},e,this,[[1,11,14,17]])})},{key:"keys",value:ct.mark(function e(){var t,i,a,o;return ct.wrap(function(u){for(;;)switch(u.prev=u.next){case 0:t=Zt(this._pairs),u.prev=1,t.s();case 3:if((i=t.n()).done){u.next=9;break}return a=dt(i.value,1),o=a[0],u.next=7,o;case 7:u.next=3;break;case 9:u.next=14;break;case 11:u.prev=11,u.t0=u.catch(1),t.e(u.t0);case 14:return u.prev=14,t.f(),u.finish(14);case 17:case"end":return u.stop()}},e,this,[[1,11,14,17]])})},{key:"values",value:ct.mark(function e(){var t,i,a,o;return ct.wrap(function(u){for(;;)switch(u.prev=u.next){case 0:t=Zt(this._pairs),u.prev=1,t.s();case 3:if((i=t.n()).done){u.next=9;break}return a=dt(i.value,2),o=a[1],u.next=7,o;case 7:u.next=3;break;case 9:u.next=14;break;case 11:u.prev=11,u.t0=u.catch(1),t.e(u.t0);case 14:return u.prev=14,t.f(),u.finish(14);case 17:case"end":return u.stop()}},e,this,[[1,11,14,17]])})},{key:"toIdArray",value:function(){var t;return Vt(t=pt(this._pairs)).call(t,function(i){return i[0]})}},{key:"toItemArray",value:function(){var t;return Vt(t=pt(this._pairs)).call(t,function(i){return i[1]})}},{key:"toEntryArray",value:function(){return pt(this._pairs)}},{key:"toObjectMap",value:function(){var t=QB(null),i=Zt(this._pairs),a;try{for(i.s();!(a=i.n()).done;){var o=dt(a.value,2),s=o[0],u=o[1];t[s]=u}}catch(l){i.e(l)}finally{i.f()}return t}},{key:"toMap",value:function(){return new v_(this._pairs)}},{key:"toIdSet",value:function(){return new Ph(this.toIdArray())}},{key:"toItemSet",value:function(){return new Ph(this.toItemArray())}},{key:"cache",value:function(){return new n(pt(this._pairs))}},{key:"distinct",value:function(t){var i=new Ph,a=Zt(this._pairs),o;try{for(a.s();!(o=a.n()).done;){var s=dt(o.value,2),u=s[0],l=s[1];i.add(t(l,u))}}catch(h){a.e(h)}finally{a.f()}return i}},{key:"filter",value:function(t){var i=this._pairs;return new n({[fn](){return ct.mark(function a(){var o,s,u,l,h;return ct.wrap(function(c){for(;;)switch(c.prev=c.next){case 0:o=Zt(i),c.prev=1,o.s();case 3:if((s=o.n()).done){c.next=10;break}if(u=dt(s.value,2),l=u[0],h=u[1],!t(h,l)){c.next=8;break}return c.next=8,[l,h];case 8:c.next=3;break;case 10:c.next=15;break;case 12:c.prev=12,c.t0=c.catch(1),o.e(c.t0);case 15:return c.prev=15,o.f(),c.finish(15);case 18:case"end":return c.stop()}},a,null,[[1,12,15,18]])})()}})}},{key:"forEach",value:function(t){var i=Zt(this._pairs),a;try{for(i.s();!(a=i.n()).done;){var o=dt(a.value,2),s=o[0],u=o[1];t(u,s)}}catch(l){i.e(l)}finally{i.f()}}},{key:"map",value:function(t){var i=this._pairs;return new n({[fn](){return ct.mark(function a(){var o,s,u,l,h;return ct.wrap(function(c){for(;;)switch(c.prev=c.next){case 0:o=Zt(i),c.prev=1,o.s();case 3:if((s=o.n()).done){c.next=9;break}return u=dt(s.value,2),l=u[0],h=u[1],c.next=7,[l,t(h,l)];case 7:c.next=3;break;case 9:c.next=14;break;case 11:c.prev=11,c.t0=c.catch(1),o.e(c.t0);case 14:return c.prev=14,o.f(),c.finish(14);case 17:case"end":return c.stop()}},a,null,[[1,11,14,17]])})()}})}},{key:"max",value:function(t){var i=Ih(this._pairs),a=i.next();if(a.done)return null;for(var o=a.value[1],s=t(a.value[1],a.value[0]);!(a=i.next()).done;){var u=dt(a.value,2),l=u[0],h=u[1],d=t(h,l);d>s&&(s=d,o=h)}return o}},{key:"min",value:function(t){var i=Ih(this._pairs),a=i.next();if(a.done)return null;for(var o=a.value[1],s=t(a.value[1],a.value[0]);!(a=i.next()).done;){var u=dt(a.value,2),l=u[0],h=u[1],d=t(h,l);d<s&&(s=d,o=h)}return o}},{key:"reduce",value:function(t,i){var a=Zt(this._pairs),o;try{for(a.s();!(o=a.n()).done;){var s=dt(o.value,2),u=s[0],l=s[1];i=t(i,l,u)}}catch(h){a.e(h)}finally{a.f()}return i}},{key:"sort",value:function(t){var i=this;return new n({[fn]:function(){var a;return Ih(cc(a=pt(i._pairs)).call(a,function(o,s){var u=dt(o,2),l=u[0],h=u[1],d=dt(s,2),c=d[0],f=d[1];return t(h,f,l,c)}))}})}}]),n}(fn);function wg(r,n){var e=gf(r);if(Sy){var t=Sy(r);n&&(t=un(t).call(t,function(i){return O0(r,i).enumerable})),e.push.apply(e,t)}return e}function _g(r){for(var n=1;n<arguments.length;n++){var e,t,i=arguments[n]!=null?arguments[n]:{};n%2?Ei(e=wg(Object(i),!0)).call(e,function(a){zr(r,a,i[a])}):Oy?dz(r,Oy(i)):Ei(t=wg(Object(i))).call(t,function(a){fz(r,a,O0(i,a))})}return r}function kh(r,n){var e=typeof Lu<"u"&&pf(r)||r["@@iterator"];if(!e){if(It(r)||(e=vU(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function vU(r,n){var e;if(r){if(typeof r=="string")return Eg(r,n);var t=zu(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return vf(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return Eg(r,n)}}function Eg(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}function pU(r){var n=yU();return function(){var t=Js(r),i;if(n){var a=Js(this).constructor;i=ks(t,arguments,a)}else i=t.apply(this,arguments);return Mz(this,i)}}function yU(){if(typeof Reflect>"u"||!ks||ks.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(ks(Boolean,[],function(){})),!0}catch{return!1}}function gU(r,n){return r[n]==null&&(r[n]=K6()),r}var ru=function(r){Dz(e,r);var n=pU(e);function e(t,i){var a;return yu(this,e),a=n.call(this),zr(I0(a),"_queue",null),t&&!It(t)&&(i=t,t=[]),a._options=i||{},a._data=new v_,a.length=0,a._idProp=a._options.fieldId||"id",t&&t.length&&a.add(t),a.setOptions(i),a}return Nu(e,[{key:"idProp",get:function(){return this._idProp}},{key:"setOptions",value:function(i){i&&i.queue!==void 0&&(i.queue===!1?this._queue&&(this._queue.destroy(),this._queue=null):(this._queue||(this._queue=q6.extend(this,{replace:["add","update","remove"]})),i.queue&&typeof i.queue=="object"&&this._queue.setOptions(i.queue)))}},{key:"add",value:function(i,a){var o=this,s=[],u;if(It(i)){var l=Vt(i).call(i,function(c){return c[o._idProp]});if(C4(l).call(l,function(c){return o._data.has(c)}))throw new Error("A duplicate id was found in the parameter array.");for(var h=0,d=i.length;h<d;h++)u=this._addItem(i[h]),s.push(u)}else if(i&&typeof i=="object")u=this._addItem(i),s.push(u);else throw new Error("Unknown dataType");return s.length&&this._trigger("add",{items:s},a),s}},{key:"update",value:function(i,a){var o=this,s=[],u=[],l=[],h=[],d=this._idProp,c=function(g){var m=g[d];if(m!=null&&o._data.has(m)){var w=g,$=RB({},o._data.get(m)),E=o._updateItem(w);u.push(E),h.push(w),l.push($)}else{var k=o._addItem(g);s.push(k)}};if(It(i))for(var f=0,v=i.length;f<v;f++)i[f]&&typeof i[f]=="object"?c(i[f]):console.warn("Ignoring input item, which is not an object at index "+f);else if(i&&typeof i=="object")c(i);else throw new Error("Unknown dataType");if(s.length&&this._trigger("add",{items:s},a),u.length){var p={items:u,oldData:l,data:h};this._trigger("update",p,a)}return ju(s).call(s,u)}},{key:"updateOnly",value:function(i,a){var o,s=this;It(i)||(i=[i]);var u=Vt(o=Vt(i).call(i,function(h){var d=s._data.get(h[s._idProp]);if(d==null)throw new Error("Updating non-existent items is not allowed.");return{oldData:d,update:h}})).call(o,function(h){var d=h.oldData,c=h.update,f=d[s._idProp],v=cj(d,c);return s._data.set(f,v),{id:f,oldData:d,updatedData:v}});if(u.length){var l={items:Vt(u).call(u,function(h){return h.id}),oldData:Vt(u).call(u,function(h){return h.oldData}),data:Vt(u).call(u,function(h){return h.updatedData})};return this._trigger("update",l,a),l.items}else return[]}},{key:"get",value:function(i,a){var o=void 0,s=void 0,u=void 0;mg(i)?(o=i,u=a):It(i)?(s=i,u=a):u=i;var l=u&&u.returnType==="Object"?"Object":"Array",h=u&&un(u),d=[],c=void 0,f=void 0,v=void 0;if(o!=null)c=this._data.get(o),c&&h&&!h(c)&&(c=void 0);else if(s!=null)for(var p=0,y=s.length;p<y;p++)c=this._data.get(s[p]),c!=null&&(!h||h(c))&&d.push(c);else{var g;f=pt(Ji(g=this._data).call(g));for(var m=0,w=f.length;m<w;m++)v=f[m],c=this._data.get(v),c!=null&&(!h||h(c))&&d.push(c)}if(u&&u.order&&o==null&&this._sort(d,u.order),u&&u.fields){var $=u.fields;if(o!=null&&c!=null)c=this._filterFields(c,$);else for(var E=0,k=d.length;E<k;E++)d[E]=this._filterFields(d[E],$)}if(l=="Object"){for(var D={},j=0,R=d.length;j<R;j++){var M=d[j],W=M[this._idProp];D[W]=M}return D}else if(o!=null){var X;return(X=c)!==null&&X!==void 0?X:null}else return d}},{key:"getIds",value:function(i){var a=this._data,o=i&&un(i),s=i&&i.order,u=pt(Ji(a).call(a)),l=[];if(o)if(s){for(var h=[],d=0,c=u.length;d<c;d++){var f=u[d],v=this._data.get(f);v!=null&&o(v)&&h.push(v)}this._sort(h,s);for(var p=0,y=h.length;p<y;p++)l.push(h[p][this._idProp])}else for(var g=0,m=u.length;g<m;g++){var w=u[g],$=this._data.get(w);$!=null&&o($)&&l.push($[this._idProp])}else if(s){for(var E=[],k=0,D=u.length;k<D;k++){var j=u[k];E.push(a.get(j))}this._sort(E,s);for(var R=0,M=E.length;R<M;R++)l.push(E[R][this._idProp])}else for(var W=0,X=u.length;W<X;W++){var Y=u[W],ye=a.get(Y);ye!=null&&l.push(ye[this._idProp])}return l}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(i,a){var o=a&&un(a),s=this._data,u=pt(Ji(s).call(s));if(a&&a.order)for(var l=this.get(a),h=0,d=l.length;h<d;h++){var c=l[h],f=c[this._idProp];i(c,f)}else for(var v=0,p=u.length;v<p;v++){var y=u[v],g=this._data.get(y);g!=null&&(!o||o(g))&&i(g,y)}}},{key:"map",value:function(i,a){for(var o=a&&un(a),s=[],u=this._data,l=pt(Ji(u).call(u)),h=0,d=l.length;h<d;h++){var c=l[h],f=this._data.get(c);f!=null&&(!o||o(f))&&s.push(i(f,c))}return a&&a.order&&this._sort(s,a.order),s}},{key:"_filterFields",value:function(i,a){var o;return i&&YD(o=It(a)?a:gf(a)).call(o,function(s,u){return s[u]=i[u],s},{})}},{key:"_sort",value:function(i,a){if(typeof a=="string"){var o=a;cc(i).call(i,function(s,u){var l=s[o],h=u[o];return l>h?1:l<h?-1:0})}else if(typeof a=="function")cc(i).call(i,a);else throw new TypeError("Order must be a function or a string")}},{key:"remove",value:function(i,a){for(var o=[],s=[],u=It(i)?i:[i],l=0,h=u.length;l<h;l++){var d=this._remove(u[l]);if(d){var c=d[this._idProp];c!=null&&(o.push(c),s.push(d))}}return o.length&&this._trigger("remove",{items:o,oldData:s},a),o}},{key:"_remove",value:function(i){var a;if(mg(i)?a=i:i&&typeof i=="object"&&(a=i[this._idProp]),a!=null&&this._data.has(a)){var o=this._data.get(a)||null;return this._data.delete(a),--this.length,o}return null}},{key:"clear",value:function(i){for(var a,o=pt(Ji(a=this._data).call(a)),s=[],u=0,l=o.length;u<l;u++)s.push(this._data.get(o[u]));return this._data.clear(),this.length=0,this._trigger("remove",{items:o,oldData:s},i),o}},{key:"max",value:function(i){var a,o=null,s=null,u=kh(yg(a=this._data).call(a)),l;try{for(u.s();!(l=u.n()).done;){var h=l.value,d=h[i];typeof d=="number"&&(s==null||d>s)&&(o=h,s=d)}}catch(c){u.e(c)}finally{u.f()}return o||null}},{key:"min",value:function(i){var a,o=null,s=null,u=kh(yg(a=this._data).call(a)),l;try{for(u.s();!(l=u.n()).done;){var h=l.value,d=h[i];typeof d=="number"&&(s==null||d<s)&&(o=h,s=d)}}catch(c){u.e(c)}finally{u.f()}return o||null}},{key:"distinct",value:function(i){for(var a=this._data,o=pt(Ji(a).call(a)),s=[],u=0,l=0,h=o.length;l<h;l++){for(var d=o[l],c=a.get(d),f=c[i],v=!1,p=0;p<u;p++)if(s[p]==f){v=!0;break}!v&&f!==void 0&&(s[u]=f,u++)}return s}},{key:"_addItem",value:function(i){var a=gU(i,this._idProp),o=a[this._idProp];if(this._data.has(o))throw new Error("Cannot add item: item with id "+o+" already exists");return this._data.set(o,a),++this.length,o}},{key:"_updateItem",value:function(i){var a=i[this._idProp];if(a==null)throw new Error("Cannot update item: item has no id (item: "+iL(i)+")");var o=this._data.get(a);if(!o)throw new Error("Cannot update item: no item with id "+a+" found");return this._data.set(a,_g(_g({},o),i)),a}},{key:"stream",value:function(i){if(i){var a=this._data;return new $g({[fn](){return ct.mark(function s(){var u,l,h,d;return ct.wrap(function(f){for(;;)switch(f.prev=f.next){case 0:u=kh(i),f.prev=1,u.s();case 3:if((l=u.n()).done){f.next=11;break}if(h=l.value,d=a.get(h),d==null){f.next=9;break}return f.next=9,[h,d];case 9:f.next=3;break;case 11:f.next=16;break;case 13:f.prev=13,f.t0=f.catch(1),u.e(f.t0);case 16:return f.prev=16,u.f(),f.finish(16);case 19:case"end":return f.stop()}},s,null,[[1,13,16,19]])})()}})}else{var o;return new $g({[fn]:cw(o=H6(this._data)).call(o,this._data)})}}}]),e}(Y6);function mU(r,n){return typeof n=="object"&&n!==null&&r===n.idProp&&typeof n.add=="function"&&typeof n.clear=="function"&&typeof n.distinct=="function"&&typeof Ei(n)=="function"&&typeof n.get=="function"&&typeof n.getDataSet=="function"&&typeof n.getIds=="function"&&typeof n.length=="number"&&typeof Vt(n)=="function"&&typeof n.max=="function"&&typeof n.min=="function"&&typeof n.off=="function"&&typeof n.on=="function"&&typeof n.remove=="function"&&typeof n.setOptions=="function"&&typeof n.stream=="function"&&typeof n.update=="function"&&typeof n.updateOnly=="function"}function g_(r,n){return typeof n=="object"&&n!==null&&r===n.idProp&&typeof Ei(n)=="function"&&typeof n.get=="function"&&typeof n.getDataSet=="function"&&typeof n.getIds=="function"&&typeof n.length=="number"&&typeof Vt(n)=="function"&&typeof n.off=="function"&&typeof n.on=="function"&&typeof n.stream=="function"&&mU(r,n.getDataSet())}/**
 * vis-network
 * https://visjs.github.io/vis-network/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 9.1.9
 * @date    2023-11-03T01:42:27.418Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */var Ch=typeof globalThis<"u"?globalThis:typeof window<"u"?window:typeof global<"u"?global:typeof self<"u"?self:{};function L(r){return r&&r.__esModule&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r}var os=function(r){return r&&r.Math===Math&&r},_e=os(typeof globalThis=="object"&&globalThis)||os(typeof window=="object"&&window)||os(typeof self=="object"&&self)||os(typeof Ch=="object"&&Ch)||function(){return this}()||Ch||Function("return this")(),ee=function(r){try{return!!r()}catch{return!0}},bU=ee,po=!bU(function(){var r=function(){}.bind();return typeof r!="function"||r.hasOwnProperty("prototype")}),$U=po,m_=Function.prototype,Sg=m_.apply,Og=m_.call,yo=typeof Reflect=="object"&&Reflect.apply||($U?Og.bind(Sg):function(){return Og.apply(Sg,arguments)}),b_=po,$_=Function.prototype,fc=$_.call,wU=b_&&$_.bind.bind(fc,fc),re=b_?wU:function(r){return function(){return fc.apply(r,arguments)}},w_=re,_U=w_({}.toString),EU=w_("".slice),kr=function(r){return EU(_U(r),8,-1)},SU=kr,OU=re,Mf=function(r){if(SU(r)==="Function")return OU(r)},vc=typeof document=="object"&&document.all,TU=typeof vc>"u"&&vc!==void 0,__={all:vc,IS_HTMLDDA:TU},E_=__,PU=E_.all,ze=E_.IS_HTMLDDA?function(r){return typeof r=="function"||r===PU}:function(r){return typeof r=="function"},Xn={},IU=ee,He=!IU(function(){return Object.defineProperty({},1,{get:function(){return 7}})[1]!==7}),kU=po,ss=Function.prototype.call,At=kU?ss.bind(ss):function(){return ss.apply(ss,arguments)},Gu={},S_={}.propertyIsEnumerable,O_=Object.getOwnPropertyDescriptor,CU=O_&&!S_.call({1:2},1);Gu.f=CU?function(n){var e=O_(this,n);return!!e&&e.enumerable}:S_;var go=function(r,n){return{enumerable:!(r&1),configurable:!(r&2),writable:!(r&4),value:n}},xU=re,AU=ee,RU=kr,xh=Object,DU=xU("".split),Ku=AU(function(){return!xh("z").propertyIsEnumerable(0)})?function(r){return RU(r)==="String"?DU(r,""):xh(r)}:xh,Qn=function(r){return r==null},MU=Qn,NU=TypeError,mo=function(r){if(MU(r))throw new NU("Can't call method on "+r);return r},FU=Ku,BU=mo,hr=function(r){return FU(BU(r))},Tg=ze,T_=__,LU=T_.all,We=T_.IS_HTMLDDA?function(r){return typeof r=="object"?r!==null:Tg(r)||r===LU}:function(r){return typeof r=="object"?r!==null:Tg(r)},te={},Ah=te,Rh=_e,jU=ze,Pg=function(r){return jU(r)?r:void 0},zt=function(r,n){return arguments.length<2?Pg(Ah[r])||Pg(Rh[r]):Ah[r]&&Ah[r][n]||Rh[r]&&Rh[r][n]},zU=re,Ie=zU({}.isPrototypeOf),bo=typeof navigator<"u"&&String(navigator.userAgent)||"",P_=_e,Dh=bo,Ig=P_.process,kg=P_.Deno,Cg=Ig&&Ig.versions||kg&&kg.version,xg=Cg&&Cg.v8,Gt,iu;xg&&(Gt=xg.split("."),iu=Gt[0]>0&&Gt[0]<4?1:+(Gt[0]+Gt[1]));!iu&&Dh&&(Gt=Dh.match(/Edge\/(\d+)/),(!Gt||Gt[1]>=74)&&(Gt=Dh.match(/Chrome\/(\d+)/),Gt&&(iu=+Gt[1])));var $o=iu,Ag=$o,HU=ee,WU=_e,UU=WU.String,Jn=!!Object.getOwnPropertySymbols&&!HU(function(){var r=Symbol("symbol detection");return!UU(r)||!(Object(r)instanceof Symbol)||!Symbol.sham&&Ag&&Ag<41}),VU=Jn,I_=VU&&!Symbol.sham&&typeof Symbol.iterator=="symbol",GU=zt,KU=ze,qU=Ie,YU=I_,XU=Object,wo=YU?function(r){return typeof r=="symbol"}:function(r){var n=GU("Symbol");return KU(n)&&qU(n.prototype,XU(r))},QU=String,Zn=function(r){try{return QU(r)}catch{return"Object"}},JU=ze,ZU=Zn,eV=TypeError,Li=function(r){if(JU(r))return r;throw new eV(ZU(r)+" is not a function")},tV=Li,rV=Qn,Nf=function(r,n){var e=r[n];return rV(e)?void 0:tV(e)},Mh=At,Nh=ze,Fh=We,iV=TypeError,nV=function(r,n){var e,t;if(n==="string"&&Nh(e=r.toString)&&!Fh(t=Mh(e,r))||Nh(e=r.valueOf)&&!Fh(t=Mh(e,r))||n!=="string"&&Nh(e=r.toString)&&!Fh(t=Mh(e,r)))return t;throw new iV("Can't convert object to primitive value")},k_={exports:{}},Rg=_e,aV=Object.defineProperty,oV=function(r,n){try{aV(Rg,r,{value:n,configurable:!0,writable:!0})}catch{Rg[r]=n}return n},sV=_e,uV=oV,Dg="__core-js_shared__",lV=sV[Dg]||uV(Dg,{}),Ff=lV,Mg=Ff;(k_.exports=function(r,n){return Mg[r]||(Mg[r]=n!==void 0?n:{})})("versions",[]).push({version:"3.33.0",mode:"pure",copyright:"© 2014-2023 Denis Pushkarev (zloirock.ru)",license:"https://github.com/zloirock/core-js/blob/v3.33.0/LICENSE",source:"https://github.com/zloirock/core-js"});var ea=k_.exports,hV=mo,dV=Object,Et=function(r){return dV(hV(r))},cV=re,fV=Et,vV=cV({}.hasOwnProperty),Ue=Object.hasOwn||function(n,e){return vV(fV(n),e)},pV=re,yV=0,gV=Math.random(),mV=pV(1 .toString),qu=function(r){return"Symbol("+(r===void 0?"":r)+")_"+mV(++yV+gV,36)},bV=_e,$V=ea,Ng=Ue,wV=qu,_V=Jn,EV=I_,vn=bV.Symbol,Bh=$V("wks"),SV=EV?vn.for||vn:vn&&vn.withoutSetter||wV,Ee=function(r){return Ng(Bh,r)||(Bh[r]=_V&&Ng(vn,r)?vn[r]:SV("Symbol."+r)),Bh[r]},OV=At,Fg=We,Bg=wo,TV=Nf,PV=nV,IV=Ee,kV=TypeError,CV=IV("toPrimitive"),xV=function(r,n){if(!Fg(r)||Bg(r))return r;var e=TV(r,CV),t;if(e){if(n===void 0&&(n="default"),t=OV(e,r,n),!Fg(t)||Bg(t))return t;throw new kV("Can't convert object to primitive value")}return n===void 0&&(n="number"),PV(r,n)},AV=xV,RV=wo,Yu=function(r){var n=AV(r,"string");return RV(n)?n:n+""},DV=_e,Lg=We,pc=DV.document,MV=Lg(pc)&&Lg(pc.createElement),C_=function(r){return MV?pc.createElement(r):{}},NV=He,FV=ee,BV=C_,x_=!NV&&!FV(function(){return Object.defineProperty(BV("div"),"a",{get:function(){return 7}}).a!==7}),LV=He,jV=At,zV=Gu,HV=go,WV=hr,UV=Yu,VV=Ue,GV=x_,jg=Object.getOwnPropertyDescriptor;Xn.f=LV?jg:function(n,e){if(n=WV(n),e=UV(e),GV)try{return jg(n,e)}catch{}if(VV(n,e))return HV(!jV(zV.f,n,e),n[e])};var KV=ee,qV=ze,YV=/#|\.prototype\./,_o=function(r,n){var e=QV[XV(r)];return e===ZV?!0:e===JV?!1:qV(n)?KV(n):!!n},XV=_o.normalize=function(r){return String(r).replace(YV,".").toLowerCase()},QV=_o.data={},JV=_o.NATIVE="N",ZV=_o.POLYFILL="P",e8=_o,zg=Mf,t8=Li,r8=po,i8=zg(zg.bind),Eo=function(r,n){return t8(r),n===void 0?r:r8?i8(r,n):function(){return r.apply(n,arguments)}},Rt={},n8=He,a8=ee,A_=n8&&a8(function(){return Object.defineProperty(function(){},"prototype",{value:42,writable:!1}).prototype!==42}),o8=We,s8=String,u8=TypeError,Dt=function(r){if(o8(r))return r;throw new u8(s8(r)+" is not an object")},l8=He,h8=x_,d8=A_,us=Dt,Hg=Yu,c8=TypeError,Lh=Object.defineProperty,f8=Object.getOwnPropertyDescriptor,jh="enumerable",zh="configurable",Hh="writable";Rt.f=l8?d8?function(n,e,t){if(us(n),e=Hg(e),us(t),typeof n=="function"&&e==="prototype"&&"value"in t&&Hh in t&&!t[Hh]){var i=f8(n,e);i&&i[Hh]&&(n[e]=t.value,t={configurable:zh in t?t[zh]:i[zh],enumerable:jh in t?t[jh]:i[jh],writable:!1})}return Lh(n,e,t)}:Lh:function(n,e,t){if(us(n),e=Hg(e),us(t),h8)try{return Lh(n,e,t)}catch{}if("get"in t||"set"in t)throw new c8("Accessors not supported");return"value"in t&&(n[e]=t.value),n};var v8=He,p8=Rt,y8=go,ta=v8?function(r,n,e){return p8.f(r,n,y8(1,e))}:function(r,n,e){return r[n]=e,r},ls=_e,g8=yo,m8=Mf,b8=ze,$8=Xn.f,w8=e8,Zi=te,_8=Eo,en=ta,Wg=Ue,E8=function(r){var n=function(e,t,i){if(this instanceof n){switch(arguments.length){case 0:return new r;case 1:return new r(e);case 2:return new r(e,t)}return new r(e,t,i)}return g8(r,this,arguments)};return n.prototype=r.prototype,n},V=function(r,n){var e=r.target,t=r.global,i=r.stat,a=r.proto,o=t?ls:i?ls[e]:(ls[e]||{}).prototype,s=t?Zi:Zi[e]||en(Zi,e,{})[e],u=s.prototype,l,h,d,c,f,v,p,y,g;for(c in n)l=w8(t?c:e+(i?".":"#")+c,r.forced),h=!l&&o&&Wg(o,c),v=s[c],h&&(r.dontCallGetSet?(g=$8(o,c),p=g&&g.value):p=o[c]),f=h&&p?p:n[c],!(h&&typeof v==typeof f)&&(r.bind&&h?y=_8(f,ls):r.wrap&&h?y=E8(f):a&&b8(f)?y=m8(f):y=f,(r.sham||f&&f.sham||v&&v.sham)&&en(y,"sham",!0),en(s,c,y),a&&(d=e+"Prototype",Wg(Zi,d)||en(Zi,d,{}),en(Zi[d],c,f),r.real&&u&&(l||!u[c])&&en(u,c,f)))},S8=Math.ceil,O8=Math.floor,T8=Math.trunc||function(n){var e=+n;return(e>0?O8:S8)(e)},P8=T8,Xu=function(r){var n=+r;return n!==n||n===0?0:P8(n)},I8=Xu,k8=Math.max,C8=Math.min,So=function(r,n){var e=I8(r);return e<0?k8(e+n,0):C8(e,n)},x8=Xu,A8=Math.min,R8=function(r){return r>0?A8(x8(r),9007199254740991):0},D8=R8,Ht=function(r){return D8(r.length)},M8=hr,N8=So,F8=Ht,Ug=function(r){return function(n,e,t){var i=M8(n),a=F8(i),o=N8(t,a),s;if(r&&e!==e){for(;a>o;)if(s=i[o++],s!==s)return!0}else for(;a>o;o++)if((r||o in i)&&i[o]===e)return r||o||0;return!r&&-1}},Bf={includes:Ug(!0),indexOf:Ug(!1)},Oo={},B8=re,Wh=Ue,L8=hr,j8=Bf.indexOf,z8=Oo,Vg=B8([].push),R_=function(r,n){var e=L8(r),t=0,i=[],a;for(a in e)!Wh(z8,a)&&Wh(e,a)&&Vg(i,a);for(;n.length>t;)Wh(e,a=n[t++])&&(~j8(i,a)||Vg(i,a));return i},Lf=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],H8=R_,W8=Lf,Qu=Object.keys||function(n){return H8(n,W8)},To={};To.f=Object.getOwnPropertySymbols;var Gg=He,U8=re,V8=At,G8=ee,Uh=Qu,K8=To,q8=Gu,Y8=Et,X8=Ku,tn=Object.assign,Kg=Object.defineProperty,Q8=U8([].concat),J8=!tn||G8(function(){if(Gg&&tn({b:1},tn(Kg({},"a",{enumerable:!0,get:function(){Kg(this,"b",{value:3,enumerable:!1})}}),{b:2})).b!==1)return!0;var r={},n={},e=Symbol("assign detection"),t="abcdefghijklmnopqrst";return r[e]=7,t.split("").forEach(function(i){n[i]=i}),tn({},r)[e]!==7||Uh(tn({},n)).join("")!==t})?function(n,e){for(var t=Y8(n),i=arguments.length,a=1,o=K8.f,s=q8.f;i>a;)for(var u=X8(arguments[a++]),l=o?Q8(Uh(u),o(u)):Uh(u),h=l.length,d=0,c;h>d;)c=l[d++],(!Gg||V8(s,u,c))&&(t[c]=u[c]);return t}:tn,Z8=V,qg=J8;Z8({target:"Object",stat:!0,arity:2,forced:Object.assign!==qg},{assign:qg});var e9=te,t9=e9.Object.assign,r9=t9,i9=r9,n9=i9,Ae=L(n9),a9=re,Ju=a9([].slice),D_=re,o9=Li,s9=We,u9=Ue,Yg=Ju,l9=po,M_=Function,h9=D_([].concat),d9=D_([].join),Vh={},c9=function(r,n,e){if(!u9(Vh,n)){for(var t=[],i=0;i<n;i++)t[i]="a["+i+"]";Vh[n]=M_("C,a","return new C("+d9(t,",")+")")}return Vh[n](r,e)},N_=l9?M_.bind:function(n){var e=o9(this),t=e.prototype,i=Yg(arguments,1),a=function(){var s=h9(i,Yg(arguments));return this instanceof a?c9(e,s.length,s):e.apply(n,s)};return s9(t)&&(a.prototype=t),a},f9=V,Xg=N_;f9({target:"Function",proto:!0,forced:Function.bind!==Xg},{bind:Xg});var v9=te,Ve=function(r){return v9[r+"Prototype"]},p9=Ve,y9=p9("Function").bind,g9=Ie,m9=y9,Gh=Function.prototype,b9=function(r){var n=r.bind;return r===Gh||g9(Gh,r)&&n===Gh.bind?m9:n},$9=b9,F_=$9,w9=F_,O=L(w9);function jf(r,n,e,t){r.beginPath(),r.arc(n,e,t,0,2*Math.PI,!1),r.closePath()}function _9(r,n,e,t){r.beginPath(),r.rect(n-t,e-t,t*2,t*2),r.closePath()}function E9(r,n,e,t){r.beginPath(),t*=1.15,e+=.275*t;var i=t*2,a=i/2,o=Math.sqrt(3)/6*i,s=Math.sqrt(i*i-a*a);r.moveTo(n,e-(s-o)),r.lineTo(n+a,e+o),r.lineTo(n-a,e+o),r.lineTo(n,e-(s-o)),r.closePath()}function S9(r,n,e,t){r.beginPath(),t*=1.15,e-=.275*t;var i=t*2,a=i/2,o=Math.sqrt(3)/6*i,s=Math.sqrt(i*i-a*a);r.moveTo(n,e+(s-o)),r.lineTo(n+a,e-o),r.lineTo(n-a,e-o),r.lineTo(n,e+(s-o)),r.closePath()}function O9(r,n,e,t){r.beginPath(),t*=.82,e+=.1*t;for(var i=0;i<10;i++){var a=i%2===0?t*1.3:t*.5;r.lineTo(n+a*Math.sin(i*2*Math.PI/10),e-a*Math.cos(i*2*Math.PI/10))}r.closePath()}function T9(r,n,e,t){r.beginPath(),r.lineTo(n,e+t),r.lineTo(n+t,e),r.lineTo(n,e-t),r.lineTo(n-t,e),r.closePath()}function B_(r,n,e,t,i,a){var o=Math.PI/180;t-2*a<0&&(a=t/2),i-2*a<0&&(a=i/2),r.beginPath(),r.moveTo(n+a,e),r.lineTo(n+t-a,e),r.arc(n+t-a,e+a,a,o*270,o*360,!1),r.lineTo(n+t,e+i-a),r.arc(n+t-a,e+i-a,a,0,o*90,!1),r.lineTo(n+a,e+i),r.arc(n+a,e+i-a,a,o*90,o*180,!1),r.lineTo(n,e+a),r.arc(n+a,e+a,a,o*180,o*270,!1),r.closePath()}function yc(r,n,e,t,i){var a=.5522848,o=t/2*a,s=i/2*a,u=n+t,l=e+i,h=n+t/2,d=e+i/2;r.beginPath(),r.moveTo(n,d),r.bezierCurveTo(n,d-s,h-o,e,h,e),r.bezierCurveTo(h+o,e,u,d-s,u,d),r.bezierCurveTo(u,d+s,h+o,l,h,l),r.bezierCurveTo(h-o,l,n,d+s,n,d),r.closePath()}function L_(r,n,e,t,i){var a=.3333333333333333,o=t,s=i*a,u=.5522848,l=o/2*u,h=s/2*u,d=n+o,c=e+s,f=n+o/2,v=e+s/2,p=e+(i-s/2),y=e+i;r.beginPath(),r.moveTo(d,v),r.bezierCurveTo(d,v+h,f+l,c,f,c),r.bezierCurveTo(f-l,c,n,v+h,n,v),r.bezierCurveTo(n,v-h,f-l,e,f,e),r.bezierCurveTo(f+l,e,d,v-h,d,v),r.lineTo(d,p),r.bezierCurveTo(d,p+h,f+l,y,f,y),r.bezierCurveTo(f-l,y,n,p+h,n,p),r.lineTo(n,v)}function j_(r,n,e,t,i,a){r.beginPath(),r.moveTo(n,e);for(var o=a.length,s=t-n,u=i-e,l=u/s,h=Math.sqrt(s*s+u*u),d=0,c=!0,f=0,v=+a[0];h>=.1;)v=+a[d++%o],v>h&&(v=h),f=Math.sqrt(v*v/(1+l*l)),f=s<0?-f:f,n+=f,e+=l*f,c===!0?r.lineTo(n,e):r.moveTo(n,e),h-=v,c=!c}function P9(r,n,e,t){r.beginPath();var i=6,a=Math.PI*2/i;r.moveTo(n+t,e);for(var o=1;o<i;o++)r.lineTo(n+t*Math.cos(a*o),e+t*Math.sin(a*o));r.closePath()}var Qg={circle:jf,dashedLine:j_,database:L_,diamond:T9,ellipse:yc,ellipse_vis:yc,hexagon:P9,roundRect:B_,square:_9,star:O9,triangle:E9,triangleDown:S9};function I9(r){return Object.prototype.hasOwnProperty.call(Qg,r)?Qg[r]:function(n){for(var e=arguments.length,t=new Array(e>1?e-1:0),i=1;i<e;i++)t[i-1]=arguments[i];CanvasRenderingContext2D.prototype[r].call(n,t)}}var z_={exports:{}};(function(r){r.exports=n;function n(t){if(t)return e(t)}function e(t){for(var i in n.prototype)t[i]=n.prototype[i];return t}n.prototype.on=n.prototype.addEventListener=function(t,i){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(i),this},n.prototype.once=function(t,i){function a(){this.off(t,a),i.apply(this,arguments)}return a.fn=i,this.on(t,a),this},n.prototype.off=n.prototype.removeListener=n.prototype.removeAllListeners=n.prototype.removeEventListener=function(t,i){if(this._callbacks=this._callbacks||{},arguments.length==0)return this._callbacks={},this;var a=this._callbacks["$"+t];if(!a)return this;if(arguments.length==1)return delete this._callbacks["$"+t],this;for(var o,s=0;s<a.length;s++)if(o=a[s],o===i||o.fn===i){a.splice(s,1);break}return a.length===0&&delete this._callbacks["$"+t],this},n.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var i=new Array(arguments.length-1),a=this._callbacks["$"+t],o=1;o<arguments.length;o++)i[o-1]=arguments[o];if(a){a=a.slice(0);for(var o=0,s=a.length;o<s;++o)a[o].apply(this,i)}return this},n.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},n.prototype.hasListeners=function(t){return!!this.listeners(t).length}})(z_);var k9=z_.exports,H_=L(k9),C9=Ee,x9=C9("toStringTag"),W_={};W_[x9]="z";var zf=String(W_)==="[object z]",A9=zf,R9=ze,Rs=kr,D9=Ee,M9=D9("toStringTag"),N9=Object,F9=Rs(function(){return arguments}())==="Arguments",B9=function(r,n){try{return r[n]}catch{}},ji=A9?Rs:function(r){var n,e,t;return r===void 0?"Undefined":r===null?"Null":typeof(e=B9(n=N9(r),M9))=="string"?e:F9?Rs(n):(t=Rs(n))==="Object"&&R9(n.callee)?"Arguments":t},L9=ji,j9=String,dr=function(r){if(L9(r)==="Symbol")throw new TypeError("Cannot convert a Symbol value to a string");return j9(r)},Hf=re,z9=Xu,H9=dr,W9=mo,U9=Hf("".charAt),Jg=Hf("".charCodeAt),V9=Hf("".slice),Zg=function(r){return function(n,e){var t=H9(W9(n)),i=z9(e),a=t.length,o,s;return i<0||i>=a?r?"":void 0:(o=Jg(t,i),o<55296||o>56319||i+1===a||(s=Jg(t,i+1))<56320||s>57343?r?U9(t,i):o:r?V9(t,i,i+2):(o-55296<<10)+(s-56320)+65536)}},G9={codeAt:Zg(!1),charAt:Zg(!0)},K9=_e,q9=ze,em=K9.WeakMap,U_=q9(em)&&/native code/.test(String(em)),Y9=ea,X9=qu,tm=Y9("keys"),Zu=function(r){return tm[r]||(tm[r]=X9(r))},Q9=U_,V_=_e,J9=We,Z9=ta,Kh=Ue,qh=Ff,eG=Zu,tG=Oo,rm="Object already initialized",gc=V_.TypeError,rG=V_.WeakMap,nu,ja,au,iG=function(r){return au(r)?ja(r):nu(r,{})},nG=function(r){return function(n){var e;if(!J9(n)||(e=ja(n)).type!==r)throw new gc("Incompatible receiver, "+r+" required");return e}};if(Q9||qh.state){var er=qh.state||(qh.state=new rG);er.get=er.get,er.has=er.has,er.set=er.set,nu=function(r,n){if(er.has(r))throw new gc(rm);return n.facade=r,er.set(r,n),n},ja=function(r){return er.get(r)||{}},au=function(r){return er.has(r)}}else{var rn=eG("state");tG[rn]=!0,nu=function(r,n){if(Kh(r,rn))throw new gc(rm);return n.facade=r,Z9(r,rn,n),n},ja=function(r){return Kh(r,rn)?r[rn]:{}},au=function(r){return Kh(r,rn)}}var zi={set:nu,get:ja,has:au,enforce:iG,getterFor:nG},mc=He,aG=Ue,G_=Function.prototype,oG=mc&&Object.getOwnPropertyDescriptor,Wf=aG(G_,"name"),sG=Wf&&function(){}.name==="something",uG=Wf&&(!mc||mc&&oG(G_,"name").configurable),lG={EXISTS:Wf,PROPER:sG,CONFIGURABLE:uG},el={},hG=He,dG=A_,cG=Rt,fG=Dt,vG=hr,pG=Qu;el.f=hG&&!dG?Object.defineProperties:function(n,e){fG(n);for(var t=vG(e),i=pG(e),a=i.length,o=0,s;a>o;)cG.f(n,s=i[o++],t[s]);return n};var yG=zt,gG=yG("document","documentElement"),mG=Dt,bG=el,im=Lf,$G=Oo,wG=gG,_G=C_,EG=Zu,nm=">",am="<",bc="prototype",$c="script",K_=EG("IE_PROTO"),Yh=function(){},q_=function(r){return am+$c+nm+r+am+"/"+$c+nm},om=function(r){r.write(q_("")),r.close();var n=r.parentWindow.Object;return r=null,n},SG=function(){var r=_G("iframe"),n="java"+$c+":",e;return r.style.display="none",wG.appendChild(r),r.src=String(n),e=r.contentWindow.document,e.open(),e.write(q_("document.F=Object")),e.close(),e.F},hs,Ds=function(){try{hs=new ActiveXObject("htmlfile")}catch{}Ds=typeof document<"u"?document.domain&&hs?om(hs):SG():om(hs);for(var r=im.length;r--;)delete Ds[bc][im[r]];return Ds()};$G[K_]=!0;var ra=Object.create||function(n,e){var t;return n!==null?(Yh[bc]=mG(n),t=new Yh,Yh[bc]=null,t[K_]=n):t=Ds(),e===void 0?t:bG.f(t,e)},OG=ee,Y_=!OG(function(){function r(){}return r.prototype.constructor=null,Object.getPrototypeOf(new r)!==r.prototype}),TG=Ue,PG=ze,IG=Et,kG=Zu,CG=Y_,sm=kG("IE_PROTO"),wc=Object,xG=wc.prototype,tl=CG?wc.getPrototypeOf:function(r){var n=IG(r);if(TG(n,sm))return n[sm];var e=n.constructor;return PG(e)&&n instanceof e?e.prototype:n instanceof wc?xG:null},AG=ta,Po=function(r,n,e,t){return t&&t.enumerable?r[n]=e:AG(r,n,e),r},RG=ee,DG=ze,MG=We,NG=ra,um=tl,FG=Po,BG=Ee,_c=BG("iterator"),X_=!1,mr,Xh,Qh;[].keys&&(Qh=[].keys(),"next"in Qh?(Xh=um(um(Qh)),Xh!==Object.prototype&&(mr=Xh)):X_=!0);var LG=!MG(mr)||RG(function(){var r={};return mr[_c].call(r)!==r});LG?mr={}:mr=NG(mr);DG(mr[_c])||FG(mr,_c,function(){return this});var Q_={IteratorPrototype:mr,BUGGY_SAFARI_ITERATORS:X_},jG=zf,zG=ji,HG=jG?{}.toString:function(){return"[object "+zG(this)+"]"},WG=zf,UG=Rt.f,VG=ta,GG=Ue,KG=HG,qG=Ee,lm=qG("toStringTag"),ia=function(r,n,e,t){if(r){var i=e?r:r.prototype;GG(i,lm)||UG(i,lm,{configurable:!0,value:n}),t&&!WG&&VG(i,"toString",KG)}},na={},YG=Q_.IteratorPrototype,XG=ra,QG=go,JG=ia,ZG=na,eK=function(){return this},tK=function(r,n,e,t){var i=n+" Iterator";return r.prototype=XG(YG,{next:QG(+!t,e)}),JG(r,i,!1,!0),ZG[i]=eK,r},rK=re,iK=Li,nK=function(r,n,e){try{return rK(iK(Object.getOwnPropertyDescriptor(r,n)[e]))}catch{}},aK=ze,oK=String,sK=TypeError,uK=function(r){if(typeof r=="object"||aK(r))return r;throw new sK("Can't set "+oK(r)+" as a prototype")},lK=nK,hK=Dt,dK=uK,cK=Object.setPrototypeOf||("__proto__"in{}?function(){var r=!1,n={},e;try{e=lK(Object.prototype,"__proto__","set"),e(n,[]),r=n instanceof Array}catch{}return function(i,a){return hK(i),dK(a),r?e(i,a):i.__proto__=a,i}}():void 0),fK=V,vK=At,pK=lG,yK=tK,gK=tl,mK=ia,hm=Po,bK=Ee,dm=na,$K=Q_,wK=pK.PROPER,ds=$K.BUGGY_SAFARI_ITERATORS,Jh=bK("iterator"),cm="keys",cs="values",fm="entries",_K=function(){return this},Uf=function(r,n,e,t,i,a,o){yK(e,n,t);var s=function(g){if(g===i&&c)return c;if(!ds&&g&&g in h)return h[g];switch(g){case cm:return function(){return new e(this,g)};case cs:return function(){return new e(this,g)};case fm:return function(){return new e(this,g)}}return function(){return new e(this)}},u=n+" Iterator",l=!1,h=r.prototype,d=h[Jh]||h["@@iterator"]||i&&h[i],c=!ds&&d||s(i),f=n==="Array"&&h.entries||d,v,p,y;if(f&&(v=gK(f.call(new r)),v!==Object.prototype&&v.next&&(mK(v,u,!0,!0),dm[u]=_K)),wK&&i===cs&&d&&d.name!==cs&&(l=!0,c=function(){return vK(d,this)}),i)if(p={values:s(cs),keys:a?c:s(cm),entries:s(fm)},o)for(y in p)(ds||l||!(y in h))&&hm(h,y,p[y]);else fK({target:n,proto:!0,forced:ds||l},p);return o&&h[Jh]!==c&&hm(h,Jh,c,{name:i}),dm[n]=c,p},Vf=function(r,n){return{value:r,done:n}},EK=G9.charAt,SK=dr,J_=zi,OK=Uf,vm=Vf,Z_="String Iterator",TK=J_.set,PK=J_.getterFor(Z_);OK(String,"String",function(r){TK(this,{type:Z_,string:SK(r),index:0})},function(){var n=PK(this),e=n.string,t=n.index,i;return t>=e.length?vm(void 0,!0):(i=EK(e,t),n.index+=i.length,vm(i,!1))});var IK=At,pm=Dt,kK=Nf,eE=function(r,n,e){var t,i;pm(r);try{if(t=kK(r,"return"),!t){if(n==="throw")throw e;return e}t=IK(t,r)}catch(a){i=!0,t=a}if(n==="throw")throw e;if(i)throw t;return pm(t),e},CK=Dt,xK=eE,AK=function(r,n,e,t){try{return t?n(CK(e)[0],e[1]):n(e)}catch(i){xK(r,"throw",i)}},RK=Ee,DK=na,MK=RK("iterator"),NK=Array.prototype,tE=function(r){return r!==void 0&&(DK.Array===r||NK[MK]===r)},FK=re,BK=ze,Ec=Ff,LK=FK(Function.toString);BK(Ec.inspectSource)||(Ec.inspectSource=function(r){return LK(r)});var jK=Ec.inspectSource,zK=re,HK=ee,rE=ze,WK=ji,UK=zt,VK=jK,iE=function(){},GK=[],nE=UK("Reflect","construct"),Gf=/^\s*(?:class|function)\b/,KK=zK(Gf.exec),qK=!Gf.test(iE),da=function(n){if(!rE(n))return!1;try{return nE(iE,GK,n),!0}catch{return!1}},aE=function(n){if(!rE(n))return!1;switch(WK(n)){case"AsyncFunction":case"GeneratorFunction":case"AsyncGeneratorFunction":return!1}try{return qK||!!KK(Gf,VK(n))}catch{return!0}};aE.sham=!0;var rl=!nE||HK(function(){var r;return da(da.call)||!da(Object)||!da(function(){r=!0})||r})?aE:da,YK=Yu,XK=Rt,QK=go,aa=function(r,n,e){var t=YK(n);t in r?XK.f(r,t,QK(0,e)):r[t]=e},JK=ji,ym=Nf,ZK=Qn,e7=na,t7=Ee,r7=t7("iterator"),il=function(r){if(!ZK(r))return ym(r,r7)||ym(r,"@@iterator")||e7[JK(r)]},i7=At,n7=Li,a7=Dt,o7=Zn,s7=il,u7=TypeError,oE=function(r,n){var e=arguments.length<2?s7(r):n;if(n7(e))return a7(i7(e,r));throw new u7(o7(r)+" is not iterable")},l7=Eo,h7=At,d7=Et,c7=AK,f7=tE,v7=rl,p7=Ht,gm=aa,y7=oE,g7=il,mm=Array,m7=function(n){var e=d7(n),t=v7(this),i=arguments.length,a=i>1?arguments[1]:void 0,o=a!==void 0;o&&(a=l7(a,i>2?arguments[2]:void 0));var s=g7(e),u=0,l,h,d,c,f,v;if(s&&!(this===mm&&f7(s)))for(c=y7(e,s),f=c.next,h=t?new this:[];!(d=h7(f,c)).done;u++)v=o?c7(c,a,[d.value,u],!0):d.value,gm(h,u,v);else for(l=p7(e),h=t?new this(l):mm(l);l>u;u++)v=o?a(e[u],u):e[u],gm(h,u,v);return h.length=u,h},b7=Ee,sE=b7("iterator"),uE=!1;try{var $7=0,bm={next:function(){return{done:!!$7++}},return:function(){uE=!0}};bm[sE]=function(){return this},Array.from(bm,function(){throw 2})}catch{}var w7=function(r,n){try{if(!n&&!uE)return!1}catch{return!1}var e=!1;try{var t={};t[sE]=function(){return{next:function(){return{done:e=!0}}}},r(t)}catch{}return e},_7=V,E7=m7,S7=w7,O7=!S7(function(r){Array.from(r)});_7({target:"Array",stat:!0,forced:O7},{from:E7});var T7=te,P7=T7.Array.from,I7=P7,lE=I7,k7=lE,Hi=L(k7),C7=hr,$m=na,hE=zi;Rt.f;var x7=Uf,fs=Vf,dE="Array Iterator",A7=hE.set,R7=hE.getterFor(dE);x7(Array,"Array",function(r,n){A7(this,{type:dE,target:C7(r),index:0,kind:n})},function(){var r=R7(this),n=r.target,e=r.kind,t=r.index++;if(!n||t>=n.length)return r.target=void 0,fs(void 0,!0);switch(e){case"keys":return fs(t,!1);case"values":return fs(n[t],!1)}return fs([t,n[t]],!1)},"values");$m.Arguments=$m.Array;var D7=il,M7=D7,N7={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0},F7=N7,B7=_e,L7=ji,j7=ta,wm=na,z7=Ee,_m=z7("toStringTag");for(var Zh in F7){var Em=B7[Zh],ed=Em&&Em.prototype;ed&&L7(ed)!==_m&&j7(ed,_m,Zh),wm[Zh]=wm.Array}var H7=M7,W7=H7,U7=W7,V7=U7,G7=V7,K7=G7,cE=K7,fE=L(cE),q7=cE,Wi=L(q7);function C(r,n){if(!(r instanceof n))throw new TypeError("Cannot call a class as a function")}var vE={exports:{}},Y7=V,X7=He,Sm=Rt.f;Y7({target:"Object",stat:!0,forced:Object.defineProperty!==Sm,sham:!X7},{defineProperty:Sm});var Q7=te,pE=Q7.Object,J7=vE.exports=function(n,e,t){return pE.defineProperty(n,e,t)};pE.defineProperty.sham&&(J7.sham=!0);var Z7=vE.exports,eq=Z7,yE=eq,tq=yE,rq=tq,iq=rq,nq=iq,aq=nq,nl=L(aq),oq=kr,Ui=Array.isArray||function(n){return oq(n)==="Array"},sq=TypeError,uq=9007199254740991,Kf=function(r){if(r>uq)throw sq("Maximum allowed index exceeded");return r},Om=Ui,lq=rl,hq=We,dq=Ee,cq=dq("species"),Tm=Array,fq=function(r){var n;return Om(r)&&(n=r.constructor,lq(n)&&(n===Tm||Om(n.prototype))?n=void 0:hq(n)&&(n=n[cq],n===null&&(n=void 0))),n===void 0?Tm:n},vq=fq,qf=function(r,n){return new(vq(r))(n===0?0:n)},pq=ee,yq=Ee,gq=$o,mq=yq("species"),Io=function(r){return gq>=51||!pq(function(){var n=[],e=n.constructor={};return e[mq]=function(){return{foo:1}},n[r](Boolean).foo!==1})},bq=V,$q=ee,wq=Ui,_q=We,Eq=Et,Sq=Ht,Pm=Kf,Im=aa,Oq=qf,Tq=Io,Pq=Ee,Iq=$o,gE=Pq("isConcatSpreadable"),kq=Iq>=51||!$q(function(){var r=[];return r[gE]=!1,r.concat()[0]!==r}),Cq=function(r){if(!_q(r))return!1;var n=r[gE];return n!==void 0?!!n:wq(r)},xq=!kq||!Tq("concat");bq({target:"Array",proto:!0,arity:1,forced:xq},{concat:function(n){var e=Eq(this),t=Oq(e,0),i=0,a,o,s,u,l;for(a=-1,s=arguments.length;a<s;a++)if(l=a===-1?e:arguments[a],Cq(l))for(u=Sq(l),Pm(i+u),o=0;o<u;o++,i++)o in l&&Im(t,i,l[o]);else Pm(i+1),Im(t,i++,l);return t.length=i,t}});var ko={},Aq=R_,Rq=Lf,Dq=Rq.concat("length","prototype");ko.f=Object.getOwnPropertyNames||function(n){return Aq(n,Dq)};var al={},km=So,Mq=Ht,Nq=aa,Fq=Array,Bq=Math.max,mE=function(r,n,e){for(var t=Mq(r),i=km(n,t),a=km(e===void 0?t:e,t),o=Fq(Bq(a-i,0)),s=0;i<a;i++,s++)Nq(o,s,r[i]);return o.length=s,o},Lq=kr,jq=hr,bE=ko.f,zq=mE,$E=typeof window=="object"&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],Hq=function(r){try{return bE(r)}catch{return zq($E)}};al.f=function(n){return $E&&Lq(n)==="Window"?Hq(n):bE(jq(n))};var Wq=Rt,Yf=function(r,n,e){return Wq.f(r,n,e)},Co={},Uq=Ee;Co.f=Uq;var Cm=te,Vq=Ue,Gq=Co,Kq=Rt.f,Se=function(r){var n=Cm.Symbol||(Cm.Symbol={});Vq(n,r)||Kq(n,r,{value:Gq.f(r)})},qq=At,Yq=zt,Xq=Ee,Qq=Po,wE=function(){var r=Yq("Symbol"),n=r&&r.prototype,e=n&&n.valueOf,t=Xq("toPrimitive");n&&!n[t]&&Qq(n,t,function(i){return qq(e,this)},{arity:1})},Jq=Eo,Zq=re,eY=Ku,tY=Et,rY=Ht,iY=qf,xm=Zq([].push),Ar=function(r){var n=r===1,e=r===2,t=r===3,i=r===4,a=r===6,o=r===7,s=r===5||a;return function(u,l,h,d){for(var c=tY(u),f=eY(c),v=Jq(l,h),p=rY(f),y=0,g=d||iY,m=n?g(u,p):e||o?g(u,0):void 0,w,$;p>y;y++)if((s||y in f)&&(w=f[y],$=v(w,y,c),r))if(n)m[y]=$;else if($)switch(r){case 3:return!0;case 5:return w;case 6:return y;case 2:xm(m,w)}else switch(r){case 4:return!1;case 7:xm(m,w)}return a?-1:t||i?i:m}},ti={forEach:Ar(0),map:Ar(1),filter:Ar(2),some:Ar(3),every:Ar(4),find:Ar(5),findIndex:Ar(6),filterReject:Ar(7)},ol=V,sl=_e,Xf=At,nY=re,kn=He,Cn=Jn,aY=ee,Be=Ue,oY=Ie,Sc=Dt,ul=hr,Qf=Yu,sY=dr,Oc=go,za=ra,_E=Qu,uY=ko,EE=al,lY=To,SE=Xn,OE=Rt,hY=el,TE=Gu,Am=Po,dY=Yf,Jf=ea,cY=Zu,PE=Oo,Rm=qu,fY=Ee,vY=Co,pY=Se,yY=wE,gY=ia,IE=zi,ll=ti.forEach,yt=cY("hidden"),hl="Symbol",Ha="prototype",mY=IE.set,Dm=IE.getterFor(hl),Yt=Object[Ha],gi=sl.Symbol,ga=gi&&gi[Ha],bY=sl.RangeError,$Y=sl.TypeError,td=sl.QObject,kE=SE.f,mi=OE.f,CE=EE.f,wY=TE.f,xE=nY([].push),Or=Jf("symbols"),xo=Jf("op-symbols"),_Y=Jf("wks"),Tc=!td||!td[Ha]||!td[Ha].findChild,AE=function(r,n,e){var t=kE(Yt,n);t&&delete Yt[n],mi(r,n,e),t&&r!==Yt&&mi(Yt,n,t)},Pc=kn&&aY(function(){return za(mi({},"a",{get:function(){return mi(this,"a",{value:7}).a}})).a!==7})?AE:mi,rd=function(r,n){var e=Or[r]=za(ga);return mY(e,{type:hl,tag:r,description:n}),kn||(e.description=n),e},dl=function(n,e,t){n===Yt&&dl(xo,e,t),Sc(n);var i=Qf(e);return Sc(t),Be(Or,i)?(t.enumerable?(Be(n,yt)&&n[yt][i]&&(n[yt][i]=!1),t=za(t,{enumerable:Oc(0,!1)})):(Be(n,yt)||mi(n,yt,Oc(1,{})),n[yt][i]=!0),Pc(n,i,t)):mi(n,i,t)},Zf=function(n,e){Sc(n);var t=ul(e),i=_E(t).concat(NE(t));return ll(i,function(a){(!kn||Xf(RE,t,a))&&dl(n,a,t[a])}),n},EY=function(n,e){return e===void 0?za(n):Zf(za(n),e)},RE=function(n){var e=Qf(n),t=Xf(wY,this,e);return this===Yt&&Be(Or,e)&&!Be(xo,e)?!1:t||!Be(this,e)||!Be(Or,e)||Be(this,yt)&&this[yt][e]?t:!0},DE=function(n,e){var t=ul(n),i=Qf(e);if(!(t===Yt&&Be(Or,i)&&!Be(xo,i))){var a=kE(t,i);return a&&Be(Or,i)&&!(Be(t,yt)&&t[yt][i])&&(a.enumerable=!0),a}},ME=function(n){var e=CE(ul(n)),t=[];return ll(e,function(i){!Be(Or,i)&&!Be(PE,i)&&xE(t,i)}),t},NE=function(r){var n=r===Yt,e=CE(n?xo:ul(r)),t=[];return ll(e,function(i){Be(Or,i)&&(!n||Be(Yt,i))&&xE(t,Or[i])}),t};Cn||(gi=function(){if(oY(ga,this))throw new $Y("Symbol is not a constructor");var n=!arguments.length||arguments[0]===void 0?void 0:sY(arguments[0]),e=Rm(n),t=function(i){this===Yt&&Xf(t,xo,i),Be(this,yt)&&Be(this[yt],e)&&(this[yt][e]=!1);var a=Oc(1,i);try{Pc(this,e,a)}catch(o){if(!(o instanceof bY))throw o;AE(this,e,a)}};return kn&&Tc&&Pc(Yt,e,{configurable:!0,set:t}),rd(e,n)},ga=gi[Ha],Am(ga,"toString",function(){return Dm(this).tag}),Am(gi,"withoutSetter",function(r){return rd(Rm(r),r)}),TE.f=RE,OE.f=dl,hY.f=Zf,SE.f=DE,uY.f=EE.f=ME,lY.f=NE,vY.f=function(r){return rd(fY(r),r)},kn&&dY(ga,"description",{configurable:!0,get:function(){return Dm(this).description}}));ol({global:!0,constructor:!0,wrap:!0,forced:!Cn,sham:!Cn},{Symbol:gi});ll(_E(_Y),function(r){pY(r)});ol({target:hl,stat:!0,forced:!Cn},{useSetter:function(){Tc=!0},useSimple:function(){Tc=!1}});ol({target:"Object",stat:!0,forced:!Cn,sham:!kn},{create:EY,defineProperty:dl,defineProperties:Zf,getOwnPropertyDescriptor:DE});ol({target:"Object",stat:!0,forced:!Cn},{getOwnPropertyNames:ME});yY();gY(gi,hl);PE[yt]=!0;var SY=Jn,FE=SY&&!!Symbol.for&&!!Symbol.keyFor,OY=V,TY=zt,PY=Ue,IY=dr,BE=ea,kY=FE,id=BE("string-to-symbol-registry"),CY=BE("symbol-to-string-registry");OY({target:"Symbol",stat:!0,forced:!kY},{for:function(r){var n=IY(r);if(PY(id,n))return id[n];var e=TY("Symbol")(n);return id[n]=e,CY[e]=n,e}});var xY=V,AY=Ue,RY=wo,DY=Zn,MY=ea,NY=FE,Mm=MY("symbol-to-string-registry");xY({target:"Symbol",stat:!0,forced:!NY},{keyFor:function(n){if(!RY(n))throw new TypeError(DY(n)+" is not a symbol");if(AY(Mm,n))return Mm[n]}});var FY=re,Nm=Ui,BY=ze,Fm=kr,LY=dr,Bm=FY([].push),jY=function(r){if(BY(r))return r;if(Nm(r)){for(var n=r.length,e=[],t=0;t<n;t++){var i=r[t];typeof i=="string"?Bm(e,i):(typeof i=="number"||Fm(i)==="Number"||Fm(i)==="String")&&Bm(e,LY(i))}var a=e.length,o=!0;return function(s,u){if(o)return o=!1,u;if(Nm(this))return u;for(var l=0;l<a;l++)if(e[l]===s)return u}}},zY=V,LE=zt,jE=yo,HY=At,Ao=re,zE=ee,Lm=ze,jm=wo,HE=Ju,WY=jY,UY=Jn,VY=String,Wr=LE("JSON","stringify"),vs=Ao(/./.exec),zm=Ao("".charAt),GY=Ao("".charCodeAt),KY=Ao("".replace),qY=Ao(1 .toString),YY=/[\uD800-\uDFFF]/g,Hm=/^[\uD800-\uDBFF]$/,Wm=/^[\uDC00-\uDFFF]$/,Um=!UY||zE(function(){var r=LE("Symbol")("stringify detection");return Wr([r])!=="[null]"||Wr({a:r})!=="{}"||Wr(Object(r))!=="{}"}),Vm=zE(function(){return Wr("\uDF06\uD834")!=='"\\udf06\\ud834"'||Wr("\uDEAD")!=='"\\udead"'}),XY=function(r,n){var e=HE(arguments),t=WY(n);if(!(!Lm(t)&&(r===void 0||jm(r))))return e[1]=function(i,a){if(Lm(t)&&(a=HY(t,this,VY(i),a)),!jm(a))return a},jE(Wr,null,e)},QY=function(r,n,e){var t=zm(e,n-1),i=zm(e,n+1);return vs(Hm,r)&&!vs(Wm,i)||vs(Wm,r)&&!vs(Hm,t)?"\\u"+qY(GY(r,0),16):r};Wr&&zY({target:"JSON",stat:!0,arity:3,forced:Um||Vm},{stringify:function(n,e,t){var i=HE(arguments),a=jE(Um?XY:Wr,null,i);return Vm&&typeof a=="string"?KY(a,YY,QY):a}});var JY=V,ZY=Jn,eX=ee,WE=To,tX=Et,rX=!ZY||eX(function(){WE.f(1)});JY({target:"Object",stat:!0,forced:rX},{getOwnPropertySymbols:function(n){var e=WE.f;return e?e(tX(n)):[]}});var iX=Se;iX("asyncIterator");var nX=Se;nX("hasInstance");var aX=Se;aX("isConcatSpreadable");var oX=Se;oX("iterator");var sX=Se;sX("match");var uX=Se;uX("matchAll");var lX=Se;lX("replace");var hX=Se;hX("search");var dX=Se;dX("species");var cX=Se;cX("split");var fX=Se,vX=wE;fX("toPrimitive");vX();var pX=zt,yX=Se,gX=ia;yX("toStringTag");gX(pX("Symbol"),"Symbol");var mX=Se;mX("unscopables");var bX=_e,$X=ia;$X(bX.JSON,"JSON",!0);var wX=te,_X=wX.Symbol,EX=_X,UE=EX,SX=Ee,OX=Rt.f,Gm=SX("metadata"),Km=Function.prototype;Km[Gm]===void 0&&OX(Km,Gm,{value:null});var TX=Se;TX("asyncDispose");var PX=Se;PX("dispose");var IX=Se;IX("metadata");var kX=UE,CX=kX,xX=zt,AX=re,ev=xX("Symbol"),RX=ev.keyFor,DX=AX(ev.prototype.valueOf),VE=ev.isRegisteredSymbol||function(n){try{return RX(DX(n))!==void 0}catch{return!1}},MX=V,NX=VE;MX({target:"Symbol",stat:!0},{isRegisteredSymbol:NX});var FX=ea,GE=zt,BX=re,LX=wo,jX=Ee,ou=GE("Symbol"),qm=ou.isWellKnownSymbol,KE=GE("Object","getOwnPropertyNames"),zX=BX(ou.prototype.valueOf),Ym=FX("wks");for(var nd=0,Xm=KE(ou),HX=Xm.length;nd<HX;nd++)try{var Qm=Xm[nd];LX(ou[Qm])&&jX(Qm)}catch{}var qE=function(n){if(qm&&qm(n))return!0;try{for(var e=zX(n),t=0,i=KE(Ym),a=i.length;t<a;t++)if(Ym[i[t]]==e)return!0}catch{}return!1},WX=V,UX=qE;WX({target:"Symbol",stat:!0,forced:!0},{isWellKnownSymbol:UX});var VX=Se;VX("matcher");var GX=Se;GX("observable");var KX=V,qX=VE;KX({target:"Symbol",stat:!0,name:"isRegisteredSymbol"},{isRegistered:qX});var YX=V,XX=qE;YX({target:"Symbol",stat:!0,name:"isWellKnownSymbol",forced:!0},{isWellKnown:XX});var QX=Se;QX("metadataKey");var JX=Se;JX("patternMatch");var ZX=Se;ZX("replaceAll");var eQ=CX,tQ=eQ,rQ=tQ,pn=L(rQ),iQ=Co,nQ=iQ.f("iterator"),aQ=nQ,oQ=aQ,sQ=oQ,uQ=sQ,lQ=uQ,hQ=lQ,dQ=hQ,cQ=L(dQ);function se(r){"@babel/helpers - typeof";return se=typeof pn=="function"&&typeof cQ=="symbol"?function(n){return typeof n}:function(n){return n&&typeof pn=="function"&&n.constructor===pn&&n!==pn.prototype?"symbol":typeof n},se(r)}var fQ=Co,vQ=fQ.f("toPrimitive"),pQ=vQ,yQ=pQ,gQ=yQ,mQ=gQ,bQ=mQ,$Q=bQ,wQ=$Q,_Q=L(wQ);function EQ(r,n){if(se(r)!=="object"||r===null)return r;var e=r[_Q];if(e!==void 0){var t=e.call(r,n||"default");if(se(t)!=="object")return t;throw new TypeError("@@toPrimitive must return a primitive value.")}return(n==="string"?String:Number)(r)}function YE(r){var n=EQ(r,"string");return se(n)==="symbol"?n:String(n)}function Jm(r,n){for(var e=0;e<n.length;e++){var t=n[e];t.enumerable=t.enumerable||!1,t.configurable=!0,"value"in t&&(t.writable=!0),nl(r,YE(t.key),t)}}function x(r,n,e){return n&&Jm(r.prototype,n),e&&Jm(r,e),nl(r,"prototype",{writable:!1}),r}var SQ=V,OQ=Ui;SQ({target:"Array",stat:!0},{isArray:OQ});var TQ=te,PQ=TQ.Array.isArray,IQ=PQ,XE=IQ,kQ=XE,CQ=kQ,xQ=CQ,AQ=xQ,RQ=AQ,QE=L(RQ);function DQ(r){if(QE(r))return r}var MQ=He,NQ=Ui,FQ=TypeError,BQ=Object.getOwnPropertyDescriptor,LQ=MQ&&!function(){if(this!==void 0)return!0;try{Object.defineProperty([],"length",{writable:!1}).length=1}catch(r){return r instanceof TypeError}}(),JE=LQ?function(r,n){if(NQ(r)&&!BQ(r,"length").writable)throw new FQ("Cannot set read only .length");return r.length=n}:function(r,n){return r.length=n},jQ=V,zQ=Et,HQ=Ht,WQ=JE,UQ=Kf,VQ=ee,GQ=VQ(function(){return[].push.call({length:4294967296},1)!==4294967297}),KQ=function(){try{Object.defineProperty([],"length",{writable:!1}).push()}catch(r){return r instanceof TypeError}},qQ=GQ||!KQ();jQ({target:"Array",proto:!0,arity:1,forced:qQ},{push:function(n){var e=zQ(this),t=HQ(e),i=arguments.length;UQ(t+i);for(var a=0;a<i;a++)e[t]=arguments[a],t++;return WQ(e,t),t}});var YQ=Ve,XQ=YQ("Array").push,QQ=Ie,JQ=XQ,ad=Array.prototype,ZQ=function(r){var n=r.push;return r===ad||QQ(ad,r)&&n===ad.push?JQ:n},eJ=ZQ,tJ=eJ,rJ=tJ,iJ=rJ,nJ=iJ,aJ=nJ,oJ=aJ,sJ=L(oJ);function uJ(r,n){var e=r==null?null:typeof pn<"u"&&fE(r)||r["@@iterator"];if(e!=null){var t,i,a,o,s=[],u=!0,l=!1;try{if(a=(e=e.call(r)).next,n===0){if(Object(e)!==e)return;u=!1}else for(;!(u=(t=a.call(e)).done)&&(sJ(s).call(s,t.value),s.length!==n);u=!0);}catch(h){l=!0,i=h}finally{try{if(!u&&e.return!=null&&(o=e.return(),Object(o)!==o))return}finally{if(l)throw i}}return s}}var lJ=V,Zm=Ui,hJ=rl,dJ=We,eb=So,cJ=Ht,fJ=hr,vJ=aa,pJ=Ee,yJ=Io,gJ=Ju,mJ=yJ("slice"),bJ=pJ("species"),od=Array,$J=Math.max;lJ({target:"Array",proto:!0,forced:!mJ},{slice:function(n,e){var t=fJ(this),i=cJ(t),a=eb(n,i),o=eb(e===void 0?i:e,i),s,u,l;if(Zm(t)&&(s=t.constructor,hJ(s)&&(s===od||Zm(s.prototype))?s=void 0:dJ(s)&&(s=s[bJ],s===null&&(s=void 0)),s===od||s===void 0))return gJ(t,a,o);for(u=new(s===void 0?od:s)($J(o-a,0)),l=0;a<o;a++,l++)a in t&&vJ(u,l,t[a]);return u.length=l,u}});var wJ=Ve,_J=wJ("Array").slice,EJ=Ie,SJ=_J,sd=Array.prototype,OJ=function(r){var n=r.slice;return r===sd||EJ(sd,r)&&n===sd.slice?SJ:n},TJ=OJ,ZE=TJ,PJ=ZE,IJ=PJ,kJ=IJ,CJ=kJ,xJ=CJ,AJ=L(xJ),RJ=lE,DJ=RJ,MJ=DJ,NJ=MJ,FJ=NJ,eS=L(FJ);function Ic(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}function tS(r,n){var e;if(r){if(typeof r=="string")return Ic(r,n);var t=AJ(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return eS(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return Ic(r,n)}}function BJ(){throw new TypeError(`Invalid attempt to destructure non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function be(r,n){return DQ(r)||uJ(r,n)||tS(r,n)||BJ()}function LJ(r){if(QE(r))return Ic(r)}function jJ(r){if(typeof pn<"u"&&fE(r)!=null||r["@@iterator"]!=null)return eS(r)}function zJ(){throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function tr(r){return LJ(r)||jJ(r)||tS(r)||zJ()}var HJ=UE,ri=L(HJ),WJ=Ve,UJ=WJ("Array").concat,VJ=Ie,GJ=UJ,ud=Array.prototype,KJ=function(r){var n=r.concat;return r===ud||VJ(ud,r)&&n===ud.concat?GJ:n},qJ=KJ,YJ=qJ,XJ=YJ,tv=L(XJ),QJ=ZE,Ye=L(QJ),JJ=zt,ZJ=re,eZ=ko,tZ=To,rZ=Dt,iZ=ZJ([].concat),nZ=JJ("Reflect","ownKeys")||function(n){var e=eZ.f(rZ(n)),t=tZ.f;return t?iZ(e,t(n)):e},aZ=XE,ae=L(aZ),oZ=V,sZ=ti.map,uZ=Io,lZ=uZ("map");oZ({target:"Array",proto:!0,forced:!lZ},{map:function(n){return sZ(this,n,arguments.length>1?arguments[1]:void 0)}});var hZ=Ve,dZ=hZ("Array").map,cZ=Ie,fZ=dZ,ld=Array.prototype,vZ=function(r){var n=r.map;return r===ld||cZ(ld,r)&&n===ld.map?fZ:n},pZ=vZ,yZ=pZ,gZ=yZ,xn=L(gZ),mZ=V,bZ=Et,rS=Qu,$Z=ee,wZ=$Z(function(){rS(1)});mZ({target:"Object",stat:!0,forced:wZ},{keys:function(n){return rS(bZ(n))}});var _Z=te,EZ=_Z.Object.keys,SZ=EZ,OZ=SZ,TZ=OZ,me=L(TZ),PZ=V,IZ=re,iS=Date,kZ=IZ(iS.prototype.getTime);PZ({target:"Date",stat:!0},{now:function(){return kZ(new iS)}});var CZ=te,xZ=CZ.Date.now,AZ=xZ,RZ=AZ,DZ=RZ,su=L(DZ),MZ=ee,oa=function(r,n){var e=[][r];return!!e&&MZ(function(){e.call(null,n||function(){return 1},1)})},NZ=ti.forEach,FZ=oa,BZ=FZ("forEach"),LZ=BZ?[].forEach:function(n){return NZ(this,n,arguments.length>1?arguments[1]:void 0)},jZ=V,tb=LZ;jZ({target:"Array",proto:!0,forced:[].forEach!==tb},{forEach:tb});var zZ=Ve,HZ=zZ("Array").forEach,WZ=HZ,UZ=WZ,VZ=ji,GZ=Ue,KZ=Ie,qZ=UZ,hd=Array.prototype,YZ={DOMTokenList:!0,NodeList:!0},XZ=function(r){var n=r.forEach;return r===hd||KZ(hd,r)&&n===hd.forEach||GZ(YZ,VZ(r))?qZ:n},QZ=XZ,ue=L(QZ),JZ=V,ZZ=re,eee=Ui,tee=ZZ([].reverse),rb=[1,2];JZ({target:"Array",proto:!0,forced:String(rb)===String(rb.reverse())},{reverse:function(){return eee(this)&&(this.length=this.length),tee(this)}});var ree=Ve,iee=ree("Array").reverse,nee=Ie,aee=iee,dd=Array.prototype,oee=function(r){var n=r.reverse;return r===dd||nee(dd,r)&&n===dd.reverse?aee:n},see=oee,uee=see,lee=uee,bi=L(lee),ib=Zn,hee=TypeError,nS=function(r,n){if(!delete r[n])throw new hee("Cannot delete property "+ib(n)+" of "+ib(r))},dee=V,cee=Et,fee=So,vee=Xu,pee=Ht,yee=JE,gee=Kf,mee=qf,bee=aa,cd=nS,$ee=Io,wee=$ee("splice"),_ee=Math.max,Eee=Math.min;dee({target:"Array",proto:!0,forced:!wee},{splice:function(n,e){var t=cee(this),i=pee(t),a=fee(n,i),o=arguments.length,s,u,l,h,d,c;for(o===0?s=u=0:o===1?(s=0,u=i-a):(s=o-2,u=Eee(_ee(vee(e),0),i-a)),gee(i+s-u),l=mee(t,u),h=0;h<u;h++)d=a+h,d in t&&bee(l,h,t[d]);if(l.length=u,s<u){for(h=a;h<i-u;h++)d=h+u,c=h+s,d in t?t[c]=t[d]:cd(t,c);for(h=i;h>i-u+s;h--)cd(t,h-1)}else if(s>u)for(h=i-u;h>a;h--)d=h+u-1,c=h+s-1,d in t?t[c]=t[d]:cd(t,c);for(h=0;h<s;h++)t[h+a]=arguments[h+2];return yee(t,i-u+s),l}});var See=Ve,Oee=See("Array").splice,Tee=Ie,Pee=Oee,fd=Array.prototype,Iee=function(r){var n=r.splice;return r===fd||Tee(fd,r)&&n===fd.splice?Pee:n},kee=Iee,Cee=kee,xee=Cee,br=L(xee),Aee=V,Ree=Bf.includes,Dee=ee,Mee=Dee(function(){return!Array(1).includes()});Aee({target:"Array",proto:!0,forced:Mee},{includes:function(n){return Ree(this,n,arguments.length>1?arguments[1]:void 0)}});var Nee=Ve,Fee=Nee("Array").includes,Bee=We,Lee=kr,jee=Ee,zee=jee("match"),Hee=function(r){var n;return Bee(r)&&((n=r[zee])!==void 0?!!n:Lee(r)==="RegExp")},Wee=Hee,Uee=TypeError,Vee=function(r){if(Wee(r))throw new Uee("The method doesn't accept regular expressions");return r},Gee=Ee,Kee=Gee("match"),qee=function(r){var n=/./;try{"/./"[r](n)}catch{try{return n[Kee]=!1,"/./"[r](n)}catch{}}return!1},Yee=V,Xee=re,Qee=Vee,Jee=mo,nb=dr,Zee=qee,ete=Xee("".indexOf);Yee({target:"String",proto:!0,forced:!Zee("includes")},{includes:function(n){return!!~ete(nb(Jee(this)),nb(Qee(n)),arguments.length>1?arguments[1]:void 0)}});var tte=Ve,rte=tte("String").includes,ab=Ie,ite=Fee,nte=rte,vd=Array.prototype,pd=String.prototype,ate=function(r){var n=r.includes;return r===vd||ab(vd,r)&&n===vd.includes?ite:typeof r=="string"||r===pd||ab(pd,r)&&n===pd.includes?nte:n},ote=ate,ste=ote,ute=ste,Ur=L(ute),lte=V,hte=ee,dte=Et,aS=tl,cte=Y_,fte=hte(function(){aS(1)});lte({target:"Object",stat:!0,forced:fte,sham:!cte},{getPrototypeOf:function(n){return aS(dte(n))}});var vte=te,pte=vte.Object.getPrototypeOf,yte=pte,oS=yte,gte=oS,ob=L(gte),mte=V,bte=ti.filter,$te=Io,wte=$te("filter");mte({target:"Array",proto:!0,forced:!wte},{filter:function(n){return bte(this,n,arguments.length>1?arguments[1]:void 0)}});var _te=Ve,Ete=_te("Array").filter,Ste=Ie,Ote=Ete,yd=Array.prototype,Tte=function(r){var n=r.filter;return r===yd||Ste(yd,r)&&n===yd.filter?Ote:n},Pte=Tte,Ite=Pte,kte=Ite,gt=L(kte),rv=`	
\v\f\r                　\u2028\u2029\uFEFF`,Cte=re,xte=mo,Ate=dr,kc=rv,sb=Cte("".replace),Rte=RegExp("^["+kc+"]+"),Dte=RegExp("(^|[^"+kc+"])["+kc+"]+$"),gd=function(r){return function(n){var e=Ate(xte(n));return r&1&&(e=sb(e,Rte,"")),r&2&&(e=sb(e,Dte,"$1")),e}},sS={start:gd(1),end:gd(2),trim:gd(3)},uS=_e,Mte=ee,Nte=re,Fte=dr,Bte=sS.trim,ub=rv,Sa=uS.parseInt,lb=uS.Symbol,hb=lb&&lb.iterator,lS=/^[+-]?0x/i,Lte=Nte(lS.exec),jte=Sa(ub+"08")!==8||Sa(ub+"0x16")!==22||hb&&!Mte(function(){Sa(Object(hb))}),zte=jte?function(n,e){var t=Bte(Fte(n));return Sa(t,e>>>0||(Lte(lS,t)?16:10))}:Sa,Hte=V,db=zte;Hte({global:!0,forced:parseInt!==db},{parseInt:db});var Wte=te,Ute=Wte.parseInt,Vte=Ute,Gte=Vte,Kte=Gte,Kt=L(Kte),qte=V,Yte=Mf,Xte=Bf.indexOf,Qte=oa,Cc=Yte([].indexOf),hS=!!Cc&&1/Cc([1],1,-0)<0,Jte=hS||!Qte("indexOf");qte({target:"Array",proto:!0,forced:Jte},{indexOf:function(n){var e=arguments.length>1?arguments[1]:void 0;return hS?Cc(this,n,e)||0:Xte(this,n,e)}});var Zte=Ve,ere=Zte("Array").indexOf,tre=Ie,rre=ere,md=Array.prototype,ire=function(r){var n=r.indexOf;return r===md||tre(md,r)&&n===md.indexOf?rre:n},nre=ire,are=nre,ore=are,Z=L(ore),sre=V,ure=He,lre=ra;sre({target:"Object",stat:!0,sham:!ure},{create:lre});var hre=te,dre=hre.Object,cre=function(n,e){return dre.create(n,e)},fre=cre,dS=fre,vre=dS,$i=L(vre),xc=te,pre=yo;xc.JSON||(xc.JSON={stringify:JSON.stringify});var yre=function(n,e,t){return pre(xc.JSON.stringify,null,arguments)},gre=yre,mre=gre,bre=mre,Ro=L(bre),$re=typeof Bun=="function"&&Bun&&typeof Bun.version=="string",wre=TypeError,_re=function(r,n){if(r<n)throw new wre("Not enough arguments");return r},cS=_e,Ere=yo,Sre=ze,Ore=$re,Tre=bo,Pre=Ju,Ire=_re,kre=cS.Function,Cre=/MSIE .\./.test(Tre)||Ore&&function(){var r=cS.Bun.version.split(".");return r.length<3||r[0]==="0"&&(r[1]<3||r[1]==="3"&&r[2]==="0")}(),fS=function(r,n){var e=n?2:1;return Cre?function(t,i){var a=Ire(arguments.length,1)>e,o=Sre(t)?t:kre(t),s=a?Pre(arguments,e):[],u=a?function(){Ere(o,this,s)}:o;return n?r(u,i):r(u)}:r},xre=V,vS=_e,Are=fS,cb=Are(vS.setInterval,!0);xre({global:!0,bind:!0,forced:vS.setInterval!==cb},{setInterval:cb});var Rre=V,pS=_e,Dre=fS,fb=Dre(pS.setTimeout,!0);Rre({global:!0,bind:!0,forced:pS.setTimeout!==fb},{setTimeout:fb});var Mre=te,Nre=Mre.setTimeout,Fre=Nre,or=L(Fre),Bre=Et,vb=So,Lre=Ht,jre=function(n){for(var e=Bre(this),t=Lre(e),i=arguments.length,a=vb(i>1?arguments[1]:void 0,t),o=i>2?arguments[2]:void 0,s=o===void 0?t:vb(o,t);s>a;)e[a++]=n;return e},zre=V,Hre=jre;zre({target:"Array",proto:!0},{fill:Hre});var Wre=Ve,Ure=Wre("Array").fill,Vre=Ie,Gre=Ure,bd=Array.prototype,Kre=function(r){var n=r.fill;return r===bd||Vre(bd,r)&&n===bd.fill?Gre:n},qre=Kre,Yre=qre,Xre=Yre,Do=L(Xre);/*! Hammer.JS - v2.0.17-rc - 2019-12-16
 * http://naver.github.io/egjs
 *
 * Forked By Naver egjs
 * Copyright (c) hammerjs
 * Licensed under the MIT license */function Qt(){return Qt=Object.assign||function(r){for(var n=1;n<arguments.length;n++){var e=arguments[n];for(var t in e)Object.prototype.hasOwnProperty.call(e,t)&&(r[t]=e[t])}return r},Qt.apply(this,arguments)}function Wt(r,n){r.prototype=Object.create(n.prototype),r.prototype.constructor=r,r.__proto__=n}function ps(r){if(r===void 0)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return r}var Ac;typeof Object.assign!="function"?Ac=function(n){if(n==null)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(n),t=1;t<arguments.length;t++){var i=arguments[t];if(i!=null)for(var a in i)i.hasOwnProperty(a)&&(e[a]=i[a])}return e}:Ac=Object.assign;var Ii=Ac,pb=["","webkit","Moz","MS","ms","o"],Qre=typeof document>"u"?{style:{}}:document.createElement("div"),Jre="function",yn=Math.round,ki=Math.abs,iv=Date.now;function cl(r,n){for(var e,t,i=n[0].toUpperCase()+n.slice(1),a=0;a<pb.length;){if(e=pb[a],t=e?e+i:n,t in r)return t;a++}}var $r;typeof window>"u"?$r={}:$r=window;var yS=cl(Qre.style,"touchAction"),gS=yS!==void 0;function Zre(){if(!gS)return!1;var r={},n=$r.CSS&&$r.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach(function(e){return r[e]=n?$r.CSS.supports("touch-action",e):!0}),r}var mS="compute",bS="auto",Rc="manipulation",wi="none",Wa="pan-x",Ua="pan-y",ys=Zre(),eie=/mobile|tablet|ip(ad|hone|od)|android/i,$S="ontouchstart"in $r,tie=cl($r,"PointerEvent")!==void 0,rie=$S&&eie.test(navigator.userAgent),Mo="touch",iie="pen",nv="mouse",nie="kinect",aie=25,ut=1,Vi=2,Re=4,bt=8,uu=1,No=2,Fo=4,Bo=8,An=16,sr=No|Fo,_i=Bo|An,wS=sr|_i,_S=["x","y"],lu=["clientX","clientY"];function wr(r,n,e){var t;if(r)if(r.forEach)r.forEach(n,e);else if(r.length!==void 0)for(t=0;t<r.length;)n.call(e,r[t],t,r),t++;else for(t in r)r.hasOwnProperty(t)&&n.call(e,r[t],t,r)}function fl(r,n){return typeof r===Jre?r.apply(n&&n[0]||void 0,n):r}function di(r,n){return r.indexOf(n)>-1}function oie(r){if(di(r,wi))return wi;var n=di(r,Wa),e=di(r,Ua);return n&&e?wi:n||e?n?Wa:Ua:di(r,Rc)?Rc:bS}var ES=function(){function r(e,t){this.manager=e,this.set(t)}var n=r.prototype;return n.set=function(t){t===mS&&(t=this.compute()),gS&&this.manager.element.style&&ys[t]&&(this.manager.element.style[yS]=t),this.actions=t.toLowerCase().trim()},n.update=function(){this.set(this.manager.options.touchAction)},n.compute=function(){var t=[];return wr(this.manager.recognizers,function(i){fl(i.options.enable,[i])&&(t=t.concat(i.getTouchAction()))}),oie(t.join(" "))},n.preventDefaults=function(t){var i=t.srcEvent,a=t.offsetDirection;if(this.manager.session.prevented){i.preventDefault();return}var o=this.actions,s=di(o,wi)&&!ys[wi],u=di(o,Ua)&&!ys[Ua],l=di(o,Wa)&&!ys[Wa];if(s){var h=t.pointers.length===1,d=t.distance<2,c=t.deltaTime<250;if(h&&d&&c)return}if(!(l&&u)&&(s||u&&a&sr||l&&a&_i))return this.preventSrc(i)},n.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},r}();function av(r,n){for(;r;){if(r===n)return!0;r=r.parentNode}return!1}function SS(r){var n=r.length;if(n===1)return{x:yn(r[0].clientX),y:yn(r[0].clientY)};for(var e=0,t=0,i=0;i<n;)e+=r[i].clientX,t+=r[i].clientY,i++;return{x:yn(e/n),y:yn(t/n)}}function yb(r){for(var n=[],e=0;e<r.pointers.length;)n[e]={clientX:yn(r.pointers[e].clientX),clientY:yn(r.pointers[e].clientY)},e++;return{timeStamp:iv(),pointers:n,center:SS(n),deltaX:r.deltaX,deltaY:r.deltaY}}function hu(r,n,e){e||(e=_S);var t=n[e[0]]-r[e[0]],i=n[e[1]]-r[e[1]];return Math.sqrt(t*t+i*i)}function Dc(r,n,e){e||(e=_S);var t=n[e[0]]-r[e[0]],i=n[e[1]]-r[e[1]];return Math.atan2(i,t)*180/Math.PI}function OS(r,n){return r===n?uu:ki(r)>=ki(n)?r<0?No:Fo:n<0?Bo:An}function sie(r,n){var e=n.center,t=r.offsetDelta||{},i=r.prevDelta||{},a=r.prevInput||{};(n.eventType===ut||a.eventType===Re)&&(i=r.prevDelta={x:a.deltaX||0,y:a.deltaY||0},t=r.offsetDelta={x:e.x,y:e.y}),n.deltaX=i.x+(e.x-t.x),n.deltaY=i.y+(e.y-t.y)}function TS(r,n,e){return{x:n/r||0,y:e/r||0}}function uie(r,n){return hu(n[0],n[1],lu)/hu(r[0],r[1],lu)}function lie(r,n){return Dc(n[1],n[0],lu)+Dc(r[1],r[0],lu)}function hie(r,n){var e=r.lastInterval||n,t=n.timeStamp-e.timeStamp,i,a,o,s;if(n.eventType!==bt&&(t>aie||e.velocity===void 0)){var u=n.deltaX-e.deltaX,l=n.deltaY-e.deltaY,h=TS(t,u,l);a=h.x,o=h.y,i=ki(h.x)>ki(h.y)?h.x:h.y,s=OS(u,l),r.lastInterval=n}else i=e.velocity,a=e.velocityX,o=e.velocityY,s=e.direction;n.velocity=i,n.velocityX=a,n.velocityY=o,n.direction=s}function die(r,n){var e=r.session,t=n.pointers,i=t.length;e.firstInput||(e.firstInput=yb(n)),i>1&&!e.firstMultiple?e.firstMultiple=yb(n):i===1&&(e.firstMultiple=!1);var a=e.firstInput,o=e.firstMultiple,s=o?o.center:a.center,u=n.center=SS(t);n.timeStamp=iv(),n.deltaTime=n.timeStamp-a.timeStamp,n.angle=Dc(s,u),n.distance=hu(s,u),sie(e,n),n.offsetDirection=OS(n.deltaX,n.deltaY);var l=TS(n.deltaTime,n.deltaX,n.deltaY);n.overallVelocityX=l.x,n.overallVelocityY=l.y,n.overallVelocity=ki(l.x)>ki(l.y)?l.x:l.y,n.scale=o?uie(o.pointers,t):1,n.rotation=o?lie(o.pointers,t):0,n.maxPointers=e.prevInput?n.pointers.length>e.prevInput.maxPointers?n.pointers.length:e.prevInput.maxPointers:n.pointers.length,hie(e,n);var h=r.element,d=n.srcEvent,c;d.composedPath?c=d.composedPath()[0]:d.path?c=d.path[0]:c=d.target,av(c,h)&&(h=c),n.target=h}function cie(r,n,e){var t=e.pointers.length,i=e.changedPointers.length,a=n&ut&&t-i===0,o=n&(Re|bt)&&t-i===0;e.isFirst=!!a,e.isFinal=!!o,a&&(r.session={}),e.eventType=n,die(r,e),r.emit("hammer.input",e),r.recognize(e),r.session.prevInput=e}function Va(r){return r.trim().split(/\s+/g)}function Oa(r,n,e){wr(Va(n),function(t){r.addEventListener(t,e,!1)})}function Ta(r,n,e){wr(Va(n),function(t){r.removeEventListener(t,e,!1)})}function gb(r){var n=r.ownerDocument||r;return n.defaultView||n.parentWindow||window}var sa=function(){function r(e,t){var i=this;this.manager=e,this.callback=t,this.element=e.element,this.target=e.options.inputTarget,this.domHandler=function(a){fl(e.options.enable,[e])&&i.handler(a)},this.init()}var n=r.prototype;return n.handler=function(){},n.init=function(){this.evEl&&Oa(this.element,this.evEl,this.domHandler),this.evTarget&&Oa(this.target,this.evTarget,this.domHandler),this.evWin&&Oa(gb(this.element),this.evWin,this.domHandler)},n.destroy=function(){this.evEl&&Ta(this.element,this.evEl,this.domHandler),this.evTarget&&Ta(this.target,this.evTarget,this.domHandler),this.evWin&&Ta(gb(this.element),this.evWin,this.domHandler)},r}();function Ci(r,n,e){if(r.indexOf&&!e)return r.indexOf(n);for(var t=0;t<r.length;){if(e&&r[t][e]==n||!e&&r[t]===n)return t;t++}return-1}var fie={pointerdown:ut,pointermove:Vi,pointerup:Re,pointercancel:bt,pointerout:bt},vie={2:Mo,3:iie,4:nv,5:nie},PS="pointerdown",IS="pointermove pointerup pointercancel";$r.MSPointerEvent&&!$r.PointerEvent&&(PS="MSPointerDown",IS="MSPointerMove MSPointerUp MSPointerCancel");var kS=function(r){Wt(n,r);function n(){var t,i=n.prototype;return i.evEl=PS,i.evWin=IS,t=r.apply(this,arguments)||this,t.store=t.manager.session.pointerEvents=[],t}var e=n.prototype;return e.handler=function(i){var a=this.store,o=!1,s=i.type.toLowerCase().replace("ms",""),u=fie[s],l=vie[i.pointerType]||i.pointerType,h=l===Mo,d=Ci(a,i.pointerId,"pointerId");u&ut&&(i.button===0||h)?d<0&&(a.push(i),d=a.length-1):u&(Re|bt)&&(o=!0),!(d<0)&&(a[d]=i,this.callback(this.manager,u,{pointers:a,changedPointers:[i],pointerType:l,srcEvent:i}),o&&a.splice(d,1))},n}(sa);function Ga(r){return Array.prototype.slice.call(r,0)}function ov(r,n,e){for(var t=[],i=[],a=0;a<r.length;){var o=n?r[a][n]:r[a];Ci(i,o)<0&&t.push(r[a]),i[a]=o,a++}return e&&(n?t=t.sort(function(s,u){return s[n]>u[n]}):t=t.sort()),t}var pie={touchstart:ut,touchmove:Vi,touchend:Re,touchcancel:bt},yie="touchstart touchmove touchend touchcancel",sv=function(r){Wt(n,r);function n(){var t;return n.prototype.evTarget=yie,t=r.apply(this,arguments)||this,t.targetIds={},t}var e=n.prototype;return e.handler=function(i){var a=pie[i.type],o=gie.call(this,i,a);o&&this.callback(this.manager,a,{pointers:o[0],changedPointers:o[1],pointerType:Mo,srcEvent:i})},n}(sa);function gie(r,n){var e=Ga(r.touches),t=this.targetIds;if(n&(ut|Vi)&&e.length===1)return t[e[0].identifier]=!0,[e,e];var i,a,o=Ga(r.changedTouches),s=[],u=this.target;if(a=e.filter(function(l){return av(l.target,u)}),n===ut)for(i=0;i<a.length;)t[a[i].identifier]=!0,i++;for(i=0;i<o.length;)t[o[i].identifier]&&s.push(o[i]),n&(Re|bt)&&delete t[o[i].identifier],i++;if(s.length)return[ov(a.concat(s),"identifier",!0),s]}var mie={mousedown:ut,mousemove:Vi,mouseup:Re},bie="mousedown",$ie="mousemove mouseup",uv=function(r){Wt(n,r);function n(){var t,i=n.prototype;return i.evEl=bie,i.evWin=$ie,t=r.apply(this,arguments)||this,t.pressed=!1,t}var e=n.prototype;return e.handler=function(i){var a=mie[i.type];a&ut&&i.button===0&&(this.pressed=!0),a&Vi&&i.which!==1&&(a=Re),this.pressed&&(a&Re&&(this.pressed=!1),this.callback(this.manager,a,{pointers:[i],changedPointers:[i],pointerType:nv,srcEvent:i}))},n}(sa),wie=2500,mb=25;function bb(r){var n=r.changedPointers,e=n[0];if(e.identifier===this.primaryTouch){var t={x:e.clientX,y:e.clientY},i=this.lastTouches;this.lastTouches.push(t);var a=function(){var s=i.indexOf(t);s>-1&&i.splice(s,1)};setTimeout(a,wie)}}function _ie(r,n){r&ut?(this.primaryTouch=n.changedPointers[0].identifier,bb.call(this,n)):r&(Re|bt)&&bb.call(this,n)}function Eie(r){for(var n=r.srcEvent.clientX,e=r.srcEvent.clientY,t=0;t<this.lastTouches.length;t++){var i=this.lastTouches[t],a=Math.abs(n-i.x),o=Math.abs(e-i.y);if(a<=mb&&o<=mb)return!0}return!1}var CS=function(){var r=function(n){Wt(e,n);function e(i,a){var o;return o=n.call(this,i,a)||this,o.handler=function(s,u,l){var h=l.pointerType===Mo,d=l.pointerType===nv;if(!(d&&l.sourceCapabilities&&l.sourceCapabilities.firesTouchEvents)){if(h)_ie.call(ps(ps(o)),u,l);else if(d&&Eie.call(ps(ps(o)),l))return;o.callback(s,u,l)}},o.touch=new sv(o.manager,o.handler),o.mouse=new uv(o.manager,o.handler),o.primaryTouch=null,o.lastTouches=[],o}var t=e.prototype;return t.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(sa);return r}();function Sie(r){var n,e=r.options.inputClass;return e?n=e:tie?n=kS:rie?n=sv:$S?n=CS:n=uv,new n(r,cie)}function gn(r,n,e){return Array.isArray(r)?(wr(r,e[n],e),!0):!1}var Ms=1,Lt=2,Rn=4,Vr=8,_r=Vr,Ka=16,ir=32,Oie=1;function Tie(){return Oie++}function gs(r,n){var e=n.manager;return e?e.get(r):r}function $b(r){return r&Ka?"cancel":r&Vr?"end":r&Rn?"move":r&Lt?"start":""}var Lo=function(){function r(e){e===void 0&&(e={}),this.options=Qt({enable:!0},e),this.id=Tie(),this.manager=null,this.state=Ms,this.simultaneous={},this.requireFail=[]}var n=r.prototype;return n.set=function(t){return Ii(this.options,t),this.manager&&this.manager.touchAction.update(),this},n.recognizeWith=function(t){if(gn(t,"recognizeWith",this))return this;var i=this.simultaneous;return t=gs(t,this),i[t.id]||(i[t.id]=t,t.recognizeWith(this)),this},n.dropRecognizeWith=function(t){return gn(t,"dropRecognizeWith",this)?this:(t=gs(t,this),delete this.simultaneous[t.id],this)},n.requireFailure=function(t){if(gn(t,"requireFailure",this))return this;var i=this.requireFail;return t=gs(t,this),Ci(i,t)===-1&&(i.push(t),t.requireFailure(this)),this},n.dropRequireFailure=function(t){if(gn(t,"dropRequireFailure",this))return this;t=gs(t,this);var i=Ci(this.requireFail,t);return i>-1&&this.requireFail.splice(i,1),this},n.hasRequireFailures=function(){return this.requireFail.length>0},n.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},n.emit=function(t){var i=this,a=this.state;function o(s){i.manager.emit(s,t)}a<Vr&&o(i.options.event+$b(a)),o(i.options.event),t.additionalEvent&&o(t.additionalEvent),a>=Vr&&o(i.options.event+$b(a))},n.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=ir},n.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(ir|Ms)))return!1;t++}return!0},n.recognize=function(t){var i=Ii({},t);if(!fl(this.options.enable,[this,i])){this.reset(),this.state=ir;return}this.state&(_r|Ka|ir)&&(this.state=Ms),this.state=this.process(i),this.state&(Lt|Rn|Vr|Ka)&&this.tryEmit(i)},n.process=function(t){},n.getTouchAction=function(){},n.reset=function(){},r}(),Mc=function(r){Wt(n,r);function n(t){var i;return t===void 0&&(t={}),i=r.call(this,Qt({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},t))||this,i.pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}var e=n.prototype;return e.getTouchAction=function(){return[Rc]},e.process=function(i){var a=this,o=this.options,s=i.pointers.length===o.pointers,u=i.distance<o.threshold,l=i.deltaTime<o.time;if(this.reset(),i.eventType&ut&&this.count===0)return this.failTimeout();if(u&&l&&s){if(i.eventType!==Re)return this.failTimeout();var h=this.pTime?i.timeStamp-this.pTime<o.interval:!0,d=!this.pCenter||hu(this.pCenter,i.center)<o.posThreshold;this.pTime=i.timeStamp,this.pCenter=i.center,!d||!h?this.count=1:this.count+=1,this._input=i;var c=this.count%o.taps;if(c===0)return this.hasRequireFailures()?(this._timer=setTimeout(function(){a.state=_r,a.tryEmit()},o.interval),Lt):_r}return ir},e.failTimeout=function(){var i=this;return this._timer=setTimeout(function(){i.state=ir},this.options.interval),ir},e.reset=function(){clearTimeout(this._timer)},e.emit=function(){this.state===_r&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},n}(Lo),Dn=function(r){Wt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Qt({pointers:1},t))||this}var e=n.prototype;return e.attrTest=function(i){var a=this.options.pointers;return a===0||i.pointers.length===a},e.process=function(i){var a=this.state,o=i.eventType,s=a&(Lt|Rn),u=this.attrTest(i);return s&&(o&bt||!u)?a|Ka:s||u?o&Re?a|Vr:a&Lt?a|Rn:Lt:ir},n}(Lo);function xS(r){return r===An?"down":r===Bo?"up":r===No?"left":r===Fo?"right":""}var lv=function(r){Wt(n,r);function n(t){var i;return t===void 0&&(t={}),i=r.call(this,Qt({event:"pan",threshold:10,pointers:1,direction:wS},t))||this,i.pX=null,i.pY=null,i}var e=n.prototype;return e.getTouchAction=function(){var i=this.options.direction,a=[];return i&sr&&a.push(Ua),i&_i&&a.push(Wa),a},e.directionTest=function(i){var a=this.options,o=!0,s=i.distance,u=i.direction,l=i.deltaX,h=i.deltaY;return u&a.direction||(a.direction&sr?(u=l===0?uu:l<0?No:Fo,o=l!==this.pX,s=Math.abs(i.deltaX)):(u=h===0?uu:h<0?Bo:An,o=h!==this.pY,s=Math.abs(i.deltaY))),i.direction=u,o&&s>a.threshold&&u&a.direction},e.attrTest=function(i){return Dn.prototype.attrTest.call(this,i)&&(this.state&Lt||!(this.state&Lt)&&this.directionTest(i))},e.emit=function(i){this.pX=i.deltaX,this.pY=i.deltaY;var a=xS(i.direction);a&&(i.additionalEvent=this.options.event+a),r.prototype.emit.call(this,i)},n}(Dn),AS=function(r){Wt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Qt({event:"swipe",threshold:10,velocity:.3,direction:sr|_i,pointers:1},t))||this}var e=n.prototype;return e.getTouchAction=function(){return lv.prototype.getTouchAction.call(this)},e.attrTest=function(i){var a=this.options.direction,o;return a&(sr|_i)?o=i.overallVelocity:a&sr?o=i.overallVelocityX:a&_i&&(o=i.overallVelocityY),r.prototype.attrTest.call(this,i)&&a&i.offsetDirection&&i.distance>this.options.threshold&&i.maxPointers===this.options.pointers&&ki(o)>this.options.velocity&&i.eventType&Re},e.emit=function(i){var a=xS(i.offsetDirection);a&&this.manager.emit(this.options.event+a,i),this.manager.emit(this.options.event,i)},n}(Dn),RS=function(r){Wt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Qt({event:"pinch",threshold:0,pointers:2},t))||this}var e=n.prototype;return e.getTouchAction=function(){return[wi]},e.attrTest=function(i){return r.prototype.attrTest.call(this,i)&&(Math.abs(i.scale-1)>this.options.threshold||this.state&Lt)},e.emit=function(i){if(i.scale!==1){var a=i.scale<1?"in":"out";i.additionalEvent=this.options.event+a}r.prototype.emit.call(this,i)},n}(Dn),DS=function(r){Wt(n,r);function n(t){return t===void 0&&(t={}),r.call(this,Qt({event:"rotate",threshold:0,pointers:2},t))||this}var e=n.prototype;return e.getTouchAction=function(){return[wi]},e.attrTest=function(i){return r.prototype.attrTest.call(this,i)&&(Math.abs(i.rotation)>this.options.threshold||this.state&Lt)},n}(Dn),MS=function(r){Wt(n,r);function n(t){var i;return t===void 0&&(t={}),i=r.call(this,Qt({event:"press",pointers:1,time:251,threshold:9},t))||this,i._timer=null,i._input=null,i}var e=n.prototype;return e.getTouchAction=function(){return[bS]},e.process=function(i){var a=this,o=this.options,s=i.pointers.length===o.pointers,u=i.distance<o.threshold,l=i.deltaTime>o.time;if(this._input=i,!u||!s||i.eventType&(Re|bt)&&!l)this.reset();else if(i.eventType&ut)this.reset(),this._timer=setTimeout(function(){a.state=_r,a.tryEmit()},o.time);else if(i.eventType&Re)return _r;return ir},e.reset=function(){clearTimeout(this._timer)},e.emit=function(i){this.state===_r&&(i&&i.eventType&Re?this.manager.emit(this.options.event+"up",i):(this._input.timeStamp=iv(),this.manager.emit(this.options.event,this._input)))},n}(Lo),NS={domEvents:!1,touchAction:mS,enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},wb=[[DS,{enable:!1}],[RS,{enable:!1},["rotate"]],[AS,{direction:sr}],[lv,{direction:sr},["swipe"]],[Mc],[Mc,{event:"doubletap",taps:2},["tap"]],[MS]],Pie=1,_b=2;function Eb(r,n){var e=r.element;if(e.style){var t;wr(r.options.cssProps,function(i,a){t=cl(e.style,a),n?(r.oldCssProps[t]=e.style[t],e.style[t]=i):e.style[t]=r.oldCssProps[t]||""}),n||(r.oldCssProps={})}}function Iie(r,n){var e=document.createEvent("Event");e.initEvent(r,!0,!0),e.gesture=n,n.target.dispatchEvent(e)}var Sb=function(){function r(e,t){var i=this;this.options=Ii({},NS,t||{}),this.options.inputTarget=this.options.inputTarget||e,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=e,this.input=Sie(this),this.touchAction=new ES(this,this.options.touchAction),Eb(this,!0),wr(this.options.recognizers,function(a){var o=i.add(new a[0](a[1]));a[2]&&o.recognizeWith(a[2]),a[3]&&o.requireFailure(a[3])},this)}var n=r.prototype;return n.set=function(t){return Ii(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},n.stop=function(t){this.session.stopped=t?_b:Pie},n.recognize=function(t){var i=this.session;if(!i.stopped){this.touchAction.preventDefaults(t);var a,o=this.recognizers,s=i.curRecognizer;(!s||s&&s.state&_r)&&(i.curRecognizer=null,s=null);for(var u=0;u<o.length;)a=o[u],i.stopped!==_b&&(!s||a===s||a.canRecognizeWith(s))?a.recognize(t):a.reset(),!s&&a.state&(Lt|Rn|Vr)&&(i.curRecognizer=a,s=a),u++}},n.get=function(t){if(t instanceof Lo)return t;for(var i=this.recognizers,a=0;a<i.length;a++)if(i[a].options.event===t)return i[a];return null},n.add=function(t){if(gn(t,"add",this))return this;var i=this.get(t.options.event);return i&&this.remove(i),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},n.remove=function(t){if(gn(t,"remove",this))return this;var i=this.get(t);if(t){var a=this.recognizers,o=Ci(a,i);o!==-1&&(a.splice(o,1),this.touchAction.update())}return this},n.on=function(t,i){if(t===void 0||i===void 0)return this;var a=this.handlers;return wr(Va(t),function(o){a[o]=a[o]||[],a[o].push(i)}),this},n.off=function(t,i){if(t===void 0)return this;var a=this.handlers;return wr(Va(t),function(o){i?a[o]&&a[o].splice(Ci(a[o],i),1):delete a[o]}),this},n.emit=function(t,i){this.options.domEvents&&Iie(t,i);var a=this.handlers[t]&&this.handlers[t].slice();if(!(!a||!a.length)){i.type=t,i.preventDefault=function(){i.srcEvent.preventDefault()};for(var o=0;o<a.length;)a[o](i),o++}},n.destroy=function(){this.element&&Eb(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},r}(),kie={touchstart:ut,touchmove:Vi,touchend:Re,touchcancel:bt},Cie="touchstart",xie="touchstart touchmove touchend touchcancel",Aie=function(r){Wt(n,r);function n(){var t,i=n.prototype;return i.evTarget=Cie,i.evWin=xie,t=r.apply(this,arguments)||this,t.started=!1,t}var e=n.prototype;return e.handler=function(i){var a=kie[i.type];if(a===ut&&(this.started=!0),!!this.started){var o=Rie.call(this,i,a);a&(Re|bt)&&o[0].length-o[1].length===0&&(this.started=!1),this.callback(this.manager,a,{pointers:o[0],changedPointers:o[1],pointerType:Mo,srcEvent:i})}},n}(sa);function Rie(r,n){var e=Ga(r.touches),t=Ga(r.changedTouches);return n&(Re|bt)&&(e=ov(e.concat(t),"identifier",!0)),[e,t]}function FS(r,n,e){var t="DEPRECATED METHOD: "+n+`
`+e+` AT 
`;return function(){var i=new Error("get-stack-trace"),a=i&&i.stack?i.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,t,a),r.apply(this,arguments)}}var BS=FS(function(r,n,e){for(var t=Object.keys(n),i=0;i<t.length;)(!e||e&&r[t[i]]===void 0)&&(r[t[i]]=n[t[i]]),i++;return r},"extend","Use `assign`."),Die=FS(function(r,n){return BS(r,n,!0)},"merge","Use `assign`.");function Mie(r,n,e){var t=n.prototype,i;i=r.prototype=Object.create(t),i.constructor=r,i._super=t,e&&Ii(i,e)}function Ob(r,n){return function(){return r.apply(n,arguments)}}var LS=function(){var r=function(e,t){return t===void 0&&(t={}),new Sb(e,Qt({recognizers:wb.concat()},t))};return r.VERSION="2.0.17-rc",r.DIRECTION_ALL=wS,r.DIRECTION_DOWN=An,r.DIRECTION_LEFT=No,r.DIRECTION_RIGHT=Fo,r.DIRECTION_UP=Bo,r.DIRECTION_HORIZONTAL=sr,r.DIRECTION_VERTICAL=_i,r.DIRECTION_NONE=uu,r.DIRECTION_DOWN=An,r.INPUT_START=ut,r.INPUT_MOVE=Vi,r.INPUT_END=Re,r.INPUT_CANCEL=bt,r.STATE_POSSIBLE=Ms,r.STATE_BEGAN=Lt,r.STATE_CHANGED=Rn,r.STATE_ENDED=Vr,r.STATE_RECOGNIZED=_r,r.STATE_CANCELLED=Ka,r.STATE_FAILED=ir,r.Manager=Sb,r.Input=sa,r.TouchAction=ES,r.TouchInput=sv,r.MouseInput=uv,r.PointerEventInput=kS,r.TouchMouseInput=CS,r.SingleTouchInput=Aie,r.Recognizer=Lo,r.AttrRecognizer=Dn,r.Tap=Mc,r.Pan=lv,r.Swipe=AS,r.Pinch=RS,r.Rotate=DS,r.Press=MS,r.on=Oa,r.off=Ta,r.each=wr,r.merge=Die,r.extend=BS,r.bindFn=Ob,r.assign=Ii,r.inherit=Mie,r.bindFn=Ob,r.prefixed=cl,r.toArray=Ga,r.inArray=Ci,r.uniqueArray=ov,r.splitStr=Va,r.boolOrFn=fl,r.hasParent=av,r.addEventListeners=Oa,r.removeEventListeners=Ta,r.defaults=Ii({},NS,{preset:wb}),r}();LS.defaults;var Nie=LS;function jS(r,n){var e=typeof ri<"u"&&Wi(r)||r["@@iterator"];if(!e){if(ae(r)||(e=Fie(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function Fie(r,n){var e;if(r){if(typeof r=="string")return Tb(r,n);var t=Ye(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Hi(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return Tb(r,n)}}function Tb(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}ri("DELETE");function vl(){for(var r=arguments.length,n=new Array(r),e=0;e<r;e++)n[e]=arguments[e];return Bie(n.length?n:[su()])}function Bie(r){var n=Lie(r),e=be(n,3),t=e[0],i=e[1],a=e[2],o=1,s=function(){var l=2091639*t+o*23283064365386963e-26;return t=i,i=a,a=l-(o=l|0)};return s.uint32=function(){return s()*4294967296},s.fract53=function(){return s()+(s()*2097152|0)*11102230246251565e-32},s.algorithm="Alea",s.seed=r,s.version="0.9",s}function Lie(){for(var r=jie(),n=r(" "),e=r(" "),t=r(" "),i=0;i<arguments.length;i++)n-=r(i<0||arguments.length<=i?void 0:arguments[i]),n<0&&(n+=1),e-=r(i<0||arguments.length<=i?void 0:arguments[i]),e<0&&(e+=1),t-=r(i<0||arguments.length<=i?void 0:arguments[i]),t<0&&(t+=1);return[n,e,t]}function jie(){var r=4022871197;return function(n){for(var e=n.toString(),t=0;t<e.length;t++){r+=e.charCodeAt(t);var i=.02519603282416938*r;r=i>>>0,i-=r,i*=r,r=i>>>0,i-=r,r+=i*4294967296}return(r>>>0)*23283064365386963e-26}}function zie(){var r=function(){};return{on:r,off:r,destroy:r,emit:r,get:function(){return{set:r}}}}var hv=typeof window<"u"?window.Hammer||Nie:function(){return zie()};function nr(r){var n=this,e;this._cleanupQueue=[],this.active=!1,this._dom={container:r,overlay:document.createElement("div")},this._dom.overlay.classList.add("vis-overlay"),this._dom.container.appendChild(this._dom.overlay),this._cleanupQueue.push(function(){n._dom.overlay.parentNode.removeChild(n._dom.overlay)});var t=hv(this._dom.overlay);t.on("tap",O(e=this._onTapOverlay).call(e,this)),this._cleanupQueue.push(function(){t.destroy()});var i=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];ue(i).call(i,function(a){t.on(a,function(o){o.srcEvent.stopPropagation()})}),document&&document.body&&(this._onClick=function(a){Hie(a.target,r)||n.deactivate()},document.body.addEventListener("click",this._onClick),this._cleanupQueue.push(function(){document.body.removeEventListener("click",n._onClick)})),this._escListener=function(a){("key"in a?a.key==="Escape":a.keyCode===27)&&n.deactivate()}}H_(nr.prototype);nr.current=null;nr.prototype.destroy=function(){var r,n;this.deactivate();var e=jS(bi(r=br(n=this._cleanupQueue).call(n,0)).call(r)),t;try{for(e.s();!(t=e.n()).done;){var i=t.value;i()}}catch(a){e.e(a)}finally{e.f()}};nr.prototype.activate=function(){nr.current&&nr.current.deactivate(),nr.current=this,this.active=!0,this._dom.overlay.style.display="none",this._dom.container.classList.add("vis-active"),this.emit("change"),this.emit("activate"),document.body.addEventListener("keydown",this._escListener)};nr.prototype.deactivate=function(){this.active=!1,this._dom.overlay.style.display="block",this._dom.container.classList.remove("vis-active"),document.body.removeEventListener("keydown",this._escListener),this.emit("change"),this.emit("deactivate")};nr.prototype._onTapOverlay=function(r){this.activate(),r.srcEvent.stopPropagation()};function Hie(r,n){for(;r;){if(r===n)return!0;r=r.parentNode}return!1}var Wie=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Uie=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Vie=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Gie=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function Mr(r){if(r)for(;r.hasChildNodes()===!0;){var n=r.firstChild;n&&(Mr(n),r.removeChild(n))}}function bn(r){return r instanceof String||typeof r=="string"}function Pb(r){return se(r)==="object"&&r!==null}function xi(r,n,e,t){var i=!1;t===!0&&(i=n[e]===null&&r[e]!==void 0),i?delete r[e]:r[e]=n[e]}function zS(r,n){var e=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1;for(var t in r)if(n[t]!==void 0)if(n[t]===null||se(n[t])!=="object")xi(r,n,t,e);else{var i=r[t],a=n[t];Pb(i)&&Pb(a)&&zS(i,a,e)}}function ua(r,n,e){var t=arguments.length>3&&arguments[3]!==void 0?arguments[3]:!1;if(ae(e))throw new TypeError("Arrays are not supported by deepExtend");for(var i=0;i<r.length;i++){var a=r[i];if(Object.prototype.hasOwnProperty.call(e,a))if(e[a]&&e[a].constructor===Object)n[a]===void 0&&(n[a]={}),n[a].constructor===Object?he(n[a],e[a],!1,t):xi(n,e,a,t);else{if(ae(e[a]))throw new TypeError("Arrays are not supported by deepExtend");xi(n,e,a,t)}}return n}function du(r,n,e){var t=arguments.length>3&&arguments[3]!==void 0?arguments[3]:!1;if(ae(e))throw new TypeError("Arrays are not supported by deepExtend");for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)&&!Ur(r).call(r,i))if(e[i]&&e[i].constructor===Object)n[i]===void 0&&(n[i]={}),n[i].constructor===Object?he(n[i],e[i]):xi(n,e,i,t);else if(ae(e[i])){n[i]=[];for(var a=0;a<e[i].length;a++)n[i].push(e[i][a])}else xi(n,e,i,t);return n}function he(r,n){var e=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1,t=arguments.length>3&&arguments[3]!==void 0?arguments[3]:!1;for(var i in n)if(Object.prototype.hasOwnProperty.call(n,i)||e===!0)if(se(n[i])==="object"&&n[i]!==null&&ob(n[i])===Object.prototype)r[i]===void 0?r[i]=he({},n[i],e):se(r[i])==="object"&&r[i]!==null&&ob(r[i])===Object.prototype?he(r[i],n[i],e):xi(r,n,i,t);else if(ae(n[i])){var a;r[i]=Ye(a=n[i]).call(a)}else xi(r,n,i,t);return r}function cu(r,n){var e;return tv(e=[]).call(e,tr(r),[n])}function Kie(r){return Ye(r).call(r)}function qie(r){return r.getBoundingClientRect().left}function Yie(r){return r.getBoundingClientRect().top}function J(r,n){if(ae(r))for(var e=r.length,t=0;t<e;t++)n(r[t],t,r);else for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&n(r[i],i,r)}function dv(r){var n;switch(r.length){case 3:case 4:return n=Uie.exec(r),n?{r:Kt(n[1]+n[1],16),g:Kt(n[2]+n[2],16),b:Kt(n[3]+n[3],16)}:null;case 6:case 7:return n=Wie.exec(r),n?{r:Kt(n[1],16),g:Kt(n[2],16),b:Kt(n[3],16)}:null;default:return null}}function Ft(r,n){if(Ur(r).call(r,"rgba"))return r;if(Ur(r).call(r,"rgb")){var e=r.substr(Z(r).call(r,"(")+1).replace(")","").split(",");return"rgba("+e[0]+","+e[1]+","+e[2]+","+n+")"}else{var t=dv(r);return t==null?r:"rgba("+t.r+","+t.g+","+t.b+","+n+")"}}function HS(r,n,e){var t;return"#"+Ye(t=((1<<24)+(r<<16)+(n<<8)+e).toString(16)).call(t,1)}function Nc(r,n){if(bn(r)){var e=r;if(US(e)){var t,i=xn(t=e.substr(4).substr(0,e.length-5).split(",")).call(t,function(d){return Kt(d)});e=HS(i[0],i[1],i[2])}if(WS(e)===!0){var a=Xie(e),o={h:a.h,s:a.s*.8,v:Math.min(1,a.v*1.02)},s={h:a.h,s:Math.min(1,a.s*1.25),v:a.v*.8},u=Fc(s.h,s.s,s.v),l=Fc(o.h,o.s,o.v);return{background:e,border:u,highlight:{background:l,border:u},hover:{background:l,border:u}}}else return{background:e,border:e,highlight:{background:e,border:e},hover:{background:e,border:e}}}else{var h={background:r.background||void 0,border:r.border||void 0,highlight:bn(r.highlight)?{border:r.highlight,background:r.highlight}:{background:r.highlight&&r.highlight.background||void 0,border:r.highlight&&r.highlight.border||void 0},hover:bn(r.hover)?{border:r.hover,background:r.hover}:{border:r.hover&&r.hover.border||void 0,background:r.hover&&r.hover.background||void 0}};return h}}function ma(r,n,e){r=r/255,n=n/255,e=e/255;var t=Math.min(r,Math.min(n,e)),i=Math.max(r,Math.max(n,e));if(t===i)return{h:0,s:0,v:t};var a=r===t?n-e:e===t?r-n:e-r,o=r===t?3:e===t?1:5,s=60*(o-a/(i-t))/360,u=(i-t)/i,l=i;return{h:s,s:u,v:l}}function Ns(r,n,e){var t,i,a,o=Math.floor(r*6),s=r*6-o,u=e*(1-n),l=e*(1-s*n),h=e*(1-(1-s)*n);switch(o%6){case 0:t=e,i=h,a=u;break;case 1:t=l,i=e,a=u;break;case 2:t=u,i=e,a=h;break;case 3:t=u,i=l,a=e;break;case 4:t=h,i=u,a=e;break;case 5:t=e,i=u,a=l;break}return{r:Math.floor(t*255),g:Math.floor(i*255),b:Math.floor(a*255)}}function Fc(r,n,e){var t=Ns(r,n,e);return HS(t.r,t.g,t.b)}function Xie(r){var n=dv(r);if(!n)throw new TypeError("'".concat(r,"' is not a valid color."));return ma(n.r,n.g,n.b)}function WS(r){var n=/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(r);return n}function US(r){return Vie.test(r)}function Qie(r){return Gie.test(r)}function Gr(r){if(r===null||se(r)!=="object")return null;if(r instanceof Element)return r;var n=$i(r);for(var e in r)Object.prototype.hasOwnProperty.call(r,e)&&se(r[e])=="object"&&(n[e]=Gr(r[e]));return n}function Nt(r,n,e){var t=arguments.length>3&&arguments[3]!==void 0?arguments[3]:{},i=function(v){return v!=null},a=function(v){return v!==null&&se(v)==="object"},o=function(v){for(var p in v)if(Object.prototype.hasOwnProperty.call(v,p))return!1;return!0};if(!a(r))throw new Error("Parameter mergeTarget must be an object");if(!a(n))throw new Error("Parameter options must be an object");if(!i(e))throw new Error("Parameter option must have a value");if(!a(t))throw new Error("Parameter globalOptions must be an object");var s=function(v,p,y){a(v[y])||(v[y]={});var g=p[y],m=v[y];for(var w in g)Object.prototype.hasOwnProperty.call(g,w)&&(m[w]=g[w])},u=n[e],l=a(t)&&!o(t),h=l?t[e]:void 0,d=h?h.enabled:void 0;if(u!==void 0){if(typeof u=="boolean"){a(r[e])||(r[e]={}),r[e].enabled=u;return}if(u===null&&!a(r[e]))if(i(h))r[e]=$i(h);else return;if(a(u)){var c=!0;u.enabled!==void 0?c=u.enabled:d!==void 0&&(c=h.enabled),s(r,n,e),r[e].enabled=c}}}var Jie={linear:function(n){return n},easeInQuad:function(n){return n*n},easeOutQuad:function(n){return n*(2-n)},easeInOutQuad:function(n){return n<.5?2*n*n:-1+(4-2*n)*n},easeInCubic:function(n){return n*n*n},easeOutCubic:function(n){return--n*n*n+1},easeInOutCubic:function(n){return n<.5?4*n*n*n:(n-1)*(2*n-2)*(2*n-2)+1},easeInQuart:function(n){return n*n*n*n},easeOutQuart:function(n){return 1- --n*n*n*n},easeInOutQuart:function(n){return n<.5?8*n*n*n*n:1-8*--n*n*n*n},easeInQuint:function(n){return n*n*n*n*n},easeOutQuint:function(n){return 1+--n*n*n*n*n},easeInOutQuint:function(n){return n<.5?16*n*n*n*n*n:1+16*--n*n*n*n*n}};function Nr(r,n){var e;ae(n)||(n=[n]);var t=jS(r),i;try{for(t.s();!(i=t.n()).done;){var a=i.value;if(a){e=a[n[0]];for(var o=1;o<n.length;o++)e&&(e=e[n[o]]);if(typeof e<"u")break}}}catch(s){t.e(s)}finally{t.f()}return e}var Zie={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},ene=function(){function r(){var n=arguments.length>0&&arguments[0]!==void 0?arguments[0]:1;C(this,r),this.pixelRatio=n,this.generated=!1,this.centerCoordinates={x:289/2,y:289/2},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return x(r,[{key:"insertTo",value:function(e){this.hammer!==void 0&&(this.hammer.destroy(),this.hammer=void 0),this.container=e,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(e){if(typeof e=="function")this.updateCallback=e;else throw new Error("Function attempted to set as colorPicker update callback is not a function.")}},{key:"setCloseCallback",value:function(e){if(typeof e=="function")this.closeCallback=e;else throw new Error("Function attempted to set as colorPicker closing callback is not a function.")}},{key:"_isColorString",value:function(e){if(typeof e=="string")return Zie[e]}},{key:"setColor",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;if(e!=="none"){var i,a=this._isColorString(e);if(a!==void 0&&(e=a),bn(e)===!0){if(US(e)===!0){var o=e.substr(4).substr(0,e.length-5).split(",");i={r:o[0],g:o[1],b:o[2],a:1}}else if(Qie(e)===!0){var s=e.substr(5).substr(0,e.length-6).split(",");i={r:s[0],g:s[1],b:s[2],a:s[3]}}else if(WS(e)===!0){var u=dv(e);i={r:u.r,g:u.g,b:u.b,a:1}}}else if(e instanceof Object&&e.r!==void 0&&e.g!==void 0&&e.b!==void 0){var l=e.a!==void 0?e.a:"1.0";i={r:e.r,g:e.g,b:e.b,a:l}}if(i===void 0)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Ro(e));this._setColor(i,t)}}},{key:"show",value:function(){this.closeCallback!==void 0&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var e=this,t=arguments.length>0&&arguments[0]!==void 0?arguments[0]:!0;t===!0&&(this.previousColor=Ae({},this.color)),this.applied===!0&&this.updateCallback(this.initialColor),this.frame.style.display="none",or(function(){e.closeCallback!==void 0&&(e.closeCallback(),e.closeCallback=void 0)},0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){this.previousColor!==void 0?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;t===!0&&(this.initialColor=Ae({},e)),this.color=e;var i=ma(e.r,e.g,e.b),a=2*Math.PI,o=this.r*i.s,s=this.centerCoordinates.x+o*Math.sin(a*i.h),u=this.centerCoordinates.y+o*Math.cos(a*i.h);this.colorPickerSelector.style.left=s-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=u-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(e)}},{key:"_setOpacity",value:function(e){this.color.a=e/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(e){var t=ma(this.color.r,this.color.g,this.color.b);t.v=e/100;var i=Ns(t.h,t.s,t.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:this.color,t=ma(e.r,e.g,e.b),i=this.colorPickerCanvas.getContext("2d");this.pixelRation===void 0&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var a=this.colorPickerCanvas.clientWidth,o=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,a,o),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-t.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),Do(i).call(i),this.brightnessRange.value=100*t.v,this.opacityRange.value=100*e.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var e,t,i,a;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var s=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(s.webkitBackingStorePixelRatio||s.mozBackingStorePixelRatio||s.msBackingStorePixelRatio||s.oBackingStorePixelRatio||s.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var o=document.createElement("DIV");o.style.color="red",o.style.fontWeight="bold",o.style.padding="10px",o.innerText="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(o)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch{}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch{}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var u=this;this.opacityRange.onchange=function(){u._setOpacity(this.value)},this.opacityRange.oninput=function(){u._setOpacity(this.value)},this.brightnessRange.onchange=function(){u._setBrightness(this.value)},this.brightnessRange.oninput=function(){u._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerText="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerText="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerText="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerText="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerText="cancel",this.cancelButton.onclick=O(e=this._hide).call(e,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerText="apply",this.applyButton.onclick=O(t=this._apply).call(t,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerText="save",this.saveButton.onclick=O(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerText="load last",this.loadButton.onclick=O(a=this._loadLast).call(a,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var e=this;this.drag={},this.pinch={},this.hammer=new hv(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.on("hammer.input",function(t){t.isFirst&&e._moveSelector(t)}),this.hammer.on("tap",function(t){e._moveSelector(t)}),this.hammer.on("panstart",function(t){e._moveSelector(t)}),this.hammer.on("panmove",function(t){e._moveSelector(t)}),this.hammer.on("panend",function(t){e._moveSelector(t)})}},{key:"_generateHueCircle",value:function(){if(this.generated===!1){var e=this.colorPickerCanvas.getContext("2d");this.pixelRation===void 0&&(this.pixelRatio=(window.devicePixelRatio||1)/(e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1)),e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var t=this.colorPickerCanvas.clientWidth,i=this.colorPickerCanvas.clientHeight;e.clearRect(0,0,t,i);var a,o,s,u;this.centerCoordinates={x:t*.5,y:i*.5},this.r=.49*t;var l=2*Math.PI/360,h=1/360,d=1/this.r,c;for(s=0;s<360;s++)for(u=0;u<this.r;u++)a=this.centerCoordinates.x+u*Math.sin(l*s),o=this.centerCoordinates.y+u*Math.cos(l*s),c=Ns(s*h,u*d,1),e.fillStyle="rgb("+c.r+","+c.g+","+c.b+")",e.fillRect(a-.5,o-.5,2,2);e.strokeStyle="rgba(0,0,0,1)",e.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),e.stroke(),this.hueCircle=e.getImageData(0,0,t,i)}this.generated=!0}},{key:"_moveSelector",value:function(e){var t=this.colorPickerDiv.getBoundingClientRect(),i=e.center.x-t.left,a=e.center.y-t.top,o=.5*this.colorPickerDiv.clientHeight,s=.5*this.colorPickerDiv.clientWidth,u=i-s,l=a-o,h=Math.atan2(u,l),d=.98*Math.min(Math.sqrt(u*u+l*l),s),c=Math.cos(h)*d+o,f=Math.sin(h)*d+s;this.colorPickerSelector.style.top=c-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=f-.5*this.colorPickerSelector.clientWidth+"px";var v=h/(2*Math.PI);v=v<0?v+1:v;var p=d/this.r,y=ma(this.color.r,this.color.g,this.color.b);y.h=v,y.s=p;var g=Ns(y.h,y.s,y.v);g.a=this.color.a,this.color=g,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),r}();function Bc(){for(var r=arguments.length,n=new Array(r),e=0;e<r;e++)n[e]=arguments[e];if(n.length<1)throw new TypeError("Invalid arguments.");if(n.length===1)return document.createTextNode(n[0]);var t=document.createElement(n[0]);return t.appendChild(Bc.apply(void 0,tr(Ye(n).call(n,1)))),t}var tne=function(){function r(n,e,t){var i=arguments.length>3&&arguments[3]!==void 0?arguments[3]:1,a=arguments.length>4&&arguments[4]!==void 0?arguments[4]:function(){return!1};C(this,r),this.parent=n,this.changedOptions=[],this.container=e,this.allowCreation=!1,this.hideOption=a,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},Ae(this.options,this.defaultOptions),this.configureOptions=t,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new ene(i),this.wrapper=void 0}return x(r,[{key:"setOptions",value:function(e){if(e!==void 0){this.popupHistory={},this._removePopup();var t=!0;if(typeof e=="string")this.options.filter=e;else if(ae(e))this.options.filter=e.join();else if(se(e)==="object"){if(e==null)throw new TypeError("options cannot be null");e.container!==void 0&&(this.options.container=e.container),gt(e)!==void 0&&(this.options.filter=gt(e)),e.showButton!==void 0&&(this.options.showButton=e.showButton),e.enabled!==void 0&&(t=e.enabled)}else typeof e=="boolean"?(this.options.filter=!0,t=e):typeof e=="function"&&(this.options.filter=e,t=!0);gt(this.options)===!1&&(t=!1),this.options.enabled=t}this._clean()}},{key:"setModuleOptions",value:function(e){this.moduleOptions=e,this.options.enabled===!0&&(this._clean(),this.options.container!==void 0&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var e=gt(this.options),t=0,i=!1;for(var a in this.configureOptions)Object.prototype.hasOwnProperty.call(this.configureOptions,a)&&(this.allowCreation=!1,i=!1,typeof e=="function"?(i=e(a,[]),i=i||this._handleObject(this.configureOptions[a],[a],!0)):(e===!0||Z(e).call(e,a)!==-1)&&(i=!0),i!==!1&&(this.allowCreation=!0,t>0&&this._makeItem([]),this._makeHeader(a),this._handleObject(this.configureOptions[a],[a])),t++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var e=0;e<this.domElements.length;e++)this.wrapper.appendChild(this.domElements[e]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var e=0;e<this.domElements.length;e++)this.wrapper.removeChild(this.domElements[e]);this.wrapper!==void 0&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(e){for(var t=this.moduleOptions,i=0;i<e.length;i++)if(t[e[i]]!==void 0)t=t[e[i]];else{t=void 0;break}return t}},{key:"_makeItem",value:function(e){if(this.allowCreation===!0){var t=document.createElement("div");t.className="vis-configuration vis-config-item vis-config-s"+e.length;for(var i=arguments.length,a=new Array(i>1?i-1:0),o=1;o<i;o++)a[o-1]=arguments[o];return ue(a).call(a,function(s){t.appendChild(s)}),this.domElements.push(t),this.domElements.length}return 0}},{key:"_makeHeader",value:function(e){var t=document.createElement("div");t.className="vis-configuration vis-config-header",t.innerText=e,this._makeItem([],t)}},{key:"_makeLabel",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1,a=document.createElement("div");if(a.className="vis-configuration vis-config-label vis-config-s"+t.length,i===!0){for(;a.firstChild;)a.removeChild(a.firstChild);a.appendChild(Bc("i","b",e))}else a.innerText=e+":";return a}},{key:"_makeDropdown",value:function(e,t,i){var a=document.createElement("select");a.className="vis-configuration vis-config-select";var o=0;t!==void 0&&Z(e).call(e,t)!==-1&&(o=Z(e).call(e,t));for(var s=0;s<e.length;s++){var u=document.createElement("option");u.value=e[s],s===o&&(u.selected="selected"),u.innerText=e[s],a.appendChild(u)}var l=this;a.onchange=function(){l._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,a)}},{key:"_makeRange",value:function(e,t,i){var a=e[0],o=e[1],s=e[2],u=e[3],l=document.createElement("input");l.className="vis-configuration vis-config-range";try{l.type="range",l.min=o,l.max=s}catch{}l.step=u;var h="",d=0;if(t!==void 0){var c=1.2;t<0&&t*c<o?(l.min=Math.ceil(t*c),d=l.min,h="range increased"):t/c<o&&(l.min=Math.ceil(t/c),d=l.min,h="range increased"),t*c>s&&s!==1&&(l.max=Math.ceil(t*c),d=l.max,h="range increased"),l.value=t}else l.value=a;var f=document.createElement("input");f.className="vis-configuration vis-config-rangeinput",f.value=l.value;var v=this;l.onchange=function(){f.value=this.value,v._update(Number(this.value),i)},l.oninput=function(){f.value=this.value};var p=this._makeLabel(i[i.length-1],i),y=this._makeItem(i,p,l,f);h!==""&&this.popupHistory[y]!==d&&(this.popupHistory[y]=d,this._setupPopup(h,y))}},{key:"_makeButton",value:function(){var e=this;if(this.options.showButton===!0){var t=document.createElement("div");t.className="vis-configuration vis-config-button",t.innerText="generate options",t.onclick=function(){e._printOptions()},t.onmouseover=function(){t.className="vis-configuration vis-config-button hover"},t.onmouseout=function(){t.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(t)}}},{key:"_setupPopup",value:function(e,t){var i=this;if(this.initialized===!0&&this.allowCreation===!0&&this.popupCounter<this.popupLimit){var a=document.createElement("div");a.id="vis-configuration-popup",a.className="vis-configuration-popup",a.innerText=e,a.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:a,index:t}}}},{key:"_removePopup",value:function(){this.popupDiv.html!==void 0&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var e=this;if(this.popupDiv.html!==void 0){var t=this.domElements[this.popupDiv.index],i=t.getBoundingClientRect();this.popupDiv.html.style.left=i.left+"px",this.popupDiv.html.style.top=i.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=or(function(){e.popupDiv.html.style.opacity=0},1500),this.popupDiv.deleteTimeout=or(function(){e._removePopup()},1800)}}},{key:"_makeCheckbox",value:function(e,t,i){var a=document.createElement("input");a.type="checkbox",a.className="vis-configuration vis-config-checkbox",a.checked=e,t!==void 0&&(a.checked=t,t!==e&&(se(e)==="object"?t!==e.enabled&&this.changedOptions.push({path:i,value:t}):this.changedOptions.push({path:i,value:t})));var o=this;a.onchange=function(){o._update(this.checked,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,a)}},{key:"_makeTextInput",value:function(e,t,i){var a=document.createElement("input");a.type="text",a.className="vis-configuration vis-config-text",a.value=t,t!==e&&this.changedOptions.push({path:i,value:t});var o=this;a.onchange=function(){o._update(this.value,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,a)}},{key:"_makeColorField",value:function(e,t,i){var a=this,o=e[1],s=document.createElement("div");t=t===void 0?o:t,t!=="none"?(s.className="vis-configuration vis-config-colorBlock",s.style.backgroundColor=t):s.className="vis-configuration vis-config-colorBlock none",t=t===void 0?o:t,s.onclick=function(){a._showColorPicker(t,s,i)};var u=this._makeLabel(i[i.length-1],i);this._makeItem(i,u,s)}},{key:"_showColorPicker",value:function(e,t,i){var a=this;t.onclick=function(){},this.colorPicker.insertTo(t),this.colorPicker.show(),this.colorPicker.setColor(e),this.colorPicker.setUpdateCallback(function(o){var s="rgba("+o.r+","+o.g+","+o.b+","+o.a+")";t.style.backgroundColor=s,a._update(s,i)}),this.colorPicker.setCloseCallback(function(){t.onclick=function(){a._showColorPicker(e,t,i)}})}},{key:"_handleObject",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:[],i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1,a=!1,o=gt(this.options),s=!1;for(var u in e)if(Object.prototype.hasOwnProperty.call(e,u)){a=!0;var l=e[u],h=cu(t,u);if(typeof o=="function"&&(a=o(u,t),a===!1&&!ae(l)&&typeof l!="string"&&typeof l!="boolean"&&l instanceof Object&&(this.allowCreation=!1,a=this._handleObject(l,h,!0),this.allowCreation=i===!1)),a!==!1){s=!0;var d=this._getValue(h);if(ae(l))this._handleArray(l,d,h);else if(typeof l=="string")this._makeTextInput(l,d,h);else if(typeof l=="boolean")this._makeCheckbox(l,d,h);else if(l instanceof Object){if(!this.hideOption(t,u,this.moduleOptions))if(l.enabled!==void 0){var c=cu(h,"enabled"),f=this._getValue(c);if(f===!0){var v=this._makeLabel(u,h,!0);this._makeItem(h,v),s=this._handleObject(l,h)||s}else this._makeCheckbox(l,f,h)}else{var p=this._makeLabel(u,h,!0);this._makeItem(h,p),s=this._handleObject(l,h)||s}}else console.error("dont know how to handle",l,u,h)}}return s}},{key:"_handleArray",value:function(e,t,i){typeof e[0]=="string"&&e[0]==="color"?(this._makeColorField(e,t,i),e[1]!==t&&this.changedOptions.push({path:i,value:t})):typeof e[0]=="string"?(this._makeDropdown(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:t})):typeof e[0]=="number"&&(this._makeRange(e,t,i),e[0]!==t&&this.changedOptions.push({path:i,value:Number(t)}))}},{key:"_update",value:function(e,t){var i=this._constructOptions(e,t);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:{},a=i;e=e==="true"?!0:e,e=e==="false"?!1:e;for(var o=0;o<t.length;o++)t[o]!=="global"&&(a[t[o]]===void 0&&(a[t[o]]={}),o!==t.length-1?a=a[t[o]]:a[t[o]]=e);return i}},{key:"_printOptions",value:function(){for(var e=this.getOptions();this.optionsContainer.firstChild;)this.optionsContainer.removeChild(this.optionsContainer.firstChild);this.optionsContainer.appendChild(Bc("pre","const options = "+Ro(e,null,2)))}},{key:"getOptions",value:function(){for(var e={},t=0;t<this.changedOptions.length;t++)this._constructOptions(this.changedOptions[t].value,this.changedOptions[t].path,e);return e}}]),r}(),rne=function(){function r(n,e){C(this,r),this.container=n,this.overflowMethod=e||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return x(r,[{key:"setPosition",value:function(e,t){this.x=Kt(e),this.y=Kt(t)}},{key:"setText",value:function(e){if(e instanceof Element){for(;this.frame.firstChild;)this.frame.removeChild(this.frame.firstChild);this.frame.appendChild(e)}else this.frame.innerText=e}},{key:"show",value:function(e){if(e===void 0&&(e=!0),e===!0){var t=this.frame.clientHeight,i=this.frame.clientWidth,a=this.frame.parentNode.clientHeight,o=this.frame.parentNode.clientWidth,s=0,u=0;if(this.overflowMethod=="flip"){var l=!1,h=!0;this.y-t<this.padding&&(h=!1),this.x+i>o-this.padding&&(l=!0),l?s=this.x-i:s=this.x,h?u=this.y-t:u=this.y}else u=this.y-t,u+t+this.padding>a&&(u=a-t-this.padding),u<this.padding&&(u=this.padding),s=this.x,s+i+this.padding>o&&(s=o-i-this.padding),s<this.padding&&(s=this.padding);this.frame.style.left=s+"px",this.frame.style.top=u+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),r}(),ca=!1,Ib,Lc="background: #FFeeee; color: #dd0000",ine=function(){function r(){C(this,r)}return x(r,null,[{key:"validate",value:function(e,t,i){ca=!1,Ib=t;var a=t;return i!==void 0&&(a=t[i]),r.parse(e,a,[]),ca}},{key:"parse",value:function(e,t,i){for(var a in e)Object.prototype.hasOwnProperty.call(e,a)&&r.check(a,e,t,i)}},{key:"check",value:function(e,t,i,a){if(i[e]===void 0&&i.__any__===void 0){r.getSuggestion(e,i,a);return}var o=e,s=!0;i[e]===void 0&&i.__any__!==void 0&&(o="__any__",s=r.getType(t[e])==="object");var u=i[o];s&&u.__type__!==void 0&&(u=u.__type__),r.checkFields(e,t,i,o,u,a)}},{key:"checkFields",value:function(e,t,i,a,o,s){var u=function(c){console.error("%c"+c+r.printLocation(s,e),Lc)},l=r.getType(t[e]),h=o[l];h!==void 0?r.getType(h)==="array"&&Z(h).call(h,t[e])===-1?(u('Invalid option detected in "'+e+'". Allowed values are:'+r.print(h)+' not "'+t[e]+'". '),ca=!0):l==="object"&&a!=="__any__"&&(s=cu(s,e),r.parse(t[e],i[a],s)):o.any===void 0&&(u('Invalid type received for "'+e+'". Expected: '+r.print(me(o))+". Received ["+l+'] "'+t[e]+'"'),ca=!0)}},{key:"getType",value:function(e){var t=se(e);return t==="object"?e===null?"null":e instanceof Boolean?"boolean":e instanceof Number?"number":e instanceof String?"string":ae(e)?"array":e instanceof Date?"date":e.nodeType!==void 0?"dom":e._isAMomentObject===!0?"moment":"object":t==="number"?"number":t==="boolean"?"boolean":t==="string"?"string":t===void 0?"undefined":t}},{key:"getSuggestion",value:function(e,t,i){var a=r.findInOptions(e,t,i,!1),o=r.findInOptions(e,Ib,[],!0),s=8,u=4,l;a.indexMatch!==void 0?l=" in "+r.printLocation(a.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+a.indexMatch+`"?

`:o.distance<=u&&a.distance>o.distance?l=" in "+r.printLocation(a.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+r.printLocation(o.path,o.closestMatch,""):a.distance<=s?l='. Did you mean "'+a.closestMatch+'"?'+r.printLocation(a.path,e):l=". Did you mean one of these: "+r.print(me(t))+r.printLocation(i,e),console.error('%cUnknown option detected: "'+e+'"'+l,Lc),ca=!0}},{key:"findInOptions",value:function(e,t,i){var a=arguments.length>3&&arguments[3]!==void 0?arguments[3]:!1,o=1e9,s="",u=[],l=e.toLowerCase(),h=void 0;for(var d in t){var c=void 0;if(t[d].__type__!==void 0&&a===!0){var f=r.findInOptions(e,t[d],cu(i,d));o>f.distance&&(s=f.closestMatch,u=f.path,o=f.distance,h=f.indexMatch)}else{var v;Z(v=d.toLowerCase()).call(v,l)!==-1&&(h=d),c=r.levenshteinDistance(e,d),o>c&&(s=d,u=Kie(i),o=c)}}return{closestMatch:s,path:u,distance:o,indexMatch:h}}},{key:"printLocation",value:function(e,t){for(var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:`Problem value found at: 
`,a=`

`+i+`options = {
`,o=0;o<e.length;o++){for(var s=0;s<o+1;s++)a+="  ";a+=e[o]+`: {
`}for(var u=0;u<e.length+1;u++)a+="  ";a+=t+`
`;for(var l=0;l<e.length+1;l++){for(var h=0;h<e.length-l;h++)a+="  ";a+=`}
`}return a+`

`}},{key:"print",value:function(e){return Ro(e).replace(/(")|(\[)|(\])|(,"__type__")/g,"").replace(/(,)/g,", ")}},{key:"levenshteinDistance",value:function(e,t){if(e.length===0)return t.length;if(t.length===0)return e.length;var i=[],a;for(a=0;a<=t.length;a++)i[a]=[a];var o;for(o=0;o<=e.length;o++)i[0][o]=o;for(a=1;a<=t.length;a++)for(o=1;o<=e.length;o++)t.charAt(a-1)==e.charAt(o-1)?i[a][o]=i[a-1][o-1]:i[a][o]=Math.min(i[a-1][o-1]+1,Math.min(i[a][o-1]+1,i[a-1][o]+1));return i[t.length][e.length]}}]),r}(),nne=nr,ane=tne,$n=hv,one=rne,VS=Lc,sne=ine;function une(r){return Br=r,cne()}var GS={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},cv=$i(GS);cv.color="color.color";cv.style="dashes";var nt={NULL:0,DELIMITER:1,IDENTIFIER:2,UNKNOWN:3},kb={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},Br="",Mn=0,Q="",U="",ft=nt.NULL;function lne(){Mn=0,Q=Br.charAt(0)}function Ne(){Mn++,Q=Br.charAt(Mn)}function nn(){return Br.charAt(Mn+1)}function Cb(r){var n=r.charCodeAt(0);return n<47?n===35||n===46:n<59?n>47:n<91?n>64:n<96?n===95:n<123?n>96:!1}function qr(r,n){if(r||(r={}),n)for(var e in n)n.hasOwnProperty(e)&&(r[e]=n[e]);return r}function hne(r,n,e){for(var t=n.split("."),i=r;t.length;){var a=t.shift();t.length?(i[a]||(i[a]={}),i=i[a]):i[a]=e}}function KS(r,n){for(var e,t,i=null,a=[r],o=r;o.parent;)a.push(o.parent),o=o.parent;if(o.nodes){for(e=0,t=o.nodes.length;e<t;e++)if(n.id===o.nodes[e].id){i=o.nodes[e];break}}for(i||(i={id:n.id},r.node&&(i.attr=qr(i.attr,r.node))),e=a.length-1;e>=0;e--){var s,u=a[e];u.nodes||(u.nodes=[]),Z(s=u.nodes).call(s,i)===-1&&u.nodes.push(i)}n.attr&&(i.attr=qr(i.attr,n.attr))}function dne(r,n){if(r.edges||(r.edges=[]),r.edges.push(n),r.edge){var e=qr({},r.edge);n.attr=qr(e,n.attr)}}function qS(r,n,e,t,i){var a={from:n,to:e,type:t};return r.edge&&(a.attr=qr({},r.edge)),a.attr=qr(a.attr||{},i),i!=null&&i.hasOwnProperty("arrows")&&i.arrows!=null&&(a.arrows={to:{enabled:!0,type:i.arrows.type}},i.arrows=null),a}function de(){for(ft=nt.NULL,U="";Q===" "||Q==="	"||Q===`
`||Q==="\r";)Ne();do{var r=!1;if(Q==="#"){for(var n=Mn-1;Br.charAt(n)===" "||Br.charAt(n)==="	";)n--;if(Br.charAt(n)===`
`||Br.charAt(n)===""){for(;Q!=""&&Q!=`
`;)Ne();r=!0}}if(Q==="/"&&nn()==="/"){for(;Q!=""&&Q!=`
`;)Ne();r=!0}if(Q==="/"&&nn()==="*"){for(;Q!="";)if(Q==="*"&&nn()==="/"){Ne(),Ne();break}else Ne();r=!0}for(;Q===" "||Q==="	"||Q===`
`||Q==="\r";)Ne()}while(r);if(Q===""){ft=nt.DELIMITER;return}var e=Q+nn();if(kb[e]){ft=nt.DELIMITER,U=e,Ne(),Ne();return}if(kb[Q]){ft=nt.DELIMITER,U=Q,Ne();return}if(Cb(Q)||Q==="-"){for(U+=Q,Ne();Cb(Q);)U+=Q,Ne();U==="false"?U=!1:U==="true"?U=!0:isNaN(Number(U))||(U=Number(U)),ft=nt.IDENTIFIER;return}if(Q==='"'){for(Ne();Q!=""&&(Q!='"'||Q==='"'&&nn()==='"');)Q==='"'?(U+=Q,Ne()):Q==="\\"&&nn()==="n"?(U+=`
`,Ne()):U+=Q,Ne();if(Q!='"')throw at('End of string " expected');Ne(),ft=nt.IDENTIFIER;return}for(ft=nt.UNKNOWN;Q!="";)U+=Q,Ne();throw new SyntaxError('Syntax error in part "'+JS(U,30)+'"')}function cne(){var r={};if(lne(),de(),U==="strict"&&(r.strict=!0,de()),(U==="graph"||U==="digraph")&&(r.type=U,de()),ft===nt.IDENTIFIER&&(r.id=U,de()),U!="{")throw at("Angle bracket { expected");if(de(),YS(r),U!="}")throw at("Angle bracket } expected");if(de(),U!=="")throw at("End of file expected");return de(),delete r.node,delete r.edge,delete r.graph,r}function YS(r){for(;U!==""&&U!="}";)fne(r),U===";"&&de()}function fne(r){var n=XS(r);if(n){QS(r,n);return}var e=vne(r);if(!e){if(ft!=nt.IDENTIFIER)throw at("Identifier expected");var t=U;if(de(),U==="="){if(de(),ft!=nt.IDENTIFIER)throw at("Identifier expected");r[t]=U,de()}else pne(r,t)}}function XS(r){var n=null;if(U==="subgraph"&&(n={},n.type="subgraph",de(),ft===nt.IDENTIFIER&&(n.id=U,de())),U==="{"){if(de(),n||(n={}),n.parent=r,n.node=r.node,n.edge=r.edge,n.graph=r.graph,YS(n),U!="}")throw at("Angle bracket } expected");de(),delete n.node,delete n.edge,delete n.graph,delete n.parent,r.subgraphs||(r.subgraphs=[]),r.subgraphs.push(n)}return n}function vne(r){return U==="node"?(de(),r.node=Pa(),"node"):U==="edge"?(de(),r.edge=Pa(),"edge"):U==="graph"?(de(),r.graph=Pa(),"graph"):null}function pne(r,n){var e={id:n},t=Pa();t&&(e.attr=t),KS(r,e),QS(r,n)}function QS(r,n){for(;U==="->"||U==="--";){var e,t=U;de();var i=XS(r);if(i)e=i;else{if(ft!=nt.IDENTIFIER)throw at("Identifier or subgraph expected");e=U,KS(r,{id:e}),de()}var a=Pa(),o=qS(r,n,e,t,a);dne(r,o),n=e}}function Pa(){for(var r,n=null,e={dashed:!0,solid:!1,dotted:[1,5]},t={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},i=new Array,a=new Array;U==="[";){for(de(),n={};U!==""&&U!="]";){if(ft!=nt.IDENTIFIER)throw at("Attribute name expected");var o=U;if(de(),U!="=")throw at("Equal sign = expected");if(de(),ft!=nt.IDENTIFIER)throw at("Attribute value expected");var s=U;o==="style"&&(s=e[s]);var u;o==="arrowhead"&&(u=t[s],o="arrows",s={to:{enabled:!0,type:u}}),o==="arrowtail"&&(u=t[s],o="arrows",s={from:{enabled:!0,type:u}}),i.push({attr:n,name:o,value:s}),a.push(o),de(),U==","&&de()}if(U!="]")throw at("Bracket ] expected");de()}if(Ur(a).call(a,"dir")){var l={};for(l.arrows={},r=0;r<i.length;r++)if(i[r].name==="arrows")if(i[r].value.to!=null)l.arrows.to=r;else if(i[r].value.from!=null)l.arrows.from=r;else throw at("Invalid value of arrows");else i[r].name==="dir"&&(l.dir=r);var h=i[l.dir].value;if(!Ur(a).call(a,"arrows"))if(h==="both")i.push({attr:i[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=i.length-1,i.push({attr:i[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=i.length-1;else if(h==="forward")i.push({attr:i[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=i.length-1;else if(h==="back")i.push({attr:i[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=i.length-1;else if(h==="none")i.push({attr:i[l.dir].attr,name:"arrows",value:""}),l.arrows.to=i.length-1;else throw at('Invalid dir type "'+h+'"');var d,c;if(h==="both")l.arrows.to&&l.arrows.from?(c=i[l.arrows.to].value.to.type,d=i[l.arrows.from].value.from.type,i[l.arrows.to]={attr:i[l.arrows.to].attr,name:i[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}},br(i).call(i,l.arrows.from,1)):l.arrows.to?(c=i[l.arrows.to].value.to.type,d="arrow",i[l.arrows.to]={attr:i[l.arrows.to].attr,name:i[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="arrow",d=i[l.arrows.from].value.from.type,i[l.arrows.from]={attr:i[l.arrows.from].attr,name:i[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}});else if(h==="back")l.arrows.to&&l.arrows.from?(c="",d=i[l.arrows.from].value.from.type,i[l.arrows.from]={attr:i[l.arrows.from].attr,name:i[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.to?(c="",d="arrow",l.arrows.from=l.arrows.to,i[l.arrows.from]={attr:i[l.arrows.from].attr,name:i[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="",d=i[l.arrows.from].value.from.type,i[l.arrows.to]={attr:i[l.arrows.from].attr,name:i[l.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}),i[l.arrows.from]={attr:i[l.arrows.from].attr,name:i[l.arrows.from].name,value:{from:{enabled:!0,type:i[l.arrows.from].value.from.type}}};else if(h==="none"){var f;l.arrows.to?f=l.arrows.to:f=l.arrows.from,i[f]={attr:i[f].attr,name:i[f].name,value:""}}else if(h==="forward")l.arrows.to&&l.arrows.from?(c=i[l.arrows.to].value.to.type,d="",i[l.arrows.to]={attr:i[l.arrows.to].attr,name:i[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.to?(c=i[l.arrows.to].value.to.type,d="",i[l.arrows.to]={attr:i[l.arrows.to].attr,name:i[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}):l.arrows.from&&(c="arrow",d="",l.arrows.to=l.arrows.from,i[l.arrows.to]={attr:i[l.arrows.to].attr,name:i[l.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:d}}}),i[l.arrows.to]={attr:i[l.arrows.to].attr,name:i[l.arrows.to].name,value:{to:{enabled:!0,type:i[l.arrows.to].value.to.type}}};else throw at('Invalid dir type "'+h+'"');br(i).call(i,l.dir,1)}var v;if(Ur(a).call(a,"penwidth")){var p=[];for(v=i.length,r=0;r<v;r++)i[r].name!=="width"&&(i[r].name==="penwidth"&&(i[r].name="width"),p.push(i[r]));i=p}for(v=i.length,r=0;r<v;r++)hne(i[r].attr,i[r].name,i[r].value);return n}function at(r){return new SyntaxError(r+', got "'+JS(U,30)+'" (char '+Mn+")")}function JS(r,n){return r.length<=n?r:r.substr(0,27)+"..."}function yne(r,n,e){ae(r)?ue(r).call(r,function(t){ae(n)?ue(n).call(n,function(i){e(t,i)}):e(t,n)}):ae(n)?ue(n).call(n,function(t){e(r,t)}):e(r,n)}function $d(r,n,e){for(var t=n.split("."),i=t.pop(),a=r,o=0;o<t.length;o++){var s=t[o];s in a||(a[s]={}),a=a[s]}return a[i]=e,r}function xb(r,n){var e={};for(var t in r)if(r.hasOwnProperty(t)){var i=n[t];ae(i)?ue(i).call(i,function(a){$d(e,a,r[t])}):typeof i=="string"?$d(e,i,r[t]):$d(e,t,r[t])}return e}function gne(r){var n=une(r),e={nodes:[],edges:[],options:{}};if(n.nodes){var t;ue(t=n.nodes).call(t,function(o){var s={id:o.id,label:String(o.label||o.id)};qr(s,xb(o.attr,GS)),s.image&&(s.shape="image"),e.nodes.push(s)})}if(n.edges){var i,a=function(s){var u={from:s.from,to:s.to};return qr(u,xb(s.attr,cv)),u.arrows==null&&s.type==="->"&&(u.arrows="to"),u};ue(i=n.edges).call(i,function(o){var s,u;if(o.from instanceof Object?s=o.from.nodes:s={id:o.from},o.to instanceof Object?u=o.to.nodes:u={id:o.to},o.from instanceof Object&&o.from.edges){var l;ue(l=o.from.edges).call(l,function(d){var c=a(d);e.edges.push(c)})}if(yne(s,u,function(d,c){var f=qS(e,d.id,c.id,o.type,o.attr),v=a(f);e.edges.push(v)}),o.to instanceof Object&&o.to.edges){var h;ue(h=o.to.edges).call(h,function(d){var c=a(d);e.edges.push(c)})}})}return n.attr&&(e.options=n.attr),e}function mne(r,n){var e,t={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};n!=null&&(n.fixed!=null&&(t.nodes.fixed=n.fixed),n.parseColor!=null&&(t.nodes.parseColor=n.parseColor),n.inheritColor!=null&&(t.edges.inheritColor=n.inheritColor));var i=r.edges,a=xn(i).call(i,function(s){var u={from:s.source,id:s.id,to:s.target};return s.attributes!=null&&(u.attributes=s.attributes),s.label!=null&&(u.label=s.label),s.attributes!=null&&s.attributes.title!=null&&(u.title=s.attributes.title),s.type==="Directed"&&(u.arrows="to"),s.color&&t.edges.inheritColor===!1&&(u.color=s.color),u}),o=xn(e=r.nodes).call(e,function(s){var u={id:s.id,fixed:t.nodes.fixed&&s.x!=null&&s.y!=null};return s.attributes!=null&&(u.attributes=s.attributes),s.label!=null&&(u.label=s.label),s.size!=null&&(u.size=s.size),s.attributes!=null&&s.attributes.title!=null&&(u.title=s.attributes.title),s.title!=null&&(u.title=s.title),s.x!=null&&(u.x=s.x),s.y!=null&&(u.y=s.y),s.color!=null&&(t.nodes.parseColor===!0?u.color=s.color:u.color={background:s.color,border:s.color,highlight:{background:s.color,border:s.color},hover:{background:s.color,border:s.color}}),u});return{nodes:o,edges:a}}var bne={addDescription:"Click in an empty space to place a new node.",addEdge:"Add Edge",addNode:"Add Node",back:"Back",close:"Close",createEdgeError:"Cannot link edges to a cluster.",del:"Delete selected",deleteClusterError:"Clusters cannot be deleted.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",edit:"Edit",editClusterError:"Clusters cannot be edited.",editEdge:"Edit Edge",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",editNode:"Edit Node"},$ne={addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",addEdge:"Kante hinzufügen",addNode:"Knoten hinzufügen",back:"Zurück",close:"Schließen",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",del:"Lösche Auswahl",deleteClusterError:"Cluster können nicht gelöscht werden.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",edit:"Editieren",editClusterError:"Cluster können nicht editiert werden.",editEdge:"Kante editieren",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",editNode:"Knoten editieren"},wne={addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",addEdge:"Añadir arista",addNode:"Añadir nodo",back:"Atrás",close:"Cerrar",createEdgeError:"No se puede conectar una arista a un grupo.",del:"Eliminar selección",deleteClusterError:"No es posible eliminar grupos.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",edit:"Editar",editClusterError:"No es posible editar grupos.",editEdge:"Editar arista",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",editNode:"Editar nodo"},_ne={addDescription:"Clicca per aggiungere un nuovo nodo",addEdge:"Aggiungi un vertice",addNode:"Aggiungi un nodo",back:"Indietro",close:"Chiudere",createEdgeError:"Non si possono collegare vertici ad un cluster",del:"Cancella la selezione",deleteClusterError:"I cluster non possono essere cancellati",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",edit:"Modifica",editClusterError:"I clusters non possono essere modificati.",editEdge:"Modifica il vertice",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",editNode:"Modifica il nodo"},Ene={addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",addEdge:"Link toevoegen",addNode:"Node toevoegen",back:"Terug",close:"Sluiten",createEdgeError:"Kan geen link maken naar een cluster.",del:"Selectie verwijderen",deleteClusterError:"Clusters kunnen niet worden verwijderd.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",edit:"Wijzigen",editClusterError:"Clusters kunnen niet worden aangepast.",editEdge:"Link wijzigen",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",editNode:"Node wijzigen"},Sne={addDescription:"Clique em um espaço em branco para adicionar um novo nó",addEdge:"Adicionar aresta",addNode:"Adicionar nó",back:"Voltar",close:"Fechar",createEdgeError:"Não foi possível linkar arestas a um cluster.",del:"Remover selecionado",deleteClusterError:"Clusters não puderam ser removidos.",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",edit:"Editar",editClusterError:"Clusters não puderam ser editados.",editEdge:"Editar aresta",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",editNode:"Editar nó"},One={addDescription:"Кликните в свободное место, чтобы добавить новый узел.",addEdge:"Добавить ребро",addNode:"Добавить узел",back:"Назад",close:"Закрывать",createEdgeError:"Невозможно соединить ребра в кластер.",del:"Удалить выбранное",deleteClusterError:"Кластеры не могут быть удалены",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",edit:"Редактировать",editClusterError:"Кластеры недоступны для редактирования.",editEdge:"Редактировать ребро",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",editNode:"Редактировать узел"},Tne={addDescription:"单击空白处放置新节点。",addEdge:"添加连接线",addNode:"添加节点",back:"返回",close:"關閉",createEdgeError:"无法将连接线连接到群集。",del:"删除选定",deleteClusterError:"无法删除群集。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",edit:"编辑",editClusterError:"无法编辑群集。",editEdge:"编辑连接线",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",editNode:"编辑节点"},Pne={addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",addEdge:"Додати край",addNode:"Додати вузол",back:"Назад",close:"Закрити",createEdgeError:"Не можливо об'єднати краї в групу.",del:"Видалити обране",deleteClusterError:"Групи не можуть бути видалені.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",edit:"Редагувати",editClusterError:"Групи недоступні для редагування.",editEdge:"Редагувати край",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",editNode:"Редагувати вузол"},Ine={addDescription:"Cliquez dans un endroit vide pour placer un nœud.",addEdge:"Ajouter un lien",addNode:"Ajouter un nœud",back:"Retour",close:"Fermer",createEdgeError:"Impossible de créer un lien vers un cluster.",del:"Effacer la sélection",deleteClusterError:"Les clusters ne peuvent pas être effacés.",edgeDescription:"Cliquez sur un nœud et glissez le lien vers un autre nœud pour les connecter.",edit:"Éditer",editClusterError:"Les clusters ne peuvent pas être édités.",editEdge:"Éditer le lien",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un nœud.",editNode:"Éditer le nœud"},kne={addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",addEdge:"Přidat hranu",addNode:"Přidat vrchol",back:"Zpět",close:"Zavřít",createEdgeError:"Nelze připojit hranu ke shluku.",del:"Smazat výběr",deleteClusterError:"Nelze mazat shluky.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",edit:"Upravit",editClusterError:"Nelze upravovat shluky.",editEdge:"Upravit hranu",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",editNode:"Upravit vrchol"},Cne=Object.freeze({__proto__:null,cn:Tne,cs:kne,de:$ne,en:bne,es:wne,fr:Ine,it:_ne,nl:Ene,pt:Sne,ru:One,uk:Pne});function xne(r,n){try{var e=n.split(/[-_ /]/,2),t=be(e,2),i=t[0],a=t[1],o=i!=null?i.toLowerCase():null,s=a!=null?a.toUpperCase():null;if(o&&s){var u=o+"-"+s;if(Object.prototype.hasOwnProperty.call(r,u))return u;var l;console.warn(tv(l="Unknown variant ".concat(s," of language ")).call(l,o,"."))}if(o){var h=o;if(Object.prototype.hasOwnProperty.call(r,h))return h;console.warn("Unknown language ".concat(o))}return console.warn("Unknown locale ".concat(n,", falling back to English.")),"en"}catch(d){return console.error(d),console.warn("Unexpected error while normalizing locale ".concat(n,", falling back to English.")),"en"}}var Ane=function(){function r(){C(this,r),this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}return x(r,[{key:"init",value:function(){if(!this.initialized()){this.src=this.image.src;var e=this.image.width,t=this.image.height;this.width=e,this.height=t;var i=Math.floor(t/2),a=Math.floor(t/4),o=Math.floor(t/8),s=Math.floor(t/16),u=Math.floor(e/2),l=Math.floor(e/4),h=Math.floor(e/8),d=Math.floor(e/16);this.canvas.width=3*l,this.canvas.height=i,this.coordinates=[[0,0,u,i],[u,0,l,a],[u,a,h,o],[5*h,a,d,s]],this._fillMipMap()}}},{key:"initialized",value:function(){return this.coordinates!==void 0}},{key:"_fillMipMap",value:function(){var e=this.canvas.getContext("2d"),t=this.coordinates[0];e.drawImage(this.image,t[0],t[1],t[2],t[3]);for(var i=1;i<this.NUM_ITERATIONS;i++){var a=this.coordinates[i-1],o=this.coordinates[i];e.drawImage(this.canvas,a[0],a[1],a[2],a[3],o[0],o[1],o[2],o[3])}}},{key:"drawImageAtPosition",value:function(e,t,i,a,o,s){if(this.initialized())if(t>2){t*=.5;for(var u=0;t>2&&u<this.NUM_ITERATIONS;)t*=.5,u+=1;u>=this.NUM_ITERATIONS&&(u=this.NUM_ITERATIONS-1);var l=this.coordinates[u];e.drawImage(this.canvas,l[0],l[1],l[2],l[3],i,a,o,s)}else e.drawImage(this.image,i,a,o,s)}}]),r}(),Rne=function(){function r(n){C(this,r),this.images={},this.imageBroken={},this.callback=n}return x(r,[{key:"_tryloadBrokenUrl",value:function(e,t,i){if(!(e===void 0||i===void 0)){if(t===void 0){console.warn("No broken url image defined");return}i.image.onerror=function(){console.error("Could not load brokenImage:",t)},i.image.src=t}}},{key:"_redrawWithImage",value:function(e){this.callback&&this.callback(e)}},{key:"load",value:function(e,t){var i=this,a=this.images[e];if(a)return a;var o=new Ane;return this.images[e]=o,o.image.onload=function(){i._fixImageCoordinates(o.image),o.init(),i._redrawWithImage(o)},o.image.onerror=function(){console.error("Could not load image:",e),i._tryloadBrokenUrl(e,t,o)},o.image.src=e,o}},{key:"_fixImageCoordinates",value:function(e){e.width===0&&(document.body.appendChild(e),e.width=e.offsetWidth,e.height=e.offsetHeight,document.body.removeChild(e))}}]),r}(),ZS={exports:{}},Dne=ee,Mne=Dne(function(){if(typeof ArrayBuffer=="function"){var r=new ArrayBuffer(8);Object.isExtensible(r)&&Object.defineProperty(r,"a",{value:8})}}),Nne=ee,Fne=We,Bne=kr,Ab=Mne,Fs=Object.isExtensible,Lne=Nne(function(){Fs(1)}),jne=Lne||Ab?function(n){return!Fne(n)||Ab&&Bne(n)==="ArrayBuffer"?!1:Fs?Fs(n):!0}:Fs,zne=ee,eO=!zne(function(){return Object.isExtensible(Object.preventExtensions({}))}),Hne=V,Wne=re,Une=Oo,Vne=We,fv=Ue,Gne=Rt.f,Rb=ko,Kne=al,vv=jne,qne=qu,Yne=eO,tO=!1,Tr=qne("meta"),Xne=0,pv=function(r){Gne(r,Tr,{value:{objectID:"O"+Xne++,weakData:{}}})},Qne=function(r,n){if(!Vne(r))return typeof r=="symbol"?r:(typeof r=="string"?"S":"P")+r;if(!fv(r,Tr)){if(!vv(r))return"F";if(!n)return"E";pv(r)}return r[Tr].objectID},Jne=function(r,n){if(!fv(r,Tr)){if(!vv(r))return!0;if(!n)return!1;pv(r)}return r[Tr].weakData},Zne=function(r){return Yne&&tO&&vv(r)&&!fv(r,Tr)&&pv(r),r},eae=function(){tae.enable=function(){},tO=!0;var r=Rb.f,n=Wne([].splice),e={};e[Tr]=1,r(e).length&&(Rb.f=function(t){for(var i=r(t),a=0,o=i.length;a<o;a++)if(i[a]===Tr){n(i,a,1);break}return i},Hne({target:"Object",stat:!0,forced:!0},{getOwnPropertyNames:Kne.f}))},tae=ZS.exports={enable:eae,fastKey:Qne,getWeakData:Jne,onFreeze:Zne};Une[Tr]=!0;var pl=ZS.exports,rae=Eo,iae=At,nae=Dt,aae=Zn,oae=tE,sae=Ht,Db=Ie,uae=oE,lae=il,Mb=eE,hae=TypeError,Bs=function(r,n){this.stopped=r,this.result=n},Nb=Bs.prototype,yv=function(r,n,e){var t=e&&e.that,i=!!(e&&e.AS_ENTRIES),a=!!(e&&e.IS_RECORD),o=!!(e&&e.IS_ITERATOR),s=!!(e&&e.INTERRUPTED),u=rae(n,t),l,h,d,c,f,v,p,y=function(m){return l&&Mb(l,"normal",m),new Bs(!0,m)},g=function(m){return i?(nae(m),s?u(m[0],m[1],y):u(m[0],m[1])):s?u(m,y):u(m)};if(a)l=r.iterator;else if(o)l=r;else{if(h=lae(r),!h)throw new hae(aae(r)+" is not iterable");if(oae(h)){for(d=0,c=sae(r);c>d;d++)if(f=g(r[d]),f&&Db(Nb,f))return f;return new Bs(!1)}l=uae(r,h)}for(v=a?r.next:l.next;!(p=iae(v,l)).done;){try{f=g(p.value)}catch(m){Mb(l,"throw",m)}if(typeof f=="object"&&f&&Db(Nb,f))return f}return new Bs(!1)},dae=Ie,cae=TypeError,gv=function(r,n){if(dae(n,r))return r;throw new cae("Incorrect invocation")},fae=V,vae=_e,pae=pl,yae=ee,gae=ta,mae=yv,bae=gv,$ae=ze,wae=We,_ae=Qn,Eae=ia,Sae=Rt.f,Oae=ti.forEach,Tae=He,rO=zi,Pae=rO.set,Iae=rO.getterFor,mv=function(r,n,e){var t=r.indexOf("Map")!==-1,i=r.indexOf("Weak")!==-1,a=t?"set":"add",o=vae[r],s=o&&o.prototype,u={},l;if(!Tae||!$ae(o)||!(i||s.forEach&&!yae(function(){new o().entries().next()})))l=e.getConstructor(n,r,t,a),pae.enable();else{l=n(function(c,f){Pae(bae(c,h),{type:r,collection:new o}),_ae(f)||mae(f,c[a],{that:c,AS_ENTRIES:t})});var h=l.prototype,d=Iae(r);Oae(["add","clear","delete","forEach","get","has","set","keys","values","entries"],function(c){var f=c==="add"||c==="set";c in s&&!(i&&c==="clear")&&gae(h,c,function(v,p){var y=d(this).collection;if(!f&&i&&!wae(v))return c==="get"?void 0:!1;var g=y[c](v===0?0:v,p);return f?this:g})}),i||Sae(h,"size",{configurable:!0,get:function(){return d(this).collection.size}})}return Eae(l,r,!1,!0),u[r]=l,fae({global:!0,forced:!0},u),i||e.setStrong(l,r,t),l},kae=Po,bv=function(r,n,e){for(var t in n)e&&e.unsafe&&r[t]?r[t]=n[t]:kae(r,t,n[t],e);return r},Cae=zt,xae=Yf,Aae=Ee,Rae=He,Fb=Aae("species"),Dae=function(r){var n=Cae(r);Rae&&n&&!n[Fb]&&xae(n,Fb,{configurable:!0,get:function(){return this}})},Mae=ra,Nae=Yf,Bb=bv,Fae=Eo,Bae=gv,Lae=Qn,jae=yv,zae=Uf,ms=Vf,Hae=Dae,fa=He,Lb=pl.fastKey,iO=zi,jb=iO.set,wd=iO.getterFor,nO={getConstructor:function(r,n,e,t){var i=r(function(l,h){Bae(l,a),jb(l,{type:n,index:Mae(null),first:void 0,last:void 0,size:0}),fa||(l.size=0),Lae(h)||jae(h,l[t],{that:l,AS_ENTRIES:e})}),a=i.prototype,o=wd(n),s=function(l,h,d){var c=o(l),f=u(l,h),v,p;return f?f.value=d:(c.last=f={index:p=Lb(h,!0),key:h,value:d,previous:v=c.last,next:void 0,removed:!1},c.first||(c.first=f),v&&(v.next=f),fa?c.size++:l.size++,p!=="F"&&(c.index[p]=f)),l},u=function(l,h){var d=o(l),c=Lb(h),f;if(c!=="F")return d.index[c];for(f=d.first;f;f=f.next)if(f.key===h)return f};return Bb(a,{clear:function(){for(var h=this,d=o(h),c=d.index,f=d.first;f;)f.removed=!0,f.previous&&(f.previous=f.previous.next=void 0),delete c[f.index],f=f.next;d.first=d.last=void 0,fa?d.size=0:h.size=0},delete:function(l){var h=this,d=o(h),c=u(h,l);if(c){var f=c.next,v=c.previous;delete d.index[c.index],c.removed=!0,v&&(v.next=f),f&&(f.previous=v),d.first===c&&(d.first=f),d.last===c&&(d.last=v),fa?d.size--:h.size--}return!!c},forEach:function(h){for(var d=o(this),c=Fae(h,arguments.length>1?arguments[1]:void 0),f;f=f?f.next:d.first;)for(c(f.value,f.key,this);f&&f.removed;)f=f.previous},has:function(h){return!!u(this,h)}}),Bb(a,e?{get:function(h){var d=u(this,h);return d&&d.value},set:function(h,d){return s(this,h===0?0:h,d)}}:{add:function(h){return s(this,h=h===0?0:h,h)}}),fa&&Nae(a,"size",{configurable:!0,get:function(){return o(this).size}}),i},setStrong:function(r,n,e){var t=n+" Iterator",i=wd(n),a=wd(t);zae(r,n,function(o,s){jb(this,{type:t,target:o,state:i(o),kind:s,last:void 0})},function(){for(var o=a(this),s=o.kind,u=o.last;u&&u.removed;)u=u.previous;return!o.target||!(o.last=u=u?u.next:o.state.first)?(o.target=void 0,ms(void 0,!0)):ms(s==="keys"?u.key:s==="values"?u.value:[u.key,u.value],!1)},e?"entries":"values",!e,!0),Hae(n)}},Wae=mv,Uae=nO;Wae("Map",function(r){return function(){return r(this,arguments.length?arguments[0]:void 0)}},Uae);var Vae=te,Gae=Vae.Map,Kae=Gae,qae=Kae,Yae=qae,aO=L(Yae),Xae=function(){function r(){C(this,r),this.clear(),this._defaultIndex=0,this._groupIndex=0,this._defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},Ae(this.options,this.defaultOptions)}return x(r,[{key:"setOptions",value:function(e){var t=["useDefaultGroups"];if(e!==void 0){for(var i in e)if(Object.prototype.hasOwnProperty.call(e,i)&&Z(t).call(t,i)===-1){var a=e[i];this.add(i,a)}}}},{key:"clear",value:function(){this._groups=new aO,this._groupNames=[]}},{key:"get",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0,i=this._groups.get(e);if(i===void 0&&t)if(this.options.useDefaultGroups===!1&&this._groupNames.length>0){var a=this._groupIndex%this._groupNames.length;++this._groupIndex,i={},i.color=this._groups.get(this._groupNames[a]),this._groups.set(e,i)}else{var o=this._defaultIndex%this._defaultGroups.length;this._defaultIndex++,i={},i.color=this._defaultGroups[o],this._groups.set(e,i)}return i}},{key:"add",value:function(e,t){return this._groups.has(e)||this._groupNames.push(e),this._groups.set(e,t),t}}]),r}(),Qae=V;Qae({target:"Number",stat:!0},{isNaN:function(n){return n!==n}});var Jae=te,Zae=Jae.Number.isNaN,eoe=Zae,toe=eoe,roe=toe,jc=L(roe),ioe=_e,noe=ioe.isFinite,aoe=Number.isFinite||function(n){return typeof n=="number"&&noe(n)},ooe=V,soe=aoe;ooe({target:"Number",stat:!0},{isFinite:soe});var uoe=te,loe=uoe.Number.isFinite,hoe=loe,doe=hoe,coe=doe,ci=L(coe),foe=V,voe=ti.some,poe=oa,yoe=poe("some");foe({target:"Array",proto:!0,forced:!yoe},{some:function(n){return voe(this,n,arguments.length>1?arguments[1]:void 0)}});var goe=Ve,moe=goe("Array").some,boe=Ie,$oe=moe,_d=Array.prototype,woe=function(r){var n=r.some;return r===_d||boe(_d,r)&&n===_d.some?$oe:n},_oe=woe,Eoe=_oe,Soe=Eoe,Ooe=L(Soe),Toe=te,Poe=Toe.Object.getOwnPropertySymbols,Ioe=Poe,koe=Ioe,Coe=koe,Yr=L(Coe),oO={exports:{}},xoe=V,Aoe=ee,Roe=hr,sO=Xn.f,uO=He,Doe=!uO||Aoe(function(){sO(1)});xoe({target:"Object",stat:!0,forced:Doe,sham:!uO},{getOwnPropertyDescriptor:function(n,e){return sO(Roe(n),e)}});var Moe=te,lO=Moe.Object,Noe=oO.exports=function(n,e){return lO.getOwnPropertyDescriptor(n,e)};lO.getOwnPropertyDescriptor.sham&&(Noe.sham=!0);var Foe=oO.exports,Boe=Foe,hO=Boe,Loe=hO,ii=L(Loe),joe=V,zoe=He,Hoe=nZ,Woe=hr,Uoe=Xn,Voe=aa;joe({target:"Object",stat:!0,sham:!zoe},{getOwnPropertyDescriptors:function(n){for(var e=Woe(n),t=Uoe.f,i=Hoe(e),a={},o=0,s,u;i.length>o;)u=t(e,s=i[o++]),u!==void 0&&Voe(a,s,u);return a}});var Goe=te,Koe=Goe.Object.getOwnPropertyDescriptors,qoe=Koe,Yoe=qoe,Xoe=Yoe,Xr=L(Xoe),dO={exports:{}},Qoe=V,Joe=He,zb=el.f;Qoe({target:"Object",stat:!0,forced:Object.defineProperties!==zb,sham:!Joe},{defineProperties:zb});var Zoe=te,cO=Zoe.Object,ese=dO.exports=function(n,e){return cO.defineProperties(n,e)};cO.defineProperties.sham&&(ese.sham=!0);var tse=dO.exports,rse=tse,ise=rse,nse=ise,yl=L(nse),ase=yE,gl=L(ase);function ml(r,n,e){return n=YE(n),n in r?nl(r,n,{value:e,enumerable:!0,configurable:!0,writable:!0}):r[n]=e,r}var fO=_e,ose=ee,sse=re,use=dr,lse=sS.trim,hse=rv,dse=sse("".charAt),fu=fO.parseFloat,Hb=fO.Symbol,Wb=Hb&&Hb.iterator,cse=1/fu(hse+"-0")!==-1/0||Wb&&!ose(function(){fu(Object(Wb))}),fse=cse?function(n){var e=lse(use(n)),t=fu(e);return t===0&&dse(e,0)==="-"?-0:t}:fu,vse=V,Ub=fse;vse({global:!0,forced:parseFloat!==Ub},{parseFloat:Ub});var pse=te,yse=pse.parseFloat,gse=yse,mse=gse,bse=mse,vO=L(bse),$se=V,wse=ee,_se=al.f,Ese=wse(function(){return!Object.getOwnPropertyNames(1)});$se({target:"Object",stat:!0,forced:Ese},{getOwnPropertyNames:_se});var Sse=te,Ose=Sse.Object,Tse=function(n){return Ose.getOwnPropertyNames(n)},Pse=Tse,Ise=Pse,kse=Ise,Cse=L(kse);function $v(r,n){var e=["node","edge","label"],t=!0,i=Nr(n,"chosen");if(typeof i=="boolean")t=i;else if(se(i)==="object"){if(Z(e).call(e,r)===-1)throw new Error("choosify: subOption '"+r+"' should be one of '"+e.join("', '")+"'");var a=Nr(n,["chosen",r]);(typeof a=="boolean"||typeof a=="function")&&(t=a)}return t}function zc(r,n,e){if(r.width<=0||r.height<=0)return!1;if(e!==void 0){var t={x:n.x-e.x,y:n.y-e.y};if(e.angle!==0){var i=-e.angle,a={x:Math.cos(i)*t.x-Math.sin(i)*t.y,y:Math.sin(i)*t.x+Math.cos(i)*t.y};n=a}else n=t}var o=r.x+r.width,s=r.y+r.width;return r.left<n.x&&o>n.x&&r.top<n.y&&s>n.y}function vu(r){return typeof r=="string"&&r!==""}function pO(r,n,e,t){var i=t.x,a=t.y;if(typeof t.distanceToBorder=="function"){var o=t.distanceToBorder(r,n),s=Math.sin(n)*o,u=Math.cos(n)*o;u===o?(i+=o,a=t.y):s===o?(i=t.x,a-=o):(i+=u,a-=s)}else t.shape.width>t.shape.height?(i=t.x+t.shape.width*.5,a=t.y-e):(i=t.x+e,a=t.y-t.shape.height*.5);return{x:i,y:a}}var xse=Ve,Ase=xse("Array").values,Rse=Ase,Dse=Rse,Mse=ji,Nse=Ue,Fse=Ie,Bse=Dse,Ed=Array.prototype,Lse={DOMTokenList:!0,NodeList:!0},jse=function(r){var n=r.values;return r===Ed||Fse(Ed,r)&&n===Ed.values||Nse(Lse,Mse(r))?Bse:n},zse=jse,yO=L(zse),Hse=function(){function r(n){C(this,r),this.measureText=n,this.current=0,this.width=0,this.height=0,this.lines=[]}return x(r,[{key:"_add",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:"normal";this.lines[e]===void 0&&(this.lines[e]={width:0,height:0,blocks:[]});var a=t;(t===void 0||t==="")&&(a=" ");var o=this.measureText(a,i),s=Ae({},yO(o));s.text=t,s.width=o.width,s.mod=i,(t===void 0||t==="")&&(s.width=0),this.lines[e].blocks.push(s),this.lines[e].width+=s.width}},{key:"curWidth",value:function(){var e=this.lines[this.current];return e===void 0?0:e.width}},{key:"append",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:"normal";this._add(this.current,e,t)}},{key:"newLine",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:"normal";this._add(this.current,e,t),this.current++}},{key:"determineLineHeights",value:function(){for(var e=0;e<this.lines.length;e++){var t=this.lines[e],i=0;if(t.blocks!==void 0)for(var a=0;a<t.blocks.length;a++){var o=t.blocks[a];i<o.height&&(i=o.height)}t.height=i}}},{key:"determineLabelSize",value:function(){for(var e=0,t=0,i=0;i<this.lines.length;i++){var a=this.lines[i];a.width>e&&(e=a.width),t+=a.height}this.width=e,this.height=t}},{key:"removeEmptyBlocks",value:function(){for(var e=[],t=0;t<this.lines.length;t++){var i=this.lines[t];if(i.blocks.length!==0&&!(t===this.lines.length-1&&i.width===0)){var a={};Ae(a,i),a.blocks=[];for(var o=void 0,s=[],u=0;u<i.blocks.length;u++){var l=i.blocks[u];l.width!==0?s.push(l):o===void 0&&(o=l)}s.length===0&&o!==void 0&&s.push(o),a.blocks=s,e.push(a)}}return e}},{key:"finalize",value:function(){this.determineLineHeights(),this.determineLabelSize();var e=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:e}}}]),r}(),Wse={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/_/,"`":/`/,afterBold:/[^*]/,afterItal:/[^_]/,afterMono:/[^`]/},Vb=function(){function r(n){C(this,r),this.text=n,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}return x(r,[{key:"mod",value:function(){return this.modStack.length===0?"normal":this.modStack[0]}},{key:"modName",value:function(){if(this.modStack.length===0)return"normal";if(this.modStack[0]==="mono")return"mono";if(this.bold&&this.ital)return"boldital";if(this.bold)return"bold";if(this.ital)return"ital"}},{key:"emitBlock",value:function(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}},{key:"add",value:function(e){e===" "&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1),e!=" "&&(this.buffer+=e)}},{key:"parseWS",value:function(e){return/[ \t]/.test(e)?(this.mono?this.add(e):this.spacing=!0,!0):!1}},{key:"setTag",value:function(e){this.emitBlock(),this[e]=!0,this.modStack.unshift(e)}},{key:"unsetTag",value:function(e){this.emitBlock(),this[e]=!1,this.modStack.shift()}},{key:"parseStartTag",value:function(e,t){return!this.mono&&!this[e]&&this.match(t)?(this.setTag(e),!0):!1}},{key:"match",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0,i=this.prepareRegExp(e),a=be(i,2),o=a[0],s=a[1],u=o.test(this.text.substr(this.position,s));return u&&t&&(this.position+=s-1),u}},{key:"parseEndTag",value:function(e,t,i){var a=this.mod()===e;return e==="mono"?a=a&&this.mono:a=a&&!this.mono,a&&this.match(t)?(i!==void 0?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(e):this.unsetTag(e),!0):!1}},{key:"replace",value:function(e,t){return this.match(e)?(this.add(t),this.position+=length-1,!0):!1}},{key:"prepareRegExp",value:function(e){var t,i;if(e instanceof RegExp)i=e,t=1;else{var a=Wse[e];a!==void 0?i=a:i=new RegExp(e),t=e.length}return[i,t]}}]),r}(),Use=function(){function r(n,e,t,i){var a=this;C(this,r),this.ctx=n,this.parent=e,this.selected=t,this.hover=i;var o=function(u,l){if(u===void 0)return 0;var h=a.parent.getFormattingValues(n,t,i,l),d=0;if(u!==""){var c=a.ctx.measureText(u);d=c.width}return{width:d,values:h}};this.lines=new Hse(o)}return x(r,[{key:"process",value:function(e){if(!vu(e))return this.lines.finalize();var t=this.parent.fontOptions;e=e.replace(/\r\n/g,`
`),e=e.replace(/\r/g,`
`);var i=String(e).split(`
`),a=i.length;if(t.multi)for(var o=0;o<a;o++){var s=this.splitBlocks(i[o],t.multi);if(s!==void 0){if(s.length===0){this.lines.newLine("");continue}if(t.maxWdt>0)for(var u=0;u<s.length;u++){var l=s[u].mod,h=s[u].text;this.splitStringIntoLines(h,l,!0)}else for(var d=0;d<s.length;d++){var c=s[d].mod,f=s[d].text;this.lines.append(f,c)}this.lines.newLine()}}else if(t.maxWdt>0)for(var v=0;v<a;v++)this.splitStringIntoLines(i[v]);else for(var p=0;p<a;p++)this.lines.newLine(i[p]);return this.lines.finalize()}},{key:"decodeMarkupSystem",value:function(e){var t="none";return e==="markdown"||e==="md"?t="markdown":(e===!0||e==="html")&&(t="html"),t}},{key:"splitHtmlBlocks",value:function(e){for(var t=new Vb(e),i=function(u){if(/&/.test(u)){var l=t.replace(t.text,"&lt;","<")||t.replace(t.text,"&amp;","&");return l||t.add("&"),!0}return!1};t.position<t.text.length;){var a=t.text.charAt(t.position),o=t.parseWS(a)||/</.test(a)&&(t.parseStartTag("bold","<b>")||t.parseStartTag("ital","<i>")||t.parseStartTag("mono","<code>")||t.parseEndTag("bold","</b>")||t.parseEndTag("ital","</i>")||t.parseEndTag("mono","</code>"))||i(a);o||t.add(a),t.position++}return t.emitBlock(),t.blocks}},{key:"splitMarkdownBlocks",value:function(e){for(var t=this,i=new Vb(e),a=!0,o=function(h){return/\\/.test(h)?(i.position<t.text.length+1&&(i.position++,h=t.text.charAt(i.position),/ \t/.test(h)?i.spacing=!0:(i.add(h),a=!1)),!0):!1};i.position<i.text.length;){var s=i.text.charAt(i.position),u=i.parseWS(s)||o(s)||(a||i.spacing)&&(i.parseStartTag("bold","*")||i.parseStartTag("ital","_")||i.parseStartTag("mono","`"))||i.parseEndTag("bold","*","afterBold")||i.parseEndTag("ital","_","afterItal")||i.parseEndTag("mono","`","afterMono");u||(i.add(s),a=!1),i.position++}return i.emitBlock(),i.blocks}},{key:"splitBlocks",value:function(e,t){var i=this.decodeMarkupSystem(t);if(i==="none")return[{text:e,mod:"normal"}];if(i==="markdown")return this.splitMarkdownBlocks(e);if(i==="html")return this.splitHtmlBlocks(e)}},{key:"overMaxWidth",value:function(e){var t=this.ctx.measureText(e).width;return this.lines.curWidth()+t>this.parent.fontOptions.maxWdt}},{key:"getLongestFit",value:function(e){for(var t="",i=0;i<e.length;){var a=t===""?"":" ",o=t+a+e[i];if(this.overMaxWidth(o))break;t=o,i++}return i}},{key:"getLongestFitWord",value:function(e){for(var t=0;t<e.length&&!this.overMaxWidth(Ye(e).call(e,0,t));)t++;return t}},{key:"splitStringIntoLines",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:"normal",i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1;this.parent.getFormattingValues(this.ctx,this.selected,this.hover,t),e=e.replace(/^( +)/g,"$1\r"),e=e.replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r");for(var a=e.split("\r");a.length>0;){var o=this.getLongestFit(a);if(o===0){var s=a[0],u=this.getLongestFitWord(s);this.lines.newLine(Ye(s).call(s,0,u),t),a[0]=Ye(s).call(s,u)}else{var l=o;a[o-1]===" "?o--:a[l]===" "&&l++;var h=Ye(a).call(a,0,o).join("");o==a.length&&i?this.lines.append(h,t):this.lines.newLine(h,t),a=Ye(a).call(a,l)}}}}]),r}(),va=["bold","ital","boldital","mono"],gO=function(){function r(n,e){var t=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1;C(this,r),this.body=n,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(e),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=t}return x(r,[{key:"setOptions",value:function(e){if(this.elementOptions=e,this.initFontOptions(e.font),vu(e.label)?this.labelDirty=!0:e.label=void 0,e.font!==void 0&&e.font!==null){if(typeof e.font=="string")this.baseSize=this.fontOptions.size;else if(se(e.font)==="object"){var t=e.font.size;t!==void 0&&(this.baseSize=t)}}}},{key:"initFontOptions",value:function(e){var t=this;if(J(va,function(i){t.fontOptions[i]={}}),r.parseFontString(this.fontOptions,e)){this.fontOptions.vadjust=0;return}J(e,function(i,a){i!=null&&se(i)!=="object"&&(t.fontOptions[a]=i)})}},{key:"constrain",value:function(e){var t={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},i=Nr(e,"widthConstraint");if(typeof i=="number")t.maxWdt=Number(i),t.minWdt=Number(i);else if(se(i)==="object"){var a=Nr(e,["widthConstraint","maximum"]);typeof a=="number"&&(t.maxWdt=Number(a));var o=Nr(e,["widthConstraint","minimum"]);typeof o=="number"&&(t.minWdt=Number(o))}var s=Nr(e,"heightConstraint");if(typeof s=="number")t.minHgt=Number(s);else if(se(s)==="object"){var u=Nr(e,["heightConstraint","minimum"]);typeof u=="number"&&(t.minHgt=Number(u));var l=Nr(e,["heightConstraint","valign"]);typeof l=="string"&&(l==="top"||l==="bottom")&&(t.valign=l)}return t}},{key:"update",value:function(e,t){this.setOptions(e,!0),this.propagateFonts(t),he(this.fontOptions,this.constrain(t)),this.fontOptions.chooser=$v("label",t)}},{key:"adjustSizes",value:function(e){var t=e?e.right+e.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=t,this.fontOptions.minWdt-=t);var i=e?e.top+e.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}},{key:"addFontOptionsToPile",value:function(e,t){for(var i=0;i<t.length;++i)this.addFontToPile(e,t[i])}},{key:"addFontToPile",value:function(e,t){if(t!==void 0&&!(t.font===void 0||t.font===null)){var i=t.font;e.push(i)}}},{key:"getBasicOptions",value:function(e){for(var t={},i=0;i<e.length;++i){var a=e[i],o={};r.parseFontString(o,a)&&(a=o),J(a,function(s,u){s!==void 0&&(Object.prototype.hasOwnProperty.call(t,u)||(Z(va).call(va,u)!==-1?t[u]={}:t[u]=s))})}return t}},{key:"getFontOption",value:function(e,t,i){for(var a,o=0;o<e.length;++o){var s=e[o];if(Object.prototype.hasOwnProperty.call(s,t)){if(a=s[t],a==null)continue;var u={};if(r.parseFontString(u,a)&&(a=u),Object.prototype.hasOwnProperty.call(a,i))return a[i]}}if(Object.prototype.hasOwnProperty.call(this.fontOptions,i))return this.fontOptions[i];throw new Error("Did not find value for multi-font for property: '"+i+"'")}},{key:"getFontOptions",value:function(e,t){for(var i={},a=["color","size","face","mod","vadjust"],o=0;o<a.length;++o){var s=a[o];i[s]=this.getFontOption(e,t,s)}return i}},{key:"propagateFonts",value:function(e){var t=this,i=[];this.addFontOptionsToPile(i,e),this.fontOptions=this.getBasicOptions(i);for(var a=function(){var u=va[o],l=t.fontOptions[u],h=t.getFontOptions(i,u);J(h,function(d,c){l[c]=d}),l.size=Number(l.size),l.vadjust=Number(l.vadjust)},o=0;o<va.length;++o)a()}},{key:"draw",value:function(e,t,i,a,o){var s=arguments.length>5&&arguments[5]!==void 0?arguments[5]:"middle";if(this.elementOptions.label!==void 0){var u=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&u<this.elementOptions.scaling.label.drawThreshold-1||(u>=this.elementOptions.scaling.label.maxVisible&&(u=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(e,a,o,t,i,s),this._drawBackground(e),this._drawText(e,t,this.size.yLine,s,u))}}},{key:"_drawBackground",value:function(e){if(this.fontOptions.background!==void 0&&this.fontOptions.background!=="none"){e.fillStyle=this.fontOptions.background;var t=this.getSize();e.fillRect(t.left,t.top,t.width,t.height)}}},{key:"_drawText",value:function(e,t,i){var a=arguments.length>3&&arguments[3]!==void 0?arguments[3]:"middle",o=arguments.length>4?arguments[4]:void 0,s=this._setAlignment(e,t,i,a),u=be(s,2);t=u[0],i=u[1],e.textAlign="left",t=t-this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&(this.fontOptions.valign==="top"&&(i-=(this.size.height-this.size.labelHeight)/2),this.fontOptions.valign==="bottom"&&(i+=(this.size.height-this.size.labelHeight)/2));for(var l=0;l<this.lineCount;l++){var h=this.lines[l];if(h&&h.blocks){var d=0;this.isEdgeLabel||this.fontOptions.align==="center"?d+=(this.size.width-h.width)/2:this.fontOptions.align==="right"&&(d+=this.size.width-h.width);for(var c=0;c<h.blocks.length;c++){var f=h.blocks[c];e.font=f.font;var v=this._getColor(f.color,o,f.strokeColor),p=be(v,2),y=p[0],g=p[1];f.strokeWidth>0&&(e.lineWidth=f.strokeWidth,e.strokeStyle=g,e.lineJoin="round"),e.fillStyle=y,f.strokeWidth>0&&e.strokeText(f.text,t+d,i+f.vadjust),e.fillText(f.text,t+d,i+f.vadjust),d+=f.width}i+=h.height}}}},{key:"_setAlignment",value:function(e,t,i,a){if(this.isEdgeLabel&&this.fontOptions.align!=="horizontal"&&this.pointToSelf===!1){t=0,i=0;var o=2;this.fontOptions.align==="top"?(e.textBaseline="alphabetic",i-=2*o):this.fontOptions.align==="bottom"?(e.textBaseline="hanging",i+=2*o):e.textBaseline="middle"}else e.textBaseline=a;return[t,i]}},{key:"_getColor",value:function(e,t,i){var a=e||"#000000",o=i||"#ffffff";if(t<=this.elementOptions.scaling.label.drawThreshold){var s=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-t)));a=Ft(a,s),o=Ft(o,s)}return[a,o]}},{key:"getTextSize",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1,i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1;return this._processLabel(e,t,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}},{key:"getSize",value:function(){var e=2,t=this.size.left,i=this.size.top-.5*e;if(this.isEdgeLabel){var a=-this.size.width*.5;switch(this.fontOptions.align){case"middle":t=a,i=-this.size.height*.5;break;case"top":t=a,i=-(this.size.height+e);break;case"bottom":t=a,i=e;break}}var o={left:t,top:i,width:this.size.width,height:this.size.height};return o}},{key:"calculateLabelSize",value:function(e,t,i){var a=arguments.length>3&&arguments[3]!==void 0?arguments[3]:0,o=arguments.length>4&&arguments[4]!==void 0?arguments[4]:0,s=arguments.length>5&&arguments[5]!==void 0?arguments[5]:"middle";this._processLabel(e,t,i),this.size.left=a-this.size.width*.5,this.size.top=o-this.size.height*.5,this.size.yLine=o+(1-this.lineCount)*.5*this.fontOptions.size,s==="hanging"&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}},{key:"getFormattingValues",value:function(e,t,i,a){var o=function(h,d,c){return d==="normal"?c==="mod"?"":h[c]:h[d][c]!==void 0?h[d][c]:h[c]},s={color:o(this.fontOptions,a,"color"),size:o(this.fontOptions,a,"size"),face:o(this.fontOptions,a,"face"),mod:o(this.fontOptions,a,"mod"),vadjust:o(this.fontOptions,a,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(t||i)&&(a==="normal"&&this.fontOptions.chooser===!0&&this.elementOptions.labelHighlightBold?s.mod="bold":typeof this.fontOptions.chooser=="function"&&this.fontOptions.chooser(s,this.elementOptions.id,t,i));var u="";return s.mod!==void 0&&s.mod!==""&&(u+=s.mod+" "),u+=s.size+"px "+s.face,e.font=u.replace(/"/g,""),s.font=e.font,s.height=s.size,s}},{key:"differentState",value:function(e,t){return e!==this.selectedState||t!==this.hoverState}},{key:"_processLabelText",value:function(e,t,i,a){var o=new Use(e,this,t,i);return o.process(a)}},{key:"_processLabel",value:function(e,t,i){if(!(this.labelDirty===!1&&!this.differentState(t,i))){var a=this._processLabelText(e,t,i,this.elementOptions.label);this.fontOptions.minWdt>0&&a.width<this.fontOptions.minWdt&&(a.width=this.fontOptions.minWdt),this.size.labelHeight=a.height,this.fontOptions.minHgt>0&&a.height<this.fontOptions.minHgt&&(a.height=this.fontOptions.minHgt),this.lines=a.lines,this.lineCount=a.lines.length,this.size.width=a.width,this.size.height=a.height,this.selectedState=t,this.hoverState=i,this.labelDirty=!1}}},{key:"visible",value:function(){if(this.size.width===0||this.size.height===0||this.elementOptions.label===void 0)return!1;var e=this.fontOptions.size*this.body.view.scale;return!(e<this.elementOptions.scaling.label.drawThreshold-1)}}],[{key:"parseFontString",value:function(e,t){if(!t||typeof t!="string")return!1;var i=t.split(" ");return e.size=+i[0].replace("px",""),e.face=i[1],e.color=i[2],!0}}]),r}(),Vse=rl,Gse=Zn,Kse=TypeError,qse=function(r){if(Vse(r))return r;throw new Kse(Gse(r)+" is not a constructor")},Yse=V,Xse=zt,Sd=yo,Qse=N_,Gb=qse,Jse=Dt,Kb=We,Zse=ra,mO=ee,wv=Xse("Reflect","construct"),eue=Object.prototype,tue=[].push,bO=mO(function(){function r(){}return!(wv(function(){},[],r)instanceof r)}),$O=!mO(function(){wv(function(){})}),qb=bO||$O;Yse({target:"Reflect",stat:!0,forced:qb,sham:qb},{construct:function(n,e){Gb(n),Jse(e);var t=arguments.length<3?n:Gb(arguments[2]);if($O&&!bO)return wv(n,e,t);if(n===t){switch(e.length){case 0:return new n;case 1:return new n(e[0]);case 2:return new n(e[0],e[1]);case 3:return new n(e[0],e[1],e[2]);case 4:return new n(e[0],e[1],e[2],e[3])}var i=[null];return Sd(tue,i,e),new(Sd(Qse,n,i))}var a=t.prototype,o=Zse(Kb(a)?a:eue),s=Sd(n,o,e);return Kb(s)?s:o}});var rue=te,iue=rue.Reflect.construct,nue=iue,aue=nue,oue=aue,_=L(oue),sue=dS,uue=sue,lue=uue,hue=lue,due=hue,cue=L(due),fue=V,vue=cK;fue({target:"Object",stat:!0},{setPrototypeOf:vue});var pue=te,yue=pue.Object.setPrototypeOf,gue=yue,mue=gue,bue=mue,$ue=bue,wue=$ue,_ue=wue,Eue=_ue,Hc=L(Eue),Sue=F_,Oue=Sue,Tue=Oue,Pue=Tue,Iue=Pue,_v=L(Iue);function Wc(r,n){var e;return Wc=Hc?_v(e=Hc).call(e):function(i,a){return i.__proto__=a,i},Wc(r,n)}function ie(r,n){if(typeof n!="function"&&n!==null)throw new TypeError("Super expression must either be null or a function");r.prototype=cue(n&&n.prototype,{constructor:{value:r,writable:!0,configurable:!0}}),nl(r,"prototype",{writable:!1}),n&&Wc(r,n)}function kue(r){if(r===void 0)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return r}function oe(r,n){if(n&&(se(n)==="object"||typeof n=="function"))return n;if(n!==void 0)throw new TypeError("Derived constructors may only return object or undefined");return kue(r)}var Cue=oS,xue=Cue,Aue=xue,Rue=Aue,Due=Rue,Yb=L(Due);function N(r){var n;return N=Hc?_v(n=Yb).call(n):function(t){return t.__proto__||Yb(t)},N(r)}var Gi=function(){function r(n,e,t){C(this,r),this.body=e,this.labelModule=t,this.setOptions(n),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}return x(r,[{key:"setOptions",value:function(e){this.options=e}},{key:"_setMargins",value:function(e){this.margin={},this.options.margin&&(se(this.options.margin)=="object"?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),e.adjustSizes(this.margin)}},{key:"_distanceToBorder",value:function(e,t){var i=this.options.borderWidth;return e&&this.resize(e),Math.min(Math.abs(this.width/2/Math.cos(t)),Math.abs(this.height/2/Math.sin(t)))+i}},{key:"enableShadow",value:function(e,t){t.shadow&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}},{key:"disableShadow",value:function(e,t){t.shadow&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}},{key:"enableBorderDashes",value:function(e,t){if(t.borderDashes!==!1)if(e.setLineDash!==void 0){var i=t.borderDashes;i===!0&&(i=[5,15]),e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1}},{key:"disableBorderDashes",value:function(e,t){t.borderDashes!==!1&&(e.setLineDash!==void 0?e.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,t.borderDashes=!1))}},{key:"needsRefresh",value:function(e,t){return this.refreshNeeded===!0?(this.refreshNeeded=!1,!0):this.width===void 0||this.labelModule.differentState(e,t)}},{key:"initContextForDraw",value:function(e,t){var i=t.borderWidth/this.body.view.scale;e.lineWidth=Math.min(this.width,i),e.strokeStyle=t.borderColor,e.fillStyle=t.color}},{key:"performStroke",value:function(e,t){var i=t.borderWidth/this.body.view.scale;e.save(),i>0&&(this.enableBorderDashes(e,t),e.stroke(),this.disableBorderDashes(e,t)),e.restore()}},{key:"performFill",value:function(e,t){e.save(),e.fillStyle=t.color,this.enableShadow(e,t),Do(e).call(e),this.disableShadow(e,t),e.restore(),this.performStroke(e,t)}},{key:"_addBoundingBoxMargin",value:function(e){this.boundingBox.left-=e,this.boundingBox.top-=e,this.boundingBox.bottom+=e,this.boundingBox.right+=e}},{key:"_updateBoundingBox",value:function(e,t,i,a,o){i!==void 0&&this.resize(i,a,o),this.left=e-this.width/2,this.top=t-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}},{key:"updateBoundingBox",value:function(e,t,i,a,o){this._updateBoundingBox(e,t,i,a,o)}},{key:"getDimensionsFromLabel",value:function(e,t,i){this.textSize=this.labelModule.getTextSize(e,t,i);var a=this.textSize.width,o=this.textSize.height,s=14;return a===0&&(a=s,o=s),{width:a,height:o}}}]),r}();function Mue(r){var n=Nue();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Nue(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Fue=function(r){ie(e,r);var n=Mue(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o._setMargins(a),o}return x(e,[{key:"resize",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.selected,o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:this.hover;if(this.needsRefresh(a,o)){var s=this.getDimensionsFromLabel(i,a,o);this.width=s.width+this.margin.right+this.margin.left,this.height=s.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}},{key:"draw",value:function(i,a,o,s,u,l){this.resize(i,s,u),this.left=a-this.width/2,this.top=o-this.height/2,this.initContextForDraw(i,l),B_(i,this.left,this.top,this.width,this.height,l.borderRadius),this.performFill(i,l),this.updateBoundingBox(a,o,i,s,u),this.labelModule.draw(i,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,s,u)}},{key:"updateBoundingBox",value:function(i,a,o,s,u){this._updateBoundingBox(i,a,o,s,u);var l=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(l)}},{key:"distanceToBorder",value:function(i,a){i&&this.resize(i);var o=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(a)),Math.abs(this.height/2/Math.sin(a)))+o}}]),e}(Gi);function Bue(r){var n=Lue();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Lue(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Ev=function(r){ie(e,r);var n=Bue(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o.labelOffset=0,o.selected=!1,o}return x(e,[{key:"setOptions",value:function(i,a,o){this.options=i,a===void 0&&o===void 0||this.setImages(a,o)}},{key:"setImages",value:function(i,a){a&&this.selected?(this.imageObj=a,this.imageObjAlt=i):(this.imageObj=i,this.imageObjAlt=a)}},{key:"switchImages",value:function(i){var a=i&&!this.selected||!i&&this.selected;if(this.selected=i,this.imageObjAlt!==void 0&&a){var o=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=o}}},{key:"_getImagePadding",value:function(){var i={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var a=this.options.imagePadding;se(a)=="object"?(i.top=a.top,i.right=a.right,i.bottom=a.bottom,i.left=a.left):(i.top=a,i.right=a,i.bottom=a,i.left=a)}return i}},{key:"_resizeImage",value:function(){var i,a;if(this.options.shapeProperties.useImageSize===!1){var o=1,s=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?o=this.imageObj.width/this.imageObj.height:s=this.imageObj.height/this.imageObj.width),i=this.options.size*2*o,a=this.options.size*2*s}else{var u=this._getImagePadding();i=this.imageObj.width+u.left+u.right,a=this.imageObj.height+u.top+u.bottom}this.width=i,this.height=a,this.radius=.5*this.width}},{key:"_drawRawCircle",value:function(i,a,o,s){this.initContextForDraw(i,s),jf(i,a,o,s.size),this.performFill(i,s)}},{key:"_drawImageAtPosition",value:function(i,a){if(this.imageObj.width!=0){i.globalAlpha=a.opacity!==void 0?a.opacity:1,this.enableShadow(i,a);var o=1;this.options.shapeProperties.interpolation===!0&&(o=this.imageObj.width/this.width/this.body.view.scale);var s=this._getImagePadding(),u=this.left+s.left,l=this.top+s.top,h=this.width-s.left-s.right,d=this.height-s.top-s.bottom;this.imageObj.drawImageAtPosition(i,o,u,l,h,d),this.disableShadow(i,a)}}},{key:"_drawImageLabel",value:function(i,a,o,s,u){var l=0;if(this.height!==void 0){l=this.height*.5;var h=this.labelModule.getTextSize(i,s,u);h.lineCount>=1&&(l+=h.height/2)}var d=o+l;this.options.label&&(this.labelOffset=l),this.labelModule.draw(i,a,d,s,u,"hanging")}}]),e}(Gi);function jue(r){var n=zue();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function zue(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Hue=function(r){ie(e,r);var n=jue(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o._setMargins(a),o}return x(e,[{key:"resize",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.selected,o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:this.hover;if(this.needsRefresh(a,o)){var s=this.getDimensionsFromLabel(i,a,o),u=Math.max(s.width+this.margin.right+this.margin.left,s.height+this.margin.top+this.margin.bottom);this.options.size=u/2,this.width=u,this.height=u,this.radius=this.width/2}}},{key:"draw",value:function(i,a,o,s,u,l){this.resize(i,s,u),this.left=a-this.width/2,this.top=o-this.height/2,this._drawRawCircle(i,a,o,l),this.updateBoundingBox(a,o),this.labelModule.draw(i,this.left+this.textSize.width/2+this.margin.left,o,s,u)}},{key:"updateBoundingBox",value:function(i,a){this.boundingBox.top=a-this.options.size,this.boundingBox.left=i-this.options.size,this.boundingBox.right=i+this.options.size,this.boundingBox.bottom=a+this.options.size}},{key:"distanceToBorder",value:function(i){return i&&this.resize(i),this.width*.5}}]),e}(Ev);function Wue(r){var n=Uue();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Uue(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Vue=function(r){ie(e,r);var n=Wue(e);function e(t,i,a,o,s){var u;return C(this,e),u=n.call(this,t,i,a),u.setImages(o,s),u}return x(e,[{key:"resize",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.selected,o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:this.hover,s=this.imageObj.src===void 0||this.imageObj.width===void 0||this.imageObj.height===void 0;if(s){var u=this.options.size*2;this.width=u,this.height=u,this.radius=.5*this.width;return}this.needsRefresh(a,o)&&this._resizeImage()}},{key:"draw",value:function(i,a,o,s,u,l){this.switchImages(s),this.resize();var h=a,d=o;this.options.shapeProperties.coordinateOrigin==="top-left"?(this.left=a,this.top=o,h+=this.width/2,d+=this.height/2):(this.left=a-this.width/2,this.top=o-this.height/2),this._drawRawCircle(i,h,d,l),i.save(),i.clip(),this._drawImageAtPosition(i,l),i.restore(),this._drawImageLabel(i,h,d,s,u),this.updateBoundingBox(a,o)}},{key:"updateBoundingBox",value:function(i,a){this.options.shapeProperties.coordinateOrigin==="top-left"?(this.boundingBox.top=a,this.boundingBox.left=i,this.boundingBox.right=i+this.options.size*2,this.boundingBox.bottom=a+this.options.size*2):(this.boundingBox.top=a-this.options.size,this.boundingBox.left=i-this.options.size,this.boundingBox.right=i+this.options.size,this.boundingBox.bottom=a+this.options.size),this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}},{key:"distanceToBorder",value:function(i){return i&&this.resize(i),this.width*.5}}]),e}(Ev);function Gue(r){var n=Kue();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Kue(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var ni=function(r){ie(e,r);var n=Gue(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"resize",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.selected,o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:this.hover,s=arguments.length>3&&arguments[3]!==void 0?arguments[3]:{size:this.options.size};if(this.needsRefresh(a,o)){var u,l;this.labelModule.getTextSize(i,a,o);var h=2*s.size;this.width=(u=this.customSizeWidth)!==null&&u!==void 0?u:h,this.height=(l=this.customSizeHeight)!==null&&l!==void 0?l:h,this.radius=.5*this.width}}},{key:"_drawShape",value:function(i,a,o,s,u,l,h,d){var c=this;return this.resize(i,l,h,d),this.left=s-this.width/2,this.top=u-this.height/2,this.initContextForDraw(i,d),I9(a)(i,s,u,d.size),this.performFill(i,d),this.options.icon!==void 0&&this.options.icon.code!==void 0&&(i.font=(l?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),i.fillStyle=this.options.icon.color||"black",i.textAlign="center",i.textBaseline="middle",i.fillText(this.options.icon.code,s,u)),{drawExternalLabel:function(){if(c.options.label!==void 0){c.labelModule.calculateLabelSize(i,l,h,s,u,"hanging");var v=u+.5*c.height+.5*c.labelModule.size.height;c.labelModule.draw(i,s,v,l,h,"hanging")}c.updateBoundingBox(s,u)}}}},{key:"updateBoundingBox",value:function(i,a){this.boundingBox.top=a-this.options.size,this.boundingBox.left=i-this.options.size,this.boundingBox.right=i+this.options.size,this.boundingBox.bottom=a+this.options.size,this.options.label!==void 0&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}]),e}(Gi);function Xb(r,n){var e=me(r);if(Yr){var t=Yr(r);n&&(t=gt(t).call(t,function(i){return ii(r,i).enumerable})),e.push.apply(e,t)}return e}function que(r){for(var n=1;n<arguments.length;n++){var e,t,i=arguments[n]!=null?arguments[n]:{};n%2?ue(e=Xb(Object(i),!0)).call(e,function(a){ml(r,a,i[a])}):Xr?yl(r,Xr(i)):ue(t=Xb(Object(i))).call(t,function(a){gl(r,a,ii(i,a))})}return r}function Yue(r){var n=Xue();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Xue(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Que=function(r){ie(e,r);var n=Yue(e);function e(t,i,a,o){var s;return C(this,e),s=n.call(this,t,i,a,o),s.ctxRenderer=o,s}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){this.resize(i,s,u,l),this.left=a-this.width/2,this.top=o-this.height/2,i.save();var h=this.ctxRenderer({ctx:i,id:this.options.id,x:a,y:o,state:{selected:s,hover:u},style:que({},l),label:this.options.label});if(h.drawNode!=null&&h.drawNode(),i.restore(),h.drawExternalLabel){var d=h.drawExternalLabel;h.drawExternalLabel=function(){i.save(),d(),i.restore()}}return h.nodeDimensions&&(this.customSizeWidth=h.nodeDimensions.width,this.customSizeHeight=h.nodeDimensions.height),h}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(ni);function Jue(r){var n=Zue();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Zue(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var ele=function(r){ie(e,r);var n=Jue(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o._setMargins(a),o}return x(e,[{key:"resize",value:function(i,a,o){if(this.needsRefresh(a,o)){var s=this.getDimensionsFromLabel(i,a,o),u=s.width+this.margin.right+this.margin.left;this.width=u,this.height=u,this.radius=this.width/2}}},{key:"draw",value:function(i,a,o,s,u,l){this.resize(i,s,u),this.left=a-this.width/2,this.top=o-this.height/2,this.initContextForDraw(i,l),L_(i,a-this.width/2,o-this.height/2,this.width,this.height),this.performFill(i,l),this.updateBoundingBox(a,o,i,s,u),this.labelModule.draw(i,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,s,u)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(Gi);function tle(r){var n=rle();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function rle(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var ile=function(r){ie(e,r);var n=tle(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){return this._drawShape(i,"diamond",4,a,o,s,u,l)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(ni);function nle(r){var n=ale();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function ale(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var ole=function(r){ie(e,r);var n=nle(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){return this._drawShape(i,"circle",2,a,o,s,u,l)}},{key:"distanceToBorder",value:function(i){return i&&this.resize(i),this.options.size}}]),e}(ni);function sle(r){var n=ule();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function ule(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Qb=function(r){ie(e,r);var n=sle(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"resize",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.selected,o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:this.hover;if(this.needsRefresh(a,o)){var s=this.getDimensionsFromLabel(i,a,o);this.height=s.height*2,this.width=s.width+s.height,this.radius=.5*this.width}}},{key:"draw",value:function(i,a,o,s,u,l){this.resize(i,s,u),this.left=a-this.width*.5,this.top=o-this.height*.5,this.initContextForDraw(i,l),yc(i,this.left,this.top,this.width,this.height),this.performFill(i,l),this.updateBoundingBox(a,o,i,s,u),this.labelModule.draw(i,a,o,s,u)}},{key:"distanceToBorder",value:function(i,a){i&&this.resize(i);var o=this.width*.5,s=this.height*.5,u=Math.sin(a)*o,l=Math.cos(a)*s;return o*s/Math.sqrt(u*u+l*l)}}]),e}(Gi);function lle(r){var n=hle();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function hle(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var dle=function(r){ie(e,r);var n=lle(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o._setMargins(a),o}return x(e,[{key:"resize",value:function(i,a,o){this.needsRefresh(a,o)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(i,a,o,s,u,l){var h=this;return this.resize(i,s,u),this.options.icon.size=this.options.icon.size||50,this.left=a-this.width/2,this.top=o-this.height/2,this._icon(i,a,o,s,u,l),{drawExternalLabel:function(){if(h.options.label!==void 0){var c=5;h.labelModule.draw(i,h.left+h.iconSize.width/2+h.margin.left,o+h.height/2+c,s)}h.updateBoundingBox(a,o)}}}},{key:"updateBoundingBox",value:function(i,a){if(this.boundingBox.top=a-this.options.icon.size*.5,this.boundingBox.left=i-this.options.icon.size*.5,this.boundingBox.right=i+this.options.icon.size*.5,this.boundingBox.bottom=a+this.options.icon.size*.5,this.options.label!==void 0&&this.labelModule.size.width>0){var o=5;this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+o)}}},{key:"_icon",value:function(i,a,o,s,u,l){var h=Number(this.options.icon.size);this.options.icon.code!==void 0?(i.font=[this.options.icon.weight!=null?this.options.icon.weight:s?"bold":"",(this.options.icon.weight!=null&&s?5:0)+h+"px",this.options.icon.face].join(" "),i.fillStyle=this.options.icon.color||"black",i.textAlign="center",i.textBaseline="middle",this.enableShadow(i,l),i.fillText(this.options.icon.code,a,o),this.disableShadow(i,l)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(Gi);function cle(r){var n=fle();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function fle(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var vle=function(r){ie(e,r);var n=cle(e);function e(t,i,a,o,s){var u;return C(this,e),u=n.call(this,t,i,a),u.setImages(o,s),u}return x(e,[{key:"resize",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.selected,o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:this.hover,s=this.imageObj.src===void 0||this.imageObj.width===void 0||this.imageObj.height===void 0;if(s){var u=this.options.size*2;this.width=u,this.height=u;return}this.needsRefresh(a,o)&&this._resizeImage()}},{key:"draw",value:function(i,a,o,s,u,l){i.save(),this.switchImages(s),this.resize();var h=a,d=o;if(this.options.shapeProperties.coordinateOrigin==="top-left"?(this.left=a,this.top=o,h+=this.width/2,d+=this.height/2):(this.left=a-this.width/2,this.top=o-this.height/2),this.options.shapeProperties.useBorderWithImage===!0){var c=this.options.borderWidth,f=this.options.borderWidthSelected||2*this.options.borderWidth,v=(s?f:c)/this.body.view.scale;i.lineWidth=Math.min(this.width,v),i.beginPath();var p=s?this.options.color.highlight.border:u?this.options.color.hover.border:this.options.color.border,y=s?this.options.color.highlight.background:u?this.options.color.hover.background:this.options.color.background;l.opacity!==void 0&&(p=Ft(p,l.opacity),y=Ft(y,l.opacity)),i.strokeStyle=p,i.fillStyle=y,i.rect(this.left-.5*i.lineWidth,this.top-.5*i.lineWidth,this.width+i.lineWidth,this.height+i.lineWidth),Do(i).call(i),this.performStroke(i,l),i.closePath()}this._drawImageAtPosition(i,l),this._drawImageLabel(i,h,d,s,u),this.updateBoundingBox(a,o),i.restore()}},{key:"updateBoundingBox",value:function(i,a){this.resize(),this.options.shapeProperties.coordinateOrigin==="top-left"?(this.left=i,this.top=a):(this.left=i-this.width/2,this.top=a-this.height/2),this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width,this.options.label!==void 0&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(Ev);function ple(r){var n=yle();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function yle(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var gle=function(r){ie(e,r);var n=ple(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){return this._drawShape(i,"square",2,a,o,s,u,l)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(ni);function mle(r){var n=ble();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function ble(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var $le=function(r){ie(e,r);var n=mle(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){return this._drawShape(i,"hexagon",4,a,o,s,u,l)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(ni);function wle(r){var n=_le();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function _le(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Ele=function(r){ie(e,r);var n=wle(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){return this._drawShape(i,"star",4,a,o,s,u,l)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(ni);function Sle(r){var n=Ole();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Ole(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Tle=function(r){ie(e,r);var n=Sle(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o._setMargins(a),o}return x(e,[{key:"resize",value:function(i,a,o){this.needsRefresh(a,o)&&(this.textSize=this.labelModule.getTextSize(i,a,o),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(i,a,o,s,u,l){this.resize(i,s,u),this.left=a-this.width/2,this.top=o-this.height/2,this.enableShadow(i,l),this.labelModule.draw(i,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,s,u),this.disableShadow(i,l),this.updateBoundingBox(a,o,i,s,u)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(Gi);function Ple(r){var n=Ile();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Ile(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var kle=function(r){ie(e,r);var n=Ple(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){return this._drawShape(i,"triangle",3,a,o,s,u,l)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(ni);function Cle(r){var n=xle();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function xle(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Ale=function(r){ie(e,r);var n=Cle(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"draw",value:function(i,a,o,s,u,l){return this._drawShape(i,"triangleDown",3,a,o,s,u,l)}},{key:"distanceToBorder",value:function(i,a){return this._distanceToBorder(i,a)}}]),e}(ni);function Jb(r,n){var e=me(r);if(Yr){var t=Yr(r);n&&(t=gt(t).call(t,function(i){return ii(r,i).enumerable})),e.push.apply(e,t)}return e}function Zb(r){for(var n=1;n<arguments.length;n++){var e,t,i=arguments[n]!=null?arguments[n]:{};n%2?ue(e=Jb(Object(i),!0)).call(e,function(a){ml(r,a,i[a])}):Xr?yl(r,Xr(i)):ue(t=Jb(Object(i))).call(t,function(a){gl(r,a,ii(i,a))})}return r}var Pt=function(){function r(n,e,t,i,a,o){C(this,r),this.options=Gr(a),this.globalOptions=a,this.defaultOptions=o,this.body=e,this.edges=[],this.id=void 0,this.imagelist=t,this.grouplist=i,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new gO(this.body,this.options,!1),this.setOptions(n)}return x(r,[{key:"attachEdge",value:function(e){var t;Z(t=this.edges).call(t,e)===-1&&this.edges.push(e)}},{key:"detachEdge",value:function(e){var t,i=Z(t=this.edges).call(t,e);if(i!=-1){var a;br(a=this.edges).call(a,i,1)}}},{key:"setOptions",value:function(e){var t=this.options.shape;if(e){if(typeof e.color<"u"&&(this._localColor=e.color),e.id!==void 0&&(this.id=e.id),this.id===void 0)throw new Error("Node must have an id");r.checkMass(e,this.id),e.x!==void 0&&(e.x===null?(this.x=void 0,this.predefinedPosition=!1):(this.x=Kt(e.x),this.predefinedPosition=!0)),e.y!==void 0&&(e.y===null?(this.y=void 0,this.predefinedPosition=!1):(this.y=Kt(e.y),this.predefinedPosition=!0)),e.size!==void 0&&(this.baseSize=e.size),e.value!==void 0&&(e.value=vO(e.value)),r.parseOptions(this.options,e,!0,this.globalOptions,this.grouplist);var i=[e,this.options,this.defaultOptions];return this.chooser=$v("node",i),this._load_images(),this.updateLabelModule(e),e.opacity!==void 0&&r.checkOpacity(e.opacity)&&(this.options.opacity=e.opacity),this.updateShape(t),e.hidden!==void 0||e.physics!==void 0}}},{key:"_load_images",value:function(){if((this.options.shape==="circularImage"||this.options.shape==="image")&&this.options.image===void 0)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(this.options.image!==void 0){if(this.imagelist===void 0)throw new Error("Internal Error: No images provided");if(typeof this.options.image=="string")this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(this.options.image.unselected===void 0)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),this.options.image.selected!==void 0?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}},{key:"getFormattingValues",value:function(){var e={color:this.options.color.background,opacity:this.options.opacity,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};if(this.selected||this.hover?this.chooser===!0?this.selected?(this.options.borderWidthSelected!=null?e.borderWidth=this.options.borderWidthSelected:e.borderWidth*=2,e.color=this.options.color.highlight.background,e.borderColor=this.options.color.highlight.border,e.shadow=this.options.shadow.enabled):this.hover&&(e.color=this.options.color.hover.background,e.borderColor=this.options.color.hover.border,e.shadow=this.options.shadow.enabled):typeof this.chooser=="function"&&(this.chooser(e,this.options.id,this.selected,this.hover),e.shadow===!1&&(e.shadowColor!==this.options.shadow.color||e.shadowSize!==this.options.shadow.size||e.shadowX!==this.options.shadow.x||e.shadowY!==this.options.shadow.y)&&(e.shadow=!0)):e.shadow=this.options.shadow.enabled,this.options.opacity!==void 0){var t=this.options.opacity;e.borderColor=Ft(e.borderColor,t),e.color=Ft(e.color,t),e.shadowColor=Ft(e.shadowColor,t)}return e}},{key:"updateLabelModule",value:function(e){(this.options.label===void 0||this.options.label===null)&&(this.options.label=""),r.updateGroupOptions(this.options,Zb(Zb({},e),{},{color:e&&e.color||this._localColor||void 0}),this.grouplist);var t=this.grouplist.get(this.options.group,!1),i=[e,this.options,t,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,i),this.labelModule.baseSize!==void 0&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateShape",value:function(e){if(e===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new Fue(this.options,this.body,this.labelModule);break;case"circle":this.shape=new Hue(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new Vue(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"custom":this.shape=new Que(this.options,this.body,this.labelModule,this.options.ctxRenderer);break;case"database":this.shape=new ele(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new ile(this.options,this.body,this.labelModule);break;case"dot":this.shape=new ole(this.options,this.body,this.labelModule);break;case"ellipse":this.shape=new Qb(this.options,this.body,this.labelModule);break;case"icon":this.shape=new dle(this.options,this.body,this.labelModule);break;case"image":this.shape=new vle(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new gle(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new $le(this.options,this.body,this.labelModule);break;case"star":this.shape=new Ele(this.options,this.body,this.labelModule);break;case"text":this.shape=new Tle(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new kle(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new Ale(this.options,this.body,this.labelModule);break;default:this.shape=new Qb(this.options,this.body,this.labelModule);break}this.needsRefresh()}},{key:"select",value:function(){this.selected=!0,this.needsRefresh()}},{key:"unselect",value:function(){this.selected=!1,this.needsRefresh()}},{key:"needsRefresh",value:function(){this.shape.refreshNeeded=!0}},{key:"getTitle",value:function(){return this.options.title}},{key:"distanceToBorder",value:function(e,t){return this.shape.distanceToBorder(e,t)}},{key:"isFixed",value:function(){return this.options.fixed.x&&this.options.fixed.y}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"getLabelSize",value:function(){return this.labelModule.size()}},{key:"setValueRange",value:function(e,t,i){if(this.options.value!==void 0){var a=this.options.scaling.customScalingFunction(e,t,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(this.options.scaling.label.enabled===!0){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+a*s}this.options.size=this.options.scaling.min+a*o}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}},{key:"draw",value:function(e){var t=this.getFormattingValues();return this.shape.draw(e,this.x,this.y,this.selected,this.hover,t)||{}}},{key:"updateBoundingBox",value:function(e){this.shape.updateBoundingBox(this.x,this.y,e)}},{key:"resize",value:function(e){var t=this.getFormattingValues();this.shape.resize(e,this.selected,this.hover,t)}},{key:"getItemsOnPoint",value:function(e){var t=[];return this.labelModule.visible()&&zc(this.labelModule.getSize(),e)&&t.push({nodeId:this.id,labelId:0}),zc(this.shape.boundingBox,e)&&t.push({nodeId:this.id}),t}},{key:"isOverlappingWith",value:function(e){return this.shape.left<e.right&&this.shape.left+this.shape.width>e.left&&this.shape.top<e.bottom&&this.shape.top+this.shape.height>e.top}},{key:"isBoundingBoxOverlappingWith",value:function(e){return this.shape.boundingBox.left<e.right&&this.shape.boundingBox.right>e.left&&this.shape.boundingBox.top<e.bottom&&this.shape.boundingBox.bottom>e.top}}],[{key:"checkOpacity",value:function(e){return 0<=e&&e<=1}},{key:"checkCoordinateOrigin",value:function(e){return e===void 0||e==="center"||e==="top-left"}},{key:"updateGroupOptions",value:function(e,t,i){var a;if(i!==void 0){var o=e.group;if(t!==void 0&&t.group!==void 0&&o!==t.group)throw new Error("updateGroupOptions: group values in options don't match.");var s=typeof o=="number"||typeof o=="string"&&o!="";if(s){var u=i.get(o);u.opacity!==void 0&&t.opacity===void 0&&(r.checkOpacity(u.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+u.opacity),u.opacity=void 0));var l=gt(a=Cse(t)).call(a,function(h){return t[h]!=null});l.push("font"),du(l,e,u),e.color=Nc(e.color)}}}},{key:"parseOptions",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1,a=arguments.length>3&&arguments[3]!==void 0?arguments[3]:{},o=arguments.length>4?arguments[4]:void 0,s=["color","fixed","shadow"];if(du(s,e,t,i),r.checkMass(t),e.opacity!==void 0&&(r.checkOpacity(e.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+e.opacity),e.opacity=void 0)),t.opacity!==void 0&&(r.checkOpacity(t.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+t.opacity),t.opacity=void 0)),t.shapeProperties&&!r.checkCoordinateOrigin(t.shapeProperties.coordinateOrigin)&&console.error("Invalid option for node coordinateOrigin, found: "+t.shapeProperties.coordinateOrigin),Nt(e,t,"shadow",a),t.color!==void 0&&t.color!==null){var u=Nc(t.color);zS(e.color,u)}else i===!0&&t.color===null&&(e.color=Gr(a.color));t.fixed!==void 0&&t.fixed!==null&&(typeof t.fixed=="boolean"?(e.fixed.x=t.fixed,e.fixed.y=t.fixed):(t.fixed.x!==void 0&&typeof t.fixed.x=="boolean"&&(e.fixed.x=t.fixed.x),t.fixed.y!==void 0&&typeof t.fixed.y=="boolean"&&(e.fixed.y=t.fixed.y))),i===!0&&t.font===null&&(e.font=Gr(a.font)),r.updateGroupOptions(e,t,o),t.scaling!==void 0&&Nt(e.scaling,t.scaling,"label",a.scaling)}},{key:"checkMass",value:function(e,t){if(e.mass!==void 0&&e.mass<=0){var i="";t!==void 0&&(i=" in node id: "+t),console.error("%cNegative or zero mass disallowed"+i+", setting mass to 1.",VS),e.mass=1}}}]),r}();function Rle(r,n){var e=typeof ri<"u"&&Wi(r)||r["@@iterator"];if(!e){if(ae(r)||(e=Dle(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function Dle(r,n){var e;if(r){if(typeof r=="string")return e$(r,n);var t=Ye(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Hi(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return e$(r,n)}}function e$(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}var Mle=function(){function r(n,e,t,i){var a,o=this;if(C(this,r),this.body=n,this.images=e,this.groups=t,this.layoutEngine=i,this.body.functions.createNode=O(a=this.create).call(a,this),this.nodesListeners={add:function(u,l){o.add(l.items)},update:function(u,l){o.update(l.items,l.data,l.oldData)},remove:function(u,l){o.remove(l.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:void 0,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},opacity:void 0,fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(u,l,h,d){if(l===u)return .5;var c=1/(l-u);return Math.max(0,(d-u)*c)}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1,coordinateOrigin:"center"},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=Gr(this.defaultOptions),this.bindEventListeners()}return x(r,[{key:"bindEventListeners",value:function(){var e,t,i=this;this.body.emitter.on("refreshNodes",O(e=this.refresh).call(e,this)),this.body.emitter.on("refresh",O(t=this.refresh).call(t,this)),this.body.emitter.on("destroy",function(){J(i.nodesListeners,function(a,o){i.body.data.nodes&&i.body.data.nodes.off(o,a)}),delete i.body.functions.createNode,delete i.nodesListeners.add,delete i.nodesListeners.update,delete i.nodesListeners.remove,delete i.nodesListeners})}},{key:"setOptions",value:function(e){if(e!==void 0){if(Pt.parseOptions(this.options,e),e.opacity!==void 0&&(jc(e.opacity)||!ci(e.opacity)||e.opacity<0||e.opacity>1?console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+e.opacity):this.options.opacity=e.opacity),e.shape!==void 0)for(var t in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,t)&&this.body.nodes[t].updateShape();if(typeof e.font<"u"||typeof e.widthConstraint<"u"||typeof e.heightConstraint<"u")for(var i=0,a=me(this.body.nodes);i<a.length;i++){var o=a[i];this.body.nodes[o].updateLabelModule(),this.body.nodes[o].needsRefresh()}if(e.size!==void 0)for(var s in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,s)&&this.body.nodes[s].needsRefresh();(e.hidden!==void 0||e.physics!==void 0)&&this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1,i=this.body.data.nodes;if(g_("id",e))this.body.data.nodes=e;else if(ae(e))this.body.data.nodes=new ru,this.body.data.nodes.add(e);else if(!e)this.body.data.nodes=new ru;else throw new TypeError("Array or DataSet expected");if(i&&J(this.nodesListeners,function(s,u){i.off(u,s)}),this.body.nodes={},this.body.data.nodes){var a=this;J(this.nodesListeners,function(s,u){a.body.data.nodes.on(u,s)});var o=this.body.data.nodes.getIds();this.add(o,!0)}t===!1&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(e){for(var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1,i,a=[],o=0;o<e.length;o++){i=e[o];var s=this.body.data.nodes.get(i),u=this.create(s);a.push(u),this.body.nodes[i]=u}this.layoutEngine.positionInitially(a),t===!1&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(e,t,i){for(var a=this.body.nodes,o=!1,s=0;s<e.length;s++){var u=e[s],l=a[u],h=t[s];l!==void 0?l.setOptions(h)&&(o=!0):(o=!0,l=this.create(h),a[u]=l)}!o&&i!==void 0&&(o=Ooe(t).call(t,function(d,c){var f=i[c];return f&&f.level!==d.level})),o===!0?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(e){for(var t=this.body.nodes,i=0;i<e.length;i++){var a=e[i];delete t[a]}this.body.emitter.emit("_dataChanged")}},{key:"create",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:Pt;return new t(e,this.body,this.images,this.groups,this.options,this.defaultOptions)}},{key:"refresh",value:function(){var e=this,t=arguments.length>0&&arguments[0]!==void 0?arguments[0]:!1;J(this.body.nodes,function(i,a){var o=e.body.data.nodes.get(a);o!==void 0&&(t===!0&&i.setOptions({x:null,y:null}),i.setOptions({fixed:!1}),i.setOptions(o))})}},{key:"getPositions",value:function(e){var t={};if(e!==void 0){if(ae(e)===!0){for(var i=0;i<e.length;i++)if(this.body.nodes[e[i]]!==void 0){var a=this.body.nodes[e[i]];t[e[i]]={x:Math.round(a.x),y:Math.round(a.y)}}}else if(this.body.nodes[e]!==void 0){var o=this.body.nodes[e];t[e]={x:Math.round(o.x),y:Math.round(o.y)}}}else for(var s=0;s<this.body.nodeIndices.length;s++){var u=this.body.nodes[this.body.nodeIndices[s]];t[this.body.nodeIndices[s]]={x:Math.round(u.x),y:Math.round(u.y)}}return t}},{key:"getPosition",value:function(e){if(e==null)throw new TypeError("No id was specified for getPosition method.");if(this.body.nodes[e]==null)throw new ReferenceError("NodeId provided for getPosition does not exist. Provided: ".concat(e));return{x:Math.round(this.body.nodes[e].x),y:Math.round(this.body.nodes[e].y)}}},{key:"storePositions",value:function(){var e=[],t=this.body.data.nodes.getDataSet(),i=Rle(t.get()),a;try{for(i.s();!(a=i.n()).done;){var o=a.value,s=o.id,u=this.body.nodes[s],l=Math.round(u.x),h=Math.round(u.y);(o.x!==l||o.y!==h)&&e.push({id:s,x:l,y:h})}}catch(d){i.e(d)}finally{i.f()}t.update(e)}},{key:"getBoundingBox",value:function(e){if(this.body.nodes[e]!==void 0)return this.body.nodes[e].shape.boundingBox}},{key:"getConnectedNodes",value:function(e,t){var i=[];if(this.body.nodes[e]!==void 0)for(var a=this.body.nodes[e],o={},s=0;s<a.edges.length;s++){var u=a.edges[s];t!=="to"&&u.toId==a.id?o[u.fromId]===void 0&&(i.push(u.fromId),o[u.fromId]=!0):t!=="from"&&u.fromId==a.id&&o[u.toId]===void 0&&(i.push(u.toId),o[u.toId]=!0)}return i}},{key:"getConnectedEdges",value:function(e){var t=[];if(this.body.nodes[e]!==void 0)for(var i=this.body.nodes[e],a=0;a<i.edges.length;a++)t.push(i.edges[a].id);else console.error("NodeId provided for getConnectedEdges does not exist. Provided: ",e);return t}},{key:"moveNode",value:function(e,t,i){var a=this;this.body.nodes[e]!==void 0?(this.body.nodes[e].x=Number(t),this.body.nodes[e].y=Number(i),or(function(){a.body.emitter.emit("startSimulation")},0)):console.error("Node id supplied to moveNode does not exist. Provided: ",e)}}]),r}(),t$=Ue,Nle=function(r){return r!==void 0&&(t$(r,"value")||t$(r,"writable"))},Fle=V,Ble=At,Lle=We,jle=Dt,zle=Nle,Hle=Xn,Wle=tl;function wO(r,n){var e=arguments.length<3?r:arguments[2],t,i;if(jle(r)===e)return r[n];if(t=Hle.f(r,n),t)return zle(t)?t.value:t.get===void 0?void 0:Ble(t.get,e);if(Lle(i=Wle(r)))return wO(i,n,e)}Fle({target:"Reflect",stat:!0},{get:wO});var Ule=te,Vle=Ule.Reflect.get,Gle=Vle,Kle=Gle,qle=Kle,Yle=qle,Xle=Yle,Qle=Xle,Jle=Qle,r$=L(Jle),Zle=hO,ehe=Zle,the=ehe,rhe=the,ihe=rhe,nhe=L(ihe);function ahe(r,n){for(;!Object.prototype.hasOwnProperty.call(r,n)&&(r=N(r),r!==null););return r}function Ls(){if(typeof Reflect<"u"&&r$){var r;Ls=_v(r=r$).call(r)}else Ls=function(e,t,i){var a=ahe(e,t);if(a){var o=nhe(a,t);return o.get?o.get.call(arguments.length<3?e:i):o.value}};return Ls.apply(this,arguments)}var ohe=V,i$=Math.hypot,she=Math.abs,uhe=Math.sqrt,lhe=!!i$&&i$(1/0,NaN)!==1/0;ohe({target:"Math",stat:!0,arity:2,forced:lhe},{hypot:function(n,e){for(var t=0,i=0,a=arguments.length,o=0,s,u;i<a;)s=she(arguments[i++]),o<s?(u=o/s,t=t*u*u+1,o=s):s>0?(u=s/o,t+=u*u):t+=s;return o===1/0?1/0:o*uhe(t)}});var hhe=te,dhe=hhe.Math.hypot,che=dhe,fhe=che,vhe=fhe,phe=L(vhe);function _O(r){var n=yhe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function yhe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Pe=function(){function r(){C(this,r)}return x(r,null,[{key:"transform",value:function(e,t){ae(e)||(e=[e]);for(var i=t.point.x,a=t.point.y,o=t.angle,s=t.length,u=0;u<e.length;++u){var l=e[u],h=l.x*Math.cos(o)-l.y*Math.sin(o),d=l.x*Math.sin(o)+l.y*Math.cos(o);l.x=i+s*h,l.y=a+s*d}}},{key:"drawPath",value:function(e,t){e.beginPath(),e.moveTo(t[0].x,t[0].y);for(var i=1;i<t.length;++i)e.lineTo(t[i].x,t[i].y);e.closePath()}}]),r}(),ghe=function(r){ie(e,r);var n=_O(e);function e(){return C(this,e),n.apply(this,arguments)}return x(e,null,[{key:"draw",value:function(i,a){if(a.image){i.save(),i.translate(a.point.x,a.point.y),i.rotate(Math.PI/2+a.angle);var o=a.imageWidth!=null?a.imageWidth:a.image.width,s=a.imageHeight!=null?a.imageHeight:a.image.height;a.image.drawImageAtPosition(i,1,-o/2,0,o,s),i.restore()}return!1}}]),e}(Pe),mhe=function(r){ie(e,r);var n=_O(e);function e(){return C(this,e),n.apply(this,arguments)}return x(e,null,[{key:"draw",value:function(i,a){var o=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return Pe.transform(o,a),Pe.drawPath(i,o),!0}}]),e}(Pe),bhe=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return Pe.transform(i,t),Pe.drawPath(e,i),!0}}]),r}(),$he=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i={x:-.4,y:0};Pe.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";var a=Math.PI,o=t.angle-a/2,s=t.angle+a/2;return e.beginPath(),e.arc(i.x,i.y,t.length*.4,o,s,!1),e.stroke(),!0}}]),r}(),whe=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i={x:-.3,y:0};Pe.transform(i,t),e.strokeStyle=e.fillStyle,e.fillStyle="rgba(0, 0, 0, 0)";var a=Math.PI,o=t.angle+a/2,s=t.angle+3*a/2;return e.beginPath(),e.arc(i.x,i.y,t.length*.4,o,s,!1),e.stroke(),!0}}]),r}(),_he=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return Pe.transform(i,t),Pe.drawPath(e,i),!0}}]),r}(),Ehe=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return Pe.transform(i,t),Pe.drawPath(e,i),!0}}]),r}(),She=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i={x:-.4,y:0};return Pe.transform(i,t),jf(e,i.x,i.y,t.length*.4),!0}}]),r}(),Ohe=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return Pe.transform(i,t),Pe.drawPath(e,i),!0}}]),r}(),The=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return Pe.transform(i,t),Pe.drawPath(e,i),!0}}]),r}(),Phe=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return Pe.transform(i,t),Pe.drawPath(e,i),!0}}]),r}(),Ihe=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return Pe.transform(i,t),Pe.drawPath(e,i),!0}}]),r}(),EO=function(){function r(){C(this,r)}return x(r,null,[{key:"draw",value:function(e,t){var i;switch(t.type&&(i=t.type.toLowerCase()),i){case"image":return ghe.draw(e,t);case"circle":return She.draw(e,t);case"box":return The.draw(e,t);case"crow":return bhe.draw(e,t);case"curve":return $he.draw(e,t);case"diamond":return Phe.draw(e,t);case"inv_curve":return whe.draw(e,t);case"triangle":return _he.draw(e,t);case"inv_triangle":return Ehe.draw(e,t);case"bar":return Ohe.draw(e,t);case"vee":return Ihe.draw(e,t);case"arrow":default:return mhe.draw(e,t)}}}]),r}();function n$(r,n){var e=me(r);if(Yr){var t=Yr(r);n&&(t=gt(t).call(t,function(i){return ii(r,i).enumerable})),e.push.apply(e,t)}return e}function a$(r){for(var n=1;n<arguments.length;n++){var e,t,i=arguments[n]!=null?arguments[n]:{};n%2?ue(e=n$(Object(i),!0)).call(e,function(a){ml(r,a,i[a])}):Xr?yl(r,Xr(i)):ue(t=n$(Object(i))).call(t,function(a){gl(r,a,ii(i,a))})}return r}var SO=function(){function r(n,e,t){C(this,r),this._body=e,this._labelModule=t,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(n),this.fromPoint=this.from,this.toPoint=this.to}return x(r,[{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}},{key:"cleanup",value:function(){return!1}},{key:"setOptions",value:function(e){this.options=e,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}},{key:"drawLine",value:function(e,t,i,a){var o=arguments.length>4&&arguments[4]!==void 0?arguments[4]:this.getViaNode();e.strokeStyle=this.getColor(e,t),e.lineWidth=t.width,t.dashes!==!1?this._drawDashedLine(e,t,o):this._drawLine(e,t,o)}},{key:"_drawLine",value:function(e,t,i,a,o){if(this.from!=this.to)this._line(e,t,i,a,o);else{var s=this._getCircleData(e),u=be(s,3),l=u[0],h=u[1],d=u[2];this._circle(e,t,l,h,d)}}},{key:"_drawDashedLine",value:function(e,t,i,a,o){e.lineCap="round";var s=ae(t.dashes)?t.dashes:[5,5];if(e.setLineDash!==void 0){if(e.save(),e.setLineDash(s),e.lineDashOffset=0,this.from!=this.to)this._line(e,t,i);else{var u=this._getCircleData(e),l=be(u,3),h=l[0],d=l[1],c=l[2];this._circle(e,t,h,d,c)}e.setLineDash([0]),e.lineDashOffset=0,e.restore()}else{if(this.from!=this.to)j_(e,this.from.x,this.from.y,this.to.x,this.to.y,s);else{var f=this._getCircleData(e),v=be(f,3),p=v[0],y=v[1],g=v[2];this._circle(e,t,p,y,g)}this.enableShadow(e,t),e.stroke(),this.disableShadow(e,t)}}},{key:"findBorderPosition",value:function(e,t,i){return this.from!=this.to?this._findBorderPosition(e,t,i):this._findBorderPositionCircle(e,t,i)}},{key:"findBorderPositions",value:function(e){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,e),to:this._findBorderPosition(this.to,e)};var t,i=Ye(t=this._getCircleData(e)).call(t,0,2),a=be(i,2),o=a[0],s=a[1];return{from:this._findBorderPositionCircle(this.from,e,{x:o,y:s,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,e,{x:o,y:s,low:.6,high:.8,direction:1})}}},{key:"_getCircleData",value:function(e){var t=this.options.selfReference.size;e!==void 0&&this.from.shape.width===void 0&&this.from.shape.resize(e);var i=pO(e,this.options.selfReference.angle,t,this.from);return[i.x,i.y,t]}},{key:"_pointOnCircle",value:function(e,t,i,a){var o=a*2*Math.PI;return{x:e+i*Math.cos(o),y:t-i*Math.sin(o)}}},{key:"_findBorderPositionCircle",value:function(e,t,i){var a=i.x,o=i.y,s=i.low,u=i.high,l=i.direction,h=10,d=this.options.selfReference.size,c=.05,f,v=(s+u)*.5,p=0;this.options.arrowStrikethrough===!0&&(l===-1?p=this.options.endPointOffset.from:l===1&&(p=this.options.endPointOffset.to));var y=0;do{v=(s+u)*.5,f=this._pointOnCircle(a,o,d,v);var g=Math.atan2(e.y-f.y,e.x-f.x),m=e.distanceToBorder(t,g)+p,w=Math.sqrt(Math.pow(f.x-e.x,2)+Math.pow(f.y-e.y,2)),$=m-w;if(Math.abs($)<c)break;$>0?l>0?s=v:u=v:l>0?u=v:s=v,++y}while(s<=u&&y<h);return a$(a$({},f),{},{t:v})}},{key:"getLineWidth",value:function(e,t){return e===!0?Math.max(this.selectionWidth,.3/this._body.view.scale):t===!0?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}},{key:"getColor",value:function(e,t){if(t.inheritsColor!==!1){if(t.inheritsColor==="both"&&this.from.id!==this.to.id){var i=e.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y),a=this.from.options.color.highlight.border,o=this.to.options.color.highlight.border;return this.from.selected===!1&&this.to.selected===!1?(a=Ft(this.from.options.color.border,t.opacity),o=Ft(this.to.options.color.border,t.opacity)):this.from.selected===!0&&this.to.selected===!1?o=this.to.options.color.border:this.from.selected===!1&&this.to.selected===!0&&(a=this.from.options.color.border),i.addColorStop(0,a),i.addColorStop(1,o),i}return t.inheritsColor==="to"?Ft(this.to.options.color.border,t.opacity):Ft(this.from.options.color.border,t.opacity)}else return Ft(t.color,t.opacity)}},{key:"_circle",value:function(e,t,i,a,o){this.enableShadow(e,t);var s=0,u=Math.PI*2;if(!this.options.selfReference.renderBehindTheNode){var l=this.options.selfReference.angle,h=this.options.selfReference.angle+Math.PI,d=this._findBorderPositionCircle(this.from,e,{x:i,y:a,low:l,high:h,direction:-1}),c=this._findBorderPositionCircle(this.from,e,{x:i,y:a,low:l,high:h,direction:1});s=Math.atan2(d.y-a,d.x-i),u=Math.atan2(c.y-a,c.x-i)}e.beginPath(),e.arc(i,a,o,s,u,!1),e.stroke(),this.disableShadow(e,t)}},{key:"getDistanceToEdge",value:function(e,t,i,a,o,s){if(this.from!=this.to)return this._getDistanceToEdge(e,t,i,a,o,s);var u=this._getCircleData(void 0),l=be(u,3),h=l[0],d=l[1],c=l[2],f=h-o,v=d-s;return Math.abs(Math.sqrt(f*f+v*v)-c)}},{key:"_getDistanceToLine",value:function(e,t,i,a,o,s){var u=i-e,l=a-t,h=u*u+l*l,d=((o-e)*u+(s-t)*l)/h;d>1?d=1:d<0&&(d=0);var c=e+d*u,f=t+d*l,v=c-o,p=f-s;return Math.sqrt(v*v+p*p)}},{key:"getArrowData",value:function(e,t,i,a,o,s){var u,l,h,d,c,f,v,p=s.width;t==="from"?(h=this.from,d=this.to,c=s.fromArrowScale<0,f=Math.abs(s.fromArrowScale),v=s.fromArrowType):t==="to"?(h=this.to,d=this.from,c=s.toArrowScale<0,f=Math.abs(s.toArrowScale),v=s.toArrowType):(h=this.to,d=this.from,c=s.middleArrowScale<0,f=Math.abs(s.middleArrowScale),v=s.middleArrowType);var y=15*f+3*p;if(h!=d){var g=phe(h.x-d.x,h.y-d.y),m=y/g;if(t!=="middle")if(this.options.smooth.enabled===!0){var w=this._findBorderPosition(h,e,{via:i}),$=this.getPoint(w.t+m*(t==="from"?1:-1),i);u=Math.atan2(w.y-$.y,w.x-$.x),l=w}else u=Math.atan2(h.y-d.y,h.x-d.x),l=this._findBorderPosition(h,e);else{var E=(c?-m:m)/2,k=this.getPoint(.5+E,i),D=this.getPoint(.5-E,i);u=Math.atan2(k.y-D.y,k.x-D.x),l=this.getPoint(.5,i)}}else{var j=this._getCircleData(e),R=be(j,3),M=R[0],W=R[1],X=R[2];if(t==="from"){var Y=this.options.selfReference.angle,ye=this.options.selfReference.angle+Math.PI,Ge=this._findBorderPositionCircle(this.from,e,{x:M,y:W,low:Y,high:ye,direction:-1});u=Ge.t*-2*Math.PI+1.5*Math.PI+.1*Math.PI,l=Ge}else if(t==="to"){var ke=this.options.selfReference.angle,St=this.options.selfReference.angle+Math.PI,rt=this._findBorderPositionCircle(this.from,e,{x:M,y:W,low:ke,high:St,direction:1});u=rt.t*-2*Math.PI+1.5*Math.PI-1.1*Math.PI,l=rt}else{var Qe=this.options.selfReference.angle/(2*Math.PI);l=this._pointOnCircle(M,W,X,Qe),u=Qe*-2*Math.PI+1.5*Math.PI+.1*Math.PI}}var Ot=l.x-y*.9*Math.cos(u),Je=l.y-y*.9*Math.sin(u),ce={x:Ot,y:Je};return{point:l,core:ce,angle:u,length:y,type:v}}},{key:"drawArrowHead",value:function(e,t,i,a,o){e.strokeStyle=this.getColor(e,t),e.fillStyle=e.strokeStyle,e.lineWidth=t.width;var s=EO.draw(e,o);s&&(this.enableShadow(e,t),Do(e).call(e),this.disableShadow(e,t))}},{key:"enableShadow",value:function(e,t){t.shadow===!0&&(e.shadowColor=t.shadowColor,e.shadowBlur=t.shadowSize,e.shadowOffsetX=t.shadowX,e.shadowOffsetY=t.shadowY)}},{key:"disableShadow",value:function(e,t){t.shadow===!0&&(e.shadowColor="rgba(0,0,0,0)",e.shadowBlur=0,e.shadowOffsetX=0,e.shadowOffsetY=0)}},{key:"drawBackground",value:function(e,t){if(t.background!==!1){var i={strokeStyle:e.strokeStyle,lineWidth:e.lineWidth,dashes:e.dashes};e.strokeStyle=t.backgroundColor,e.lineWidth=t.backgroundSize,this.setStrokeDashed(e,t.backgroundDashes),e.stroke(),e.strokeStyle=i.strokeStyle,e.lineWidth=i.lineWidth,e.dashes=i.dashes,this.setStrokeDashed(e,t.dashes)}}},{key:"setStrokeDashed",value:function(e,t){if(t!==!1)if(e.setLineDash!==void 0){var i=ae(t)?t:[5,5];e.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else e.setLineDash!==void 0?e.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}]),r}();function o$(r,n){var e=me(r);if(Yr){var t=Yr(r);n&&(t=gt(t).call(t,function(i){return ii(r,i).enumerable})),e.push.apply(e,t)}return e}function s$(r){for(var n=1;n<arguments.length;n++){var e,t,i=arguments[n]!=null?arguments[n]:{};n%2?ue(e=o$(Object(i),!0)).call(e,function(a){ml(r,a,i[a])}):Xr?yl(r,Xr(i)):ue(t=o$(Object(i))).call(t,function(a){gl(r,a,ii(i,a))})}return r}function khe(r){var n=Che();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Che(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Sv=function(r){ie(e,r);var n=khe(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"_findBorderPositionBezier",value:function(i,a){var o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:this._getViaCoordinates(),s=10,u=.2,l=!1,h=1,d=0,c=this.to,f,v,p=this.options.endPointOffset?this.options.endPointOffset.to:0;i.id===this.from.id&&(c=this.from,l=!0,p=this.options.endPointOffset?this.options.endPointOffset.from:0),this.options.arrowStrikethrough===!1&&(p=0);var y=0;do{v=(d+h)*.5,f=this.getPoint(v,o);var g=Math.atan2(c.y-f.y,c.x-f.x),m=c.distanceToBorder(a,g)+p,w=Math.sqrt(Math.pow(f.x-c.x,2)+Math.pow(f.y-c.y,2)),$=m-w;if(Math.abs($)<u)break;$<0?l===!1?d=v:h=v:l===!1?h=v:d=v,++y}while(d<=h&&y<s);return s$(s$({},f),{},{t:v})}},{key:"_getDistanceToBezierEdge",value:function(i,a,o,s,u,l,h){var d=1e9,c,f,v,p,y,g=i,m=a;for(f=1;f<10;f++)v=.1*f,p=Math.pow(1-v,2)*i+2*v*(1-v)*h.x+Math.pow(v,2)*o,y=Math.pow(1-v,2)*a+2*v*(1-v)*h.y+Math.pow(v,2)*s,f>0&&(c=this._getDistanceToLine(g,m,p,y,u,l),d=c<d?c:d),g=p,m=y;return d}},{key:"_bezierCurve",value:function(i,a,o,s){i.beginPath(),i.moveTo(this.fromPoint.x,this.fromPoint.y),o!=null&&o.x!=null?s!=null&&s.x!=null?i.bezierCurveTo(o.x,o.y,s.x,s.y,this.toPoint.x,this.toPoint.y):i.quadraticCurveTo(o.x,o.y,this.toPoint.x,this.toPoint.y):i.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(i,a),this.enableShadow(i,a),i.stroke(),this.disableShadow(i,a)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}}]),e}(SO);function xhe(r){var n=Ahe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Ahe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var u$=function(r){ie(e,r);var n=xhe(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o.via=o.via,o._boundFunction=function(){o.positionBezierNode()},o._body.emitter.on("_repositionBezierNodes",o._boundFunction),o}return x(e,[{key:"setOptions",value:function(i){Ls(N(e.prototype),"setOptions",this).call(this,i);var a=!1;this.options.physics!==i.physics&&(a=!0),this.options=i,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),a===!0&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}},{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.from===void 0||this.to===void 0||this.options.physics===!1?this.via.setOptions({physics:!1}):this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}},{key:"cleanup",value:function(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),this.via!==void 0?(delete this._body.nodes[this.via.id],this.via=void 0,!0):!1}},{key:"setupSupportNode",value:function(){if(this.via===void 0){var i="edgeId:"+this.id,a=this._body.functions.createNode({id:i,shape:"circle",physics:!0,hidden:!0});this._body.nodes[i]=a,this.via=a,this.via.parentEdgeId=this.id,this.positionBezierNode()}}},{key:"positionBezierNode",value:function(){this.via!==void 0&&this.from!==void 0&&this.to!==void 0?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):this.via!==void 0&&(this.via.x=0,this.via.y=0)}},{key:"_line",value:function(i,a,o){this._bezierCurve(i,a,o)}},{key:"_getViaCoordinates",value:function(){return this.via}},{key:"getViaNode",value:function(){return this.via}},{key:"getPoint",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.via;if(this.from===this.to){var o=this._getCircleData(),s=be(o,3),u=s[0],l=s[1],h=s[2],d=2*Math.PI*(1-i);return{x:u+h*Math.sin(d),y:l+h-h*(1-Math.cos(d))}}else return{x:Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*a.x+Math.pow(i,2)*this.toPoint.x,y:Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*a.y+Math.pow(i,2)*this.toPoint.y}}},{key:"_findBorderPosition",value:function(i,a){return this._findBorderPositionBezier(i,a,this.via)}},{key:"_getDistanceToEdge",value:function(i,a,o,s,u,l){return this._getDistanceToBezierEdge(i,a,o,s,u,l,this.via)}}]),e}(Sv);function Rhe(r){var n=Dhe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Dhe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var l$=function(r){ie(e,r);var n=Rhe(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"_line",value:function(i,a,o){this._bezierCurve(i,a,o)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_getViaCoordinates",value:function(){var i=this.options.smooth.roundness,a=this.options.smooth.type,o=Math.abs(this.from.x-this.to.x),s=Math.abs(this.from.y-this.to.y);if(a==="discrete"||a==="diagonalCross"){var u,l;o<=s?u=l=i*s:u=l=i*o,this.from.x>this.to.x&&(u=-u),this.from.y>=this.to.y&&(l=-l);var h=this.from.x+u,d=this.from.y+l;return a==="discrete"&&(o<=s?h=o<i*s?this.from.x:h:d=s<i*o?this.from.y:d),{x:h,y:d}}else if(a==="straightCross"){var c=(1-i)*o,f=(1-i)*s;return o<=s?(c=0,this.from.y<this.to.y&&(f=-f)):(this.from.x<this.to.x&&(c=-c),f=0),{x:this.to.x+c,y:this.to.y+f}}else if(a==="horizontal"){var v=(1-i)*o;return this.from.x<this.to.x&&(v=-v),{x:this.to.x+v,y:this.from.y}}else if(a==="vertical"){var p=(1-i)*s;return this.from.y<this.to.y&&(p=-p),{x:this.from.x,y:this.to.y+p}}else if(a==="curvedCW"){o=this.to.x-this.from.x,s=this.from.y-this.to.y;var y=Math.sqrt(o*o+s*s),g=Math.PI,m=Math.atan2(s,o),w=(m+(i*.5+.5)*g)%(2*g);return{x:this.from.x+(i*.5+.5)*y*Math.sin(w),y:this.from.y+(i*.5+.5)*y*Math.cos(w)}}else if(a==="curvedCCW"){o=this.to.x-this.from.x,s=this.from.y-this.to.y;var $=Math.sqrt(o*o+s*s),E=Math.PI,k=Math.atan2(s,o),D=(k+(-i*.5+.5)*E)%(2*E);return{x:this.from.x+(i*.5+.5)*$*Math.sin(D),y:this.from.y+(i*.5+.5)*$*Math.cos(D)}}else{var j,R;o<=s?j=R=i*s:j=R=i*o,this.from.x>this.to.x&&(j=-j),this.from.y>=this.to.y&&(R=-R);var M=this.from.x+j,W=this.from.y+R;return o<=s?this.from.x<=this.to.x?M=this.to.x<M?this.to.x:M:M=this.to.x>M?this.to.x:M:this.from.y>=this.to.y?W=this.to.y>W?this.to.y:W:W=this.to.y<W?this.to.y:W,{x:M,y:W}}}},{key:"_findBorderPosition",value:function(i,a){var o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:{};return this._findBorderPositionBezier(i,a,o.via)}},{key:"_getDistanceToEdge",value:function(i,a,o,s,u,l){var h=arguments.length>6&&arguments[6]!==void 0?arguments[6]:this._getViaCoordinates();return this._getDistanceToBezierEdge(i,a,o,s,u,l,h)}},{key:"getPoint",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this._getViaCoordinates(),o=i,s=Math.pow(1-o,2)*this.fromPoint.x+2*o*(1-o)*a.x+Math.pow(o,2)*this.toPoint.x,u=Math.pow(1-o,2)*this.fromPoint.y+2*o*(1-o)*a.y+Math.pow(o,2)*this.toPoint.y;return{x:s,y:u}}}]),e}(Sv);function Mhe(r){var n=Nhe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Nhe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Fhe=function(r){ie(e,r);var n=Mhe(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"_getDistanceToBezierEdge2",value:function(i,a,o,s,u,l,h,d){for(var c=1e9,f=i,v=a,p=[0,0,0,0],y=1;y<10;y++){var g=.1*y;p[0]=Math.pow(1-g,3),p[1]=3*g*Math.pow(1-g,2),p[2]=3*Math.pow(g,2)*(1-g),p[3]=Math.pow(g,3);var m=p[0]*i+p[1]*h.x+p[2]*d.x+p[3]*o,w=p[0]*a+p[1]*h.y+p[2]*d.y+p[3]*s;if(y>0){var $=this._getDistanceToLine(f,v,m,w,u,l);c=$<c?$:c}f=m,v=w}return c}}]),e}(Sv);function Bhe(r){var n=Lhe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Lhe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var h$=function(r){ie(e,r);var n=Bhe(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"_line",value:function(i,a,o){var s=o[0],u=o[1];this._bezierCurve(i,a,s,u)}},{key:"_getViaCoordinates",value:function(){var i=this.from.x-this.to.x,a=this.from.y-this.to.y,o,s,u,l,h=this.options.smooth.roundness;return(Math.abs(i)>Math.abs(a)||this.options.smooth.forceDirection===!0||this.options.smooth.forceDirection==="horizontal")&&this.options.smooth.forceDirection!=="vertical"?(s=this.from.y,l=this.to.y,o=this.from.x-h*i,u=this.to.x+h*i):(s=this.from.y-h*a,l=this.to.y+h*a,o=this.from.x,u=this.to.x),[{x:o,y:s},{x:u,y:l}]}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_findBorderPosition",value:function(i,a){return this._findBorderPositionBezier(i,a)}},{key:"_getDistanceToEdge",value:function(i,a,o,s,u,l){var h=arguments.length>6&&arguments[6]!==void 0?arguments[6]:this._getViaCoordinates(),d=be(h,2),c=d[0],f=d[1];return this._getDistanceToBezierEdge2(i,a,o,s,u,l,c,f)}},{key:"getPoint",value:function(i){var a=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this._getViaCoordinates(),o=be(a,2),s=o[0],u=o[1],l=i,h=[Math.pow(1-l,3),3*l*Math.pow(1-l,2),3*Math.pow(l,2)*(1-l),Math.pow(l,3)],d=h[0]*this.fromPoint.x+h[1]*s.x+h[2]*u.x+h[3]*this.toPoint.x,c=h[0]*this.fromPoint.y+h[1]*s.y+h[2]*u.y+h[3]*this.toPoint.y;return{x:d,y:c}}}]),e}(Fhe);function jhe(r){var n=zhe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function zhe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var d$=function(r){ie(e,r);var n=jhe(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"_line",value:function(i,a){i.beginPath(),i.moveTo(this.fromPoint.x,this.fromPoint.y),i.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(i,a),i.stroke(),this.disableShadow(i,a)}},{key:"getViaNode",value:function(){}},{key:"getPoint",value:function(i){return{x:(1-i)*this.fromPoint.x+i*this.toPoint.x,y:(1-i)*this.fromPoint.y+i*this.toPoint.y}}},{key:"_findBorderPosition",value:function(i,a){var o=this.to,s=this.from;i.id===this.from.id&&(o=this.from,s=this.to);var u=Math.atan2(o.y-s.y,o.x-s.x),l=o.x-s.x,h=o.y-s.y,d=Math.sqrt(l*l+h*h),c=i.distanceToBorder(a,u),f=(d-c)/d;return{x:(1-f)*s.x+f*o.x,y:(1-f)*s.y+f*o.y,t:0}}},{key:"_getDistanceToEdge",value:function(i,a,o,s,u,l){return this._getDistanceToLine(i,a,o,s,u,l)}}]),e}(SO),wn=function(){function r(n,e,t,i,a){if(C(this,r),e===void 0)throw new Error("No body provided");this.options=Gr(i),this.globalOptions=i,this.defaultOptions=a,this.body=e,this.imagelist=t,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new gO(this.body,this.options,!0),this.setOptions(n)}return x(r,[{key:"setOptions",value:function(e){if(e){var t=typeof e.physics<"u"&&this.options.physics!==e.physics||typeof e.hidden<"u"&&(this.options.hidden||!1)!==(e.hidden||!1)||typeof e.from<"u"&&this.options.from!==e.from||typeof e.to<"u"&&this.options.to!==e.to;r.parseOptions(this.options,e,!0,this.globalOptions),e.id!==void 0&&(this.id=e.id),e.from!==void 0&&(this.fromId=e.from),e.to!==void 0&&(this.toId=e.to),e.title!==void 0&&(this.title=e.title),e.value!==void 0&&(e.value=vO(e.value));var i=[e,this.options,this.defaultOptions];return this.chooser=$v("edge",i),this.updateLabelModule(e),t=this.updateEdgeType()||t,this._setInteractionWidths(),this.connect(),t}}},{key:"getFormattingValues",value:function(){var e=this.options.arrows.to===!0||this.options.arrows.to.enabled===!0,t=this.options.arrows.from===!0||this.options.arrows.from.enabled===!0,i=this.options.arrows.middle===!0||this.options.arrows.middle.enabled===!0,a=this.options.color.inherit,o={toArrow:e,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:t,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:a?void 0:this.options.color.color,inheritsColor:a,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(this.chooser===!0){if(this.selected){var s=this.options.selectionWidth;typeof s=="function"?o.width=s(o.width):typeof s=="number"&&(o.width+=s),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.highlight,o.shadow=this.options.shadow.enabled}else if(this.hover){var u=this.options.hoverWidth;typeof u=="function"?o.width=u(o.width):typeof u=="number"&&(o.width+=u),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.hover,o.shadow=this.options.shadow.enabled}}else typeof this.chooser=="function"&&(this.chooser(o,this.options.id,this.selected,this.hover),o.color!==void 0&&(o.inheritsColor=!1),o.shadow===!1&&(o.shadowColor!==this.options.shadow.color||o.shadowSize!==this.options.shadow.size||o.shadowX!==this.options.shadow.x||o.shadowY!==this.options.shadow.y)&&(o.shadow=!0));else o.shadow=this.options.shadow.enabled,o.width=Math.max(o.width,.3/this.body.view.scale);return o}},{key:"updateLabelModule",value:function(e){var t=[e,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,t),this.labelModule.baseSize!==void 0&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateEdgeType",value:function(){var e=this.options.smooth,t=!1,i=!0;return this.edgeType!==void 0&&((this.edgeType instanceof u$&&e.enabled===!0&&e.type==="dynamic"||this.edgeType instanceof h$&&e.enabled===!0&&e.type==="cubicBezier"||this.edgeType instanceof l$&&e.enabled===!0&&e.type!=="dynamic"&&e.type!=="cubicBezier"||this.edgeType instanceof d$&&e.type.enabled===!1)&&(i=!1),i===!0&&(t=this.cleanup())),i===!0?e.enabled===!0?e.type==="dynamic"?(t=!0,this.edgeType=new u$(this.options,this.body,this.labelModule)):e.type==="cubicBezier"?this.edgeType=new h$(this.options,this.body,this.labelModule):this.edgeType=new l$(this.options,this.body,this.labelModule):this.edgeType=new d$(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),t}},{key:"connect",value:function(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=this.from!==void 0&&this.to!==void 0,this.connected===!0?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}},{key:"disconnect",value:function(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}},{key:"getTitle",value:function(){return this.title}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"setValueRange",value:function(e,t,i){if(this.options.value!==void 0){var a=this.options.scaling.customScalingFunction(e,t,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(this.options.scaling.label.enabled===!0){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+a*s}this.options.width=this.options.scaling.min+a*o}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}},{key:"_setInteractionWidths",value:function(){typeof this.options.hoverWidth=="function"?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,typeof this.options.selectionWidth=="function"?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}},{key:"draw",value:function(e){var t=this.getFormattingValues();if(!t.hidden){var i=this.edgeType.getViaNode();this.edgeType.drawLine(e,t,this.selected,this.hover,i),this.drawLabel(e,i)}}},{key:"drawArrows",value:function(e){var t=this.getFormattingValues();if(!t.hidden){var i=this.edgeType.getViaNode(),a={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,t.fromArrow&&(a.from=this.edgeType.getArrowData(e,"from",i,this.selected,this.hover,t),t.arrowStrikethrough===!1&&(this.edgeType.fromPoint=a.from.core),t.fromArrowSrc&&(a.from.image=this.imagelist.load(t.fromArrowSrc)),t.fromArrowImageWidth&&(a.from.imageWidth=t.fromArrowImageWidth),t.fromArrowImageHeight&&(a.from.imageHeight=t.fromArrowImageHeight)),t.toArrow&&(a.to=this.edgeType.getArrowData(e,"to",i,this.selected,this.hover,t),t.arrowStrikethrough===!1&&(this.edgeType.toPoint=a.to.core),t.toArrowSrc&&(a.to.image=this.imagelist.load(t.toArrowSrc)),t.toArrowImageWidth&&(a.to.imageWidth=t.toArrowImageWidth),t.toArrowImageHeight&&(a.to.imageHeight=t.toArrowImageHeight)),t.middleArrow&&(a.middle=this.edgeType.getArrowData(e,"middle",i,this.selected,this.hover,t),t.middleArrowSrc&&(a.middle.image=this.imagelist.load(t.middleArrowSrc)),t.middleArrowImageWidth&&(a.middle.imageWidth=t.middleArrowImageWidth),t.middleArrowImageHeight&&(a.middle.imageHeight=t.middleArrowImageHeight)),t.fromArrow&&this.edgeType.drawArrowHead(e,t,this.selected,this.hover,a.from),t.middleArrow&&this.edgeType.drawArrowHead(e,t,this.selected,this.hover,a.middle),t.toArrow&&this.edgeType.drawArrowHead(e,t,this.selected,this.hover,a.to)}}},{key:"drawLabel",value:function(e,t){if(this.options.label!==void 0){var i=this.from,a=this.to;this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(e,this.selected,this.hover);var o;if(i.id!=a.id){this.labelModule.pointToSelf=!1,o=this.edgeType.getPoint(.5,t),e.save();var s=this._getRotation(e);s.angle!=0&&(e.translate(s.x,s.y),e.rotate(s.angle)),this.labelModule.draw(e,o.x,o.y,this.selected,this.hover),e.restore()}else{this.labelModule.pointToSelf=!0;var u=pO(e,this.options.selfReference.angle,this.options.selfReference.size,i);o=this._pointOnCircle(u.x,u.y,this.options.selfReference.size,this.options.selfReference.angle),this.labelModule.draw(e,o.x,o.y,this.selected,this.hover)}}}},{key:"getItemsOnPoint",value:function(e){var t=[];if(this.labelModule.visible()){var i=this._getRotation();zc(this.labelModule.getSize(),e,i)&&t.push({edgeId:this.id,labelId:0})}var a={left:e.x,top:e.y};return this.isOverlappingWith(a)&&t.push({edgeId:this.id}),t}},{key:"isOverlappingWith",value:function(e){if(this.connected){var t=10,i=this.from.x,a=this.from.y,o=this.to.x,s=this.to.y,u=e.left,l=e.top,h=this.edgeType.getDistanceToEdge(i,a,o,s,u,l);return h<t}else return!1}},{key:"_getRotation",value:function(e){var t=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,t);e!==void 0&&this.labelModule.calculateLabelSize(e,this.selected,this.hover,i.x,i.y);var a={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible()||this.options.font.align==="horizontal")return a;var o=this.from.y-this.to.y,s=this.from.x-this.to.x,u=Math.atan2(o,s);return(u<-1&&s<0||u>0&&s<0)&&(u+=Math.PI),a.angle=u,a}},{key:"_pointOnCircle",value:function(e,t,i,a){return{x:e+i*Math.cos(a),y:t-i*Math.sin(a)}}},{key:"select",value:function(){this.selected=!0}},{key:"unselect",value:function(){this.selected=!1}},{key:"cleanup",value:function(){return this.edgeType.cleanup()}},{key:"remove",value:function(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}},{key:"endPointsValid",value:function(){return this.body.nodes[this.fromId]!==void 0&&this.body.nodes[this.toId]!==void 0}}],[{key:"parseOptions",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1,a=arguments.length>3&&arguments[3]!==void 0?arguments[3]:{},o=arguments.length>4&&arguments[4]!==void 0?arguments[4]:!1,s=["endPointOffset","arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","selfReference","to","title","value","width","font","chosen","widthConstraint"];if(ua(s,e,t,i),t.endPointOffset!==void 0&&t.endPointOffset.from!==void 0&&(ci(t.endPointOffset.from)?e.endPointOffset.from=t.endPointOffset.from:(e.endPointOffset.from=a.endPointOffset.from!==void 0?a.endPointOffset.from:0,console.error("endPointOffset.from is not a valid number"))),t.endPointOffset!==void 0&&t.endPointOffset.to!==void 0&&(ci(t.endPointOffset.to)?e.endPointOffset.to=t.endPointOffset.to:(e.endPointOffset.to=a.endPointOffset.to!==void 0?a.endPointOffset.to:0,console.error("endPointOffset.to is not a valid number"))),vu(t.label)?e.label=t.label:vu(e.label)||(e.label=void 0),Nt(e,t,"smooth",a),Nt(e,t,"shadow",a),Nt(e,t,"background",a),t.dashes!==void 0&&t.dashes!==null?e.dashes=t.dashes:i===!0&&t.dashes===null&&(e.dashes=$i(a.dashes)),t.scaling!==void 0&&t.scaling!==null?(t.scaling.min!==void 0&&(e.scaling.min=t.scaling.min),t.scaling.max!==void 0&&(e.scaling.max=t.scaling.max),Nt(e.scaling,t.scaling,"label",a.scaling)):i===!0&&t.scaling===null&&(e.scaling=$i(a.scaling)),t.arrows!==void 0&&t.arrows!==null)if(typeof t.arrows=="string"){var u=t.arrows.toLowerCase();e.arrows.to.enabled=Z(u).call(u,"to")!=-1,e.arrows.middle.enabled=Z(u).call(u,"middle")!=-1,e.arrows.from.enabled=Z(u).call(u,"from")!=-1}else if(se(t.arrows)==="object")Nt(e.arrows,t.arrows,"to",a.arrows),Nt(e.arrows,t.arrows,"middle",a.arrows),Nt(e.arrows,t.arrows,"from",a.arrows);else throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+Ro(t.arrows));else i===!0&&t.arrows===null&&(e.arrows=$i(a.arrows));if(t.color!==void 0&&t.color!==null){var l=bn(t.color)?{color:t.color,highlight:t.color,hover:t.color,inherit:!1,opacity:1}:t.color,h=e.color;if(o)he(h,a.color,!1,i);else for(var d in h)Object.prototype.hasOwnProperty.call(h,d)&&delete h[d];if(bn(h))h.color=h,h.highlight=h,h.hover=h,h.inherit=!1,l.opacity===void 0&&(h.opacity=1);else{var c=!1;l.color!==void 0&&(h.color=l.color,c=!0),l.highlight!==void 0&&(h.highlight=l.highlight,c=!0),l.hover!==void 0&&(h.hover=l.hover,c=!0),l.inherit!==void 0&&(h.inherit=l.inherit),l.opacity!==void 0&&(h.opacity=Math.min(1,Math.max(0,l.opacity))),c===!0?h.inherit=!1:h.inherit===void 0&&(h.inherit="from")}}else i===!0&&t.color===null&&(e.color=Gr(a.color));i===!0&&t.font===null&&(e.font=Gr(a.font)),Object.prototype.hasOwnProperty.call(t,"selfReferenceSize")&&(console.warn("The selfReferenceSize property has been deprecated. Please use selfReference property instead. The selfReference can be set like thise selfReference:{size:30, angle:Math.PI / 4}"),e.selfReference.size=t.selfReferenceSize)}}]),r}(),Hhe=function(){function r(n,e,t){var i,a=this;C(this,r),this.body=n,this.images=e,this.groups=t,this.body.functions.createEdge=O(i=this.create).call(i,this),this.edgesListeners={add:function(s,u){a.add(u.items)},update:function(s,u){a.update(u.items)},remove:function(s,u){a.remove(u.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},endPointOffset:{from:0,to:0},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(s,u,l,h){if(u===s)return .5;var d=1/(u-s);return Math.max(0,(h-s)*d)}},selectionWidth:1.5,selfReference:{size:20,angle:Math.PI/4,renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},he(this.options,this.defaultOptions),this.bindEventListeners()}return x(r,[{key:"bindEventListeners",value:function(){var e=this,t,i;this.body.emitter.on("_forceDisableDynamicCurves",function(a){var o=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;a==="dynamic"&&(a="continuous");var s=!1;for(var u in e.body.edges)if(Object.prototype.hasOwnProperty.call(e.body.edges,u)){var l=e.body.edges[u],h=e.body.data.edges.get(u);if(h!=null){var d=h.smooth;d!==void 0&&d.enabled===!0&&d.type==="dynamic"&&(a===void 0?l.setOptions({smooth:!1}):l.setOptions({smooth:{type:a}}),s=!0)}}o===!0&&s===!0&&e.body.emitter.emit("_dataChanged")}),this.body.emitter.on("_dataUpdated",function(){e.reconnectEdges()}),this.body.emitter.on("refreshEdges",O(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",O(i=this.refresh).call(i,this)),this.body.emitter.on("destroy",function(){J(e.edgesListeners,function(a,o){e.body.data.edges&&e.body.data.edges.off(o,a)}),delete e.body.functions.createEdge,delete e.edgesListeners.add,delete e.edgesListeners.update,delete e.edgesListeners.remove,delete e.edgesListeners})}},{key:"setOptions",value:function(e){if(e!==void 0){wn.parseOptions(this.options,e,!0,this.defaultOptions,!0);var t=!1;if(e.smooth!==void 0)for(var i in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,i)&&(t=this.body.edges[i].updateEdgeType()||t);if(e.font!==void 0)for(var a in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,a)&&this.body.edges[a].updateLabelModule();(e.hidden!==void 0||e.physics!==void 0||t===!0)&&this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(e){var t=this,i=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1,a=this.body.data.edges;if(g_("id",e))this.body.data.edges=e;else if(ae(e))this.body.data.edges=new ru,this.body.data.edges.add(e);else if(!e)this.body.data.edges=new ru;else throw new TypeError("Array or DataSet expected");if(a&&J(this.edgesListeners,function(s,u){a.off(u,s)}),this.body.edges={},this.body.data.edges){J(this.edgesListeners,function(s,u){t.body.data.edges.on(u,s)});var o=this.body.data.edges.getIds();this.add(o,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),i===!1&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(e){for(var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1,i=this.body.edges,a=this.body.data.edges,o=0;o<e.length;o++){var s=e[o],u=i[s];u&&u.disconnect();var l=a.get(s,{showInternalIds:!0});i[s]=this.create(l)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),t===!1&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(e){for(var t=this.body.edges,i=this.body.data.edges,a=!1,o=0;o<e.length;o++){var s=e[o],u=i.get(s),l=t[s];l!==void 0?(l.disconnect(),a=l.setOptions(u)||a,l.connect()):(this.body.edges[s]=this.create(u),a=!0)}a===!0?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;if(e.length!==0){var i=this.body.edges;J(e,function(a){var o=i[a];o!==void 0&&o.remove()}),t&&this.body.emitter.emit("_dataChanged")}}},{key:"refresh",value:function(){var e=this;J(this.body.edges,function(t,i){var a=e.body.data.edges.get(i);a!==void 0&&t.setOptions(a)})}},{key:"create",value:function(e){return new wn(e,this.body,this.images,this.options,this.defaultOptions)}},{key:"reconnectEdges",value:function(){var e,t=this.body.nodes,i=this.body.edges;for(e in t)Object.prototype.hasOwnProperty.call(t,e)&&(t[e].edges=[]);for(e in i)if(Object.prototype.hasOwnProperty.call(i,e)){var a=i[e];a.from=null,a.to=null,a.connect()}}},{key:"getConnectedNodes",value:function(e){var t=[];if(this.body.edges[e]!==void 0){var i=this.body.edges[e];i.fromId!==void 0&&t.push(i.fromId),i.toId!==void 0&&t.push(i.toId)}return t}},{key:"_updateState",value:function(){this._addMissingEdges(),this._removeInvalidEdges()}},{key:"_removeInvalidEdges",value:function(){var e=this,t=[];J(this.body.edges,function(i,a){var o=e.body.nodes[i.toId],s=e.body.nodes[i.fromId];o!==void 0&&o.isCluster===!0||s!==void 0&&s.isCluster===!0||(o===void 0||s===void 0)&&t.push(a)}),this.remove(t,!1)}},{key:"_addMissingEdges",value:function(){var e=this.body.data.edges;if(e!=null){var t=this.body.edges,i=[];ue(e).call(e,function(a,o){var s=t[o];s===void 0&&i.push(o)}),this.add(i,!0)}}}]),r}(),OO=function(){function r(n,e,t){C(this,r),this.body=n,this.physicsBody=e,this.barnesHutTree,this.setOptions(t),this._rng=vl("BARNES HUT SOLVER")}return x(r,[{key:"setOptions",value:function(e){this.options=e,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}},{key:"solve",value:function(){if(this.options.gravitationalConstant!==0&&this.physicsBody.physicsNodeIndices.length>0){var e,t=this.body.nodes,i=this.physicsBody.physicsNodeIndices,a=i.length,o=this._formBarnesHutTree(t,i);this.barnesHutTree=o;for(var s=0;s<a;s++)e=t[i[s]],e.options.mass>0&&this._getForceContributions(o.root,e)}}},{key:"_getForceContributions",value:function(e,t){this._getForceContribution(e.children.NW,t),this._getForceContribution(e.children.NE,t),this._getForceContribution(e.children.SW,t),this._getForceContribution(e.children.SE,t)}},{key:"_getForceContribution",value:function(e,t){if(e.childrenCount>0){var i=e.centerOfMass.x-t.x,a=e.centerOfMass.y-t.y,o=Math.sqrt(i*i+a*a);o*e.calcSize>this.thetaInversed?this._calculateForces(o,i,a,t,e):e.childrenCount===4?this._getForceContributions(e,t):e.children.data.id!=t.id&&this._calculateForces(o,i,a,t,e)}}},{key:"_calculateForces",value:function(e,t,i,a,o){e===0&&(e=.1,t=e),this.overlapAvoidanceFactor<1&&a.shape.radius&&(e=Math.max(.1+this.overlapAvoidanceFactor*a.shape.radius,e-a.shape.radius));var s=this.options.gravitationalConstant*o.mass*a.options.mass/Math.pow(e,3),u=t*s,l=i*s;this.physicsBody.forces[a.id].x+=u,this.physicsBody.forces[a.id].y+=l}},{key:"_formBarnesHutTree",value:function(e,t){for(var i,a=t.length,o=e[t[0]].x,s=e[t[0]].y,u=e[t[0]].x,l=e[t[0]].y,h=1;h<a;h++){var d=e[t[h]],c=d.x,f=d.y;d.options.mass>0&&(c<o&&(o=c),c>u&&(u=c),f<s&&(s=f),f>l&&(l=f))}var v=Math.abs(u-o)-Math.abs(l-s);v>0?(s-=.5*v,l+=.5*v):(o+=.5*v,u-=.5*v);var p=1e-5,y=Math.max(p,Math.abs(u-o)),g=.5*y,m=.5*(o+u),w=.5*(s+l),$={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:m-g,maxX:m+g,minY:w-g,maxY:w+g},size:y,calcSize:1/y,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch($.root);for(var E=0;E<a;E++)i=e[t[E]],i.options.mass>0&&this._placeInTree($.root,i);return $}},{key:"_updateBranchMass",value:function(e,t){var i=e.centerOfMass,a=e.mass+t.options.mass,o=1/a;i.x=i.x*e.mass+t.x*t.options.mass,i.x*=o,i.y=i.y*e.mass+t.y*t.options.mass,i.y*=o,e.mass=a;var s=Math.max(Math.max(t.height,t.radius),t.width);e.maxWidth=e.maxWidth<s?s:e.maxWidth}},{key:"_placeInTree",value:function(e,t,i){(i!=!0||i===void 0)&&this._updateBranchMass(e,t);var a=e.children.NW.range,o;a.maxX>t.x?a.maxY>t.y?o="NW":o="SW":a.maxY>t.y?o="NE":o="SE",this._placeInRegion(e,t,o)}},{key:"_placeInRegion",value:function(e,t,i){var a=e.children[i];switch(a.childrenCount){case 0:a.children.data=t,a.childrenCount=1,this._updateBranchMass(a,t);break;case 1:a.children.data.x===t.x&&a.children.data.y===t.y?(t.x+=this._rng(),t.y+=this._rng()):(this._splitBranch(a),this._placeInTree(a,t));break;case 4:this._placeInTree(a,t);break}}},{key:"_splitBranch",value:function(e){var t=null;e.childrenCount===1&&(t=e.children.data,e.mass=0,e.centerOfMass.x=0,e.centerOfMass.y=0),e.childrenCount=4,e.children.data=null,this._insertRegion(e,"NW"),this._insertRegion(e,"NE"),this._insertRegion(e,"SW"),this._insertRegion(e,"SE"),t!=null&&this._placeInTree(e,t)}},{key:"_insertRegion",value:function(e,t){var i,a,o,s,u=.5*e.size;switch(t){case"NW":i=e.range.minX,a=e.range.minX+u,o=e.range.minY,s=e.range.minY+u;break;case"NE":i=e.range.minX+u,a=e.range.maxX,o=e.range.minY,s=e.range.minY+u;break;case"SW":i=e.range.minX,a=e.range.minX+u,o=e.range.minY+u,s=e.range.maxY;break;case"SE":i=e.range.minX+u,a=e.range.maxX,o=e.range.minY+u,s=e.range.maxY;break}e.children[t]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:a,minY:o,maxY:s},size:.5*e.size,calcSize:2*e.calcSize,children:{data:null},maxWidth:0,level:e.level+1,childrenCount:0}}},{key:"_debug",value:function(e,t){this.barnesHutTree!==void 0&&(e.lineWidth=1,this._drawBranch(this.barnesHutTree.root,e,t))}},{key:"_drawBranch",value:function(e,t,i){i===void 0&&(i="#FF0000"),e.childrenCount===4&&(this._drawBranch(e.children.NW,t),this._drawBranch(e.children.NE,t),this._drawBranch(e.children.SE,t),this._drawBranch(e.children.SW,t)),t.strokeStyle=i,t.beginPath(),t.moveTo(e.range.minX,e.range.minY),t.lineTo(e.range.maxX,e.range.minY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.minY),t.lineTo(e.range.maxX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.maxX,e.range.maxY),t.lineTo(e.range.minX,e.range.maxY),t.stroke(),t.beginPath(),t.moveTo(e.range.minX,e.range.maxY),t.lineTo(e.range.minX,e.range.minY),t.stroke()}}]),r}(),Whe=function(){function r(n,e,t){C(this,r),this._rng=vl("REPULSION SOLVER"),this.body=n,this.physicsBody=e,this.setOptions(t)}return x(r,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,a,o,s,u,l,h=this.body.nodes,d=this.physicsBody.physicsNodeIndices,c=this.physicsBody.forces,f=this.options.nodeDistance,v=-2/3/f,p=4/3,y=0;y<d.length-1;y++){u=h[d[y]];for(var g=y+1;g<d.length;g++)l=h[d[g]],e=l.x-u.x,t=l.y-u.y,i=Math.sqrt(e*e+t*t),i===0&&(i=.1*this._rng(),e=i),i<2*f&&(i<.5*f?s=1:s=v*i+p,s=s/i,a=e*s,o=t*s,c[u.id].x-=a,c[u.id].y-=o,c[l.id].x+=a,c[l.id].y+=o)}}}]),r}(),Uhe=function(){function r(n,e,t){C(this,r),this.body=n,this.physicsBody=e,this.setOptions(t)}return x(r,[{key:"setOptions",value:function(e){this.options=e,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}},{key:"solve",value:function(){for(var e=this.body.nodes,t=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,a=this.options.nodeDistance,o=0;o<t.length-1;o++)for(var s=e[t[o]],u=o+1;u<t.length;u++){var l=e[t[u]];if(s.level===l.level){var h=a+this.overlapAvoidanceFactor*((s.shape.radius||0)/2+(l.shape.radius||0)/2),d=l.x-s.x,c=l.y-s.y,f=Math.sqrt(d*d+c*c),v=.05,p=void 0;f<h?p=-Math.pow(v*f,2)+Math.pow(v*h,2):p=0,f!==0&&(p=p/f);var y=d*p,g=c*p;i[s.id].x-=y,i[s.id].y-=g,i[l.id].x+=y,i[l.id].y+=g}}}}]),r}(),Od=function(){function r(n,e,t){C(this,r),this.body=n,this.physicsBody=e,this.setOptions(t)}return x(r,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i=this.physicsBody.physicsEdgeIndices,a=this.body.edges,o,s,u,l=0;l<i.length;l++)t=a[i[l]],t.connected===!0&&t.toId!==t.fromId&&this.body.nodes[t.toId]!==void 0&&this.body.nodes[t.fromId]!==void 0&&(t.edgeType.via!==void 0?(e=t.options.length===void 0?this.options.springLength:t.options.length,o=t.to,s=t.edgeType.via,u=t.from,this._calculateSpringForce(o,s,.5*e),this._calculateSpringForce(s,u,.5*e)):(e=t.options.length===void 0?this.options.springLength*1.5:t.options.length,this._calculateSpringForce(t.from,t.to,e)))}},{key:"_calculateSpringForce",value:function(e,t,i){var a=e.x-t.x,o=e.y-t.y,s=Math.max(Math.sqrt(a*a+o*o),.01),u=this.options.springConstant*(i-s)/s,l=a*u,h=o*u;this.physicsBody.forces[e.id]!==void 0&&(this.physicsBody.forces[e.id].x+=l,this.physicsBody.forces[e.id].y+=h),this.physicsBody.forces[t.id]!==void 0&&(this.physicsBody.forces[t.id].x-=l,this.physicsBody.forces[t.id].y-=h)}}]),r}(),Vhe=function(){function r(n,e,t){C(this,r),this.body=n,this.physicsBody=e,this.setOptions(t)}return x(r,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,a,o,s,u,l,h=this.body.edges,d=.5,c=this.physicsBody.physicsEdgeIndices,f=this.physicsBody.physicsNodeIndices,v=this.physicsBody.forces,p=0;p<f.length;p++){var y=f[p];v[y].springFx=0,v[y].springFy=0}for(var g=0;g<c.length;g++)t=h[c[g]],t.connected===!0&&(e=t.options.length===void 0?this.options.springLength:t.options.length,i=t.from.x-t.to.x,a=t.from.y-t.to.y,l=Math.sqrt(i*i+a*a),l=l===0?.01:l,u=this.options.springConstant*(e-l)/l,o=i*u,s=a*u,t.to.level!=t.from.level?(v[t.toId]!==void 0&&(v[t.toId].springFx-=o,v[t.toId].springFy-=s),v[t.fromId]!==void 0&&(v[t.fromId].springFx+=o,v[t.fromId].springFy+=s)):(v[t.toId]!==void 0&&(v[t.toId].x-=d*o,v[t.toId].y-=d*s),v[t.fromId]!==void 0&&(v[t.fromId].x+=d*o,v[t.fromId].y+=d*s)));u=1;for(var m,w,$=0;$<f.length;$++){var E=f[$];m=Math.min(u,Math.max(-u,v[E].springFx)),w=Math.min(u,Math.max(-u,v[E].springFy)),v[E].x+=m,v[E].y+=w}for(var k=0,D=0,j=0;j<f.length;j++){var R=f[j];k+=v[R].x,D+=v[R].y}for(var M=k/f.length,W=D/f.length,X=0;X<f.length;X++){var Y=f[X];v[Y].x-=M,v[Y].y-=W}}}]),r}(),js=function(){function r(n,e,t){C(this,r),this.body=n,this.physicsBody=e,this.setOptions(t)}return x(r,[{key:"setOptions",value:function(e){this.options=e}},{key:"solve",value:function(){for(var e,t,i,a,o=this.body.nodes,s=this.physicsBody.physicsNodeIndices,u=this.physicsBody.forces,l=0;l<s.length;l++){var h=s[l];a=o[h],e=-a.x,t=-a.y,i=Math.sqrt(e*e+t*t),this._calculateForces(i,e,t,u,a)}}},{key:"_calculateForces",value:function(e,t,i,a,o){var s=e===0?0:this.options.centralGravity/e;a[o.id].x=t*s,a[o.id].y=i*s}}]),r}();function Ghe(r){var n=Khe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Khe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var qhe=function(r){ie(e,r);var n=Ghe(e);function e(t,i,a){var o;return C(this,e),o=n.call(this,t,i,a),o._rng=vl("FORCE ATLAS 2 BASED REPULSION SOLVER"),o}return x(e,[{key:"_calculateForces",value:function(i,a,o,s,u){i===0&&(i=.1*this._rng(),a=i),this.overlapAvoidanceFactor<1&&s.shape.radius&&(i=Math.max(.1+this.overlapAvoidanceFactor*s.shape.radius,i-s.shape.radius));var l=s.edges.length+1,h=this.options.gravitationalConstant*u.mass*s.options.mass*l/Math.pow(i,2),d=a*h,c=o*h;this.physicsBody.forces[s.id].x+=d,this.physicsBody.forces[s.id].y+=c}}]),e}(OO);function Yhe(r){var n=Xhe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function Xhe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var Qhe=function(r){ie(e,r);var n=Yhe(e);function e(t,i,a){return C(this,e),n.call(this,t,i,a)}return x(e,[{key:"_calculateForces",value:function(i,a,o,s,u){if(i>0){var l=u.edges.length+1,h=this.options.centralGravity*l*u.options.mass;s[u.id].x=a*h,s[u.id].y=o*h}}}]),e}(js),Jhe=function(){function r(n){C(this,r),this.body=n,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0,wind:{x:0,y:0}},Ae(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}return x(r,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("initPhysics",function(){e.initPhysics()}),this.body.emitter.on("_layoutFailed",function(){e.layoutFailed=!0}),this.body.emitter.on("resetPhysics",function(){e.stopSimulation(),e.ready=!1}),this.body.emitter.on("disablePhysics",function(){e.physicsEnabled=!1,e.stopSimulation()}),this.body.emitter.on("restorePhysics",function(){e.setOptions(e.options),e.ready===!0&&e.startSimulation()}),this.body.emitter.on("startSimulation",function(){e.ready===!0&&e.startSimulation()}),this.body.emitter.on("stopSimulation",function(){e.stopSimulation()}),this.body.emitter.on("destroy",function(){e.stopSimulation(!1),e.body.emitter.off()}),this.body.emitter.on("_dataChanged",function(){e.updatePhysicsData()})}},{key:"setOptions",value:function(e){if(e!==void 0)if(e===!1)this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation();else if(e===!0)this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation();else{this.physicsEnabled=!0,du(["stabilization"],this.options,e),Nt(this.options,e,"stabilization"),e.enabled===void 0&&(this.options.enabled=!0),this.options.enabled===!1&&(this.physicsEnabled=!1,this.stopSimulation());var t=this.options.wind;t&&((typeof t.x!="number"||jc(t.x))&&(t.x=0),(typeof t.y!="number"||jc(t.y))&&(t.y=0)),this.timestep=this.options.timestep}this.init()}},{key:"init",value:function(){var e;this.options.solver==="forceAtlas2Based"?(e=this.options.forceAtlas2Based,this.nodesSolver=new qhe(this.body,this.physicsBody,e),this.edgesSolver=new Od(this.body,this.physicsBody,e),this.gravitySolver=new Qhe(this.body,this.physicsBody,e)):this.options.solver==="repulsion"?(e=this.options.repulsion,this.nodesSolver=new Whe(this.body,this.physicsBody,e),this.edgesSolver=new Od(this.body,this.physicsBody,e),this.gravitySolver=new js(this.body,this.physicsBody,e)):this.options.solver==="hierarchicalRepulsion"?(e=this.options.hierarchicalRepulsion,this.nodesSolver=new Uhe(this.body,this.physicsBody,e),this.edgesSolver=new Vhe(this.body,this.physicsBody,e),this.gravitySolver=new js(this.body,this.physicsBody,e)):(e=this.options.barnesHut,this.nodesSolver=new OO(this.body,this.physicsBody,e),this.edgesSolver=new Od(this.body,this.physicsBody,e),this.gravitySolver=new js(this.body,this.physicsBody,e)),this.modelOptions=e}},{key:"initPhysics",value:function(){this.physicsEnabled===!0&&this.options.enabled===!0?this.options.stabilization.enabled===!0?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}},{key:"startSimulation",value:function(){if(this.physicsEnabled===!0&&this.options.enabled===!0){if(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),this.viewFunction===void 0){var e;this.viewFunction=O(e=this.simulationStep).call(e,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering")}}else this.body.emitter.emit("_redraw")}},{key:"stopSimulation",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:!0;this.stabilized=!0,e===!0&&this._emitStabilized(),this.viewFunction!==void 0&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,e===!0&&this.body.emitter.emit("_stopRendering"))}},{key:"simulationStep",value:function(){var e=su();this.physicsTick();var t=su()-e;(t<.4*this.simulationInterval||this.runDoubleSpeed===!0)&&this.stabilized===!1&&(this.physicsTick(),this.runDoubleSpeed=!0),this.stabilized===!0&&this.stopSimulation()}},{key:"_emitStabilized",value:function(){var e=this,t=arguments.length>0&&arguments[0]!==void 0?arguments[0]:this.stabilizationIterations;(this.stabilizationIterations>1||this.startedStabilization===!0)&&or(function(){e.body.emitter.emit("stabilized",{iterations:t}),e.startedStabilization=!1,e.stabilizationIterations=0},0)}},{key:"physicsStep",value:function(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}},{key:"adjustTimeStep",value:function(){var e=1.2;this._evaluateStepQuality()===!0?this.timestep=e*this.timestep:this.timestep/e<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/e))}},{key:"physicsTick",value:function(){if(this._startStabilizing(),this.stabilized!==!0){if(this.adaptiveTimestep===!0&&this.adaptiveTimestepEnabled===!0){var e=this.adaptiveCounter%this.adaptiveInterval===0;e?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1}else this.timestep=this.options.timestep,this.physicsStep();this.stabilized===!0&&this.revert(),this.stabilizationIterations++}}},{key:"updatePhysicsData",value:function(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];var e=this.body.nodes,t=this.body.edges;for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&e[i].options.physics===!0&&this.physicsBody.physicsNodeIndices.push(e[i].id);for(var a in t)Object.prototype.hasOwnProperty.call(t,a)&&t[a].options.physics===!0&&this.physicsBody.physicsEdgeIndices.push(t[a].id);for(var o=0;o<this.physicsBody.physicsNodeIndices.length;o++){var s=this.physicsBody.physicsNodeIndices[o];this.physicsBody.forces[s]={x:0,y:0},this.physicsBody.velocities[s]===void 0&&(this.physicsBody.velocities[s]={x:0,y:0})}for(var u in this.physicsBody.velocities)e[u]===void 0&&delete this.physicsBody.velocities[u]}},{key:"revert",value:function(){var e=me(this.previousStates),t=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(var a=0;a<e.length;a++){var o=e[a];t[o]!==void 0?t[o].options.physics===!0&&(this.referenceState[o]={positions:{x:t[o].x,y:t[o].y}},i[o].x=this.previousStates[o].vx,i[o].y=this.previousStates[o].vy,t[o].x=this.previousStates[o].x,t[o].y=this.previousStates[o].y):delete this.previousStates[o]}}},{key:"_evaluateStepQuality",value:function(){var e,t,i,a=this.body.nodes,o=this.referenceState,s=.3;for(var u in this.referenceState)if(Object.prototype.hasOwnProperty.call(this.referenceState,u)&&a[u]!==void 0&&(e=a[u].x-o[u].positions.x,t=a[u].y-o[u].positions.y,i=Math.sqrt(Math.pow(e,2)+Math.pow(t,2)),i>s))return!1;return!0}},{key:"moveNodes",value:function(){for(var e=this.physicsBody.physicsNodeIndices,t=0,i=0,a=5,o=0;o<e.length;o++){var s=e[o],u=this._performStep(s);t=Math.max(t,u),i+=u}this.adaptiveTimestepEnabled=i/e.length<a,this.stabilized=t<this.options.minVelocity}},{key:"calculateComponentVelocity",value:function(e,t,i){var a=this.modelOptions.damping*e,o=(t-a)/i;e+=o*this.timestep;var s=this.options.maxVelocity||1e9;return Math.abs(e)>s&&(e=e>0?s:-s),e}},{key:"_performStep",value:function(e){var t=this.body.nodes[e],i=this.physicsBody.forces[e];this.options.wind&&(i.x+=this.options.wind.x,i.y+=this.options.wind.y);var a=this.physicsBody.velocities[e];this.previousStates[e]={x:t.x,y:t.y,vx:a.x,vy:a.y},t.options.fixed.x===!1?(a.x=this.calculateComponentVelocity(a.x,i.x,t.options.mass),t.x+=a.x*this.timestep):(i.x=0,a.x=0),t.options.fixed.y===!1?(a.y=this.calculateComponentVelocity(a.y,i.y,t.options.mass),t.y+=a.y*this.timestep):(i.y=0,a.y=0);var o=Math.sqrt(Math.pow(a.x,2)+Math.pow(a.y,2));return o}},{key:"_freezeNodes",value:function(){var e=this.body.nodes;for(var t in e)if(Object.prototype.hasOwnProperty.call(e,t)&&e[t].x&&e[t].y){var i=e[t].options.fixed;this.freezeCache[t]={x:i.x,y:i.y},i.x=!0,i.y=!0}}},{key:"_restoreFrozenNodes",value:function(){var e=this.body.nodes;for(var t in e)Object.prototype.hasOwnProperty.call(e,t)&&this.freezeCache[t]!==void 0&&(e[t].options.fixed.x=this.freezeCache[t].x,e[t].options.fixed.y=this.freezeCache[t].y);this.freezeCache={}}},{key:"stabilize",value:function(){var e=this,t=arguments.length>0&&arguments[0]!==void 0?arguments[0]:this.options.stabilization.iterations;if(typeof t!="number"&&(t=this.options.stabilization.iterations,console.error("The stabilize method needs a numeric amount of iterations. Switching to default: ",t)),this.physicsBody.physicsNodeIndices.length===0){this.ready=!0;return}this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=t,this.options.stabilization.onlyDynamicEdges===!0&&this._freezeNodes(),this.stabilizationIterations=0,or(function(){return e._stabilizationBatch()},0)}},{key:"_startStabilizing",value:function(){return this.startedStabilization===!0?!1:(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}},{key:"_stabilizationBatch",value:function(){var e=this,t=function(){return e.stabilized===!1&&e.stabilizationIterations<e.targetIterations},i=function(){e.body.emitter.emit("stabilizationProgress",{iterations:e.stabilizationIterations,total:e.targetIterations})};this._startStabilizing()&&i();for(var a=0;t()&&a<this.options.stabilization.updateInterval;)this.physicsTick(),a++;if(i(),t()){var o;or(O(o=this._stabilizationBatch).call(o,this),0)}else this._finalizeStabilization()}},{key:"_finalizeStabilization",value:function(){this.body.emitter.emit("_allowRedraw"),this.options.stabilization.fit===!0&&this.body.emitter.emit("fit"),this.options.stabilization.onlyDynamicEdges===!0&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),this.stabilized===!0?this._emitStabilized():this.startSimulation(),this.ready=!0}},{key:"_drawForces",value:function(e){for(var t=0;t<this.physicsBody.physicsNodeIndices.length;t++){var i=this.physicsBody.physicsNodeIndices[t],a=this.body.nodes[i],o=this.physicsBody.forces[i],s=20,u=.03,l=Math.sqrt(Math.pow(o.x,2)+Math.pow(o.x,2)),h=Math.min(Math.max(5,l),15),d=3*h,c=Fc((180-Math.min(1,Math.max(0,u*l))*180)/360,1,1),f={x:a.x+s*o.x,y:a.y+s*o.y};e.lineWidth=h,e.strokeStyle=c,e.beginPath(),e.moveTo(a.x,a.y),e.lineTo(f.x,f.y),e.stroke();var v=Math.atan2(o.y,o.x);e.fillStyle=c,EO.draw(e,{type:"arrow",point:f,angle:v,length:d}),Do(e).call(e)}}}]),r}();let bs;const Zhe=new Uint8Array(16);function ede(){if(!bs&&(bs=typeof crypto<"u"&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto),!bs))throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return bs(Zhe)}const qe=[];for(let r=0;r<256;++r)qe.push((r+256).toString(16).slice(1));function tde(r,n=0){return qe[r[n+0]]+qe[r[n+1]]+qe[r[n+2]]+qe[r[n+3]]+"-"+qe[r[n+4]]+qe[r[n+5]]+"-"+qe[r[n+6]]+qe[r[n+7]]+"-"+qe[r[n+8]]+qe[r[n+9]]+"-"+qe[r[n+10]]+qe[r[n+11]]+qe[r[n+12]]+qe[r[n+13]]+qe[r[n+14]]+qe[r[n+15]]}const rde=typeof crypto<"u"&&crypto.randomUUID&&crypto.randomUUID.bind(crypto);var c$={randomUUID:rde};function Ia(r,n,e){if(c$.randomUUID&&!n&&!r)return c$.randomUUID();r=r||{};const t=r.random||(r.rng||ede)();return t[6]=t[6]&15|64,t[8]=t[8]&63|128,tde(t)}var ot=function(){function r(){C(this,r)}return x(r,null,[{key:"getRange",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:[],i=1e9,a=-1e9,o=1e9,s=-1e9,u;if(t.length>0)for(var l=0;l<t.length;l++)u=e[t[l]],o>u.shape.boundingBox.left&&(o=u.shape.boundingBox.left),s<u.shape.boundingBox.right&&(s=u.shape.boundingBox.right),i>u.shape.boundingBox.top&&(i=u.shape.boundingBox.top),a<u.shape.boundingBox.bottom&&(a=u.shape.boundingBox.bottom);return o===1e9&&s===-1e9&&i===1e9&&a===-1e9&&(i=0,a=0,o=0,s=0),{minX:o,maxX:s,minY:i,maxY:a}}},{key:"getRangeCore",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:[],i=1e9,a=-1e9,o=1e9,s=-1e9,u;if(t.length>0)for(var l=0;l<t.length;l++)u=e[t[l]],o>u.x&&(o=u.x),s<u.x&&(s=u.x),i>u.y&&(i=u.y),a<u.y&&(a=u.y);return o===1e9&&s===-1e9&&i===1e9&&a===-1e9&&(i=0,a=0,o=0,s=0),{minX:o,maxX:s,minY:i,maxY:a}}},{key:"findCenter",value:function(e){return{x:.5*(e.maxX+e.minX),y:.5*(e.maxY+e.minY)}}},{key:"cloneOptions",value:function(e,t){var i={};return t===void 0||t==="node"?(he(i,e.options,!0),i.x=e.x,i.y=e.y,i.amountOfConnections=e.edges.length):he(i,e.options,!0),i}}]),r}();function ide(r){var n=nde();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function nde(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var ade=function(r){ie(e,r);var n=ide(e);function e(t,i,a,o,s,u){var l;return C(this,e),l=n.call(this,t,i,a,o,s,u),l.isCluster=!0,l.containedNodes={},l.containedEdges={},l}return x(e,[{key:"_openChildCluster",value:function(i){var a=this,o=this.body.nodes[i];if(this.containedNodes[i]===void 0)throw new Error("node with id: "+i+" not in current cluster");if(!o.isCluster)throw new Error("node with id: "+i+" is not a cluster");delete this.containedNodes[i],J(o.edges,function(s){delete a.containedEdges[s.id]}),J(o.containedNodes,function(s,u){a.containedNodes[u]=s}),o.containedNodes={},J(o.containedEdges,function(s,u){a.containedEdges[u]=s}),o.containedEdges={},J(o.edges,function(s){J(a.edges,function(u){var l,h,d=Z(l=u.clusteringEdgeReplacingIds).call(l,s.id);d!==-1&&(J(s.clusteringEdgeReplacingIds,function(c){u.clusteringEdgeReplacingIds.push(c),a.body.edges[c].edgeReplacedById=u.id}),br(h=u.clusteringEdgeReplacingIds).call(h,d,1))})}),o.edges=[]}}]),e}(Pt),ode=function(){function r(n){var e=this;C(this,r),this.body=n,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},Ae(this.options,this.defaultOptions),this.body.emitter.on("_resetData",function(){e.clusteredNodes={},e.clusteredEdges={}})}return x(r,[{key:"clusterByHubsize",value:function(e,t){e===void 0?e=this._getHubSize():se(e)==="object"&&(t=this._checkOptions(e),e=this._getHubSize());for(var i=[],a=0;a<this.body.nodeIndices.length;a++){var o=this.body.nodes[this.body.nodeIndices[a]];o.edges.length>=e&&i.push(o.id)}for(var s=0;s<i.length;s++)this.clusterByConnection(i[s],t,!0);this.body.emitter.emit("_dataChanged")}},{key:"cluster",value:function(){var e=this,t=arguments.length>0&&arguments[0]!==void 0?arguments[0]:{},i=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;if(t.joinCondition===void 0)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");t=this._checkOptions(t);var a={},o={};J(this.body.nodes,function(s,u){s.options&&t.joinCondition(s.options)===!0&&(a[u]=s,J(s.edges,function(l){e.clusteredEdges[l.id]===void 0&&(o[l.id]=l)}))}),this._cluster(a,o,t,i)}},{key:"clusterByEdgeCount",value:function(e,t){var i=this,a=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!0;t=this._checkOptions(t);for(var o=[],s={},u,l,h,d=function(){var p={},y={},g=i.body.nodeIndices[c],m=i.body.nodes[g];if(s[g]===void 0){h=0,l=[];for(var w=0;w<m.edges.length;w++)u=m.edges[w],i.clusteredEdges[u.id]===void 0&&(u.toId!==u.fromId&&h++,l.push(u));if(h===e){for(var $=function(Y){if(t.joinCondition===void 0||t.joinCondition===null)return!0;var ye=ot.cloneOptions(Y);return t.joinCondition(ye)},E=!0,k=0;k<l.length;k++){u=l[k];var D=i._getConnectedId(u,g);if($(m))y[u.id]=u,p[g]=m,p[D]=i.body.nodes[D],s[g]=!0;else{E=!1;break}}if(me(p).length>0&&me(y).length>0&&E===!0){var j=function(){for(var Y=0;Y<o.length;++Y)for(var ye in p)if(o[Y].nodes[ye]!==void 0)return o[Y]},R=j();if(R!==void 0){for(var M in p)R.nodes[M]===void 0&&(R.nodes[M]=p[M]);for(var W in y)R.edges[W]===void 0&&(R.edges[W]=y[W])}else o.push({nodes:p,edges:y})}}}},c=0;c<this.body.nodeIndices.length;c++)d();for(var f=0;f<o.length;f++)this._cluster(o[f].nodes,o[f].edges,t,!1);a===!0&&this.body.emitter.emit("_dataChanged")}},{key:"clusterOutliers",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;this.clusterByEdgeCount(1,e,t)}},{key:"clusterBridges",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;this.clusterByEdgeCount(2,e,t)}},{key:"clusterByConnection",value:function(e,t){var i,a=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!0;if(e===void 0)throw new Error("No nodeId supplied to clusterByConnection!");if(this.body.nodes[e]===void 0)throw new Error("The nodeId given to clusterByConnection does not exist!");var o=this.body.nodes[e];t=this._checkOptions(t,o),t.clusterNodeProperties.x===void 0&&(t.clusterNodeProperties.x=o.x),t.clusterNodeProperties.y===void 0&&(t.clusterNodeProperties.y=o.y),t.clusterNodeProperties.fixed===void 0&&(t.clusterNodeProperties.fixed={},t.clusterNodeProperties.fixed.x=o.options.fixed.x,t.clusterNodeProperties.fixed.y=o.options.fixed.y);var s={},u={},l=o.id,h=ot.cloneOptions(o);s[l]=o;for(var d=0;d<o.edges.length;d++){var c=o.edges[d];if(this.clusteredEdges[c.id]===void 0){var f=this._getConnectedId(c,l);if(this.clusteredNodes[f]===void 0)if(f!==l)if(t.joinCondition===void 0)u[c.id]=c,s[f]=this.body.nodes[f];else{var v=ot.cloneOptions(this.body.nodes[f]);t.joinCondition(h,v)===!0&&(u[c.id]=c,s[f]=this.body.nodes[f])}else u[c.id]=c}}var p=xn(i=me(s)).call(i,function($){return s[$].id});for(var y in s)if(Object.prototype.hasOwnProperty.call(s,y))for(var g=s[y],m=0;m<g.edges.length;m++){var w=g.edges[m];Z(p).call(p,this._getConnectedId(w,g.id))>-1&&(u[w.id]=w)}this._cluster(s,u,t,a)}},{key:"_createClusterEdges",value:function(e,t,i,a){for(var o,s,u,l,h,d,c=me(e),f=[],v=0;v<c.length;v++){s=c[v],u=e[s];for(var p=0;p<u.edges.length;p++)o=u.edges[p],this.clusteredEdges[o.id]===void 0&&(o.toId==o.fromId?t[o.id]=o:o.toId==s?(l=i.id,h=o.fromId,d=h):(l=o.toId,h=i.id,d=l),e[d]===void 0&&f.push({edge:o,fromId:h,toId:l}))}for(var y=[],g=function(D){for(var j=0;j<y.length;j++){var R=y[j],M=D.fromId===R.fromId&&D.toId===R.toId,W=D.fromId===R.toId&&D.toId===R.fromId;if(M||W)return R}return null},m=0;m<f.length;m++){var w=f[m],$=w.edge,E=g(w);E===null?(E=this._createClusteredEdge(w.fromId,w.toId,$,a),y.push(E)):E.clusteringEdgeReplacingIds.push($.id),this.body.edges[$.id].edgeReplacedById=E.id,this._backupEdgeOptions($),$.setOptions({physics:!1})}}},{key:"_checkOptions",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:{};return e.clusterEdgeProperties===void 0&&(e.clusterEdgeProperties={}),e.clusterNodeProperties===void 0&&(e.clusterNodeProperties={}),e}},{key:"_cluster",value:function(e,t,i){var a=arguments.length>3&&arguments[3]!==void 0?arguments[3]:!0,o=[];for(var s in e)Object.prototype.hasOwnProperty.call(e,s)&&this.clusteredNodes[s]!==void 0&&o.push(s);for(var u=0;u<o.length;++u)delete e[o[u]];if(me(e).length!=0&&!(me(e).length==1&&i.clusterNodeProperties.allowSingleNodeCluster!=!0)){var l=he({},i.clusterNodeProperties);if(i.processProperties!==void 0){var h=[];for(var d in e)if(Object.prototype.hasOwnProperty.call(e,d)){var c=ot.cloneOptions(e[d]);h.push(c)}var f=[];for(var v in t)if(Object.prototype.hasOwnProperty.call(t,v)&&v.substr(0,12)!=="clusterEdge:"){var p=ot.cloneOptions(t[v],"edge");f.push(p)}if(l=i.processProperties(l,h,f),!l)throw new Error("The processProperties function does not return properties!")}l.id===void 0&&(l.id="cluster:"+Ia());var y=l.id;l.label===void 0&&(l.label="cluster");var g=void 0;l.x===void 0&&(g=this._getClusterPosition(e),l.x=g.x),l.y===void 0&&(g===void 0&&(g=this._getClusterPosition(e)),l.y=g.y),l.id=y;var m=this.body.functions.createNode(l,ade);m.containedNodes=e,m.containedEdges=t,m.clusterEdgeProperties=i.clusterEdgeProperties,this.body.nodes[l.id]=m,this._clusterEdges(e,t,l,i.clusterEdgeProperties),l.id=void 0,a===!0&&this.body.emitter.emit("_dataChanged")}}},{key:"_backupEdgeOptions",value:function(e){this.clusteredEdges[e.id]===void 0&&(this.clusteredEdges[e.id]={physics:e.options.physics})}},{key:"_restoreEdge",value:function(e){var t=this.clusteredEdges[e.id];t!==void 0&&(e.setOptions({physics:t.physics}),delete this.clusteredEdges[e.id])}},{key:"isCluster",value:function(e){return this.body.nodes[e]!==void 0?this.body.nodes[e].isCluster===!0:(console.error("Node does not exist."),!1)}},{key:"_getClusterPosition",value:function(e){for(var t=me(e),i=e[t[0]].x,a=e[t[0]].x,o=e[t[0]].y,s=e[t[0]].y,u,l=1;l<t.length;l++)u=e[t[l]],i=u.x<i?u.x:i,a=u.x>a?u.x:a,o=u.y<o?u.y:o,s=u.y>s?u.y:s;return{x:.5*(i+a),y:.5*(o+s)}}},{key:"openCluster",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!0;if(e===void 0)throw new Error("No clusterNodeId supplied to openCluster.");var a=this.body.nodes[e];if(a===void 0)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(a.isCluster!==!0||a.containedNodes===void 0||a.containedEdges===void 0)throw new Error("The node:"+e+" is not a valid cluster.");var o=this.findNode(e),s=Z(o).call(o,e)-1;if(s>=0){var u=o[s],l=this.body.nodes[u];l._openChildCluster(e),delete this.body.nodes[e],i===!0&&this.body.emitter.emit("_dataChanged");return}var h=a.containedNodes,d=a.containedEdges;if(t!==void 0&&t.releaseFunction!==void 0&&typeof t.releaseFunction=="function"){var c={},f={x:a.x,y:a.y};for(var v in h)if(Object.prototype.hasOwnProperty.call(h,v)){var p=this.body.nodes[v];c[v]={x:p.x,y:p.y}}var y=t.releaseFunction(f,c);for(var g in h)if(Object.prototype.hasOwnProperty.call(h,g)){var m=this.body.nodes[g];y[g]!==void 0&&(m.x=y[g].x===void 0?a.x:y[g].x,m.y=y[g].y===void 0?a.y:y[g].y)}}else J(h,function(rt){rt.options.fixed.x===!1&&(rt.x=a.x),rt.options.fixed.y===!1&&(rt.y=a.y)});for(var w in h)if(Object.prototype.hasOwnProperty.call(h,w)){var $=this.body.nodes[w];$.vx=a.vx,$.vy=a.vy,$.setOptions({physics:!0}),delete this.clusteredNodes[w]}for(var E=[],k=0;k<a.edges.length;k++)E.push(a.edges[k]);for(var D=0;D<E.length;D++){for(var j=E[D],R=this._getConnectedId(j,e),M=this.clusteredNodes[R],W=0;W<j.clusteringEdgeReplacingIds.length;W++){var X=j.clusteringEdgeReplacingIds[W],Y=this.body.edges[X];if(Y!==void 0)if(M!==void 0){var ye=this.body.nodes[M.clusterId];ye.containedEdges[Y.id]=Y,delete d[Y.id];var Ge=Y.fromId,ke=Y.toId;Y.toId==R?ke=M.clusterId:Ge=M.clusterId,this._createClusteredEdge(Ge,ke,Y,ye.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(Y)}j.remove()}for(var St in d)Object.prototype.hasOwnProperty.call(d,St)&&this._restoreEdge(d[St]);delete this.body.nodes[e],i===!0&&this.body.emitter.emit("_dataChanged")}},{key:"getNodesInCluster",value:function(e){var t=[];if(this.isCluster(e)===!0){var i=this.body.nodes[e].containedNodes;for(var a in i)Object.prototype.hasOwnProperty.call(i,a)&&t.push(this.body.nodes[a].id)}return t}},{key:"findNode",value:function(e){for(var t=[],i=100,a=0,o;this.clusteredNodes[e]!==void 0&&a<i;){if(o=this.body.nodes[e],o===void 0)return[];t.push(o.id),e=this.clusteredNodes[e].clusterId,a++}return o=this.body.nodes[e],o===void 0?[]:(t.push(o.id),bi(t).call(t),t)}},{key:"updateClusteredNode",value:function(e,t){if(e===void 0)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(t===void 0)throw new Error("No newOptions supplied to updateClusteredNode.");if(this.body.nodes[e]===void 0)throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[e].setOptions(t),this.body.emitter.emit("_dataChanged")}},{key:"updateEdge",value:function(e,t){if(e===void 0)throw new Error("No startEdgeId supplied to updateEdge.");if(t===void 0)throw new Error("No newOptions supplied to updateEdge.");if(this.body.edges[e]===void 0)throw new Error("The startEdgeId supplied to updateEdge does not exist.");for(var i=this.getClusteredEdges(e),a=0;a<i.length;a++){var o=this.body.edges[i[a]];o.setOptions(t)}this.body.emitter.emit("_dataChanged")}},{key:"getClusteredEdges",value:function(e){for(var t=[],i=100,a=0;e!==void 0&&this.body.edges[e]!==void 0&&a<i;)t.push(this.body.edges[e].id),e=this.body.edges[e].edgeReplacedById,a++;return bi(t).call(t),t}},{key:"getBaseEdge",value:function(e){return this.getBaseEdges(e)[0]}},{key:"getBaseEdges",value:function(e){for(var t=[e],i=[],a=[],o=100,s=0;t.length>0&&s<o;){var u=t.pop();if(u!==void 0){var l=this.body.edges[u];if(l!==void 0){s++;var h=l.clusteringEdgeReplacingIds;if(h===void 0)a.push(u);else for(var d=0;d<h.length;++d){var c=h[d];Z(t).call(t,h)!==-1||Z(i).call(i,h)!==-1||t.push(c)}i.push(u)}}}return a}},{key:"_getConnectedId",value:function(e,t){return e.toId!=t?e.toId:(e.fromId!=t,e.fromId)}},{key:"_getHubSize",value:function(){for(var e=0,t=0,i=0,a=0,o=0;o<this.body.nodeIndices.length;o++){var s=this.body.nodes[this.body.nodeIndices[o]];s.edges.length>a&&(a=s.edges.length),e+=s.edges.length,t+=Math.pow(s.edges.length,2),i+=1}e=e/i,t=t/i;var u=t-Math.pow(e,2),l=Math.sqrt(u),h=Math.floor(e+2*l);return h>a&&(h=a),h}},{key:"_createClusteredEdge",value:function(e,t,i,a,o){var s=ot.cloneOptions(i,"edge");he(s,a),s.from=e,s.to=t,s.id="clusterEdge:"+Ia(),o!==void 0&&he(s,o);var u=this.body.functions.createEdge(s);return u.clusteringEdgeReplacingIds=[i.id],u.connect(),this.body.edges[u.id]=u,u}},{key:"_clusterEdges",value:function(e,t,i,a){if(t instanceof wn){var o=t,s={};s[o.id]=o,t=s}if(e instanceof Pt){var u=e,l={};l[u.id]=u,e=l}if(i==null)throw new Error("_clusterEdges: parameter clusterNode required");a===void 0&&(a=i.clusterEdgeProperties),this._createClusterEdges(e,t,i,a);for(var h in t)if(Object.prototype.hasOwnProperty.call(t,h)&&this.body.edges[h]!==void 0){var d=this.body.edges[h];this._backupEdgeOptions(d),d.setOptions({physics:!1})}for(var c in e)Object.prototype.hasOwnProperty.call(e,c)&&(this.clusteredNodes[c]={clusterId:i.id,node:this.body.nodes[c]},this.body.nodes[c].setOptions({physics:!1}))}},{key:"_getClusterNodeForNode",value:function(e){if(e!==void 0){var t=this.clusteredNodes[e];if(t!==void 0){var i=t.clusterId;if(i!==void 0)return this.body.nodes[i]}}}},{key:"_filter",value:function(e,t){var i=[];return J(e,function(a){t(a)&&i.push(a)}),i}},{key:"_updateState",value:function(){var e=this,t,i=[],a={},o=function(v){J(e.body.nodes,function(p){p.isCluster===!0&&v(p)})};for(t in this.clusteredNodes)if(Object.prototype.hasOwnProperty.call(this.clusteredNodes,t)){var s=this.body.nodes[t];s===void 0&&i.push(t)}o(function(f){for(var v=0;v<i.length;v++)delete f.containedNodes[i[v]]});for(var u=0;u<i.length;u++)delete this.clusteredNodes[i[u]];J(this.clusteredEdges,function(f){var v=e.body.edges[f];(v===void 0||!v.endPointsValid())&&(a[f]=f)}),o(function(f){J(f.containedEdges,function(v,p){!v.endPointsValid()&&!a[p]&&(a[p]=p)})}),J(this.body.edges,function(f,v){var p=!0,y=f.clusteringEdgeReplacingIds;if(y!==void 0){var g=0;J(y,function(m){var w=e.body.edges[m];w!==void 0&&w.endPointsValid()&&(g+=1)}),p=g>0}(!f.endPointsValid()||!p)&&(a[v]=v)}),o(function(f){J(a,function(v){delete f.containedEdges[v],J(f.edges,function(p,y){if(p.id===v){f.edges[y]=null;return}p.clusteringEdgeReplacingIds=e._filter(p.clusteringEdgeReplacingIds,function(g){return!a[g]})}),f.edges=e._filter(f.edges,function(p){return p!==null})})}),J(a,function(f){delete e.clusteredEdges[f]}),J(a,function(f){delete e.body.edges[f]});var l=me(this.body.edges);J(l,function(f){var v=e.body.edges[f],p=e._isClusteredNode(v.fromId)||e._isClusteredNode(v.toId);if(p!==e._isClusteredEdge(v.id))if(p){var y=e._getClusterNodeForNode(v.fromId);y!==void 0&&e._clusterEdges(e.body.nodes[v.fromId],v,y);var g=e._getClusterNodeForNode(v.toId);g!==void 0&&e._clusterEdges(e.body.nodes[v.toId],v,g)}else delete e._clusterEdges[f],e._restoreEdge(v)});for(var h=!1,d=!0,c=function(){var v=[];o(function(y){var g=me(y.containedNodes).length,m=y.options.allowSingleNodeCluster===!0;(m&&g<1||!m&&g<2)&&v.push(y.id)});for(var p=0;p<v.length;++p)e.openCluster(v[p],{},!1);d=v.length>0,h=h||d};d;)c();h&&this._updateState()}},{key:"_isClusteredNode",value:function(e){return this.clusteredNodes[e]!==void 0}},{key:"_isClusteredEdge",value:function(e){return this.clusteredEdges[e]!==void 0}}]),r}();function sde(){var r;window!==void 0&&(r=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),r===void 0?window.requestAnimationFrame=function(n){n()}:window.requestAnimationFrame=r}var ude=function(){function r(n,e){C(this,r),sde(),this.body=n,this.canvas=e,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},Ae(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}return x(r,[{key:"bindEventListeners",value:function(){var e=this,t;this.body.emitter.on("dragStart",function(){e.dragging=!0}),this.body.emitter.on("dragEnd",function(){e.dragging=!1}),this.body.emitter.on("zoom",function(){e.zooming=!0,window.clearTimeout(e.zoomTimeoutId),e.zoomTimeoutId=or(function(){var i;e.zooming=!1,O(i=e._requestRedraw).call(i,e)()},250)}),this.body.emitter.on("_resizeNodes",function(){e._resizeNodes()}),this.body.emitter.on("_redraw",function(){e.renderingActive===!1&&e._redraw()}),this.body.emitter.on("_blockRedraw",function(){e.allowRedraw=!1}),this.body.emitter.on("_allowRedraw",function(){e.allowRedraw=!0,e.redrawRequested=!1}),this.body.emitter.on("_requestRedraw",O(t=this._requestRedraw).call(t,this)),this.body.emitter.on("_startRendering",function(){e.renderRequests+=1,e.renderingActive=!0,e._startRendering()}),this.body.emitter.on("_stopRendering",function(){e.renderRequests-=1,e.renderingActive=e.renderRequests>0,e.renderTimer=void 0}),this.body.emitter.on("destroy",function(){e.renderRequests=0,e.allowRedraw=!1,e.renderingActive=!1,e.requiresTimeout===!0?clearTimeout(e.renderTimer):window.cancelAnimationFrame(e.renderTimer),e.body.emitter.off()})}},{key:"setOptions",value:function(e){if(e!==void 0){var t=["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"];ua(t,this.options,e)}}},{key:"_requestNextFrame",value:function(e,t){if(!(typeof window>"u")){var i,a=window;return this.requiresTimeout===!0?i=or(e,t):a.requestAnimationFrame&&(i=a.requestAnimationFrame(e)),i}}},{key:"_startRendering",value:function(){if(this.renderingActive===!0&&this.renderTimer===void 0){var e;this.renderTimer=this._requestNextFrame(O(e=this._renderStep).call(e,this),this.simulationInterval)}}},{key:"_renderStep",value:function(){this.renderingActive===!0&&(this.renderTimer=void 0,this.requiresTimeout===!0&&this._startRendering(),this._redraw(),this.requiresTimeout===!1&&this._startRendering())}},{key:"redraw",value:function(){this.body.emitter.emit("setSize"),this._redraw()}},{key:"_requestRedraw",value:function(){var e=this;this.redrawRequested!==!0&&this.renderingActive===!1&&this.allowRedraw===!0&&(this.redrawRequested=!0,this._requestNextFrame(function(){e._redraw(!1)},0))}},{key:"_redraw",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:!1;if(this.allowRedraw===!0){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1;var t={drawExternalLabels:null};(this.canvas.frame.canvas.width===0||this.canvas.frame.canvas.height===0)&&this.canvas.setSize(),this.canvas.setTransform();var i=this.canvas.getContext(),a=this.canvas.frame.canvas.clientWidth,o=this.canvas.frame.canvas.clientHeight;if(i.clearRect(0,0,a,o),this.canvas.frame.clientWidth===0)return;if(i.save(),i.translate(this.body.view.translation.x,this.body.view.translation.y),i.scale(this.body.view.scale,this.body.view.scale),i.beginPath(),this.body.emitter.emit("beforeDrawing",i),i.closePath(),e===!1&&(this.dragging===!1||this.dragging===!0&&this.options.hideEdgesOnDrag===!1)&&(this.zooming===!1||this.zooming===!0&&this.options.hideEdgesOnZoom===!1)&&this._drawEdges(i),this.dragging===!1||this.dragging===!0&&this.options.hideNodesOnDrag===!1){var s=this._drawNodes(i,e),u=s.drawExternalLabels;t.drawExternalLabels=u}e===!1&&(this.dragging===!1||this.dragging===!0&&this.options.hideEdgesOnDrag===!1)&&(this.zooming===!1||this.zooming===!0&&this.options.hideEdgesOnZoom===!1)&&this._drawArrows(i),t.drawExternalLabels!=null&&t.drawExternalLabels(),e===!1&&this._drawSelectionBox(i),i.beginPath(),this.body.emitter.emit("afterDrawing",i),i.closePath(),i.restore(),e===!0&&i.clearRect(0,0,a,o)}}},{key:"_resizeNodes",value:function(){this.canvas.setTransform();var e=this.canvas.getContext();e.save(),e.translate(this.body.view.translation.x,this.body.view.translation.y),e.scale(this.body.view.scale,this.body.view.scale);var t=this.body.nodes,i;for(var a in t)Object.prototype.hasOwnProperty.call(t,a)&&(i=t[a],i.resize(e),i.updateBoundingBox(e,i.selected));e.restore()}},{key:"_drawNodes",value:function(e){for(var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1,i=this.body.nodes,a=this.body.nodeIndices,o,s=[],u=[],l=20,h=this.canvas.DOMtoCanvas({x:-l,y:-l}),d=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+l,y:this.canvas.frame.canvas.clientHeight+l}),c={top:h.y,left:h.x,bottom:d.y,right:d.x},f=[],v=0;v<a.length;v++)if(o=i[a[v]],o.hover)u.push(a[v]);else if(o.isSelected())s.push(a[v]);else if(t===!0){var p=o.draw(e);p.drawExternalLabel!=null&&f.push(p.drawExternalLabel)}else if(o.isBoundingBoxOverlappingWith(c)===!0){var y=o.draw(e);y.drawExternalLabel!=null&&f.push(y.drawExternalLabel)}else o.updateBoundingBox(e,o.selected);var g,m=s.length,w=u.length;for(g=0;g<m;g++){o=i[s[g]];var $=o.draw(e);$.drawExternalLabel!=null&&f.push($.drawExternalLabel)}for(g=0;g<w;g++){o=i[u[g]];var E=o.draw(e);E.drawExternalLabel!=null&&f.push(E.drawExternalLabel)}return{drawExternalLabels:function(){for(var D=0,j=f;D<j.length;D++){var R=j[D];R()}}}}},{key:"_drawEdges",value:function(e){for(var t=this.body.edges,i=this.body.edgeIndices,a=0;a<i.length;a++){var o=t[i[a]];o.connected===!0&&o.draw(e)}}},{key:"_drawArrows",value:function(e){for(var t=this.body.edges,i=this.body.edgeIndices,a=0;a<i.length;a++){var o=t[i[a]];o.connected===!0&&o.drawArrows(e)}}},{key:"_determineBrowserMethod",value:function(){if(typeof window<"u"){var e=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,Z(e).call(e,"msie 9.0")!=-1?this.requiresTimeout=!0:Z(e).call(e,"safari")!=-1&&Z(e).call(e,"chrome")<=-1&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}},{key:"_drawSelectionBox",value:function(e){if(this.body.selectionBox.show){e.beginPath();var t=this.body.selectionBox.position.end.x-this.body.selectionBox.position.start.x,i=this.body.selectionBox.position.end.y-this.body.selectionBox.position.start.y;e.rect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,t,i),e.fillStyle="rgba(151, 194, 252, 0.2)",e.fillRect(this.body.selectionBox.position.start.x,this.body.selectionBox.position.start.y,t,i),e.strokeStyle="rgba(151, 194, 252, 1)",e.stroke()}else e.closePath()}}]),r}(),lde=te,hde=lde.setInterval,dde=hde,cde=L(dde);function pu(r,n){n.inputHandler=function(e){e.isFirst&&n(e)},r.on("hammer.input",n.inputHandler)}function TO(r,n){return n.inputHandler=function(e){e.isFinal&&n(e)},r.on("hammer.input",n.inputHandler)}var fde=function(){function r(n){C(this,r),this.body=n,this.pixelRatio=1,this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this._cleanupCallbacks=[],this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},Ae(this.options,this.defaultOptions),this.bindEventListeners()}return x(r,[{key:"bindEventListeners",value:function(){var e=this,t;this.body.emitter.once("resize",function(i){i.width!==0&&(e.body.view.translation.x=i.width*.5),i.height!==0&&(e.body.view.translation.y=i.height*.5)}),this.body.emitter.on("setSize",O(t=this.setSize).call(t,this)),this.body.emitter.on("destroy",function(){e.hammerFrame.destroy(),e.hammer.destroy(),e._cleanUp()})}},{key:"setOptions",value:function(e){var t=this;if(e!==void 0){var i=["width","height","autoResize"];ua(i,this.options,e)}if(this._cleanUp(),this.options.autoResize===!0){var a;if(window.ResizeObserver){var o=new ResizeObserver(function(){var h=t.setSize();h===!0&&t.body.emitter.emit("_requestRedraw")}),s=this.frame;o.observe(s),this._cleanupCallbacks.push(function(){o.unobserve(s)})}else{var u=cde(function(){var h=t.setSize();h===!0&&t.body.emitter.emit("_requestRedraw")},1e3);this._cleanupCallbacks.push(function(){clearInterval(u)})}var l=O(a=this._onResize).call(a,this);window.addEventListener("resize",l),this._cleanupCallbacks.push(function(){window.removeEventListener("resize",l)})}}},{key:"_cleanUp",value:function(){var e,t,i;ue(e=bi(t=br(i=this._cleanupCallbacks).call(i,0)).call(t)).call(e,function(a){try{a()}catch(o){console.error(o)}})}},{key:"_onResize",value:function(){this.setSize(),this.body.emitter.emit("_redraw")}},{key:"_getCameraState",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:this.pixelRatio;this.initialized===!0&&(this.cameraState.previousWidth=this.frame.canvas.width/e,this.cameraState.previousHeight=this.frame.canvas.height/e,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/e,y:.5*this.frame.canvas.height/e}))}},{key:"_setCameraState",value:function(){if(this.cameraState.scale!==void 0&&this.frame.canvas.clientWidth!==0&&this.frame.canvas.clientHeight!==0&&this.pixelRatio!==0&&this.cameraState.previousWidth>0&&this.cameraState.previousHeight>0){var e=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,t=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,i=this.cameraState.scale;e!=1&&t!=1?i=this.cameraState.scale*.5*(e+t):e!=1?i=this.cameraState.scale*e:t!=1&&(i=this.cameraState.scale*t),this.body.view.scale=i;var a=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),o={x:a.x-this.cameraState.position.x,y:a.y-this.cameraState.position.y};this.body.view.translation.x+=o.x*this.body.view.scale,this.body.view.translation.y+=o.y*this.body.view.scale}}},{key:"_prepareValue",value:function(e){if(typeof e=="number")return e+"px";if(typeof e=="string"){if(Z(e).call(e,"%")!==-1||Z(e).call(e,"px")!==-1)return e;if(Z(e).call(e,"%")===-1)return e+"px"}throw new Error("Could not use the value supplied for width or height:"+e)}},{key:"_create",value:function(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=0,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{var e=document.createElement("DIV");e.style.color="red",e.style.fontWeight="bold",e.style.padding="10px",e.innerText="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(e)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}},{key:"_bindHammer",value:function(){var e=this;this.hammer!==void 0&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new $n(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:$n.DIRECTION_ALL}),pu(this.hammer,function(t){e.body.eventListeners.onTouch(t)}),this.hammer.on("tap",function(t){e.body.eventListeners.onTap(t)}),this.hammer.on("doubletap",function(t){e.body.eventListeners.onDoubleTap(t)}),this.hammer.on("press",function(t){e.body.eventListeners.onHold(t)}),this.hammer.on("panstart",function(t){e.body.eventListeners.onDragStart(t)}),this.hammer.on("panmove",function(t){e.body.eventListeners.onDrag(t)}),this.hammer.on("panend",function(t){e.body.eventListeners.onDragEnd(t)}),this.hammer.on("pinch",function(t){e.body.eventListeners.onPinch(t)}),this.frame.canvas.addEventListener("wheel",function(t){e.body.eventListeners.onMouseWheel(t)}),this.frame.canvas.addEventListener("mousemove",function(t){e.body.eventListeners.onMouseMove(t)}),this.frame.canvas.addEventListener("contextmenu",function(t){e.body.eventListeners.onContext(t)}),this.hammerFrame=new $n(this.frame),TO(this.hammerFrame,function(t){e.body.eventListeners.onRelease(t)})}},{key:"setSize",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:this.options.width,t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.options.height;e=this._prepareValue(e),t=this._prepareValue(t);var i=!1,a=this.frame.canvas.width,o=this.frame.canvas.height,s=this.pixelRatio;if(this._setPixelRatio(),e!=this.options.width||t!=this.options.height||this.frame.style.width!=e||this.frame.style.height!=t)this._getCameraState(s),this.frame.style.width=e,this.frame.style.height=t,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=e,this.options.height=t,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{var u=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),l=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);(this.frame.canvas.width!==u||this.frame.canvas.height!==l)&&this._getCameraState(s),this.frame.canvas.width!==u&&(this.frame.canvas.width=u,i=!0),this.frame.canvas.height!==l&&(this.frame.canvas.height=l,i=!0)}return i===!0&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(a/this.pixelRatio),oldHeight:Math.round(o/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}},{key:"getContext",value:function(){return this.frame.canvas.getContext("2d")}},{key:"_determinePixelRatio",value:function(){var e=this.getContext();if(e===void 0)throw new Error("Could not get canvax context");var t=1;typeof window<"u"&&(t=window.devicePixelRatio||1);var i=e.webkitBackingStorePixelRatio||e.mozBackingStorePixelRatio||e.msBackingStorePixelRatio||e.oBackingStorePixelRatio||e.backingStorePixelRatio||1;return t/i}},{key:"_setPixelRatio",value:function(){this.pixelRatio=this._determinePixelRatio()}},{key:"setTransform",value:function(){var e=this.getContext();if(e===void 0)throw new Error("Could not get canvax context");e.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}},{key:"_XconvertDOMtoCanvas",value:function(e){return(e-this.body.view.translation.x)/this.body.view.scale}},{key:"_XconvertCanvasToDOM",value:function(e){return e*this.body.view.scale+this.body.view.translation.x}},{key:"_YconvertDOMtoCanvas",value:function(e){return(e-this.body.view.translation.y)/this.body.view.scale}},{key:"_YconvertCanvasToDOM",value:function(e){return e*this.body.view.scale+this.body.view.translation.y}},{key:"canvasToDOM",value:function(e){return{x:this._XconvertCanvasToDOM(e.x),y:this._YconvertCanvasToDOM(e.y)}}},{key:"DOMtoCanvas",value:function(e){return{x:this._XconvertDOMtoCanvas(e.x),y:this._YconvertDOMtoCanvas(e.y)}}}]),r}();function vde(r,n){var e=Ae({nodes:n,minZoomLevel:Number.MIN_VALUE,maxZoomLevel:1},r??{});if(!ae(e.nodes))throw new TypeError("Nodes has to be an array of ids.");if(e.nodes.length===0&&(e.nodes=n),!(typeof e.minZoomLevel=="number"&&e.minZoomLevel>0))throw new TypeError("Min zoom level has to be a number higher than zero.");if(!(typeof e.maxZoomLevel=="number"&&e.minZoomLevel<=e.maxZoomLevel))throw new TypeError("Max zoom level has to be a number higher than min zoom level.");return e}var pde=function(){function r(n,e){var t,i=this,a;C(this,r),this.body=n,this.canvas=e,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",O(t=this.fit).call(t,this)),this.body.emitter.on("animationFinished",function(){i.body.emitter.emit("_stopRendering")}),this.body.emitter.on("unlockNode",O(a=this.releaseNode).call(a,this))}return x(r,[{key:"setOptions",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:{};this.options=e}},{key:"fit",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1;e=vde(e,this.body.nodeIndices);var i=this.canvas.frame.canvas.clientWidth,a=this.canvas.frame.canvas.clientHeight,o,s;if(i===0||a===0)s=1,o=ot.getRange(this.body.nodes,e.nodes);else if(t===!0){var u=0;for(var l in this.body.nodes)if(Object.prototype.hasOwnProperty.call(this.body.nodes,l)){var h=this.body.nodes[l];h.predefinedPosition===!0&&(u+=1)}if(u>.5*this.body.nodeIndices.length){this.fit(e,!1);return}o=ot.getRange(this.body.nodes,e.nodes);var d=this.body.nodeIndices.length;s=12.662/(d+7.4147)+.0964822;var c=Math.min(i/600,a/600);s*=c}else{this.body.emitter.emit("_resizeNodes"),o=ot.getRange(this.body.nodes,e.nodes);var f=Math.abs(o.maxX-o.minX)*1.1,v=Math.abs(o.maxY-o.minY)*1.1,p=i/f,y=a/v;s=p<=y?p:y}s>e.maxZoomLevel?s=e.maxZoomLevel:s<e.minZoomLevel&&(s=e.minZoomLevel);var g=ot.findCenter(o),m={position:g,scale:s,animation:e.animation};this.moveTo(m)}},{key:"focus",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{};if(this.body.nodes[e]!==void 0){var i={x:this.body.nodes[e].x,y:this.body.nodes[e].y};t.position=i,t.lockedOnNode=e,this.moveTo(t)}else console.error("Node: "+e+" cannot be found.")}},{key:"moveTo",value:function(e){if(e===void 0){e={};return}if(e.offset!=null){if(e.offset.x!=null){if(e.offset.x=+e.offset.x,!ci(e.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else e.offset.x=0;if(e.offset.y!=null){if(e.offset.y=+e.offset.y,!ci(e.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else e.offset.x=0}else e.offset={x:0,y:0};if(e.position!=null){if(e.position.x!=null){if(e.position.x=+e.position.x,!ci(e.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else e.position.x=0;if(e.position.y!=null){if(e.position.y=+e.position.y,!ci(e.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else e.position.x=0}else e.position=this.getViewPosition();if(e.scale!=null){if(e.scale=+e.scale,!(e.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else e.scale=this.body.view.scale;e.animation===void 0&&(e.animation={duration:0}),e.animation===!1&&(e.animation={duration:0}),e.animation===!0&&(e.animation={}),e.animation.duration===void 0&&(e.animation.duration=1e3),e.animation.easingFunction===void 0&&(e.animation.easingFunction="easeInOutQuad"),this.animateView(e)}},{key:"animateView",value:function(e){if(e!==void 0){this.animationEasingFunction=e.animation.easingFunction,this.releaseNode(),e.locked===!0&&(this.lockedOnNodeId=e.lockedOnNode,this.lockedOnNodeOffset=e.offset),this.easingTime!=0&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=e.scale,this.body.view.scale=this.targetScale;var t=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),i={x:t.x-e.position.x,y:t.y-e.position.y};if(this.targetTranslation={x:this.sourceTranslation.x+i.x*this.targetScale+e.offset.x,y:this.sourceTranslation.y+i.y*this.targetScale+e.offset.y},e.animation.duration===0)if(this.lockedOnNodeId!=null){var a;this.viewFunction=O(a=this._lockedRedraw).call(a,this),this.body.emitter.on("initRedraw",this.viewFunction)}else this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw");else{var o;this.animationSpeed=1/(60*e.animation.duration*.001)||1/60,this.animationEasingFunction=e.animation.easingFunction,this.viewFunction=O(o=this._transitionRedraw).call(o,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering")}}}},{key:"_lockedRedraw",value:function(){var e={x:this.body.nodes[this.lockedOnNodeId].x,y:this.body.nodes[this.lockedOnNodeId].y},t=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),i={x:t.x-e.x,y:t.y-e.y},a=this.body.view.translation,o={x:a.x+i.x*this.body.view.scale+this.lockedOnNodeOffset.x,y:a.y+i.y*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=o}},{key:"releaseNode",value:function(){this.lockedOnNodeId!==void 0&&this.viewFunction!==void 0&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}},{key:"_transitionRedraw",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:!1;this.easingTime+=this.animationSpeed,this.easingTime=e===!0?1:this.easingTime;var t=Jie[this.animationEasingFunction](this.easingTime);if(this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*t,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*t,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*t},this.easingTime>=1){if(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,this.lockedOnNodeId!=null){var i;this.viewFunction=O(i=this._lockedRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction)}this.body.emitter.emit("animationFinished")}}},{key:"getScale",value:function(){return this.body.view.scale}},{key:"getViewPosition",value:function(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}]),r}();function f$(r){var n=r&&r.preventDefault||!1,e=r&&r.container||window,t={},i={keydown:{},keyup:{}},a={},o;for(o=97;o<=122;o++)a[String.fromCharCode(o)]={code:65+(o-97),shift:!1};for(o=65;o<=90;o++)a[String.fromCharCode(o)]={code:o,shift:!0};for(o=0;o<=9;o++)a[""+o]={code:48+o,shift:!1};for(o=1;o<=12;o++)a["F"+o]={code:111+o,shift:!1};for(o=0;o<=9;o++)a["num"+o]={code:96+o,shift:!1};a["num*"]={code:106,shift:!1},a["num+"]={code:107,shift:!1},a["num-"]={code:109,shift:!1},a["num/"]={code:111,shift:!1},a["num."]={code:110,shift:!1},a.left={code:37,shift:!1},a.up={code:38,shift:!1},a.right={code:39,shift:!1},a.down={code:40,shift:!1},a.space={code:32,shift:!1},a.enter={code:13,shift:!1},a.shift={code:16,shift:void 0},a.esc={code:27,shift:!1},a.backspace={code:8,shift:!1},a.tab={code:9,shift:!1},a.ctrl={code:17,shift:!1},a.alt={code:18,shift:!1},a.delete={code:46,shift:!1},a.pageup={code:33,shift:!1},a.pagedown={code:34,shift:!1},a["="]={code:187,shift:!1},a["-"]={code:189,shift:!1},a["]"]={code:221,shift:!1},a["["]={code:219,shift:!1};var s=function(h){l(h,"keydown")},u=function(h){l(h,"keyup")},l=function(h,d){if(i[d][h.keyCode]!==void 0){for(var c=i[d][h.keyCode],f=0;f<c.length;f++)(c[f].shift===void 0||c[f].shift==!0&&h.shiftKey==!0||c[f].shift==!1&&h.shiftKey==!1)&&c[f].fn(h);n==!0&&h.preventDefault()}};return t.bind=function(h,d,c){if(c===void 0&&(c="keydown"),a[h]===void 0)throw new Error("unsupported key: "+h);i[c][a[h].code]===void 0&&(i[c][a[h].code]=[]),i[c][a[h].code].push({fn:d,shift:a[h].shift})},t.bindAll=function(h,d){d===void 0&&(d="keydown");for(var c in a)a.hasOwnProperty(c)&&t.bind(c,h,d)},t.getKey=function(h){for(var d in a)if(a.hasOwnProperty(d)){if(h.shiftKey==!0&&a[d].shift==!0&&h.keyCode==a[d].code)return d;if(h.shiftKey==!1&&a[d].shift==!1&&h.keyCode==a[d].code)return d;if(h.keyCode==a[d].code&&d=="shift")return d}return"unknown key, currently not supported"},t.unbind=function(h,d,c){if(c===void 0&&(c="keydown"),a[h]===void 0)throw new Error("unsupported key: "+h);if(d!==void 0){var f=[],v=i[c][a[h].code];if(v!==void 0)for(var p=0;p<v.length;p++)v[p].fn==d&&v[p].shift==a[h].shift||f.push(i[c][a[h].code][p]);i[c][a[h].code]=f}else i[c][a[h].code]=[]},t.reset=function(){i={keydown:{},keyup:{}}},t.destroy=function(){i={keydown:{},keyup:{}},e.removeEventListener("keydown",s,!0),e.removeEventListener("keyup",u,!0)},e.addEventListener("keydown",s,!0),e.addEventListener("keyup",u,!0),t}var yde=function(){function r(n,e){var t=this;C(this,r),this.body=n,this.canvas=e,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",function(){t.activated=!0,t.configureKeyboardBindings()}),this.body.emitter.on("deactivate",function(){t.activated=!1,t.configureKeyboardBindings()}),this.body.emitter.on("destroy",function(){t.keycharm!==void 0&&t.keycharm.destroy()}),this.options={}}return x(r,[{key:"setOptions",value:function(e){e!==void 0&&(this.options=e,this.create())}},{key:"create",value:function(){this.options.navigationButtons===!0?this.iconsCreated===!1&&this.loadNavigationElements():this.iconsCreated===!0&&this.cleanNavigation(),this.configureKeyboardBindings()}},{key:"cleanNavigation",value:function(){if(this.navigationHammers.length!=0){for(var e=0;e<this.navigationHammers.length;e++)this.navigationHammers[e].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}},{key:"loadNavigationElements",value:function(){var e=this;this.cleanNavigation(),this.navigationDOM={};var t=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],i=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var a=0;a<t.length;a++){this.navigationDOM[t[a]]=document.createElement("div"),this.navigationDOM[t[a]].className="vis-button vis-"+t[a],this.navigationDOM.wrapper.appendChild(this.navigationDOM[t[a]]);var o=new $n(this.navigationDOM[t[a]]);if(i[a]==="_fit"){var s;pu(o,O(s=this._fit).call(s,this))}else{var u;pu(o,O(u=this.bindToRedraw).call(u,this,i[a]))}this.navigationHammers.push(o)}var l=new $n(this.canvas.frame);TO(l,function(){e._stopMovement()}),this.navigationHammers.push(l),this.iconsCreated=!0}},{key:"bindToRedraw",value:function(e){if(this.boundFunctions[e]===void 0){var t;this.boundFunctions[e]=O(t=this[e]).call(t,this),this.body.emitter.on("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_startRendering")}}},{key:"unbindFromRedraw",value:function(e){this.boundFunctions[e]!==void 0&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[e])}},{key:"_fit",value:function(){new Date().valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=new Date().valueOf())}},{key:"_stopMovement",value:function(){for(var e in this.boundFunctions)Object.prototype.hasOwnProperty.call(this.boundFunctions,e)&&(this.body.emitter.off("initRedraw",this.boundFunctions[e]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}},{key:"_moveUp",value:function(){this.body.view.translation.y+=this.options.keyboard.speed.y}},{key:"_moveDown",value:function(){this.body.view.translation.y-=this.options.keyboard.speed.y}},{key:"_moveLeft",value:function(){this.body.view.translation.x+=this.options.keyboard.speed.x}},{key:"_moveRight",value:function(){this.body.view.translation.x-=this.options.keyboard.speed.x}},{key:"_zoomIn",value:function(){var e=this.body.view.scale,t=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,a=t/e,o=(1-a)*this.canvas.canvasViewCenter.x+i.x*a,s=(1-a)*this.canvas.canvasViewCenter.y+i.y*a;this.body.view.scale=t,this.body.view.translation={x:o,y:s},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}},{key:"_zoomOut",value:function(){var e=this.body.view.scale,t=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,a=t/e,o=(1-a)*this.canvas.canvasViewCenter.x+i.x*a,s=(1-a)*this.canvas.canvasViewCenter.y+i.y*a;this.body.view.scale=t,this.body.view.translation={x:o,y:s},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}},{key:"configureKeyboardBindings",value:function(){var e=this;if(this.keycharm!==void 0&&this.keycharm.destroy(),this.options.keyboard.enabled===!0&&(this.options.keyboard.bindToWindow===!0?this.keycharm=f$({container:window,preventDefault:!0}):this.keycharm=f$({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),this.activated===!0)){var t,i,a,o,s,u,l,h,d,c,f,v,p,y,g,m,w,$,E,k,D,j,R,M;O(t=this.keycharm).call(t,"up",function(){e.bindToRedraw("_moveUp")},"keydown"),O(i=this.keycharm).call(i,"down",function(){e.bindToRedraw("_moveDown")},"keydown"),O(a=this.keycharm).call(a,"left",function(){e.bindToRedraw("_moveLeft")},"keydown"),O(o=this.keycharm).call(o,"right",function(){e.bindToRedraw("_moveRight")},"keydown"),O(s=this.keycharm).call(s,"=",function(){e.bindToRedraw("_zoomIn")},"keydown"),O(u=this.keycharm).call(u,"num+",function(){e.bindToRedraw("_zoomIn")},"keydown"),O(l=this.keycharm).call(l,"num-",function(){e.bindToRedraw("_zoomOut")},"keydown"),O(h=this.keycharm).call(h,"-",function(){e.bindToRedraw("_zoomOut")},"keydown"),O(d=this.keycharm).call(d,"[",function(){e.bindToRedraw("_zoomOut")},"keydown"),O(c=this.keycharm).call(c,"]",function(){e.bindToRedraw("_zoomIn")},"keydown"),O(f=this.keycharm).call(f,"pageup",function(){e.bindToRedraw("_zoomIn")},"keydown"),O(v=this.keycharm).call(v,"pagedown",function(){e.bindToRedraw("_zoomOut")},"keydown"),O(p=this.keycharm).call(p,"up",function(){e.unbindFromRedraw("_moveUp")},"keyup"),O(y=this.keycharm).call(y,"down",function(){e.unbindFromRedraw("_moveDown")},"keyup"),O(g=this.keycharm).call(g,"left",function(){e.unbindFromRedraw("_moveLeft")},"keyup"),O(m=this.keycharm).call(m,"right",function(){e.unbindFromRedraw("_moveRight")},"keyup"),O(w=this.keycharm).call(w,"=",function(){e.unbindFromRedraw("_zoomIn")},"keyup"),O($=this.keycharm).call($,"num+",function(){e.unbindFromRedraw("_zoomIn")},"keyup"),O(E=this.keycharm).call(E,"num-",function(){e.unbindFromRedraw("_zoomOut")},"keyup"),O(k=this.keycharm).call(k,"-",function(){e.unbindFromRedraw("_zoomOut")},"keyup"),O(D=this.keycharm).call(D,"[",function(){e.unbindFromRedraw("_zoomOut")},"keyup"),O(j=this.keycharm).call(j,"]",function(){e.unbindFromRedraw("_zoomIn")},"keyup"),O(R=this.keycharm).call(R,"pageup",function(){e.unbindFromRedraw("_zoomIn")},"keyup"),O(M=this.keycharm).call(M,"pagedown",function(){e.unbindFromRedraw("_zoomOut")},"keyup")}}}]),r}();function gde(r,n){var e=typeof ri<"u"&&Wi(r)||r["@@iterator"];if(!e){if(ae(r)||(e=mde(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function mde(r,n){var e;if(r){if(typeof r=="string")return v$(r,n);var t=Ye(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Hi(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return v$(r,n)}}function v$(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}var bde=function(){function r(n,e,t){var i,a,o,s,u,l,h,d,c,f,v,p,y;C(this,r),this.body=n,this.canvas=e,this.selectionHandler=t,this.navigationHandler=new yde(n,e),this.body.eventListeners.onTap=O(i=this.onTap).call(i,this),this.body.eventListeners.onTouch=O(a=this.onTouch).call(a,this),this.body.eventListeners.onDoubleTap=O(o=this.onDoubleTap).call(o,this),this.body.eventListeners.onHold=O(s=this.onHold).call(s,this),this.body.eventListeners.onDragStart=O(u=this.onDragStart).call(u,this),this.body.eventListeners.onDrag=O(l=this.onDrag).call(l,this),this.body.eventListeners.onDragEnd=O(h=this.onDragEnd).call(h,this),this.body.eventListeners.onMouseWheel=O(d=this.onMouseWheel).call(d,this),this.body.eventListeners.onPinch=O(c=this.onPinch).call(c,this),this.body.eventListeners.onMouseMove=O(f=this.onMouseMove).call(f,this),this.body.eventListeners.onRelease=O(v=this.onRelease).call(v,this),this.body.eventListeners.onContext=O(p=this.onContext).call(p,this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=O(y=this.getPointer).call(y,this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0,autoFocus:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},Ae(this.options,this.defaultOptions),this.bindEventListeners()}return x(r,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("destroy",function(){clearTimeout(e.popupTimer),delete e.body.functions.getPointer})}},{key:"setOptions",value:function(e){if(e!==void 0){var t=["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"];du(t,this.options,e),Nt(this.options,e,"keyboard"),e.tooltip&&(Ae(this.options.tooltip,e.tooltip),e.tooltip.color&&(this.options.tooltip.color=Nc(e.tooltip.color)))}this.navigationHandler.setOptions(this.options)}},{key:"getPointer",value:function(e){return{x:e.x-qie(this.canvas.frame.canvas),y:e.y-Yie(this.canvas.frame.canvas)}}},{key:"onTouch",value:function(e){new Date().valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(e.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=new Date().valueOf())}},{key:"onTap",value:function(e){var t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect&&(e.changedPointers[0].ctrlKey||e.changedPointers[0].metaKey);this.checkSelectionChanges(t,i),this.selectionHandler.commitAndEmit(t,e),this.selectionHandler.generateClickEvent("click",e,t)}},{key:"onDoubleTap",value:function(e){var t=this.getPointer(e.center);this.selectionHandler.generateClickEvent("doubleClick",e,t)}},{key:"onHold",value:function(e){var t=this.getPointer(e.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(t,i),this.selectionHandler.commitAndEmit(t,e),this.selectionHandler.generateClickEvent("click",e,t),this.selectionHandler.generateClickEvent("hold",e,t)}},{key:"onRelease",value:function(e){if(new Date().valueOf()-this.touchTime>10){var t=this.getPointer(e.center);this.selectionHandler.generateClickEvent("release",e,t),this.touchTime=new Date().valueOf()}}},{key:"onContext",value:function(e){var t=this.getPointer({x:e.clientX,y:e.clientY});this.selectionHandler.generateClickEvent("oncontext",e,t)}},{key:"checkSelectionChanges",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!1;t===!0?this.selectionHandler.selectAdditionalOnPoint(e):this.selectionHandler.selectOnPoint(e)}},{key:"_determineDifference",value:function(e,t){var i=function(o,s){for(var u=[],l=0;l<o.length;l++){var h=o[l];Z(s).call(s,h)===-1&&u.push(h)}return u};return{nodes:i(e.nodes,t.nodes),edges:i(e.edges,t.edges)}}},{key:"onDragStart",value:function(e){if(!this.drag.dragging){this.drag.pointer===void 0&&this.onTouch(e);var t=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=Ae({},this.body.view.translation),this.drag.nodeId=void 0,e.srcEvent.shiftKey){this.body.selectionBox.show=!0;var i=this.getPointer(e.center);this.body.selectionBox.position.start={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)},this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)}}else if(t!==void 0&&this.options.dragNodes===!0){this.drag.nodeId=t.id,t.isSelected()===!1&&this.selectionHandler.setSelection({nodes:[t.id]}),this.selectionHandler.generateClickEvent("dragStart",e,this.drag.pointer);var a=gde(this.selectionHandler.getSelectedNodes()),o;try{for(a.s();!(o=a.n()).done;){var s=o.value,u={id:s.id,node:s,x:s.x,y:s.y,xFixed:s.options.fixed.x,yFixed:s.options.fixed.y};s.options.fixed.x=!0,s.options.fixed.y=!0,this.drag.selection.push(u)}}catch(l){a.e(l)}finally{a.f()}}else this.selectionHandler.generateClickEvent("dragStart",e,this.drag.pointer,void 0,!0)}}},{key:"onDrag",value:function(e){var t=this;if(this.drag.pinched!==!0){this.body.emitter.emit("unlockNode");var i=this.getPointer(e.center),a=this.drag.selection;if(a&&a.length&&this.options.dragNodes===!0){this.selectionHandler.generateClickEvent("dragging",e,i);var o=i.x-this.drag.pointer.x,s=i.y-this.drag.pointer.y;ue(a).call(a,function(h){var d=h.node;h.xFixed===!1&&(d.x=t.canvas._XconvertDOMtoCanvas(t.canvas._XconvertCanvasToDOM(h.x)+o)),h.yFixed===!1&&(d.y=t.canvas._YconvertDOMtoCanvas(t.canvas._YconvertCanvasToDOM(h.y)+s))}),this.body.emitter.emit("startSimulation")}else{if(e.srcEvent.shiftKey){if(this.selectionHandler.generateClickEvent("dragging",e,i,void 0,!0),this.drag.pointer===void 0){this.onDragStart(e);return}this.body.selectionBox.position.end={x:this.canvas._XconvertDOMtoCanvas(i.x),y:this.canvas._YconvertDOMtoCanvas(i.y)},this.body.emitter.emit("_requestRedraw")}if(this.options.dragView===!0&&!e.srcEvent.shiftKey){if(this.selectionHandler.generateClickEvent("dragging",e,i,void 0,!0),this.drag.pointer===void 0){this.onDragStart(e);return}var u=i.x-this.drag.pointer.x,l=i.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+u,y:this.drag.translation.y+l},this.body.emitter.emit("_requestRedraw")}}}}},{key:"onDragEnd",value:function(e){var t=this;if(this.drag.dragging=!1,this.body.selectionBox.show){var i;this.body.selectionBox.show=!1;var a=this.body.selectionBox.position,o={minX:Math.min(a.start.x,a.end.x),minY:Math.min(a.start.y,a.end.y),maxX:Math.max(a.start.x,a.end.x),maxY:Math.max(a.start.y,a.end.y)},s=gt(i=this.body.nodeIndices).call(i,function(h){var d=t.body.nodes[h];return d.x>=o.minX&&d.x<=o.maxX&&d.y>=o.minY&&d.y<=o.maxY});ue(s).call(s,function(h){return t.selectionHandler.selectObject(t.body.nodes[h])});var u=this.getPointer(e.center);this.selectionHandler.commitAndEmit(u,e),this.selectionHandler.generateClickEvent("dragEnd",e,this.getPointer(e.center),void 0,!0),this.body.emitter.emit("_requestRedraw")}else{var l=this.drag.selection;l&&l.length?(ue(l).call(l,function(h){h.node.options.fixed.x=h.xFixed,h.node.options.fixed.y=h.yFixed}),this.selectionHandler.generateClickEvent("dragEnd",e,this.getPointer(e.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler.generateClickEvent("dragEnd",e,this.getPointer(e.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}}},{key:"onPinch",value:function(e){var t=this.getPointer(e.center);this.drag.pinched=!0,this.pinch.scale===void 0&&(this.pinch.scale=1);var i=this.pinch.scale*e.scale;this.zoom(i,t)}},{key:"zoom",value:function(e,t){if(this.options.zoomView===!0){var i=this.body.view.scale;e<1e-5&&(e=1e-5),e>10&&(e=10);var a=void 0;this.drag!==void 0&&this.drag.dragging===!0&&(a=this.canvas.DOMtoCanvas(this.drag.pointer));var o=this.body.view.translation,s=e/i,u=(1-s)*t.x+o.x*s,l=(1-s)*t.y+o.y*s;if(this.body.view.scale=e,this.body.view.translation={x:u,y:l},a!=null){var h=this.canvas.canvasToDOM(a);this.drag.pointer.x=h.x,this.drag.pointer.y=h.y}this.body.emitter.emit("_requestRedraw"),i<e?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:t}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:t})}}},{key:"onMouseWheel",value:function(e){if(this.options.zoomView===!0){if(e.deltaY!==0){var t=this.body.view.scale;t*=1+(e.deltaY<0?1:-1)*(this.options.zoomSpeed*.1);var i=this.getPointer({x:e.clientX,y:e.clientY});this.zoom(t,i)}e.preventDefault()}}},{key:"onMouseMove",value:function(e){var t=this,i=this.getPointer({x:e.clientX,y:e.clientY}),a=!1;this.popup!==void 0&&(this.popup.hidden===!1&&this._checkHidePopup(i),this.popup.hidden===!1&&(a=!0,this.popup.setPosition(i.x+3,i.y-5),this.popup.show())),this.options.keyboard.autoFocus&&this.options.keyboard.bindToWindow===!1&&this.options.keyboard.enabled===!0&&this.canvas.frame.focus(),a===!1&&(this.popupTimer!==void 0&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=or(function(){return t._checkShowPopup(i)},this.options.tooltipDelay))),this.options.hover===!0&&this.selectionHandler.hoverObject(e,i)}},{key:"_checkShowPopup",value:function(e){var t=this.canvas._XconvertDOMtoCanvas(e.x),i=this.canvas._YconvertDOMtoCanvas(e.y),a={left:t,top:i,right:t,bottom:i},o=this.popupObj===void 0?void 0:this.popupObj.id,s=!1,u="node";if(this.popupObj===void 0){for(var l=this.body.nodeIndices,h=this.body.nodes,d,c=[],f=0;f<l.length;f++)d=h[l[f]],d.isOverlappingWith(a)===!0&&(s=!0,d.getTitle()!==void 0&&c.push(l[f]));c.length>0&&(this.popupObj=h[c[c.length-1]],s=!0)}if(this.popupObj===void 0&&s===!1){for(var v=this.body.edgeIndices,p=this.body.edges,y,g=[],m=0;m<v.length;m++)y=p[v[m]],y.isOverlappingWith(a)===!0&&y.connected===!0&&y.getTitle()!==void 0&&g.push(v[m]);g.length>0&&(this.popupObj=p[g[g.length-1]],u="edge")}this.popupObj!==void 0?this.popupObj.id!==o&&(this.popup===void 0&&(this.popup=new one(this.canvas.frame)),this.popup.popupTargetType=u,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(e.x+3,e.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):this.popup!==void 0&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}},{key:"_checkHidePopup",value:function(e){var t=this.selectionHandler._pointerToPositionObject(e),i=!1;if(this.popup.popupTargetType==="node"){if(this.body.nodes[this.popup.popupTargetId]!==void 0&&(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(t),i===!0)){var a=this.selectionHandler.getNodeAt(e);i=a===void 0?!1:a.id===this.popup.popupTargetId}}else this.selectionHandler.getNodeAt(e)===void 0&&this.body.edges[this.popup.popupTargetId]!==void 0&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(t));i===!1&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}]),r}(),$de=mv,wde=nO;$de("Set",function(r){return function(){return r(this,arguments.length?arguments[0]:void 0)}},wde);var _de=te,Ede=_de.Set,Sde=Ede,Ode=Sde,Tde=Ode,li=L(Tde),Pde=re,p$=bv,$s=pl.getWeakData,Ide=gv,kde=Dt,Cde=Qn,Td=We,xde=yv,PO=ti,y$=Ue,IO=zi,Ade=IO.set,Rde=IO.getterFor,Dde=PO.find,Mde=PO.findIndex,Nde=Pde([].splice),Fde=0,ws=function(r){return r.frozen||(r.frozen=new kO)},kO=function(){this.entries=[]},Pd=function(r,n){return Dde(r.entries,function(e){return e[0]===n})};kO.prototype={get:function(r){var n=Pd(this,r);if(n)return n[1]},has:function(r){return!!Pd(this,r)},set:function(r,n){var e=Pd(this,r);e?e[1]=n:this.entries.push([r,n])},delete:function(r){var n=Mde(this.entries,function(e){return e[0]===r});return~n&&Nde(this.entries,n,1),!!~n}};var Bde={getConstructor:function(r,n,e,t){var i=r(function(u,l){Ide(u,a),Ade(u,{type:n,id:Fde++,frozen:void 0}),Cde(l)||xde(l,u[t],{that:u,AS_ENTRIES:e})}),a=i.prototype,o=Rde(n),s=function(u,l,h){var d=o(u),c=$s(kde(l),!0);return c===!0?ws(d).set(l,h):c[d.id]=h,u};return p$(a,{delete:function(u){var l=o(this);if(!Td(u))return!1;var h=$s(u);return h===!0?ws(l).delete(u):h&&y$(h,l.id)&&delete h[l.id]},has:function(l){var h=o(this);if(!Td(l))return!1;var d=$s(l);return d===!0?ws(h).has(l):d&&y$(d,h.id)}}),p$(a,e?{get:function(l){var h=o(this);if(Td(l)){var d=$s(l);return d===!0?ws(h).get(l):d?d[h.id]:void 0}},set:function(l,h){return s(this,l,h)}}:{add:function(l){return s(this,l,!0)}}),i}},Lde=eO,g$=_e,zs=re,m$=bv,jde=pl,zde=mv,CO=Bde,_s=We,Es=zi.enforce,Hde=ee,Wde=U_,jo=Object,Ude=Array.isArray,Ss=jo.isExtensible,xO=jo.isFrozen,Vde=jo.isSealed,AO=jo.freeze,Gde=jo.seal,b$={},$$={},Kde=!g$.ActiveXObject&&"ActiveXObject"in g$,pa,RO=function(r){return function(){return r(this,arguments.length?arguments[0]:void 0)}},DO=zde("WeakMap",RO,CO),an=DO.prototype,Hs=zs(an.set),qde=function(){return Lde&&Hde(function(){var r=AO([]);return Hs(new DO,r,1),!xO(r)})};if(Wde)if(Kde){pa=CO.getConstructor(RO,"WeakMap",!0),jde.enable();var w$=zs(an.delete),Os=zs(an.has),_$=zs(an.get);m$(an,{delete:function(r){if(_s(r)&&!Ss(r)){var n=Es(this);return n.frozen||(n.frozen=new pa),w$(this,r)||n.frozen.delete(r)}return w$(this,r)},has:function(n){if(_s(n)&&!Ss(n)){var e=Es(this);return e.frozen||(e.frozen=new pa),Os(this,n)||e.frozen.has(n)}return Os(this,n)},get:function(n){if(_s(n)&&!Ss(n)){var e=Es(this);return e.frozen||(e.frozen=new pa),Os(this,n)?_$(this,n):e.frozen.get(n)}return _$(this,n)},set:function(n,e){if(_s(n)&&!Ss(n)){var t=Es(this);t.frozen||(t.frozen=new pa),Os(this,n)?Hs(this,n,e):t.frozen.set(n,e)}else Hs(this,n,e);return this}})}else qde()&&m$(an,{set:function(n,e){var t;return Ude(n)&&(xO(n)?t=b$:Vde(n)&&(t=$$)),Hs(this,n,e),t===b$&&AO(n),t===$$&&Gde(n),this}});var Yde=te,Xde=Yde.WeakMap,Qde=Xde,Jde=Qde,Zde=Jde,ka=L(Zde);function le(r,n,e,t){if(e==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof n=="function"?r!==n||!t:!n.has(r))throw new TypeError("Cannot read private member from an object whose class did not declare it");return e==="m"?t:e==="a"?t.call(r):t?t.value:n.get(r)}function Uc(r,n,e,t,i){if(typeof n=="function"?r!==n||!i:!n.has(r))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n.set(r,e),e}function Vc(r,n){var e=typeof ri<"u"&&Wi(r)||r["@@iterator"];if(!e){if(ae(r)||(e=ece(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function ece(r,n){var e;if(r){if(typeof r=="string")return E$(r,n);var t=Ye(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Hi(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return E$(r,n)}}function E$(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}var ui,Mt,Rr,Dr,Ws;function S$(r,n){var e=new li,t=Vc(n),i;try{for(t.s();!(i=t.n()).done;){var a=i.value;r.has(a)||e.add(a)}}catch(o){t.e(o)}finally{t.f()}return e}var O$=function(){function r(){C(this,r),ui.set(this,new li),Mt.set(this,new li)}return x(r,[{key:"size",get:function(){return le(this,Mt,"f").size}},{key:"add",value:function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];for(var a=0,o=t;a<o.length;a++){var s=o[a];le(this,Mt,"f").add(s)}}},{key:"delete",value:function(){for(var e=arguments.length,t=new Array(e),i=0;i<e;i++)t[i]=arguments[i];for(var a=0,o=t;a<o.length;a++){var s=o[a];le(this,Mt,"f").delete(s)}}},{key:"clear",value:function(){le(this,Mt,"f").clear()}},{key:"getSelection",value:function(){return tr(le(this,Mt,"f"))}},{key:"getChanges",value:function(){return{added:tr(S$(le(this,ui,"f"),le(this,Mt,"f"))),deleted:tr(S$(le(this,Mt,"f"),le(this,ui,"f"))),previous:tr(new li(le(this,ui,"f"))),current:tr(new li(le(this,Mt,"f")))}}},{key:"commit",value:function(){var e=this.getChanges();Uc(this,ui,le(this,Mt,"f")),Uc(this,Mt,new li(le(this,ui,"f")));var t=Vc(e.added),i;try{for(t.s();!(i=t.n()).done;){var a=i.value;a.select()}}catch(l){t.e(l)}finally{t.f()}var o=Vc(e.deleted),s;try{for(o.s();!(s=o.n()).done;){var u=s.value;u.unselect()}}catch(l){o.e(l)}finally{o.f()}return e}}]),r}();ui=new ka,Mt=new ka;var tce=function(){function r(){var n=arguments.length>0&&arguments[0]!==void 0?arguments[0]:function(){};C(this,r),Rr.set(this,new O$),Dr.set(this,new O$),Ws.set(this,void 0),Uc(this,Ws,n)}return x(r,[{key:"sizeNodes",get:function(){return le(this,Rr,"f").size}},{key:"sizeEdges",get:function(){return le(this,Dr,"f").size}},{key:"getNodes",value:function(){return le(this,Rr,"f").getSelection()}},{key:"getEdges",value:function(){return le(this,Dr,"f").getSelection()}},{key:"addNodes",value:function(){var e;(e=le(this,Rr,"f")).add.apply(e,arguments)}},{key:"addEdges",value:function(){var e;(e=le(this,Dr,"f")).add.apply(e,arguments)}},{key:"deleteNodes",value:function(e){le(this,Rr,"f").delete(e)}},{key:"deleteEdges",value:function(e){le(this,Dr,"f").delete(e)}},{key:"clear",value:function(){le(this,Rr,"f").clear(),le(this,Dr,"f").clear()}},{key:"commit",value:function(){for(var e,t,i={nodes:le(this,Rr,"f").commit(),edges:le(this,Dr,"f").commit()},a=arguments.length,o=new Array(a),s=0;s<a;s++)o[s]=arguments[s];return(e=le(this,Ws,"f")).call.apply(e,tv(t=[this,i]).call(t,o)),i}}]),r}();Rr=new ka,Dr=new ka,Ws=new ka;function T$(r,n){var e=typeof ri<"u"&&Wi(r)||r["@@iterator"];if(!e){if(ae(r)||(e=rce(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function rce(r,n){var e;if(r){if(typeof r=="string")return P$(r,n);var t=Ye(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Hi(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return P$(r,n)}}function P$(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}var ice=function(){function r(n,e){var t=this;C(this,r),this.body=n,this.canvas=e,this._selectionAccumulator=new tce,this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},Ae(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",function(){t.updateSelection()})}return x(r,[{key:"setOptions",value:function(e){if(e!==void 0){var t=["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"];ua(t,this.options,e)}}},{key:"selectOnPoint",value:function(e){var t=!1;if(this.options.selectable===!0){var i=this.getNodeAt(e)||this.getEdgeAt(e);this.unselectAll(),i!==void 0&&(t=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return t}},{key:"selectAdditionalOnPoint",value:function(e){var t=!1;if(this.options.selectable===!0){var i=this.getNodeAt(e)||this.getEdgeAt(e);i!==void 0&&(t=!0,i.isSelected()===!0?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return t}},{key:"_initBaseEvent",value:function(e,t){var i={};return i.pointer={DOM:{x:t.x,y:t.y},canvas:this.canvas.DOMtoCanvas(t)},i.event=e,i}},{key:"generateClickEvent",value:function(e,t,i,a){var o=arguments.length>4&&arguments[4]!==void 0?arguments[4]:!1,s=this._initBaseEvent(t,i);if(o===!0)s.nodes=[],s.edges=[];else{var u=this.getSelection();s.nodes=u.nodes,s.edges=u.edges}a!==void 0&&(s.previousSelection=a),e=="click"&&(s.items=this.getClickedItems(i)),t.controlEdge!==void 0&&(s.controlEdge=t.controlEdge),this.body.emitter.emit(e,s)}},{key:"selectObject",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:this.options.selectConnectedEdges;if(e!==void 0){if(e instanceof Pt){if(t===!0){var i;(i=this._selectionAccumulator).addEdges.apply(i,tr(e.edges))}this._selectionAccumulator.addNodes(e)}else this._selectionAccumulator.addEdges(e);return!0}return!1}},{key:"deselectObject",value:function(e){e.isSelected()===!0&&(e.selected=!1,this._removeFromSelection(e))}},{key:"_getAllNodesOverlappingWith",value:function(e){for(var t=[],i=this.body.nodes,a=0;a<this.body.nodeIndices.length;a++){var o=this.body.nodeIndices[a];i[o].isOverlappingWith(e)&&t.push(o)}return t}},{key:"_pointerToPositionObject",value:function(e){var t=this.canvas.DOMtoCanvas(e);return{left:t.x-1,top:t.y+1,right:t.x+1,bottom:t.y-1}}},{key:"getNodeAt",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0,i=this._pointerToPositionObject(e),a=this._getAllNodesOverlappingWith(i);if(a.length>0)return t===!0?this.body.nodes[a[a.length-1]]:a[a.length-1]}},{key:"_getEdgesOverlappingWith",value:function(e,t){for(var i=this.body.edges,a=0;a<this.body.edgeIndices.length;a++){var o=this.body.edgeIndices[a];i[o].isOverlappingWith(e)&&t.push(o)}}},{key:"_getAllEdgesOverlappingWith",value:function(e){var t=[];return this._getEdgesOverlappingWith(e,t),t}},{key:"getEdgeAt",value:function(e){for(var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0,i=this.canvas.DOMtoCanvas(e),a=10,o=null,s=this.body.edges,u=0;u<this.body.edgeIndices.length;u++){var l=this.body.edgeIndices[u],h=s[l];if(h.connected){var d=h.from.x,c=h.from.y,f=h.to.x,v=h.to.y,p=h.edgeType.getDistanceToEdge(d,c,f,v,i.x,i.y);p<a&&(o=l,a=p)}}if(o!==null)return t===!0?this.body.edges[o]:o}},{key:"_addToHover",value:function(e){e instanceof Pt?this.hoverObj.nodes[e.id]=e:this.hoverObj.edges[e.id]=e}},{key:"_removeFromSelection",value:function(e){if(e instanceof Pt){var t;this._selectionAccumulator.deleteNodes(e),(t=this._selectionAccumulator).deleteEdges.apply(t,tr(e.edges))}else this._selectionAccumulator.deleteEdges(e)}},{key:"unselectAll",value:function(){this._selectionAccumulator.clear()}},{key:"getSelectedNodeCount",value:function(){return this._selectionAccumulator.sizeNodes}},{key:"getSelectedEdgeCount",value:function(){return this._selectionAccumulator.sizeEdges}},{key:"_hoverConnectedEdges",value:function(e){for(var t=0;t<e.edges.length;t++){var i=e.edges[t];i.hover=!0,this._addToHover(i)}}},{key:"emitBlurEvent",value:function(e,t,i){var a=this._initBaseEvent(e,t);i.hover===!0&&(i.hover=!1,i instanceof Pt?(a.node=i.id,this.body.emitter.emit("blurNode",a)):(a.edge=i.id,this.body.emitter.emit("blurEdge",a)))}},{key:"emitHoverEvent",value:function(e,t,i){var a=this._initBaseEvent(e,t),o=!1;return i.hover===!1&&(i.hover=!0,this._addToHover(i),o=!0,i instanceof Pt?(a.node=i.id,this.body.emitter.emit("hoverNode",a)):(a.edge=i.id,this.body.emitter.emit("hoverEdge",a))),o}},{key:"hoverObject",value:function(e,t){var i=this.getNodeAt(t);i===void 0&&(i=this.getEdgeAt(t));var a=!1;for(var o in this.hoverObj.nodes)Object.prototype.hasOwnProperty.call(this.hoverObj.nodes,o)&&(i===void 0||i instanceof Pt&&i.id!=o||i instanceof wn)&&(this.emitBlurEvent(e,t,this.hoverObj.nodes[o]),delete this.hoverObj.nodes[o],a=!0);for(var s in this.hoverObj.edges)Object.prototype.hasOwnProperty.call(this.hoverObj.edges,s)&&(a===!0?(this.hoverObj.edges[s].hover=!1,delete this.hoverObj.edges[s]):(i===void 0||i instanceof wn&&i.id!=s||i instanceof Pt&&!i.hover)&&(this.emitBlurEvent(e,t,this.hoverObj.edges[s]),delete this.hoverObj.edges[s],a=!0));if(i!==void 0){var u=me(this.hoverObj.edges).length,l=me(this.hoverObj.nodes).length,h=i instanceof wn&&u===0&&l===0,d=i instanceof Pt&&u===0&&l===0;(a||h||d)&&(a=this.emitHoverEvent(e,t,i)),i instanceof Pt&&this.options.hoverConnectedEdges===!0&&this._hoverConnectedEdges(i)}a===!0&&this.body.emitter.emit("_requestRedraw")}},{key:"commitWithoutEmitting",value:function(){this._selectionAccumulator.commit()}},{key:"commitAndEmit",value:function(e,t){var i=!1,a=this._selectionAccumulator.commit(),o={nodes:a.nodes.previous,edges:a.edges.previous};a.edges.deleted.length>0&&(this.generateClickEvent("deselectEdge",t,e,o),i=!0),a.nodes.deleted.length>0&&(this.generateClickEvent("deselectNode",t,e,o),i=!0),a.nodes.added.length>0&&(this.generateClickEvent("selectNode",t,e),i=!0),a.edges.added.length>0&&(this.generateClickEvent("selectEdge",t,e),i=!0),i===!0&&this.generateClickEvent("select",t,e)}},{key:"getSelection",value:function(){return{nodes:this.getSelectedNodeIds(),edges:this.getSelectedEdgeIds()}}},{key:"getSelectedNodes",value:function(){return this._selectionAccumulator.getNodes()}},{key:"getSelectedEdges",value:function(){return this._selectionAccumulator.getEdges()}},{key:"getSelectedNodeIds",value:function(){var e;return xn(e=this._selectionAccumulator.getNodes()).call(e,function(t){return t.id})}},{key:"getSelectedEdgeIds",value:function(){var e;return xn(e=this._selectionAccumulator.getEdges()).call(e,function(t){return t.id})}},{key:"setSelection",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{};if(!e||!e.nodes&&!e.edges)throw new TypeError("Selection must be an object with nodes and/or edges properties");if((t.unselectAll||t.unselectAll===void 0)&&this.unselectAll(),e.nodes){var i=T$(e.nodes),a;try{for(i.s();!(a=i.n()).done;){var o=a.value,s=this.body.nodes[o];if(!s)throw new RangeError('Node with id "'+o+'" not found');this.selectObject(s,t.highlightEdges)}}catch(c){i.e(c)}finally{i.f()}}if(e.edges){var u=T$(e.edges),l;try{for(u.s();!(l=u.n()).done;){var h=l.value,d=this.body.edges[h];if(!d)throw new RangeError('Edge with id "'+h+'" not found');this.selectObject(d)}}catch(c){u.e(c)}finally{u.f()}}this.body.emitter.emit("_requestRedraw"),this._selectionAccumulator.commit()}},{key:"selectNodes",value:function(e){var t=arguments.length>1&&arguments[1]!==void 0?arguments[1]:!0;if(!e||e.length===void 0)throw"Selection must be an array with ids";this.setSelection({nodes:e},{highlightEdges:t})}},{key:"selectEdges",value:function(e){if(!e||e.length===void 0)throw"Selection must be an array with ids";this.setSelection({edges:e})}},{key:"updateSelection",value:function(){for(var e in this._selectionAccumulator.getNodes())Object.prototype.hasOwnProperty.call(this.body.nodes,e.id)||this._selectionAccumulator.deleteNodes(e);for(var t in this._selectionAccumulator.getEdges())Object.prototype.hasOwnProperty.call(this.body.edges,t.id)||this._selectionAccumulator.deleteEdges(t)}},{key:"getClickedItems",value:function(e){for(var t=this.canvas.DOMtoCanvas(e),i=[],a=this.body.nodeIndices,o=this.body.nodes,s=a.length-1;s>=0;s--){var u=o[a[s]],l=u.getItemsOnPoint(t);i.push.apply(i,l)}for(var h=this.body.edgeIndices,d=this.body.edges,c=h.length-1;c>=0;c--){var f=d[h[c]],v=f.getItemsOnPoint(t);i.push.apply(i,v)}return i}}]),r}(),I$=mE,nce=Math.floor,Gc=function(r,n){var e=r.length,t=nce(e/2);return e<8?ace(r,n):oce(r,Gc(I$(r,0,t),n),Gc(I$(r,t),n),n)},ace=function(r,n){for(var e=r.length,t=1,i,a;t<e;){for(a=t,i=r[t];a&&n(r[a-1],i)>0;)r[a]=r[--a];a!==t++&&(r[a]=i)}return r},oce=function(r,n,e,t){for(var i=n.length,a=e.length,o=0,s=0;o<i||s<a;)r[o+s]=o<i&&s<a?t(n[o],e[s])<=0?n[o++]:e[s++]:o<i?n[o++]:e[s++];return r},sce=Gc,uce=bo,k$=uce.match(/firefox\/(\d+)/i),lce=!!k$&&+k$[1],hce=bo,dce=/MSIE|Trident/.test(hce),cce=bo,C$=cce.match(/AppleWebKit\/(\d+)\./),fce=!!C$&&+C$[1],vce=V,MO=re,pce=Li,yce=Et,x$=Ht,gce=nS,A$=dr,Ov=ee,mce=sce,bce=oa,R$=lce,$ce=dce,D$=$o,M$=fce,Lr=[],N$=MO(Lr.sort),wce=MO(Lr.push),_ce=Ov(function(){Lr.sort(void 0)}),Ece=Ov(function(){Lr.sort(null)}),Sce=bce("sort"),NO=!Ov(function(){if(D$)return D$<70;if(!(R$&&R$>3)){if($ce)return!0;if(M$)return M$<603;var r="",n,e,t,i;for(n=65;n<76;n++){switch(e=String.fromCharCode(n),n){case 66:case 69:case 70:case 72:t=3;break;case 68:case 71:t=4;break;default:t=2}for(i=0;i<47;i++)Lr.push({k:e+i,v:t})}for(Lr.sort(function(a,o){return o.v-a.v}),i=0;i<Lr.length;i++)e=Lr[i].k.charAt(0),r.charAt(r.length-1)!==e&&(r+=e);return r!=="DGBEFHACIJK"}}),Oce=_ce||!Ece||!Sce||!NO,Tce=function(r){return function(n,e){return e===void 0?-1:n===void 0?1:r!==void 0?+r(n,e)||0:A$(n)>A$(e)?1:-1}};vce({target:"Array",proto:!0,forced:Oce},{sort:function(n){n!==void 0&&pce(n);var e=yce(this);if(NO)return n===void 0?N$(e):N$(e,n);var t=[],i=x$(e),a,o;for(o=0;o<i;o++)o in e&&wce(t,e[o]);for(mce(t,Tce(n)),a=x$(t),o=0;o<a;)e[o]=t[o++];for(;o<i;)gce(e,o++);return e}});var Pce=Ve,Ice=Pce("Array").sort,kce=Ie,Cce=Ice,Id=Array.prototype,xce=function(r){var n=r.sort;return r===Id||kce(Id,r)&&n===Id.sort?Cce:n},Ace=xce,Rce=Ace,Dce=Rce,Ca=L(Dce),Mce=Li,Nce=Et,Fce=Ku,Bce=Ht,Lce=TypeError,F$=function(r){return function(n,e,t,i){Mce(e);var a=Nce(n),o=Fce(a),s=Bce(a),u=r?s-1:0,l=r?-1:1;if(t<2)for(;;){if(u in o){i=o[u],u+=l;break}if(u+=l,r?u<0:s<=u)throw new Lce("Reduce of empty array with no initial value")}for(;r?u>=0:s>u;u+=l)u in o&&(i=e(i,o[u],u,a));return i}},jce={left:F$(!1),right:F$(!0)},zce=_e,Hce=kr,Wce=Hce(zce.process)==="process",Uce=V,Vce=jce.left,Gce=oa,B$=$o,Kce=Wce,qce=!Kce&&B$>79&&B$<83,Yce=qce||!Gce("reduce");Uce({target:"Array",proto:!0,forced:Yce},{reduce:function(n){var e=arguments.length;return Vce(this,n,e,e>1?arguments[1]:void 0)}});var Xce=Ve,Qce=Xce("Array").reduce,Jce=Ie,Zce=Qce,kd=Array.prototype,efe=function(r){var n=r.reduce;return r===kd||Jce(kd,r)&&n===kd.reduce?Zce:n},tfe=efe,rfe=tfe,ife=rfe,FO=L(ife);function BO(r){var n=nfe();return function(){var t=N(r),i;if(n){var a=N(this).constructor;i=_(t,arguments,a)}else i=t.apply(this,arguments);return oe(this,i)}}function nfe(){if(typeof Reflect>"u"||!_||_.sham)return!1;if(typeof Proxy=="function")return!0;try{return Boolean.prototype.valueOf.call(_(Boolean,[],function(){})),!0}catch{return!1}}var LO=function(){function r(){C(this,r)}return x(r,[{key:"abstract",value:function(){throw new Error("Can't instantiate abstract class!")}},{key:"fake_use",value:function(){}},{key:"curveType",value:function(){return this.abstract()}},{key:"getPosition",value:function(e){return this.fake_use(e),this.abstract()}},{key:"setPosition",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:void 0;this.fake_use(e,t,i),this.abstract()}},{key:"getTreeSize",value:function(e){return this.fake_use(e),this.abstract()}},{key:"sort",value:function(e){this.fake_use(e),this.abstract()}},{key:"fix",value:function(e,t){this.fake_use(e,t),this.abstract()}},{key:"shift",value:function(e,t){this.fake_use(e,t),this.abstract()}}]),r}(),afe=function(r){ie(e,r);var n=BO(e);function e(t){var i;return C(this,e),i=n.call(this),i.layout=t,i}return x(e,[{key:"curveType",value:function(){return"horizontal"}},{key:"getPosition",value:function(i){return i.x}},{key:"setPosition",value:function(i,a){var o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:void 0;o!==void 0&&this.layout.hierarchical.addToOrdering(i,o),i.x=a}},{key:"getTreeSize",value:function(i){var a=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,i);return{min:a.min_x,max:a.max_x}}},{key:"sort",value:function(i){Ca(i).call(i,function(a,o){return a.x-o.x})}},{key:"fix",value:function(i,a){i.y=this.layout.options.hierarchical.levelSeparation*a,i.options.fixed.y=!0}},{key:"shift",value:function(i,a){this.layout.body.nodes[i].x+=a}}]),e}(LO),ofe=function(r){ie(e,r);var n=BO(e);function e(t){var i;return C(this,e),i=n.call(this),i.layout=t,i}return x(e,[{key:"curveType",value:function(){return"vertical"}},{key:"getPosition",value:function(i){return i.y}},{key:"setPosition",value:function(i,a){var o=arguments.length>2&&arguments[2]!==void 0?arguments[2]:void 0;o!==void 0&&this.layout.hierarchical.addToOrdering(i,o),i.y=a}},{key:"getTreeSize",value:function(i){var a=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,i);return{min:a.min_y,max:a.max_y}}},{key:"sort",value:function(i){Ca(i).call(i,function(a,o){return a.y-o.y})}},{key:"fix",value:function(i,a){i.x=this.layout.options.hierarchical.levelSeparation*a,i.options.fixed.x=!0}},{key:"shift",value:function(i,a){this.layout.body.nodes[i].y+=a}}]),e}(LO),sfe=V,ufe=ti.every,lfe=oa,hfe=lfe("every");sfe({target:"Array",proto:!0,forced:!hfe},{every:function(n){return ufe(this,n,arguments.length>1?arguments[1]:void 0)}});var dfe=Ve,cfe=dfe("Array").every,ffe=Ie,vfe=cfe,Cd=Array.prototype,pfe=function(r){var n=r.every;return r===Cd||ffe(Cd,r)&&n===Cd.every?vfe:n},yfe=pfe,gfe=yfe,mfe=gfe,jO=L(mfe);function bfe(r,n){var e=typeof ri<"u"&&Wi(r)||r["@@iterator"];if(!e){if(ae(r)||(e=$fe(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function $fe(r,n){var e;if(r){if(typeof r=="string")return L$(r,n);var t=Ye(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Hi(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return L$(r,n)}}function L$(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}function wfe(r,n){var e=new li;return ue(r).call(r,function(t){var i;ue(i=t.edges).call(i,function(a){a.connected&&e.add(a)})}),ue(e).call(e,function(t){var i=t.from.id,a=t.to.id;n[i]==null&&(n[i]=0),(n[a]==null||n[i]>=n[a])&&(n[a]=n[i]+1)}),n}function _fe(r){return zO(function(n){var e,t;return jO(e=gt(t=n.edges).call(t,function(i){return r.has(i.toId)})).call(e,function(i){return i.to===n})},function(n,e){return e>n},"from",r)}function Efe(r){return zO(function(n){var e,t;return jO(e=gt(t=n.edges).call(t,function(i){return r.has(i.toId)})).call(e,function(i){return i.from===n})},function(n,e){return e<n},"to",r)}function zO(r,n,e,t){var i,a=$i(null),o=FO(i=tr(yO(t).call(t))).call(i,function(f,v){return f+1+v.edges.length},0),s=e+"Id",u=e==="to"?1:-1,l=bfe(t),h;try{var d=function(){var v=be(h.value,2),p=v[0],y=v[1];if(!t.has(p)||!r(y))return 0;a[p]=0;for(var g=[y],m=0,w,$=function(){var D,j;if(!t.has(p))return 0;var R=a[w.id]+u;if(ue(D=gt(j=w.edges).call(j,function(M){return M.connected&&M.to!==M.from&&M[e]!==w&&t.has(M.toId)&&t.has(M.fromId)})).call(D,function(M){var W=M[s],X=a[W];(X==null||n(R,X))&&(a[W]=R,g.push(M[e]))}),m>o)return{v:{v:wfe(t,a)}};++m},E;w=g.pop();)if(E=$(),E!==0&&E)return E.v},c;for(l.s();!(h=l.n()).done;)if(c=d(),c!==0&&c)return c.v}catch(f){l.e(f)}finally{l.f()}return a}var Sfe=function(){function r(){C(this,r),this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}return x(r,[{key:"addRelation",value:function(e,t){this.childrenReference[e]===void 0&&(this.childrenReference[e]=[]),this.childrenReference[e].push(t),this.parentReference[t]===void 0&&(this.parentReference[t]=[]),this.parentReference[t].push(e)}},{key:"checkIfTree",value:function(){for(var e in this.parentReference)if(this.parentReference[e].length>1){this.isTree=!1;return}this.isTree=!0}},{key:"numTrees",value:function(){return this.treeIndex+1}},{key:"setTreeIndex",value:function(e,t){t!==void 0&&this.trees[e.id]===void 0&&(this.trees[e.id]=t,this.treeIndex=Math.max(t,this.treeIndex))}},{key:"ensureLevel",value:function(e){this.levels[e]===void 0&&(this.levels[e]=0)}},{key:"getMaxLevel",value:function(e){var t=this,i={},a=function o(s){if(i[s]!==void 0)return i[s];var u=t.levels[s];if(t.childrenReference[s]){var l=t.childrenReference[s];if(l.length>0)for(var h=0;h<l.length;h++)u=Math.max(u,o(l[h]))}return i[s]=u,u};return a(e)}},{key:"levelDownstream",value:function(e,t){this.levels[t.id]===void 0&&(this.levels[e.id]===void 0&&(this.levels[e.id]=0),this.levels[t.id]=this.levels[e.id]+1)}},{key:"setMinLevelToZero",value:function(e){var t=1e9;for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&this.levels[i]!==void 0&&(t=Math.min(this.levels[i],t));for(var a in e)Object.prototype.hasOwnProperty.call(e,a)&&this.levels[a]!==void 0&&(this.levels[a]-=t)}},{key:"getTreeSize",value:function(e,t){var i=1e9,a=-1e9,o=1e9,s=-1e9;for(var u in this.trees)if(Object.prototype.hasOwnProperty.call(this.trees,u)&&this.trees[u]===t){var l=e[u];i=Math.min(l.x,i),a=Math.max(l.x,a),o=Math.min(l.y,o),s=Math.max(l.y,s)}return{min_x:i,max_x:a,min_y:o,max_y:s}}},{key:"hasSameParent",value:function(e,t){var i=this.parentReference[e.id],a=this.parentReference[t.id];if(i===void 0||a===void 0)return!1;for(var o=0;o<i.length;o++)for(var s=0;s<a.length;s++)if(i[o]==a[s])return!0;return!1}},{key:"inSameSubNetwork",value:function(e,t){return this.trees[e.id]===this.trees[t.id]}},{key:"getLevels",value:function(){return me(this.distributionOrdering)}},{key:"addToOrdering",value:function(e,t){this.distributionOrdering[t]===void 0&&(this.distributionOrdering[t]=[]);var i=!1,a=this.distributionOrdering[t];for(var o in a)if(a[o]===e){i=!0;break}i||(this.distributionOrdering[t].push(e),this.distributionIndex[e.id]=this.distributionOrdering[t].length-1)}}]),r}(),Ofe=function(){function r(n){C(this,r),this.body=n,this._resetRNG(Math.random()+":"+su()),this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},Ae(this.options,this.defaultOptions),this.bindEventListeners()}return x(r,[{key:"bindEventListeners",value:function(){var e=this;this.body.emitter.on("_dataChanged",function(){e.setupHierarchicalLayout()}),this.body.emitter.on("_dataLoaded",function(){e.layoutNetwork()}),this.body.emitter.on("_resetHierarchicalLayout",function(){e.setupHierarchicalLayout()}),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",function(){if(e.options.hierarchical.enabled===!0){var t=e.direction.curveType();e.body.emitter.emit("_forceDisableDynamicCurves",t,!1)}})}},{key:"setOptions",value:function(e,t){if(e!==void 0){var i=this.options.hierarchical,a=i.enabled;if(ua(["randomSeed","improvedLayout","clusterThreshold"],this.options,e),Nt(this.options,e,"hierarchical"),e.randomSeed!==void 0&&this._resetRNG(e.randomSeed),i.enabled===!0)return a===!0&&this.body.emitter.emit("refresh",!0),i.direction==="RL"||i.direction==="DU"?i.levelSeparation>0&&(i.levelSeparation*=-1):i.levelSeparation<0&&(i.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(t);if(a===!0)return this.body.emitter.emit("refresh"),he(t,this.optionsBackup)}return t}},{key:"_resetRNG",value:function(e){this.initialRandomSeed=e,this._rng=vl(this.initialRandomSeed)}},{key:"adaptAllOptionsForHierarchicalLayout",value:function(e){if(this.options.hierarchical.enabled===!0){var t=this.optionsBackup.physics;e.physics===void 0||e.physics===!0?(e.physics={enabled:t.enabled===void 0?!0:t.enabled,solver:"hierarchicalRepulsion"},t.enabled=t.enabled===void 0?!0:t.enabled,t.solver=t.solver||"barnesHut"):se(e.physics)==="object"?(t.enabled=e.physics.enabled===void 0?!0:e.physics.enabled,t.solver=e.physics.solver||"barnesHut",e.physics.solver="hierarchicalRepulsion"):e.physics!==!1&&(t.solver="barnesHut",e.physics={solver:"hierarchicalRepulsion"});var i=this.direction.curveType();if(e.edges===void 0)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges={smooth:!1};else if(e.edges.smooth===void 0)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},e.edges.smooth=!1;else if(typeof e.edges.smooth=="boolean")this.optionsBackup.edges={smooth:e.edges.smooth},e.edges.smooth={enabled:e.edges.smooth,type:i};else{var a=e.edges.smooth;a.type!==void 0&&a.type!=="dynamic"&&(i=a.type),this.optionsBackup.edges={smooth:{enabled:a.enabled===void 0?!0:a.enabled,type:a.type===void 0?"dynamic":a.type,roundness:a.roundness===void 0?.5:a.roundness,forceDirection:a.forceDirection===void 0?!1:a.forceDirection}},e.edges.smooth={enabled:a.enabled===void 0?!0:a.enabled,type:i,roundness:a.roundness===void 0?.5:a.roundness,forceDirection:a.forceDirection===void 0?!1:a.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return e}},{key:"positionInitially",value:function(e){if(this.options.hierarchical.enabled!==!0){this._resetRNG(this.initialRandomSeed);for(var t=e.length+50,i=0;i<e.length;i++){var a=e[i],o=2*Math.PI*this._rng();a.x===void 0&&(a.x=t*Math.cos(o)),a.y===void 0&&(a.y=t*Math.sin(o))}}}},{key:"layoutNetwork",value:function(){if(this.options.hierarchical.enabled!==!0&&this.options.improvedLayout===!0){for(var e=this.body.nodeIndices,t=0,i=0;i<e.length;i++){var a=this.body.nodes[e[i]];a.predefinedPosition===!0&&(t+=1)}if(t<.5*e.length){var o=10,s=0,u=this.options.clusterThreshold,l={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(e.length>u){for(var h=e.length;e.length>u&&s<=o;){s+=1;var d=e.length;s%3===0?this.body.modules.clustering.clusterBridges(l):this.body.modules.clustering.clusterOutliers(l);var c=e.length;if(d==c&&s%3!==0){this._declusterAll(),this.body.emitter.emit("_layoutFailed"),console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.");return}}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*h)})}s>o&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(e,this.body.edgeIndices,!0),this._shiftToCenter();for(var f=70,v=0;v<e.length;v++){var p=this.body.nodes[e[v]];p.predefinedPosition===!1&&(p.x+=(.5-this._rng())*f,p.y+=(.5-this._rng())*f)}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}},{key:"_shiftToCenter",value:function(){for(var e=ot.getRangeCore(this.body.nodes,this.body.nodeIndices),t=ot.findCenter(e),i=0;i<this.body.nodeIndices.length;i++){var a=this.body.nodes[this.body.nodeIndices[i]];a.x-=t.x,a.y-=t.y}}},{key:"_declusterAll",value:function(){for(var e=!0;e===!0;){e=!1;for(var t=0;t<this.body.nodeIndices.length;t++)this.body.nodes[this.body.nodeIndices[t]].isCluster===!0&&(e=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[t],{},!1));e===!0&&this.body.emitter.emit("_dataChanged")}}},{key:"getSeed",value:function(){return this.initialRandomSeed}},{key:"setupHierarchicalLayout",value:function(){if(this.options.hierarchical.enabled===!0&&this.body.nodeIndices.length>0){var e,t,i=!1,a=!1;this.lastNodeOnLevel={},this.hierarchical=new Sfe;for(t in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,t)&&(e=this.body.nodes[t],e.options.level!==void 0?(i=!0,this.hierarchical.levels[t]=e.options.level):a=!0);if(a===!0&&i===!0)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");if(a===!0){var o=this.options.hierarchical.sortMethod;o==="hubsize"?this._determineLevelsByHubsize():o==="directed"?this._determineLevelsDirected():o==="custom"&&this._determineLevelsCustomCallback()}for(var s in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,s)&&this.hierarchical.ensureLevel(s);var u=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(u),this._condenseHierarchy(),this._shiftToCenter()}}},{key:"_condenseHierarchy",value:function(){var e=this,t=!1,i={},a=function(){for(var w=s(),$=0,E=0;E<w.length-1;E++){var k=w[E].max-w[E+1].min;$+=k+e.options.hierarchical.treeSpacing,o(E+1,$)}},o=function(w,$){var E=e.hierarchical.trees;for(var k in E)Object.prototype.hasOwnProperty.call(E,k)&&E[k]===w&&e.direction.shift(k,$)},s=function(){for(var w=[],$=0;$<e.hierarchical.numTrees();$++)w.push(e.direction.getTreeSize($));return w},u=function m(w,$){if(!$[w.id]&&($[w.id]=!0,e.hierarchical.childrenReference[w.id])){var E=e.hierarchical.childrenReference[w.id];if(E.length>0)for(var k=0;k<E.length;k++)m(e.body.nodes[E[k]],$)}},l=function(w){var $=arguments.length>1&&arguments[1]!==void 0?arguments[1]:1e9,E=1e9,k=1e9,D=1e9,j=-1e9;for(var R in w)if(Object.prototype.hasOwnProperty.call(w,R)){var M=e.body.nodes[R],W=e.hierarchical.levels[M.id],X=e.direction.getPosition(M),Y=e._getSpaceAroundNode(M,w),ye=be(Y,2),Ge=ye[0],ke=ye[1];E=Math.min(Ge,E),k=Math.min(ke,k),W<=$&&(D=Math.min(X,D),j=Math.max(X,j))}return[D,j,E,k]},h=function(w,$){var E=e.hierarchical.getMaxLevel(w.id),k=e.hierarchical.getMaxLevel($.id);return Math.min(E,k)},d=function(w,$,E){for(var k=e.hierarchical,D=0;D<$.length;D++){var j=$[D],R=k.distributionOrdering[j];if(R.length>1)for(var M=0;M<R.length-1;M++){var W=R[M],X=R[M+1];k.hasSameParent(W,X)&&k.inSameSubNetwork(W,X)&&w(W,X,E)}}},c=function(w,$){var E=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1,k=e.direction.getPosition(w),D=e.direction.getPosition($),j=Math.abs(D-k),R=e.options.hierarchical.nodeSpacing;if(j>R){var M={},W={};u(w,M),u($,W);var X=h(w,$),Y=l(M,X),ye=l(W,X),Ge=Y[1],ke=ye[0],St=ye[2],rt=Math.abs(Ge-ke);if(rt>R){var Qe=Ge-ke+R;Qe<-St+R&&(Qe=-St+R),Qe<0&&(e._shiftBlock($.id,Qe),t=!0,E===!0&&e._centerParent($))}}},f=function(w,$){for(var E=$.id,k=$.edges,D=e.hierarchical.levels[$.id],j=e.options.hierarchical.levelSeparation*e.options.hierarchical.levelSeparation,R={},M=[],W=0;W<k.length;W++){var X=k[W];if(X.toId!=X.fromId){var Y=X.toId==E?X.from:X.to;R[k[W].id]=Y,e.hierarchical.levels[Y.id]<D&&M.push(X)}}var ye=function(Je,ce){for(var Ce=0,Oe=0;Oe<ce.length;Oe++)if(R[ce[Oe].id]!==void 0){var Ze=e.direction.getPosition(R[ce[Oe].id])-Je;Ce+=Ze/Math.sqrt(Ze*Ze+j)}return Ce},Ge=function(Je,ce){for(var Ce=0,Oe=0;Oe<ce.length;Oe++)if(R[ce[Oe].id]!==void 0){var Ze=e.direction.getPosition(R[ce[Oe].id])-Je;Ce-=j*Math.pow(Ze*Ze+j,-1.5)}return Ce},ke=function(Je,ce){for(var Ce=e.direction.getPosition($),Oe={},Ze=0;Ze<Je;Ze++){var cr=ye(Ce,ce),Tt=Ge(Ce,ce),et=40,A=Math.max(-et,Math.min(et,Math.round(cr/Tt)));if(Ce=Ce-A,Oe[Ce]!==void 0)break;Oe[Ce]=Ze}return Ce},St=function(Je){var ce=e.direction.getPosition($);if(i[$.id]===void 0){var Ce={};u($,Ce),i[$.id]=Ce}var Oe=l(i[$.id]),Ze=Oe[2],cr=Oe[3],Tt=Je-ce,et=0;Tt>0?et=Math.min(Tt,cr-e.options.hierarchical.nodeSpacing):Tt<0&&(et=-Math.min(-Tt,Ze-e.options.hierarchical.nodeSpacing)),et!=0&&(e._shiftBlock($.id,et),t=!0)},rt=function(Je){var ce=e.direction.getPosition($),Ce=e._getSpaceAroundNode($),Oe=be(Ce,2),Ze=Oe[0],cr=Oe[1],Tt=Je-ce,et=ce;Tt>0?et=Math.min(ce+(cr-e.options.hierarchical.nodeSpacing),Je):Tt<0&&(et=Math.max(ce-(Ze-e.options.hierarchical.nodeSpacing),Je)),et!==ce&&(e.direction.setPosition($,et),t=!0)},Qe=ke(w,M);St(Qe),Qe=ke(w,k),rt(Qe)},v=function(w){var $=e.hierarchical.getLevels();$=bi($).call($);for(var E=0;E<w;E++){t=!1;for(var k=0;k<$.length;k++)for(var D=$[k],j=e.hierarchical.distributionOrdering[D],R=0;R<j.length;R++)f(1e3,j[R]);if(t!==!0)break}},p=function(w){var $=e.hierarchical.getLevels();$=bi($).call($);for(var E=0;E<w&&(t=!1,d(c,$,!0),t===!0);E++);},y=function(){for(var w in e.body.nodes)Object.prototype.hasOwnProperty.call(e.body.nodes,w)&&e._centerParent(e.body.nodes[w])},g=function(){var w=e.hierarchical.getLevels();w=bi(w).call(w);for(var $=0;$<w.length;$++)for(var E=w[$],k=e.hierarchical.distributionOrdering[E],D=0;D<k.length;D++)e._centerParent(k[D])};this.options.hierarchical.blockShifting===!0&&(p(5),y()),this.options.hierarchical.edgeMinimization===!0&&v(20),this.options.hierarchical.parentCentralization===!0&&g(),a()}},{key:"_getSpaceAroundNode",value:function(e,t){var i=!0;t===void 0&&(i=!1);var a=this.hierarchical.levels[e.id];if(a!==void 0){var o=this.hierarchical.distributionIndex[e.id],s=this.direction.getPosition(e),u=this.hierarchical.distributionOrdering[a],l=1e9,h=1e9;if(o!==0){var d=u[o-1];if(i===!0&&t[d.id]===void 0||i===!1){var c=this.direction.getPosition(d);l=s-c}}if(o!=u.length-1){var f=u[o+1];if(i===!0&&t[f.id]===void 0||i===!1){var v=this.direction.getPosition(f);h=Math.min(h,v-s)}}return[l,h]}else return[0,0]}},{key:"_centerParent",value:function(e){if(this.hierarchical.parentReference[e.id])for(var t=this.hierarchical.parentReference[e.id],i=0;i<t.length;i++){var a=t[i],o=this.body.nodes[a],s=this.hierarchical.childrenReference[a];if(s!==void 0){var u=this._getCenterPosition(s),l=this.direction.getPosition(o),h=this._getSpaceAroundNode(o),d=be(h,2),c=d[0],f=d[1],v=l-u;(v<0&&Math.abs(v)<f-this.options.hierarchical.nodeSpacing||v>0&&Math.abs(v)<c-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(o,u)}}}},{key:"_placeNodesByHierarchy",value:function(e){this.positionedNodes={};for(var t in e)if(Object.prototype.hasOwnProperty.call(e,t)){var i,a=me(e[t]);a=this._indexArrayToNodes(a),Ca(i=this.direction).call(i,a);for(var o=0,s=0;s<a.length;s++){var u=a[s];if(this.positionedNodes[u.id]===void 0){var l=this.options.hierarchical.nodeSpacing,h=l*o;o>0&&(h=this.direction.getPosition(a[s-1])+l),this.direction.setPosition(u,h,t),this._validatePositionAndContinue(u,t,h),o++}}}}},{key:"_placeBranchNodes",value:function(e,t){var i,a=this.hierarchical.childrenReference[e];if(a!==void 0){for(var o=[],s=0;s<a.length;s++)o.push(this.body.nodes[a[s]]);Ca(i=this.direction).call(i,o);for(var u=0;u<o.length;u++){var l=o[u],h=this.hierarchical.levels[l.id];if(h>t&&this.positionedNodes[l.id]===void 0){var d=this.options.hierarchical.nodeSpacing,c=void 0;u===0?c=this.direction.getPosition(this.body.nodes[e]):c=this.direction.getPosition(o[u-1])+d,this.direction.setPosition(l,c,h),this._validatePositionAndContinue(l,h,c)}else return}var f=this._getCenterPosition(o);this.direction.setPosition(this.body.nodes[e],f,t)}}},{key:"_validatePositionAndContinue",value:function(e,t,i){if(this.hierarchical.isTree){if(this.lastNodeOnLevel[t]!==void 0){var a=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[t]]);if(i-a<this.options.hierarchical.nodeSpacing){var o=a+this.options.hierarchical.nodeSpacing-i,s=this._findCommonParent(this.lastNodeOnLevel[t],e.id);this._shiftBlock(s.withChild,o)}}this.lastNodeOnLevel[t]=e.id,this.positionedNodes[e.id]=!0,this._placeBranchNodes(e.id,t)}}},{key:"_indexArrayToNodes",value:function(e){for(var t=[],i=0;i<e.length;i++)t.push(this.body.nodes[e[i]]);return t}},{key:"_getDistribution",value:function(){var e={},t,i;for(t in this.body.nodes)if(Object.prototype.hasOwnProperty.call(this.body.nodes,t)){i=this.body.nodes[t];var a=this.hierarchical.levels[t]===void 0?0:this.hierarchical.levels[t];this.direction.fix(i,a),e[a]===void 0&&(e[a]={}),e[a][t]=i}return e}},{key:"_getActiveEdges",value:function(e){var t=this,i=[];return J(e.edges,function(a){var o;Z(o=t.body.edgeIndices).call(o,a.id)!==-1&&i.push(a)}),i}},{key:"_getHubSizes",value:function(){var e=this,t={},i=this.body.nodeIndices;J(i,function(o){var s=e.body.nodes[o],u=e._getActiveEdges(s).length;t[u]=!0});var a=[];return J(t,function(o){a.push(Number(o))}),Ca(a).call(a,function(o,s){return s-o}),a}},{key:"_determineLevelsByHubsize",value:function(){for(var e=this,t=function(u,l){e.hierarchical.levelDownstream(u,l)},i=this._getHubSizes(),a=function(){var u=i[o];if(u===0)return 1;J(e.body.nodeIndices,function(l){var h=e.body.nodes[l];u===e._getActiveEdges(h).length&&e._crawlNetwork(t,l)})},o=0;o<i.length&&!a();++o);}},{key:"_determineLevelsCustomCallback",value:function(){var e=this,t=1e5,i=function(s,u,l){},a=function(s,u,l){var h=e.hierarchical.levels[s.id];h===void 0&&(h=e.hierarchical.levels[s.id]=t);var d=i(ot.cloneOptions(s,"node"),ot.cloneOptions(u,"node"),ot.cloneOptions(l,"edge"));e.hierarchical.levels[u.id]=h+d};this._crawlNetwork(a),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_determineLevelsDirected",value:function(){var e,t=this,i=FO(e=this.body.nodeIndices).call(e,function(a,o){return a.set(o,t.body.nodes[o]),a},new aO);this.options.hierarchical.shakeTowards==="roots"?this.hierarchical.levels=Efe(i):this.hierarchical.levels=_fe(i),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_generateMap",value:function(){var e=this,t=function(a,o){e.hierarchical.levels[o.id]>e.hierarchical.levels[a.id]&&e.hierarchical.addRelation(a.id,o.id)};this._crawlNetwork(t),this.hierarchical.checkIfTree()}},{key:"_crawlNetwork",value:function(){var e=this,t=arguments.length>0&&arguments[0]!==void 0?arguments[0]:function(){},i=arguments.length>1?arguments[1]:void 0,a={},o=function c(f,v){if(a[f.id]===void 0){e.hierarchical.setTreeIndex(f,v),a[f.id]=!0;for(var p,y=e._getActiveEdges(f),g=0;g<y.length;g++){var m=y[g];m.connected===!0&&(m.toId==f.id?p=m.from:p=m.to,f.id!=p.id&&(t(f,p,m),c(p,v)))}}};if(i===void 0)for(var s=0,u=0;u<this.body.nodeIndices.length;u++){var l=this.body.nodeIndices[u];if(a[l]===void 0){var h=this.body.nodes[l];o(h,s),s+=1}}else{var d=this.body.nodes[i];if(d===void 0){console.error("Node not found:",i);return}o(d)}}},{key:"_shiftBlock",value:function(e,t){var i=this,a={},o=function s(u){if(!a[u]){a[u]=!0,i.direction.shift(u,t);var l=i.hierarchical.childrenReference[u];if(l!==void 0)for(var h=0;h<l.length;h++)s(l[h])}};o(e)}},{key:"_findCommonParent",value:function(e,t){var i=this,a={},o=function u(l,h){var d=i.hierarchical.parentReference[h];if(d!==void 0)for(var c=0;c<d.length;c++){var f=d[c];l[f]=!0,u(l,f)}},s=function u(l,h){var d=i.hierarchical.parentReference[h];if(d!==void 0)for(var c=0;c<d.length;c++){var f=d[c];if(l[f]!==void 0)return{foundParent:f,withChild:h};var v=u(l,f);if(v.foundParent!==null)return v}return{foundParent:null,withChild:h}};return o(a,e),s(a,t)}},{key:"setDirectionStrategy",value:function(){var e=this.options.hierarchical.direction==="UD"||this.options.hierarchical.direction==="DU";e?this.direction=new afe(this):this.direction=new ofe(this)}},{key:"_getCenterPosition",value:function(e){for(var t=1e9,i=-1e9,a=0;a<e.length;a++){var o=void 0;if(e[a].id!==void 0)o=e[a];else{var s=e[a];o=this.body.nodes[s]}var u=this.direction.getPosition(o);t=Math.min(t,u),i=Math.max(i,u)}return .5*(t+i)}}]),r}();function Tfe(r,n){var e=typeof ri<"u"&&Wi(r)||r["@@iterator"];if(!e){if(ae(r)||(e=Pfe(r))||n){e&&(r=e);var t=0,i=function(){};return{s:i,n:function(){return t>=r.length?{done:!0}:{done:!1,value:r[t++]}},e:function(l){throw l},f:i}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var a=!0,o=!1,s;return{s:function(){e=e.call(r)},n:function(){var l=e.next();return a=l.done,l},e:function(l){o=!0,s=l},f:function(){try{!a&&e.return!=null&&e.return()}finally{if(o)throw s}}}}function Pfe(r,n){var e;if(r){if(typeof r=="string")return j$(r,n);var t=Ye(e=Object.prototype.toString.call(r)).call(e,8,-1);if(t==="Object"&&r.constructor&&(t=r.constructor.name),t==="Map"||t==="Set")return Hi(r);if(t==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))return j$(r,n)}}function j$(r,n){(n==null||n>r.length)&&(n=r.length);for(var e=0,t=new Array(n);e<n;e++)t[e]=r[e];return t}var Ife=function(){function r(n,e,t,i){var a=this,o,s;C(this,r),this.body=n,this.canvas=e,this.selectionHandler=t,this.interactionHandler=i,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this._domEventListenerCleanupQueue=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},Ae(this.options,this.defaultOptions),this.body.emitter.on("destroy",function(){a._clean()}),this.body.emitter.on("_dataChanged",O(o=this._restore).call(o,this)),this.body.emitter.on("_resetData",O(s=this._restore).call(s,this))}return x(r,[{key:"_restore",value:function(){this.inMode!==!1&&(this.options.initiallyActive===!0?this.enableEditMode():this.disableEditMode())}},{key:"setOptions",value:function(e,t,i){t!==void 0&&(t.locale!==void 0?this.options.locale=t.locale:this.options.locale=i.locale,t.locales!==void 0?this.options.locales=t.locales:this.options.locales=i.locales),e!==void 0&&(typeof e=="boolean"?this.options.enabled=e:(this.options.enabled=!0,he(this.options,e)),this.options.initiallyActive===!0&&(this.editMode=!0),this._setup())}},{key:"toggleEditMode",value:function(){this.editMode===!0?this.disableEditMode():this.enableEditMode()}},{key:"enableEditMode",value:function(){this.editMode=!0,this._clean(),this.guiEnabled===!0&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}},{key:"disableEditMode",value:function(){this.editMode=!1,this._clean(),this.guiEnabled===!0&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}},{key:"showManipulatorToolbar",value:function(){if(this._clean(),this.manipulationDOM={},this.guiEnabled===!0){var e,t;this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";var i=this.selectionHandler.getSelectedNodeCount(),a=this.selectionHandler.getSelectedEdgeCount(),o=i+a,s=this.options.locales[this.options.locale],u=!1;this.options.addNode!==!1&&(this._createAddNodeButton(s),u=!0),this.options.addEdge!==!1&&(u===!0?this._createSeperator(1):u=!0,this._createAddEdgeButton(s)),i===1&&typeof this.options.editNode=="function"?(u===!0?this._createSeperator(2):u=!0,this._createEditNodeButton(s)):a===1&&i===0&&this.options.editEdge!==!1&&(u===!0?this._createSeperator(3):u=!0,this._createEditEdgeButton(s)),o!==0&&(i>0&&this.options.deleteNode!==!1?(u===!0&&this._createSeperator(4),this._createDeleteButton(s)):i===0&&this.options.deleteEdge!==!1&&(u===!0&&this._createSeperator(4),this._createDeleteButton(s))),this._bindElementEvents(this.closeDiv,O(e=this.toggleEditMode).call(e,this)),this._temporaryBindEvent("select",O(t=this.showManipulatorToolbar).call(t,this))}this.body.emitter.emit("_redraw")}},{key:"addNodeMode",value:function(){var e;if(this.editMode!==!0&&this.enableEditMode(),this._clean(),this.inMode="addNode",this.guiEnabled===!0){var t,i=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(i),this._createSeperator(),this._createDescription(i.addDescription||this.options.locales.en.addDescription),this._bindElementEvents(this.closeDiv,O(t=this.toggleEditMode).call(t,this))}this._temporaryBindEvent("click",O(e=this._performAddNode).call(e,this))}},{key:"editNode",value:function(){var e=this;this.editMode!==!0&&this.enableEditMode(),this._clean();var t=this.selectionHandler.getSelectedNodes()[0];if(t!==void 0)if(this.inMode="editNode",typeof this.options.editNode=="function")if(t.isCluster!==!0){var i=he({},t.options,!1);if(i.x=t.x,i.y=t.y,this.options.editNode.length===2)this.options.editNode(i,function(a){a!=null&&e.inMode==="editNode"&&e.body.data.nodes.getDataSet().update(a),e.showManipulatorToolbar()});else throw new Error("The function for edit does not support two arguments (data, callback)")}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError);else throw new Error("No function has been configured to handle the editing of nodes.");else this.showManipulatorToolbar()}},{key:"addEdgeMode",value:function(){var e,t,i,a,o;if(this.editMode!==!0&&this.enableEditMode(),this._clean(),this.inMode="addEdge",this.guiEnabled===!0){var s,u=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(u),this._createSeperator(),this._createDescription(u.edgeDescription||this.options.locales.en.edgeDescription),this._bindElementEvents(this.closeDiv,O(s=this.toggleEditMode).call(s,this))}this._temporaryBindUI("onTouch",O(e=this._handleConnect).call(e,this)),this._temporaryBindUI("onDragEnd",O(t=this._finishConnect).call(t,this)),this._temporaryBindUI("onDrag",O(i=this._dragControlNode).call(i,this)),this._temporaryBindUI("onRelease",O(a=this._finishConnect).call(a,this)),this._temporaryBindUI("onDragStart",O(o=this._dragStartEdge).call(o,this)),this._temporaryBindUI("onHold",function(){})}},{key:"editEdgeMode",value:function(){if(this.editMode!==!0&&this.enableEditMode(),this._clean(),this.inMode="editEdge",se(this.options.editEdge)==="object"&&typeof this.options.editEdge.editWithoutDrag=="function"&&(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdgeIds()[0],this.edgeBeingEditedId!==void 0)){var e=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(e.from.id,e.to.id);return}if(this.guiEnabled===!0){var t,i=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(i),this._createSeperator(),this._createDescription(i.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindElementEvents(this.closeDiv,O(t=this.toggleEditMode).call(t,this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdgeIds()[0],this.edgeBeingEditedId!==void 0){var a,o,s,u,l=this.body.edges[this.edgeBeingEditedId],h=this._getNewTargetNode(l.from.x,l.from.y),d=this._getNewTargetNode(l.to.x,l.to.y);this.temporaryIds.nodes.push(h.id),this.temporaryIds.nodes.push(d.id),this.body.nodes[h.id]=h,this.body.nodeIndices.push(h.id),this.body.nodes[d.id]=d,this.body.nodeIndices.push(d.id),this._temporaryBindUI("onTouch",O(a=this._controlNodeTouch).call(a,this)),this._temporaryBindUI("onTap",function(){}),this._temporaryBindUI("onHold",function(){}),this._temporaryBindUI("onDragStart",O(o=this._controlNodeDragStart).call(o,this)),this._temporaryBindUI("onDrag",O(s=this._controlNodeDrag).call(s,this)),this._temporaryBindUI("onDragEnd",O(u=this._controlNodeDragEnd).call(u,this)),this._temporaryBindUI("onMouseMove",function(){}),this._temporaryBindEvent("beforeDrawing",function(c){var f=l.edgeType.findBorderPositions(c);h.selected===!1&&(h.x=f.from.x,h.y=f.from.y),d.selected===!1&&(d.x=f.to.x,d.y=f.to.y)}),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}},{key:"deleteSelected",value:function(){var e=this;this.editMode!==!0&&this.enableEditMode(),this._clean(),this.inMode="delete";var t=this.selectionHandler.getSelectedNodeIds(),i=this.selectionHandler.getSelectedEdgeIds(),a=void 0;if(t.length>0){for(var o=0;o<t.length;o++)if(this.body.nodes[t[o]].isCluster===!0){alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);return}typeof this.options.deleteNode=="function"&&(a=this.options.deleteNode)}else i.length>0&&typeof this.options.deleteEdge=="function"&&(a=this.options.deleteEdge);if(typeof a=="function"){var s={nodes:t,edges:i};if(a.length===2)a(s,function(u){u!=null&&e.inMode==="delete"?(e.body.data.edges.getDataSet().remove(u.edges),e.body.data.nodes.getDataSet().remove(u.nodes),e.body.emitter.emit("startSimulation"),e.showManipulatorToolbar()):(e.body.emitter.emit("startSimulation"),e.showManipulatorToolbar())});else throw new Error("The function for delete does not support two arguments (data, callback)")}else this.body.data.edges.getDataSet().remove(i),this.body.data.nodes.getDataSet().remove(t),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}},{key:"_setup",value:function(){this.options.enabled===!0?(this.guiEnabled=!0,this._createWrappers(),this.editMode===!1?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}},{key:"_createWrappers",value:function(){if(this.manipulationDiv===void 0&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",this.editMode===!0?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),this.editModeDiv===void 0&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",this.editMode===!0?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),this.closeDiv===void 0){var e,t;this.closeDiv=document.createElement("button"),this.closeDiv.className="vis-close",this.closeDiv.setAttribute("aria-label",(e=(t=this.options.locales[this.options.locale])===null||t===void 0?void 0:t.close)!==null&&e!==void 0?e:this.options.locales.en.close),this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv)}}},{key:"_getNewTargetNode",value:function(e,t){var i=he({},this.options.controlNodeStyle);i.id="targetNode"+Ia(),i.hidden=!1,i.physics=!1,i.x=e,i.y=t;var a=this.body.functions.createNode(i);return a.shape.boundingBox={left:e,right:e,top:t,bottom:t},a}},{key:"_createEditButton",value:function(){var e;this._clean(),this.manipulationDOM={},Mr(this.editModeDiv);var t=this.options.locales[this.options.locale],i=this._createButton("editMode","vis-edit vis-edit-mode",t.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(i),this._bindElementEvents(i,O(e=this.toggleEditMode).call(e,this))}},{key:"_clean",value:function(){this.inMode=!1,this.guiEnabled===!0&&(Mr(this.editModeDiv),Mr(this.manipulationDiv),this._cleanupDOMEventListeners()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}},{key:"_cleanupDOMEventListeners",value:function(){var e,t=Tfe(br(e=this._domEventListenerCleanupQueue).call(e,0)),i;try{for(t.s();!(i=t.n()).done;){var a=i.value;a()}}catch(o){t.e(o)}finally{t.f()}}},{key:"_removeManipulationDOM",value:function(){this._clean(),Mr(this.manipulationDiv),Mr(this.editModeDiv),Mr(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}},{key:"_createSeperator",value:function(){var e=arguments.length>0&&arguments[0]!==void 0?arguments[0]:1;this.manipulationDOM["seperatorLineDiv"+e]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+e].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+e])}},{key:"_createAddNodeButton",value:function(e){var t,i=this._createButton("addNode","vis-add",e.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,O(t=this.addNodeMode).call(t,this))}},{key:"_createAddEdgeButton",value:function(e){var t,i=this._createButton("addEdge","vis-connect",e.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,O(t=this.addEdgeMode).call(t,this))}},{key:"_createEditNodeButton",value:function(e){var t,i=this._createButton("editNode","vis-edit",e.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,O(t=this.editNode).call(t,this))}},{key:"_createEditEdgeButton",value:function(e){var t,i=this._createButton("editEdge","vis-edit",e.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,O(t=this.editEdgeMode).call(t,this))}},{key:"_createDeleteButton",value:function(e){var t,i;this.options.rtl?i="vis-delete-rtl":i="vis-delete";var a=this._createButton("delete",i,e.del||this.options.locales.en.del);this.manipulationDiv.appendChild(a),this._bindElementEvents(a,O(t=this.deleteSelected).call(t,this))}},{key:"_createBackButton",value:function(e){var t,i=this._createButton("back","vis-back",e.back||this.options.locales.en.back);this.manipulationDiv.appendChild(i),this._bindElementEvents(i,O(t=this.showManipulatorToolbar).call(t,this))}},{key:"_createButton",value:function(e,t,i){var a=arguments.length>3&&arguments[3]!==void 0?arguments[3]:"vis-label";return this.manipulationDOM[e+"Div"]=document.createElement("button"),this.manipulationDOM[e+"Div"].className="vis-button "+t,this.manipulationDOM[e+"Label"]=document.createElement("div"),this.manipulationDOM[e+"Label"].className=a,this.manipulationDOM[e+"Label"].innerText=i,this.manipulationDOM[e+"Div"].appendChild(this.manipulationDOM[e+"Label"]),this.manipulationDOM[e+"Div"]}},{key:"_createDescription",value:function(e){this.manipulationDOM.descriptionLabel=document.createElement("div"),this.manipulationDOM.descriptionLabel.className="vis-none",this.manipulationDOM.descriptionLabel.innerText=e,this.manipulationDiv.appendChild(this.manipulationDOM.descriptionLabel)}},{key:"_temporaryBindEvent",value:function(e,t){this.temporaryEventFunctions.push({event:e,boundFunction:t}),this.body.emitter.on(e,t)}},{key:"_temporaryBindUI",value:function(e,t){if(this.body.eventListeners[e]!==void 0)this.temporaryUIFunctions[e]=this.body.eventListeners[e],this.body.eventListeners[e]=t;else throw new Error("This UI function does not exist. Typo? You tried: "+e+" possible are: "+Ro(me(this.body.eventListeners)))}},{key:"_unbindTemporaryUIs",value:function(){for(var e in this.temporaryUIFunctions)Object.prototype.hasOwnProperty.call(this.temporaryUIFunctions,e)&&(this.body.eventListeners[e]=this.temporaryUIFunctions[e],delete this.temporaryUIFunctions[e]);this.temporaryUIFunctions={}}},{key:"_unbindTemporaryEvents",value:function(){for(var e=0;e<this.temporaryEventFunctions.length;e++){var t=this.temporaryEventFunctions[e].event,i=this.temporaryEventFunctions[e].boundFunction;this.body.emitter.off(t,i)}this.temporaryEventFunctions=[]}},{key:"_bindElementEvents",value:function(e,t){var i=new $n(e,{});pu(i,t),this._domEventListenerCleanupQueue.push(function(){i.destroy()});var a=function(s){var u=s.keyCode,l=s.key;(l==="Enter"||l===" "||u===13||u===32)&&t()};e.addEventListener("keyup",a,!1),this._domEventListenerCleanupQueue.push(function(){e.removeEventListener("keyup",a,!1)})}},{key:"_cleanupTemporaryNodesAndEdges",value:function(){for(var e=0;e<this.temporaryIds.edges.length;e++){var t;this.body.edges[this.temporaryIds.edges[e]].disconnect(),delete this.body.edges[this.temporaryIds.edges[e]];var i=Z(t=this.body.edgeIndices).call(t,this.temporaryIds.edges[e]);if(i!==-1){var a;br(a=this.body.edgeIndices).call(a,i,1)}}for(var o=0;o<this.temporaryIds.nodes.length;o++){var s;delete this.body.nodes[this.temporaryIds.nodes[o]];var u=Z(s=this.body.nodeIndices).call(s,this.temporaryIds.nodes[o]);if(u!==-1){var l;br(l=this.body.nodeIndices).call(l,u,1)}}this.temporaryIds={nodes:[],edges:[]}}},{key:"_controlNodeTouch",value:function(e){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=Ae({},this.body.view.translation)}},{key:"_controlNodeDragStart",value:function(){var e=this.lastTouch,t=this.selectionHandler._pointerToPositionObject(e),i=this.body.nodes[this.temporaryIds.nodes[0]],a=this.body.nodes[this.temporaryIds.nodes[1]],o=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;var s=i.isOverlappingWith(t),u=a.isOverlappingWith(t);s===!0?(this.selectedControlNode=i,o.edgeType.from=i):u===!0&&(this.selectedControlNode=a,o.edgeType.to=a),this.selectedControlNode!==void 0&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDrag",value:function(e){this.body.emitter.emit("disablePhysics");var t=this.body.functions.getPointer(e.center),i=this.canvas.DOMtoCanvas(t);this.selectedControlNode!==void 0?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(e),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDragEnd",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),a=this.body.edges[this.edgeBeingEditedId];if(this.selectedControlNode!==void 0){this.selectionHandler.unselectAll();for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,u=o.length-1;u>=0;u--)if(o[u]!==this.selectedControlNode.id){s=this.body.nodes[o[u]];break}if(s!==void 0&&this.selectedControlNode!==void 0)if(s.isCluster===!0)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var l=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===l.id?this._performEditEdge(s.id,a.to.id):this._performEditEdge(a.from.id,s.id)}else a.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}}},{key:"_handleConnect",value:function(e){if(new Date().valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(e.center),this.lastTouch.translation=Ae({},this.body.view.translation),this.interactionHandler.drag.pointer=this.lastTouch,this.interactionHandler.drag.translation=this.lastTouch.translation;var t=this.lastTouch,i=this.selectionHandler.getNodeAt(t);if(i!==void 0)if(i.isCluster===!0)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var a=this._getNewTargetNode(i.x,i.y);this.body.nodes[a.id]=a,this.body.nodeIndices.push(a.id);var o=this.body.functions.createEdge({id:"connectionEdge"+Ia(),from:i.id,to:a.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[o.id]=o,this.body.edgeIndices.push(o.id),this.temporaryIds.nodes.push(a.id),this.temporaryIds.edges.push(o.id)}this.touchTime=new Date().valueOf()}}},{key:"_dragControlNode",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),a=void 0;this.temporaryIds.edges[0]!==void 0&&(a=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,u=o.length-1;u>=0;u--){var l;if(Z(l=this.temporaryIds.nodes).call(l,o[u])===-1){s=this.body.nodes[o[u]];break}}if(e.controlEdge={from:a,to:s?s.id:void 0},this.selectionHandler.generateClickEvent("controlNodeDragging",e,t),this.temporaryIds.nodes[0]!==void 0){var h=this.body.nodes[this.temporaryIds.nodes[0]];h.x=this.canvas._XconvertDOMtoCanvas(t.x),h.y=this.canvas._YconvertDOMtoCanvas(t.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(e)}},{key:"_finishConnect",value:function(e){var t=this.body.functions.getPointer(e.center),i=this.selectionHandler._pointerToPositionObject(t),a=void 0;this.temporaryIds.edges[0]!==void 0&&(a=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,u=o.length-1;u>=0;u--){var l;if(Z(l=this.temporaryIds.nodes).call(l,o[u])===-1){s=this.body.nodes[o[u]];break}}this._cleanupTemporaryNodesAndEdges(),s!==void 0&&(s.isCluster===!0?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):this.body.nodes[a]!==void 0&&this.body.nodes[s.id]!==void 0&&this._performAddEdge(a,s.id)),e.controlEdge={from:a,to:s?s.id:void 0},this.selectionHandler.generateClickEvent("controlNodeDragEnd",e,t),this.body.emitter.emit("_redraw")}},{key:"_dragStartEdge",value:function(e){var t=this.lastTouch;this.selectionHandler.generateClickEvent("dragStart",e,t,void 0,!0)}},{key:"_performAddNode",value:function(e){var t=this,i={id:Ia(),x:e.pointer.canvas.x,y:e.pointer.canvas.y,label:"new"};if(typeof this.options.addNode=="function")if(this.options.addNode.length===2)this.options.addNode(i,function(a){a!=null&&t.inMode==="addNode"&&t.body.data.nodes.getDataSet().add(a),t.showManipulatorToolbar()});else throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");else this.body.data.nodes.getDataSet().add(i),this.showManipulatorToolbar()}},{key:"_performAddEdge",value:function(e,t){var i=this,a={from:e,to:t};if(typeof this.options.addEdge=="function")if(this.options.addEdge.length===2)this.options.addEdge(a,function(o){o!=null&&i.inMode==="addEdge"&&(i.body.data.edges.getDataSet().add(o),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())});else throw new Error("The function for connect does not support two arguments (data,callback)");else this.body.data.edges.getDataSet().add(a),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}},{key:"_performEditEdge",value:function(e,t){var i=this,a={id:this.edgeBeingEditedId,from:e,to:t,label:this.body.data.edges.get(this.edgeBeingEditedId).label},o=this.options.editEdge;if(se(o)==="object"&&(o=o.editWithoutDrag),typeof o=="function")if(o.length===2)o(a,function(s){s==null||i.inMode!=="editEdge"?(i.body.edges[a.id].updateEdgeType(),i.body.emitter.emit("_redraw"),i.showManipulatorToolbar()):(i.body.data.edges.getDataSet().update(s),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())});else throw new Error("The function for edit does not support two arguments (data, callback)");else this.body.data.edges.getDataSet().update(a),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}]),r}(),I="string",S="boolean",b="number",ba="array",B="object",HO="dom",kfe="any",xd=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],Ad={borderWidth:{number:b},borderWidthSelected:{number:b,undefined:"undefined"},brokenImage:{string:I,undefined:"undefined"},chosen:{label:{boolean:S,function:"function"},node:{boolean:S,function:"function"},__type__:{object:B,boolean:S}},color:{border:{string:I},background:{string:I},highlight:{border:{string:I},background:{string:I},__type__:{object:B,string:I}},hover:{border:{string:I},background:{string:I},__type__:{object:B,string:I}},__type__:{object:B,string:I}},opacity:{number:b,undefined:"undefined"},fixed:{x:{boolean:S},y:{boolean:S},__type__:{object:B,boolean:S}},font:{align:{string:I},color:{string:I},size:{number:b},face:{string:I},background:{string:I},strokeWidth:{number:b},strokeColor:{string:I},vadjust:{number:b},multi:{boolean:S,string:I},bold:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},boldital:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},ital:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},mono:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},__type__:{object:B,string:I}},group:{string:I,number:b,undefined:"undefined"},heightConstraint:{minimum:{number:b},valign:{string:I},__type__:{object:B,boolean:S,number:b}},hidden:{boolean:S},icon:{face:{string:I},code:{string:I},size:{number:b},color:{string:I},weight:{string:I,number:b},__type__:{object:B}},id:{string:I,number:b},image:{selected:{string:I,undefined:"undefined"},unselected:{string:I,undefined:"undefined"},__type__:{object:B,string:I}},imagePadding:{top:{number:b},right:{number:b},bottom:{number:b},left:{number:b},__type__:{object:B,number:b}},label:{string:I,undefined:"undefined"},labelHighlightBold:{boolean:S},level:{number:b,undefined:"undefined"},margin:{top:{number:b},right:{number:b},bottom:{number:b},left:{number:b},__type__:{object:B,number:b}},mass:{number:b},physics:{boolean:S},scaling:{min:{number:b},max:{number:b},label:{enabled:{boolean:S},min:{number:b},max:{number:b},maxVisible:{number:b},drawThreshold:{number:b},__type__:{object:B,boolean:S}},customScalingFunction:{function:"function"},__type__:{object:B}},shadow:{enabled:{boolean:S},color:{string:I},size:{number:b},x:{number:b},y:{number:b},__type__:{object:B,boolean:S}},shape:{string:["custom","ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},ctxRenderer:{function:"function"},shapeProperties:{borderDashes:{boolean:S,array:ba},borderRadius:{number:b},interpolation:{boolean:S},useImageSize:{boolean:S},useBorderWithImage:{boolean:S},coordinateOrigin:{string:["center","top-left"]},__type__:{object:B}},size:{number:b},title:{string:I,dom:HO,undefined:"undefined"},value:{number:b,undefined:"undefined"},widthConstraint:{minimum:{number:b},maximum:{number:b},__type__:{object:B,boolean:S,number:b}},x:{number:b},y:{number:b},__type__:{object:B}},Cfe={configure:{enabled:{boolean:S},filter:{boolean:S,string:I,array:ba,function:"function"},container:{dom:HO},showButton:{boolean:S},__type__:{object:B,boolean:S,string:I,array:ba,function:"function"}},edges:{arrows:{to:{enabled:{boolean:S},scaleFactor:{number:b},type:{string:xd},imageHeight:{number:b},imageWidth:{number:b},src:{string:I},__type__:{object:B,boolean:S}},middle:{enabled:{boolean:S},scaleFactor:{number:b},type:{string:xd},imageWidth:{number:b},imageHeight:{number:b},src:{string:I},__type__:{object:B,boolean:S}},from:{enabled:{boolean:S},scaleFactor:{number:b},type:{string:xd},imageWidth:{number:b},imageHeight:{number:b},src:{string:I},__type__:{object:B,boolean:S}},__type__:{string:["from","to","middle"],object:B}},endPointOffset:{from:{number:b},to:{number:b},__type__:{object:B,number:b}},arrowStrikethrough:{boolean:S},background:{enabled:{boolean:S},color:{string:I},size:{number:b},dashes:{boolean:S,array:ba},__type__:{object:B,boolean:S}},chosen:{label:{boolean:S,function:"function"},edge:{boolean:S,function:"function"},__type__:{object:B,boolean:S}},color:{color:{string:I},highlight:{string:I},hover:{string:I},inherit:{string:["from","to","both"],boolean:S},opacity:{number:b},__type__:{object:B,string:I}},dashes:{boolean:S,array:ba},font:{color:{string:I},size:{number:b},face:{string:I},background:{string:I},strokeWidth:{number:b},strokeColor:{string:I},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:b},multi:{boolean:S,string:I},bold:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},boldital:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},ital:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},mono:{color:{string:I},size:{number:b},face:{string:I},mod:{string:I},vadjust:{number:b},__type__:{object:B,string:I}},__type__:{object:B,string:I}},hidden:{boolean:S},hoverWidth:{function:"function",number:b},label:{string:I,undefined:"undefined"},labelHighlightBold:{boolean:S},length:{number:b,undefined:"undefined"},physics:{boolean:S},scaling:{min:{number:b},max:{number:b},label:{enabled:{boolean:S},min:{number:b},max:{number:b},maxVisible:{number:b},drawThreshold:{number:b},__type__:{object:B,boolean:S}},customScalingFunction:{function:"function"},__type__:{object:B}},selectionWidth:{function:"function",number:b},selfReferenceSize:{number:b},selfReference:{size:{number:b},angle:{number:b},renderBehindTheNode:{boolean:S},__type__:{object:B}},shadow:{enabled:{boolean:S},color:{string:I},size:{number:b},x:{number:b},y:{number:b},__type__:{object:B,boolean:S}},smooth:{enabled:{boolean:S},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:b},forceDirection:{string:["horizontal","vertical","none"],boolean:S},__type__:{object:B,boolean:S}},title:{string:I,undefined:"undefined"},width:{number:b},widthConstraint:{maximum:{number:b},__type__:{object:B,boolean:S,number:b}},value:{number:b,undefined:"undefined"},__type__:{object:B}},groups:{useDefaultGroups:{boolean:S},__any__:Ad,__type__:{object:B}},interaction:{dragNodes:{boolean:S},dragView:{boolean:S},hideEdgesOnDrag:{boolean:S},hideEdgesOnZoom:{boolean:S},hideNodesOnDrag:{boolean:S},hover:{boolean:S},keyboard:{enabled:{boolean:S},speed:{x:{number:b},y:{number:b},zoom:{number:b},__type__:{object:B}},bindToWindow:{boolean:S},autoFocus:{boolean:S},__type__:{object:B,boolean:S}},multiselect:{boolean:S},navigationButtons:{boolean:S},selectable:{boolean:S},selectConnectedEdges:{boolean:S},hoverConnectedEdges:{boolean:S},tooltipDelay:{number:b},zoomView:{boolean:S},zoomSpeed:{number:b},__type__:{object:B}},layout:{randomSeed:{undefined:"undefined",number:b,string:I},improvedLayout:{boolean:S},clusterThreshold:{number:b},hierarchical:{enabled:{boolean:S},levelSeparation:{number:b},nodeSpacing:{number:b},treeSpacing:{number:b},blockShifting:{boolean:S},edgeMinimization:{boolean:S},parentCentralization:{boolean:S},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:B,boolean:S}},__type__:{object:B}},manipulation:{enabled:{boolean:S},initiallyActive:{boolean:S},addNode:{boolean:S,function:"function"},addEdge:{boolean:S,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:B,boolean:S,function:"function"}},deleteNode:{boolean:S,function:"function"},deleteEdge:{boolean:S,function:"function"},controlNodeStyle:Ad,__type__:{object:B,boolean:S}},nodes:Ad,physics:{enabled:{boolean:S},barnesHut:{theta:{number:b},gravitationalConstant:{number:b},centralGravity:{number:b},springLength:{number:b},springConstant:{number:b},damping:{number:b},avoidOverlap:{number:b},__type__:{object:B}},forceAtlas2Based:{theta:{number:b},gravitationalConstant:{number:b},centralGravity:{number:b},springLength:{number:b},springConstant:{number:b},damping:{number:b},avoidOverlap:{number:b},__type__:{object:B}},repulsion:{centralGravity:{number:b},springLength:{number:b},springConstant:{number:b},nodeDistance:{number:b},damping:{number:b},__type__:{object:B}},hierarchicalRepulsion:{centralGravity:{number:b},springLength:{number:b},springConstant:{number:b},nodeDistance:{number:b},damping:{number:b},avoidOverlap:{number:b},__type__:{object:B}},maxVelocity:{number:b},minVelocity:{number:b},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:S},iterations:{number:b},updateInterval:{number:b},onlyDynamicEdges:{boolean:S},fit:{boolean:S},__type__:{object:B,boolean:S}},timestep:{number:b},adaptiveTimestep:{boolean:S},wind:{x:{number:b},y:{number:b},__type__:{object:B}},__type__:{object:B,boolean:S}},autoResize:{boolean:S},clickToUse:{boolean:S},locale:{string:I},locales:{__any__:{any:kfe},__type__:{object:B}},height:{string:I},width:{string:I},__type__:{object:B}},WO={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},opacity:[0,0,1,.1],fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},endPointOffset:{from:[0,-10,10,1],to:[0,-10,10,1]},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],selfReference:{size:[20,0,200,1],angle:[Math.PI/2,-6*Math.PI,6*Math.PI,Math.PI/8],renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0,autoFocus:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,.1,2,.1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{theta:[.5,.1,1,.05],gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{theta:[.5,.1,1,.05],gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01],wind:{x:[0,-10,10,.1],y:[0,-10,10,.1]}}},xfe=function(n,e,t){var i;return!!(Ur(n).call(n,"physics")&&Ur(i=WO.physics.solver).call(i,e)&&t.physics.solver!==e&&e!=="wind")},Afe=function(){function r(){C(this,r)}return x(r,[{key:"getDistances",value:function(e,t,i){for(var a={},o=e.edges,s=0;s<t.length;s++){var u=t[s],l={};a[u]=l;for(var h=0;h<t.length;h++)l[t[h]]=s==h?0:1e9}for(var d=0;d<i.length;d++){var c=o[i[d]];c.connected===!0&&a[c.fromId]!==void 0&&a[c.toId]!==void 0&&(a[c.fromId][c.toId]=1,a[c.toId][c.fromId]=1)}for(var f=t.length,v=0;v<f;v++)for(var p=t[v],y=a[p],g=0;g<f-1;g++)for(var m=t[g],w=a[m],$=g+1;$<f;$++){var E=t[$],k=a[E],D=Math.min(w[E],w[p]+y[E]);w[E]=D,k[m]=D}return a}}]),r}(),Rfe=function(){function r(n,e,t){C(this,r),this.body=n,this.springLength=e,this.springConstant=t,this.distanceSolver=new Afe}return x(r,[{key:"setOptions",value:function(e){e&&(e.springLength&&(this.springLength=e.springLength),e.springConstant&&(this.springConstant=e.springConstant))}},{key:"solve",value:function(e,t){var i=arguments.length>2&&arguments[2]!==void 0?arguments[2]:!1,a=this.distanceSolver.getDistances(this.body,e,t);this._createL_matrix(a),this._createK_matrix(a),this._createE_matrix();for(var o=.01,s=1,u=0,l=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),h=5,d=1e9,c=0,f=0,v=0,p=0,y=0;d>o&&u<l;){u+=1;var g=this._getHighestEnergyNode(i),m=be(g,4);for(c=m[0],d=m[1],f=m[2],v=m[3],p=d,y=0;p>s&&y<h;){y+=1,this._moveNode(c,f,v);var w=this._getEnergy(c),$=be(w,3);p=$[0],f=$[1],v=$[2]}}}},{key:"_getHighestEnergyNode",value:function(e){for(var t=this.body.nodeIndices,i=this.body.nodes,a=0,o=t[0],s=0,u=0,l=0;l<t.length;l++){var h=t[l];if(i[h].predefinedPosition!==!0||i[h].isCluster===!0&&e===!0||i[h].options.fixed.x!==!0||i[h].options.fixed.y!==!0){var d=this._getEnergy(h),c=be(d,3),f=c[0],v=c[1],p=c[2];a<f&&(a=f,o=h,s=v,u=p)}}return[o,a,s,u]}},{key:"_getEnergy",value:function(e){var t=be(this.E_sums[e],2),i=t[0],a=t[1],o=Math.sqrt(Math.pow(i,2)+Math.pow(a,2));return[o,i,a]}},{key:"_moveNode",value:function(e,t,i){for(var a=this.body.nodeIndices,o=this.body.nodes,s=0,u=0,l=0,h=o[e].x,d=o[e].y,c=this.K_matrix[e],f=this.L_matrix[e],v=0;v<a.length;v++){var p=a[v];if(p!==e){var y=o[p].x,g=o[p].y,m=c[p],w=f[p],$=1/Math.pow(Math.pow(h-y,2)+Math.pow(d-g,2),1.5);s+=m*(1-w*Math.pow(d-g,2)*$),u+=m*(w*(h-y)*(d-g)*$),l+=m*(1-w*Math.pow(h-y,2)*$)}}var E=s,k=u,D=t,j=l,R=i,M=(D/E+R/k)/(k/E-j/k),W=-(k*M+D)/E;o[e].x+=W,o[e].y+=M,this._updateE_matrix(e)}},{key:"_createL_matrix",value:function(e){var t=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(var a=0;a<t.length;a++){this.L_matrix[t[a]]={};for(var o=0;o<t.length;o++)this.L_matrix[t[a]][t[o]]=i*e[t[a]][t[o]]}}},{key:"_createK_matrix",value:function(e){var t=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(var a=0;a<t.length;a++){this.K_matrix[t[a]]={};for(var o=0;o<t.length;o++)this.K_matrix[t[a]][t[o]]=i*Math.pow(e[t[a]][t[o]],-2)}}},{key:"_createE_matrix",value:function(){var e=this.body.nodeIndices,t=this.body.nodes;this.E_matrix={},this.E_sums={};for(var i=0;i<e.length;i++)this.E_matrix[e[i]]=[];for(var a=0;a<e.length;a++){for(var o=e[a],s=t[o].x,u=t[o].y,l=0,h=0,d=a;d<e.length;d++){var c=e[d];if(c!==o){var f=t[c].x,v=t[c].y,p=1/Math.sqrt(Math.pow(s-f,2)+Math.pow(u-v,2));this.E_matrix[o][d]=[this.K_matrix[o][c]*(s-f-this.L_matrix[o][c]*(s-f)*p),this.K_matrix[o][c]*(u-v-this.L_matrix[o][c]*(u-v)*p)],this.E_matrix[c][a]=this.E_matrix[o][d],l+=this.E_matrix[o][d][0],h+=this.E_matrix[o][d][1]}}this.E_sums[o]=[l,h]}}},{key:"_updateE_matrix",value:function(e){for(var t=this.body.nodeIndices,i=this.body.nodes,a=this.E_matrix[e],o=this.K_matrix[e],s=this.L_matrix[e],u=i[e].x,l=i[e].y,h=0,d=0,c=0;c<t.length;c++){var f=t[c];if(f!==e){var v=a[c],p=v[0],y=v[1],g=i[f].x,m=i[f].y,w=1/Math.sqrt(Math.pow(u-g,2)+Math.pow(l-m,2)),$=o[f]*(u-g-s[f]*(u-g)*w),E=o[f]*(l-m-s[f]*(l-m)*w);a[c]=[$,E],h+=$,d+=E;var k=this.E_sums[f];k[0]+=$-p,k[1]+=E-y}}this.E_sums[e]=[h,d]}}]),r}();function F(r,n,e){var t,i,a,o,s=this;if(!(this instanceof F))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:Cne,clickToUse:!1},Ae(this.options,this.defaultOptions),this.body={container:r,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:O(t=this.on).call(t,this),off:O(i=this.off).call(i,this),emit:O(a=this.emit).call(a,this),once:O(o=this.once).call(o,this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}},selectionBox:{show:!1,position:{start:{x:0,y:0},end:{x:0,y:0}}}},this.bindEventListeners(),this.images=new Rne(function(){return s.body.emitter.emit("_requestRedraw")}),this.groups=new Xae,this.canvas=new fde(this.body),this.selectionHandler=new ice(this.body,this.canvas),this.interactionHandler=new bde(this.body,this.canvas,this.selectionHandler),this.view=new pde(this.body,this.canvas),this.renderer=new ude(this.body,this.canvas),this.physics=new Jhe(this.body),this.layoutEngine=new Ofe(this.body),this.clustering=new ode(this.body),this.manipulation=new Ife(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new Mle(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new Hhe(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new Rfe(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(e),this.setData(n)}H_(F.prototype);F.prototype.setOptions=function(r){var n=this;if(r===null&&(r=void 0),r!==void 0){var e=sne.validate(r,Cfe);e===!0&&console.error("%cErrors have been found in the supplied options object.",VS);var t=["locale","locales","clickToUse"];if(ua(t,this.options,r),r.locale!==void 0&&(r.locale=xne(r.locales||this.options.locales,r.locale)),r=this.layoutEngine.setOptions(r.layout,r),this.canvas.setOptions(r),this.groups.setOptions(r.groups),this.nodesHandler.setOptions(r.nodes),this.edgesHandler.setOptions(r.edges),this.physics.setOptions(r.physics),this.manipulation.setOptions(r.manipulation,r,this.options),this.interactionHandler.setOptions(r.interaction),this.renderer.setOptions(r.interaction),this.selectionHandler.setOptions(r.interaction),r.groups!==void 0&&this.body.emitter.emit("refreshNodes"),"configure"in r&&(this.configurator||(this.configurator=new ane(this,this.body.container,WO,this.canvas.pixelRatio,xfe)),this.configurator.setOptions(r.configure)),this.configurator&&this.configurator.options.enabled===!0){var i={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};he(i.nodes,this.nodesHandler.options),he(i.edges,this.edgesHandler.options),he(i.layout,this.layoutEngine.options),he(i.interaction,this.selectionHandler.options),he(i.interaction,this.renderer.options),he(i.interaction,this.interactionHandler.options),he(i.manipulation,this.manipulation.options),he(i.physics,this.physics.options),he(i.global,this.canvas.options),he(i.global,this.options),this.configurator.setModuleOptions(i)}r.clickToUse!==void 0?r.clickToUse===!0?this.activator===void 0&&(this.activator=new nne(this.canvas.frame),this.activator.on("change",function(){n.body.emitter.emit("activate")})):(this.activator!==void 0&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}};F.prototype._updateVisibleIndices=function(){var r=this.body.nodes,n=this.body.edges;this.body.nodeIndices=[],this.body.edgeIndices=[];for(var e in r)Object.prototype.hasOwnProperty.call(r,e)&&!this.clustering._isClusteredNode(e)&&r[e].options.hidden===!1&&this.body.nodeIndices.push(r[e].id);for(var t in n)if(Object.prototype.hasOwnProperty.call(n,t)){var i=n[t],a=r[i.fromId],o=r[i.toId],s=a!==void 0&&o!==void 0,u=!this.clustering._isClusteredEdge(t)&&i.options.hidden===!1&&s&&a.options.hidden===!1&&o.options.hidden===!1;u&&this.body.edgeIndices.push(i.id)}};F.prototype.bindEventListeners=function(){var r=this;this.body.emitter.on("_dataChanged",function(){r.edgesHandler._updateState(),r.body.emitter.emit("_dataUpdated")}),this.body.emitter.on("_dataUpdated",function(){r.clustering._updateState(),r._updateVisibleIndices(),r._updateValueRange(r.body.nodes),r._updateValueRange(r.body.edges),r.body.emitter.emit("startSimulation"),r.body.emitter.emit("_requestRedraw")})};F.prototype.setData=function(r){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),r&&r.dot&&(r.nodes||r.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(r&&r.options),r&&r.dot){console.warn("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var n=gne(r.dot);this.setData(n);return}else if(r&&r.gephi){console.warn("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var e=mne(r.gephi);this.setData(e);return}else this.nodesHandler.setData(r&&r.nodes,!0),this.edgesHandler.setData(r&&r.edges,!0);this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")};F.prototype.destroy=function(){this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images;for(var r in this.body.nodes)Object.prototype.hasOwnProperty.call(this.body.nodes,r)&&delete this.body.nodes[r];for(var n in this.body.edges)Object.prototype.hasOwnProperty.call(this.body.edges,n)&&delete this.body.edges[n];Mr(this.body.container)};F.prototype._updateValueRange=function(r){var n,e=void 0,t=void 0,i=0;for(n in r)if(Object.prototype.hasOwnProperty.call(r,n)){var a=r[n].getValue();a!==void 0&&(e=e===void 0?a:Math.min(a,e),t=t===void 0?a:Math.max(a,t),i+=a)}if(e!==void 0&&t!==void 0)for(n in r)Object.prototype.hasOwnProperty.call(r,n)&&r[n].setValueRange(e,t,i)};F.prototype.isActive=function(){return!this.activator||this.activator.active};F.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)};F.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)};F.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)};F.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)};F.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)};F.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)};F.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)};F.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)};F.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)};F.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)};F.prototype.updateClusteredNode=function(){return this.clustering.updateClusteredNode.apply(this.clustering,arguments)};F.prototype.getClusteredEdges=function(){return this.clustering.getClusteredEdges.apply(this.clustering,arguments)};F.prototype.getBaseEdge=function(){return this.clustering.getBaseEdge.apply(this.clustering,arguments)};F.prototype.getBaseEdges=function(){return this.clustering.getBaseEdges.apply(this.clustering,arguments)};F.prototype.updateEdge=function(){return this.clustering.updateEdge.apply(this.clustering,arguments)};F.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)};F.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)};F.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)};F.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)};F.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)};F.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)};F.prototype.editNodeMode=function(){return console.warn("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)};F.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)};F.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)};F.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)};F.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)};F.prototype.getPosition=function(){return this.nodesHandler.getPosition.apply(this.nodesHandler,arguments)};F.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)};F.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)};F.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)};F.prototype.getConnectedNodes=function(r){return this.body.nodes[r]!==void 0?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)};F.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)};F.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)};F.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)};F.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)};F.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)};F.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)};F.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodeIds.apply(this.selectionHandler,arguments)};F.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdgeIds.apply(this.selectionHandler,arguments)};F.prototype.getNodeAt=function(){var r=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return r!==void 0&&r.id!==void 0?r.id:r};F.prototype.getEdgeAt=function(){var r=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return r!==void 0&&r.id!==void 0?r.id:r};F.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)};F.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)};F.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.selectionHandler.commitWithoutEmitting.apply(this.selectionHandler),this.redraw()};F.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)};F.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)};F.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)};F.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)};F.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)};F.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)};F.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)};F.prototype.getOptionsFromConfigurator=function(){var r={};return this.configurator&&(r=this.configurator.getOptions.apply(this.configurator)),r};export{F as N};
